<?php

namespace hji\membership\controllers;

use hji\membership\entities\Event;
use hji\membership\entities\UserActionEvent;
use hji\membership\observers\EventDispatcher;


class Dispatcher
{

    private $eventDispatcher;


    public function __construct(EventDispatcher $eventDispatcher)
    {
        $this->eventDispatcher = $eventDispatcher;
    }


    public function attachListener(\SplObserver $listener)
    {
        $this->eventDispatcher->attach($listener);
    }


    public function detachListener(\SplObserver $listener)
    {
        $this->eventDispatcher->detach($listener);
    }


    public function dispatchEvent($event, $attributes = null)
    {
        $this->eventDispatcher->dispatchEvent(new Event($event, $attributes));
    }


    public function dispatchUserAction($action, $attributes = null)
    {
        $this->eventDispatcher->dispatchEvent(new UserActionEvent($action, $attributes));
    }
}