<?php
namespace hji\membership\factories;


use hji\membership\Membership;
use hji\membership\models\PluginEntity;
use hji\membership\models\ThemeEntity;


/**
 * Class ProductFactory
 *
 * @since 2.0
 * @package hji\membership\factories
 */
class ProductFactory
{
    function create($file, $type)
    {
        $result = null;

        switch($type)
        {
            case 'plugin':
                $result = $this->createPlugin($file);
                break;

            case 'theme':
                $result = $this->createTheme($file);
                break;
        }

        return $result;
    }

    /**
     * @param $file
     * @return PluginEntity
     */
    public function createPlugin($file)
    {
        return new PluginEntity($file);
    }


    public function createTheme($stylesheet)
    {
        return new ThemeEntity($stylesheet);
    }
} 