<?php
namespace hji\membership\models;


use hji\membership\Membership;
use hji\membership\interfaces\Product;


/**
 * Class PluginEntity
 *
 * @since 2.0
 * @package hji\membership\models
 */
class PluginEntity extends Product
{
    protected $file;

    // Plugin data
    private $data;

    // Container for all plugins
    protected $plugins;

    protected $type = 'plugin';


    public function __construct($file)
    {
        parent::__construct($file);

        $this->plugin_file = plugin_basename($file);
    }


    public function getFile()
    {
        return $this->file;
    }


    public function getData()
    {
        if ($this->data)
        {
            return $this->data;
        }

        // See if plugin data exists in cache

        if ( ! function_exists( 'get_plugins' ) ) {
            require_once ABSPATH . 'wp-admin/includes/plugin.php';
        }

        if (!$this->plugins)
        {
            $this->plugins = get_plugins();
        }

        if (isset($this->plugins[$this->plugin_file]))
        {
            $this->data = $this->plugins[$this->plugin_file];

            return $this->data;
        }

        $this->data = get_plugin_data($this->plugin_file);

        return $this->data;
    }
}