<?php
namespace hji\membership\models;


use hji\membership\Membership;
use hji\membership\interfaces\Product;


/**
 * Class ThemeEntity
 *
 * @since 2.0
 * @package hji\membership\models
 */
class ThemeEntity extends Product
{
    protected $file;

    protected $theme;

    protected $data;


    protected $type = 'theme';


    /**
     * Theme header keys taken from WP_Theme:offsetExists()
     *
     * @var array
     * @return array
     */
    protected static function _getHeaders()
    {
        $keys = array(
            'Name', 'Version', 'Status', 'Title', 'Author', 'Author Name', 'Author URI', 'Description',
            'Template', 'Stylesheet', 'Template Files', 'Stylesheet Files', 'Template Dir', 'Stylesheet Dir',
            'Screenshot', 'Tags', 'Theme Root', 'Theme Root URI', 'Parent Theme'
        );

        return array_merge($keys, ProductDependencies::getFileHeaderProperties());
    }


    public function getFile()
    {
        return $this->file;
    }


    public function getData()
    {
        if (!$this->data)
        {
            $keys = self::_getHeaders();

            foreach($keys as $key)
            {
                $this->data[$key] = $this->getTheme()->get($key);
            }
        }

        return $this->data;
    }


    public function getTheme()
    {
        if (!$this->theme)
        {
            $this->theme = wp_get_theme(basename(dirname($this->file)));
        }

        return $this->theme;
    }
}