<?php

namespace hji\membership\models\compliances;

class ComplianceBase
{
    /**
    * The compliance mapping array
    *
    * @return array
    */
    public function getMarketsRequirements()
    {
        return array_merge(
            $this->getTexasMarketsRequirements(),
            $this->getNnerenMarketsRequirements(),
            $this->getNwmlsMarketsRequirements()
        );
    }

    /**
     * @return array
     */
    public function getTexasMarketsRequirements()
    {
        return [
            'actris'  => \hji\membership\models\compliances\TexasCompliance::class,
            'txccmls' => \hji\membership\models\compliances\TexasCompliance::class,
            'ctxmls'  => \hji\membership\models\compliances\TexasCompliance::class,
            'tylertx' => \hji\membership\models\compliances\TexasCompliance::class,
            'hlmls'   => \hji\membership\models\compliances\TexasCompliance::class,
            'harmls'  => \hji\membership\models\compliances\TexasCompliance::class,
            'laar'    => \hji\membership\models\compliances\TexasCompliance::class,
            'lubar'   => \hji\membership\models\compliances\TexasCompliance::class,
            'ntreis'  => \hji\membership\models\compliances\TexasCompliance::class,
            'rpaar'   => \hji\membership\models\compliances\TexasCompliance::class,
            'sabor'   => \hji\membership\models\compliances\TexasCompliance::class,
        ];
    }

    /**
     * @return array
     */
    public function getNwmlsMarketsRequirements()
    {
        return [
            'nwmls'   => \hji\membership\models\compliances\NwmlsCompliance::class,
        ];
    }

    /**
     * @return array
     */
    public function getNnerenMarketsRequirements()
    {
        return [
            'nneren'   => \hji\membership\models\compliances\NnerenCompliance::class,
        ];
    }
}
