<?php
namespace hji\membership\models\data;


class Paging
{
    /**
     * @var null Total number of pages
     */
    protected $count;

    /**
     * @var null The current page number (from 1 to $count)
     */
    protected $number;

    /**
     * @var null The number of items that are displayed per page.
     */
    protected $size;


    public function __construct($number = null, $count = null, $size = null)
    {
        if (is_array($number) || is_object($number))
        {
            $this->setProperties($number);
        }
        else
        {
            $this->number = $number;
            $this->count  = $count;
            $this->size   = $size;
        }
    }


    public function setProperties($data)
    {
        $data = (array)$data;

        $this->number = isset($data['number']) ? $data['number'] : null;
        $this->count  = isset($data['count']) ? $data['count'] : null;
        $this->size   = isset($data['size']) ? $data['size'] : null;
    }


    public function getCount()
    {
        return $this->count;
    }


    public function getNumber()
    {
        return $this->number;
    }


    public function getSize()
    {
        return $this->size;
    }
}