<?php
namespace hji\membership\models\webservice\abstracts;


abstract class QueryProperties
{
    private $propertiesMap = array();


    public function __construct()
    {
        $this->_setPropertiesMap();
    }


    public function set($property, $value = null)
    {
        if ($this->hasProperty($property))
        {
            $lowerCase = strtolower($property);
            $property = $this->propertiesMap[$lowerCase];
            $this->$property = $value;
        }
    }


    public function get($property)
    {
        if ($this->hasProperty($property))
        {
            $lowerCase = strtolower($property);
            $property = $this->propertiesMap[$lowerCase];
            return $this->$property;
        }
    }


    public function getAll()
    {
        $properties = array();

        foreach ($this->propertiesMap as $property)
        {
            $properties[$property] = $this->$property;
        }

        return $properties;
    }


    public function hasProperty($property)
    {
        $lowerCase = strtolower($property);

        return isset($this->propertiesMap[$lowerCase]);
    }


    protected function _setPropertiesMap()
    {
        $class = new \ReflectionClass($this);
        $properties = $class->getProperties(\ReflectionProperty::IS_PROTECTED);
        $parentProperties = $class->getParentClass()->getProperties(\ReflectionProperty::IS_PROTECTED);

        $properties = array_merge($properties, $parentProperties);

        $this->propertiesMap = array();

        if (!empty($properties))
        {
            foreach ($properties as $property)
            {
                $this->propertiesMap[strtolower($property->getName())] = $property->getName();
            }
        }
    }

}