<?php

namespace hji\membership\services;


use hji\membership\abstracts\Component;
use hji\membership\services\registries\CustomPostTypeRegistry;
use ReflectionClass;


class Registry extends Component
{
    const CPT_REGISTRY = CustomPostTypeRegistry::class;


    public function register($registryName, $objects)
    {
        if ($registry = $this->resolve($registryName))
            return $registry->register($objects);

        return;
    }


    public function resolve($registryName)
    {
        $oClass = new ReflectionClass(__CLASS__);
        $registries = $oClass->getConstants();

        if (array_search($registryName, $registries))
        {
            return $this->di()->create($registryName);
        }

        throw new \Exception("Registry with name \"$registryName\" could not be resolved.");
    }
}