<?php

namespace hji\membership\utils;

use hji\membership\Membership;
use hji\membership\models\compliances\ComplianceBase;

class ComplianceGuard
{
    /**
     * @return bool
     */
    public static function isNeededResponsiveIDXCompilance()
    {
        return !is_plugin_active('hji-blvd-framework/BlvdBase.php');
    }

    /**
     * @param $marketsAvailable
     *
     * @return bool
     */
    public static function isTexasCompilance($marketsAvailable)
    {
        $compliance = new ComplianceBase();
        $texasMarketsRequirements = $compliance->getTexasMarketsRequirements();

        foreach ($marketsAvailable as $market) {
            if (isset($texasMarketsRequirements[$market])) {

                return true;
            }
        }

        return false;
    }

    /**
     * @param $marketsAvailable
     *
     * @return bool
     */
    public static function isNwmlsCompliance($marketsAvailable)
    {
        $compliance = new ComplianceBase();
        $texasMarketsRequirements = $compliance->getNwmlsMarketsRequirements();

        foreach ($marketsAvailable as $market) {
            if (isset($texasMarketsRequirements[$market])) {

                return true;
            }
        }

        return false;
    }

    /**
     * @param $marketsAvailable
     *
     * @return bool
     */
    public static function isNnerenCompliance($marketsAvailable)
    {
        $compliance = new ComplianceBase();
        $texasMarketsRequirements = $compliance->getNnerenMarketsRequirements();

        foreach ($marketsAvailable as $market) {
            if (isset($texasMarketsRequirements[$market])) {

                return true;
            }
        }

        return false;
    }

    /**
     * @param $marketsAvailable
     *
     * @return bool
     */
    public static function isCompilanceExist($marketsAvailable)
    {
        $compliance = new ComplianceBase();
        $texasMarketsRequirements = $compliance->getMarketsRequirements();

        foreach ($marketsAvailable as $market) {
            if (isset($texasMarketsRequirements[$market])) {

                return true;
            }
        }

        return false;
    }
}
