<?php
namespace hji\common\interfaces;


class WidgetShortcode extends Shortcode
{
    function __construct(\WP_Widget $widget, $shortcodeName = null)
    {
        $this->widget = $widget;

        $shortcodeName = ($shortcodeName) ? $shortcodeName : $widget->id_base;

        if ($widget::$supportedFields)
        {
            parent::__construct($shortcodeName, $widget::$supportedFields);
        }
        else
        {
            parent::__construct($shortcodeName);
        }
    }

    /**
     * Renders shortcode's content
     *
     * @param array $params shortcode attributes (key/value pairs)
     * @return mixed
     */
    function render($params = array())
    {
        return $this->widget->getWidgetContent(array(), $params);
    }
}