

/** common.js loaded by main.js (DO NOT enqueue into WP) **/
hji.define(['require', 'jquery', 'underscore', 'backbone'], function (require, $, _, Backbone) {
  var _selectors = ['[data-init]', '[data-lookup]'];
  var $elements = $(_selectors.join(','));

  if ($('[data-init="marketReport"]').length) {
    require(['hji-common/national']);
  }

  $('#idx-register-login').on('hidden.bs.modal', function () {
    $('#idx-register-login form').each(function () {
      this.reset();
    });
    $('#idx-register-login .ajax-message').html('');
  });

  function initDataLookups() {
    /**
     * Area Lookup Selector
     */
    var polygonFields = $('[data-lookup="polygon"]');
    var lookupFields = $('[data-lookup][data-market]');

    if (polygonFields.length) {
      require(['hji-common/_lookupArea'], function () {
        polygonFields.lookupArea();
      });
    }

    require(['hji-common/_lookup'], function () {
      lookupFields.each(function () {
        if ($(this).data('lookup') != 'polygon') {
          $(this).dataLookup();
        }
      });
    });
  }

  initDataLookups(); // Even listener to re-initialize data lookups
  // especially useful when content refreshed via ajax (like in Widgets Dashboard)

  $(document).on('initDataLookups', function () {
    initDataLookups();
  });

  require(['hji-common/modal/modals'], function (modals) {
    modals.initModals();
    HJI.modals = modals;
  });

  require(['hji-common/tabsRefresh']); // Loads a polyfill for CSS object-fit
  // object-fit is used for image centering


  if (!('object-fit' in document.body.style)) {
    require(['object-fit-images-polyfill'], function () {
      objectFitImages();
    });
  } // image lazy loading


  require(['hji-common/unveil'], function () {
    $("img[data-src]").unveil(800, function () {
      // callback checks to see if we've included our object-fit polyfill
      // if so we need to re-run the polyfill against the newly loaded image
      if (typeof objectFitImages == 'function') {
        objectFitImages();
      }
    });
  });

  var $streetViewEl = $('[data-init="streetview"]');

  if ($streetViewEl.length) {
    require(['hji-common/streetView'], function () {
      $streetViewEl.streetView({
        wrapperSelector: '.street-view-wrap'
      });
    });
  }

  var $gmapEl = $('[data-init="gmap"]');
  if ($gmapEl.length) require(['hji-common/map/widget'], function () {
    return $gmapEl.gMap();
  });

  $.fn.hjiComponentInit = function () {
    var $el = $(this),
        component = $(this).data('init'),
        options = $(this).data() || {};
    var componentName = 'hji-common/' + component;
    HJI.log('Found Component ' + componentName + ' ');

    if (componentName.includes('widgets') || componentName.includes('colorbox')) {
      try {
        require([componentName], function (Component) {
          var component;

          try {
            component = new Component();
          } catch (error) {
            HJI.log('Component ' + componentName + ' is not constructable.');
          }

          if (component) component.init($el, options);
        });
      } catch (error) {
        HJI.log('ERROR: ' + componentName);
      }
    }
  };

  $elements.each(function () {
    if ($(this).data('init')) {
      $(this).hjiComponentInit();
    }
  });
});