

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

hji.define(function (require) {
  var $ = require('jquery'),
      _ = require('_'),
      api = require('hji-common/slipstream/api'),
      LocationInput = require('hji-common/lookup/locationInput'),
      getUrlParam = require('hji-common/getUrlVar');

  require('hji-common/selectize');

  $.fn.lookupArea = function (options) {
    return this.each(function () {
      var settings = $.extend({
        type: null,
        polygon: null,
        market: null,
        getArea: false,
        areaBias: HJI.commonVar('areaBias') || 'postal-city',
        callback: false,
        polynamesTarget: null
      }, options),
          $this = $(this),
          valueField = 'name',
          notFound = [],
          locationInput;

      if (settings.type == null || settings.type == 'polygon') {
        // API doesn't accept type polygon, so we reset it to null
        settings.type = null; // We need polygon ID when looking up polygon

        valueField = 'id';
      } // Set market pointer to limit results to a given market


      if ($this.data('market') != undefined && $this.data('market') != '') {
        var pointers = $this.data('market').split(',').map(function (market) {
          return '@' + market;
        });
        settings.polygon = pointers.join(',');
      }

      if (settings.polynamesTarget == null) {
        if ($this.data('polynamesTarget') != undefined && $this.data('polynamesTarget') != '') {
          settings.polynamesTarget = $this.data('polynamesTarget');
        } else {
          settings.polynamesTarget = $this.parent().find('input.polynames')[0];
        }
      }

      function prepareSelectizeOptions() {
        return {
          plugins: ['remove_button'],
          delimiter: '|',
          valueField: valueField,
          labelField: 'name',
          searchField: ['name'],
          maxItems: 10,
          maxOptions: 100,
          loadThrottle: 300,
          //                options: [],
          optgroups: [{
            id: 'place',
            name: 'Place'
          }, {
            id: 'township',
            name: 'Township'
          }, {
            id: 'county',
            name: 'County'
          }, {
            id: 'neighborhood',
            name: 'Neighborhood'
          }, {
            id: 'zipcode',
            name: 'Zip Code'
          }, {
            id: 'school',
            name: 'School'
          }],
          optgroupField: 'type',
          optgroupLabelField: 'name',
          optgroupValueField: 'id',
          optgroupOrder: ['place', 'township', 'county', 'neighborhood', 'school', 'zipcode'],
          sortField: 'name',
          create: true,
          createOnBlur: true,
          render: {
            option_create: function option_create(data, escape) {
              return '<div class="create" style="display: none">Add <strong>' + escape(data.input) + '</strong>&hellip;</div>';
            },
            optgroup_header: function optgroup_header(data, escape) {
              return '<div class="optgroup-header">' + escape(data.name) + '</span></div>';
            },
            item: function item(data, escape) {
              if (data.name == data.id) {
                var location = locationInput.getLocation(data.id);
                if (location) data.name = location.name;
              }

              return '<div data-value="' + escape(data.id) + '" class="item">' + escape(data.name) + '</div>';
            },
            option: function option(item, escape) {
              var label = item.type == 'place' || item.type == 'township' ? item.name + ', ' + item.state : item.name;
              var caption = null;

              if (item.type == 'township') {
                caption = item.label;
              }

              if (item.type == 'school' && typeof item.address !== 'undefined') {
                if (typeof item.address.city !== 'undefined' && typeof item.address.state !== 'undefined') caption = item.address.city + ', ' + item.address.state;
              } else if (item.type != 'place' && typeof item.place != 'undefined' && typeof item.state != 'undefined') {
                caption = item.place + ', ' + item.state;
              }

              return '<div>' + '<span class="selectize-label">' + escape(label) + '</span>' + (caption ? '<span class="selectize-caption">' + escape(caption) + '</span>' : '') + '</div>';
            }
          },
          load: function load(query, callback) {
            var self = this;

            var sanitize = function sanitize(string) {
              var map = {
                '&': '&amp;',
                '<': '&lt;',
                '>': '&gt;',
                '"': '&quot;',
                "'": '&#x27;',
                "/": '&#x2F;'
              };
              var reg = /[&<>"'/]/ig;
              return string.replace(reg, function (match) {
                return map[match];
              });
            };

            query = sanitize(query);

            if (self.loading) {
              var searchingMessage = query.length >= 3 ? 'Searching for matches <strong>' + query + '</strong>&hellip;<span class="spinner"></span>' : 'Area name should be at least 3 letters.';
              var searching = '<div class="optgroup-header hji-searching">' + searchingMessage + '</div>';
              self.$dropdown_content.append(searching);
            }

            if (query.length < 3) return callback();
            var params = {
              keyword: query,
              geoType: settings.type || '',
              polygon: settings.polygon,
              pageSize: '10',
              limit: '10'
            };
            params = _.pick(params, function (v, k, o) {
              return !_.isEmpty(v);
            });
            searchAreasWithSchools(params).then(function (areas) {
              // prefix each id with $ character
              for (var i in areas) {
                if (areas[i].type !== 'school') {
                  areas[i].id = '$' + areas[i].id;
                }
              } // Return data to selectize


              callback(areas); // If auto-complete  field is not in focus

              if (!self.isFocused || $.inArray(query, self.items) !== -1) {
                // Remove user typed-in query from the field
                self.removeItem(query); // If matches exists

                if (areas.length) {
                  // Insert first match into the field
                  self.addItem(areas[0].id);
                } // If no matches
                else {
                    // Tell user that such area doesn't exist
                    //alert('Area ' + query + ' is not found. Please try a different search.');
                    notFound.push(query);
                  }
              } // Remove user typed-in query from suggestion list


              self.removeOption(query);
              setTimeout(function () {
                if (!areas.length) {
                  var timer = 3000;
                  self.$dropdown_content.find('.hji-searching').html('Location "' + query + '" was not found.').css('color', 'red').fadeOut(timer);
                  setTimeout(function () {
                    self.setActiveOption(null);
                    self.close();
                    self.removeItem(query);
                  }, timer);
                } else {
                  self.$dropdown_content.find('.hji-searching').slideUp();
                }
              }, 100); // Clearing results on each search.
              // This also clears previous selection,
              // which doesn't work for us.
              // We want to be able to make multiple searches
              // and select items from each search.
              // We need to clear previous selection options in
              // in dropdown list, but not the actual selections.
              //self.clearOptions();
              //self.refreshOptions();

              setTimeout(function () {
                if (!notFound.length) return;

                if (!self.loading) {
                  var _areas = notFound.length > 1 ? 'Areas' : 'Area';

                  alert(_areas + ' "' + notFound.join(', ') + '" not found. Please try different location.');
                  notFound = [];
                }
              }, 300);
            });
          },
          onItemAdd: function onItemAdd(value, $item) {
            var self = this,
                firstChar = value.substring(0, 1),
                name = $item[0].firstChild.nodeValue,
                deleted = locationInput.locations.isDeleted(value); // Do not add items less than 3 char long

            if (value.length < 3) {
              self.removeItem(value);
              self.removeOption(value);
            } // Check if value is a $ prefixed polygon ID


            if (deleted) {
              locationInput.addLocation(deleted);
            } else if (firstChar == '$') {
              locationInput.addLocation({
                id: value,
                name: name
              });
            } else {
              var schoolId = value;
              findBestAttendanceArea(schoolId).then(function (area) {
                var id = '$' + area.id;
                $item.attr('data-value', id);
                locationInput.addLocation({
                  id: id,
                  name: name,
                  school: schoolId
                });
                processAreaData(area, settings.callback);
              })["catch"](function (data) {
                api.ready(function (API) {
                  API.call('/ws/schools/get', {
                    id: schoolId
                  }).done(function (response, xhr) {
                    if (response.success == true && response.result.schools.length) {
                      var lat = response.result.schools[0].coordinates.latitude;
                      var lng = response.result.schools[0].coordinates.longitude;
                      locationInput.addLocation({
                        id: schoolId,
                        name: name,
                        type: 'school',
                        ll: "".concat(lat, ",").concat(lng),
                        r: 2
                      });
                    }
                  });
                });
              });
            }
          },
          onItemRemove: function onItemRemove(id) {
            locationInput.removeLocation(id);
          },
          onBlur: function onBlur() {
            var polygonIDs = this.$input.val().length ? this.$input.val().trim().split('|') : [];
            var lastValue = polygonIDs.length > 0 ? polygonIDs[polygonIDs.length - 1] : null; // If user left the input field before location was selected
            // automatically select first match

            if (!locationInput.getLocation(lastValue)) {
              var s = this;
              var query = polygonIDs[polygonIDs.length - 1]; // Check if looked up items array is not empty

              if (s.currentResults.items.length) {
                // Perform a search to order array of items by match score,
                // otherwise it's not ordered correctly.
                var result = s.search(query); // If match found, add it to selectize field and submit the form

                if (result.items.length && $.inArray(query, s.items) !== -1) {
                  // Remove user typed-in query from the field
                  s.removeItem(query); // Insert first match into the field

                  s.addItem(result.items[0].id); //Remove user typed-in query from suggestion list

                  s.removeOption(query);
                }
              } else {
                // Remove query from the field
                s.removeItem(query);
              }
            }
          }
        };
      }

      ;

      var searchAreasWithSchools = function searchAreasWithSchools(parameters) {
        return new Promise(function (resolve, reject) {
          var request = [],
              params;
          request = request.concat(_toAreaRequest(parameters), _toSchoolsRequest(parameters));
          params = {
            request: JSON.stringify(request)
          };
          api.ready(function (API) {
            API.call('/ws/api/call', params).done(function (response, xhr) {
              if (response.success == true) {
                var i;

                (function () {
                  var collection = [];

                  for (i in response.result.responses) {
                    var r = response.result.responses[i];

                    if (r.success) {
                      if (r.result.areas) {
                        _.each(r.result.areas, function (area) {
                          collection.push(area);
                        });
                      }

                      if (r.result.schools) {
                        _.each(r.result.schools, function (school) {
                          var item = Object.assign({
                            type: 'school'
                          }, school);
                          collection.push(item);
                        });
                      }
                    }
                  }

                  _.sortBy(collection, 'name');

                  resolve(collection);
                })();
              } else {
                reject(response.error.message);
              }
            });
          });
        });
      };

      var findBestAttendanceArea = function findBestAttendanceArea(schoolId) {
        return new Promise(function (resolve, reject) {
          api.ready(function (API) {
            API.call('/ws/schools/attendance-areas/search', {
              school: schoolId,
              bestMatch: 'mostGrades',
              geometry: true
            }).done(function (response, xhr) {
              if (response.success == true) {
                resolve(response.result['attendance-areas'][0]);
              } else {
                reject({
                  schoolId: schoolId
                });
              }
            });
          });
        });
      };

      var _toAreaRequest = function _toAreaRequest(params) {
        var request = [],
            geoTypes = [],
            parameters = Object.assign({
          bias: settings.areaBias
        }, params);

        if (isNaN(parameters.keyword)) {
          // In cases where only one type postal/census place is available,
          // it is important to pass both geoTypes + bias, otherwise we may get no cities back.
          // The bias will make sure there are no duplicate areas returned in case both geoTypes exist.
          geoTypes = geoTypes.concat(['area/postal-city,area/census-place', 'area/township', 'area/county', 'area/neighborhood']);
        } else {
          geoTypes = ['area/zipcode'];
        }

        _.each(geoTypes, function (geoType) {
          request.push({
            uri: '/ws/areas/search',
            parameters: Object.assign({
              geoType: geoType
            }, parameters)
          });
        });

        return request;
      };

      var _toSchoolsRequest = function _toSchoolsRequest(parameters) {
        var request = [];

        if (isNaN(parameters.keyword)) {
          request.push({
            uri: '/ws/schools/search',
            parameters: {
              name: parameters.keyword,
              polygon: parameters.polygon,
              pageSize: 10,
              limit: 10
            }
          });
        }

        return request;
      };

      function selectizeThis($obj, options) {
        if ($obj.length && _typeof($obj) == 'object') {
          if ($obj[0].selectize) $obj[0].selectize.destroy();
          $obj.selectize(options); // Dirty hack to stop Chrome from forcing auto-completions since autocomplete=off no longer works

          $obj[0].selectize.$control_input.prop('autocomplete', 'new-password');
          return $obj;
        }
      }

      var getArea = function getArea(areaId, callback) {
        var id = areaId.replace('$', ''),
            params = {
          id: id,
          details: 1,
          geometry: 1
        };
        api.ready(function (API) {
          API.call('/ws/areas/get', params).done(function (response, xhr) {
            if (response.success === true) {
              processAreaData(response.result.areas[0], callback);
            }
          });
        });
      };

      var processAreaData = function processAreaData(data, callback) {
        var coords = data.geometry.coordinates ? data.geometry.coordinates : false;
        var result = data;
        var polygons = [];

        if (coords) {
          for (var n in coords) {
            var val = coords[n];
            var polygon = [];

            for (var x in val[0]) {
              polygon.push(val[0][x][0] + ' ' + val[0][x][1]);
            }

            polygons.push(polygon);
          }

          result.polygon = polygons;
        }

        if (typeof callback == 'function') {
          callback(result);
        }
      };
      /**
       * Very bad and dirty way to get pre-set parameters for the location field
       * In a perfect world, whatever uses the component would set value on it directly
       *
       * @private
       */


      var _getSearchParam = function _getSearchParam(parameter) {
        var result = null;

        var getParam = function getParam(parameter) {
          if (HJI.rIDX) {
            var _$qsw = $this.closest('[class*="checksum-"]'),
                checksum = null;

            if (_$qsw.length) {
              var checksumClass = _$qsw.attr('class').match(/checksum-([A-Za-z0-9]+)\b/g);

              if (checksumClass) {
                checksum = checksumClass[0].split('-')[1];
                return HJI.rIDX.getSearchParam(parameter, checksum);
              }
            }
          }

          var query = getUrlParam(parameter);
          return query ? query : null;
        }; // Since it may take take for rIDX to get loaded,
        // we set a small delay in case it needs it


        return new Promise(function (resolve, reject) {
          var n = 0,
              interval;
          interval = setInterval(function () {
            ++n;

            if (HJI.hasOwnProperty('rIDX') || n > 4) {
              clearInterval(interval);
              resolve(getParam(parameter));
            }
          }, 25);
        });
      };

      var locations = _getSearchParam('location'),
          polynames = _getSearchParam('polynames');

      return Promise.all([locations, polynames]).then(function (values) {
        locationInput = new LocationInput($this, {
          locations: JSON.parse(values[0]),
          polynames: values[1],
          polynamesTarget: settings.polynamesTarget
        });
        if (settings.getArea === true && typeof settings.callback === 'function') locationInput.onAddLocation(function (location) {
          return getArea(location.id, settings.callback);
        });
        return locationInput.setup().then(function () {
          return new selectizeThis($this, prepareSelectizeOptions());
        });
      });
    });
  };
});