

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

hji.define(['require', 'jquery', 'underscore', './addressLookupInterface', 'hji-common/slipstream/api', 'hji-common/selectize'], function (require, $, _, AddressLookupInterface) {
  var _helper;

  var SlipstreamAddressLookup = /*#__PURE__*/function (_AddressLookupInterfa) {
    _inherits(SlipstreamAddressLookup, _AddressLookupInterfa);

    function SlipstreamAddressLookup(el, options) {
      var _this;

      _classCallCheck(this, SlipstreamAddressLookup);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(SlipstreamAddressLookup).call(this, el, options));

      _this.init();

      return _this;
    }

    _createClass(SlipstreamAddressLookup, [{
      key: "init",
      value: function init() {
        var _this2 = this;

        var that = this,
            api = require('hji-common/slipstream/api'),
            initAddressLookup = function initAddressLookup(options) {
          return $(_this2.el).selectize(options);
        };

        api.ready(function (API) {
          var cache = {},
              options = {
            valueField: 'label',
            labelField: 'label',
            selectOnTab: true,
            options: [],
            create: false,
            highlight: false,
            // there's a highlighting bug in selectize
            persist: false,
            maxItems: 1,
            maxOptions: 5,
            loadThrottle: 50,
            diacritics: false,
            score: function score(search) {
              return function () {
                return 100;
              };
            },
            load: function load(query, callback) {
              var that = this,
                  trimmed = query.trim(),
                  lcQuery = query.toLowerCase(),
                  matchParams = {
                term: query,
                center: _helper.marketCenter(),
                limit: 5
              };
              this.setActiveOption(null);

              if (_.has(cache, lcQuery)) {
                that.clearOptions();
                return callback(cache[lcQuery]);
              }

              if (trimmed.length < 3 || this.currentResults.query != query && this.currentResults.query == trimmed) {
                return callback();
              }

              API.call('/ws/addresses/match', matchParams).done(function (data, xhr) {
                if (data.success !== true) {
                  return callback();
                } else {
                  // Cache results for repeat searches
                  cache[lcQuery] = data.result.matches;

                  if (!that.isFocused || $.inArray(query, that.items) !== -1) {
                    if (data.result.matches.length) {
                      // Insert first match into the field
                      that.addItem(data.result.matches[0]);
                      that.setActiveOption(that.getOption(data.result.matches[0].label)); // return;
                    }
                  } else {
                    that.clearOptions();
                  }

                  return callback(data.result.matches);
                }
              });
            },
            onItemAdd: function onItemAdd(value, $item) {
              if (_.has(this.options, value)) that.validateAddress(this.options[value]);
            }
          };
          initAddressLookup(options);
        });
      }
    }, {
      key: "validateAddress",
      value: function validateAddress(address) {
        var _this3 = this;

        var api = require('hji-common/slipstream/api');

        api.ready(function (API) {
          var params = {
            deliveryLine: null,
            city: null,
            state: null
          };

          _.extendOwn(params, address);

          var response = API.call('/ws/addresses/standardize', params);
          response.done(function (data, xhr) {
            if (data.success !== true) {
              _this3.addressInvalid(false);
            } else {
              if (data.result.hasOwnProperty('coordinates')) {
                _this3.addressValid(_helper.getAddress(data.result));
              } else {
                // Geocode if coordinates not returned within the address
                API.call('/ws/addresses/geocode', data.result.address).done(function (data, xhr) {
                  _this3.addressValid(_helper.getAddress(data.result));
                });
              }
            }
          });
        });
      }
    }, {
      key: "getValue",
      value: function getValue() {
        return $(el).val();
      }
    }]);

    return SlipstreamAddressLookup;
  }(AddressLookupInterface);
  /**
   * Object with helper methods
   *
   * @type {{getAddress: ((address))}}
   * @private
   */


  _helper = {
    getAddress: function getAddress() {
      var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var address = {
        deliveryLine: null,
        street: null,
        city: null,
        state: null,
        zip: null,
        lat: null,
        lng: null
      };
      var _ref = [obj.address, obj.coordinates],
          _ref$ = _ref[0],
          addr = _ref$ === void 0 ? {} : _ref$,
          _ref$2 = _ref[1],
          coord = _ref$2 === void 0 ? {} : _ref$2;
      address.deliveryLine = addr.deliveryLine || null;
      address.street = addr.deliveryLine || null;
      address.city = addr.city || null;
      address.state = addr.state || null;
      address.zip = addr.zip || null;
      address.lat = coord.latitude || null;
      address.lng = coord.longitude || null;
      return address;
    },
    marketCenter: function marketCenter() {
      var markets = HJI.commonVar('markets'),
          marketsList = _.keys(HJI.commonVar('markets'));

      if (marketsList.length) {
        var centroid = markets[marketsList[0]].centroid;
        return centroid.latitude + ':' + centroid.longitude;
      }

      return null;
    }
  };
  return SlipstreamAddressLookup;
});