

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

hji.define(['require', 'jquery', './addressLookupInterface'], function (require, $, AddressLookupInterface) {
  var gAddressLookup = /*#__PURE__*/function (_AddressLookupInterfa) {
    _inherits(gAddressLookup, _AddressLookupInterfa);

    function gAddressLookup(el, options) {
      var _this;

      _classCallCheck(this, gAddressLookup);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(gAddressLookup).call(this, el, options));

      _this.init();

      return _this;
    }

    _createClass(gAddressLookup, [{
      key: "init",
      value: function init() {
        var _this2 = this;

        var callback = function callback(address) {
          return _this2.validateAddress(address);
        },
            el = this.el;

        require(['hji-common/gMapsApi'], function (GoogleMapsLoader) {
          var autocomplete;
          var componentForm = {
            street_number: 'short_name',
            route: 'long_name',
            locality: 'long_name',
            sublocality_level_1: 'long_name',
            administrative_area_level_1: 'short_name',
            country: 'long_name',
            postal_code: 'short_name'
          };
          var hashmap = {
            street: '{street_number} {route}',
            sublocality: '{sublocality_level_1}',
            city: '{locality}',
            state: '{administrative_area_level_1}',
            zip: '{postal_code}'
          };
          var result = {
            street: null,
            city: null,
            sublocality: null,
            state: null,
            zip: null,
            lat: null,
            lng: null
          };

          (function pacSelectFirst(input) {
            // store the original event binding function
            var _addEventListener = input.addEventListener ? input.addEventListener : input.attachEvent;

            function addEventListenerWrapper(type, listener) {
              // Simulate a 'down arrow' keypress on hitting 'return' when no pac suggestion is selected,
              // and then trigger the original listener.
              if (type == "keydown") {
                var orig_listener = listener;

                listener = function listener(event) {
                  var suggestion_selected = $(".pac-item-selected").length > 0;

                  if ((event.which == 13 || event.which == 9) && !suggestion_selected) {
                    var simulated_downarrow = $.Event("keydown", {
                      keyCode: 40,
                      which: 40
                    });
                    orig_listener.apply(input, [simulated_downarrow]);
                  }

                  orig_listener.apply(input, [event]);
                };
              } // add the modified listener


              _addEventListener.apply(input, [type, listener]);
            }

            if (input.addEventListener) {
              input.addEventListener = addEventListenerWrapper;
            } else if (input.attachEvent) {
              input.attachEvent = addEventListenerWrapper;
            }
          })(el);

          function initialize() {
            // Create the autocomplete object, restricting the search
            // to geographical location types.
            autocomplete = new google.maps.places.Autocomplete(
            /** @type {HTMLInputElement} */
            el, {
              types: ['geocode']
            }); // When the user selects an address from the dropdown,
            // populate the address fields in the form.

            google.maps.event.addListener(autocomplete, 'place_changed', function () {
              var address = getAddress();

              if (typeof callback == 'function') {
                return callback(address);
              }
            });
          }

          function getHashmap() {
            return $.extend({}, hashmap);
          }

          function getResult() {
            return $.extend({}, result);
          }

          function getAddress() {
            var address = {
              street: null,
              city: null,
              state: null,
              zip: null,
              lat: null,
              lng: null
            };
            var place = autocomplete.getPlace(); // Get the place details from the autocomplete object.

            var _hashmap = getHashmap();

            var _result = getResult();

            if (!place.hasOwnProperty('address_components')) return false; // Get each component of the address from the place details
            // and replace hashmap tokens

            for (var i = 0; i < place.address_components.length; i++) {
              var addressType = place.address_components[i].types[0];

              if (componentForm[addressType]) {
                var val = place.address_components[i][componentForm[addressType]];

                for (var x in _hashmap) {
                  if (_hashmap[x].indexOf(addressType) > -1) {
                    _hashmap[x] = _hashmap[x].replace('{' + addressType + '}', val);
                  }
                }
              }
            } // Clear out remaining tokens, that didn't find their match


            for (var i in _hashmap) {
              // Only map if value is not a token
              if (_hashmap[i].indexOf('{') == -1) {
                _result[i] = _hashmap[i];
              }
            } // Map latitude and longitude to the result


            if (place.geometry) {
              _result.lat = place.geometry.location.lat();
              _result.lng = place.geometry.location.lng();
            } // Map result values to the properties of the address object


            for (var i in _result) {
              if (typeof address[i] != 'undefined') {
                address[i] = _result[i];
              }
            } // Map result sublocality (if defined) to the city property of the address object


            if (_result.sublocality) {
              address.city = _result.sublocality;
            } // Add Google's original Place object to the address


            address.g = {
              place: place
            };
            return address;
          } // Initialize autoLookup only when Google API is loaded


          GoogleMapsLoader.done(function () {
            initialize();
          });
        });
      }
    }, {
      key: "validateAddress",
      value: function validateAddress(address) {
        if (!address.street || !address.city || !address.state) {
          this.addressInvalid(address);
        } else {
          this.addressValid(address);
        }
      }
    }, {
      key: "getValue",
      value: function getValue() {
        return $(el).val();
      }
    }]);

    return gAddressLookup;
  }(AddressLookupInterface);

  return gAddressLookup;
});