

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define(['require', 'jquery', 'underscore', './addressLookup', './gAddressLookup'], function (require, $, _, SlipstreamAddressLookup, GoogleAddressLookup) {
  /**
   * Self-contained Address Lookup Widget
   *
   * Auto-complete street address selector.
   *
   * Usage:
   *      new LookupWidget($('input#target')[0])
   *          .onSelect(function(address){ console.log(address); });
   *
   *      // Google API
   *      new LookupWidget($('input#target')[0], {google: true})
   *          .onSelect(function(address){ console.log(address); });
   *
   * Available Events:
   *      onSelect(function(address){ console.log(address); });
   *      onError(function(error){ console.log(error); });
   */
  var LookupWidget = /*#__PURE__*/function () {
    function LookupWidget(el) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      _classCallCheck(this, LookupWidget);

      this.$error = null, this.el = el, this.options = options, this.addressLookup;

      if (this.options.hasOwnProperty('google') && this.options.google == true) {
        this.addressLookup = new GoogleAddressLookup(this.el, this.options);
      } else {
        this.addressLookup = new SlipstreamAddressLookup(this.el, this.options);
      }

      $(this.el)[0]['addressLookupWidget'] = this;

      this._init();
    }

    _createClass(LookupWidget, [{
      key: "_init",
      value: function _init() {
        var _this = this;

        this.addressLookup.onError(function (message) {
          return _this.renderError(message);
        }); // Remove any rendered error messages if user made another selection

        this.onSelect(function () {
          return _this.clearError();
        });
      }
    }, {
      key: "onSelect",
      value: function onSelect(callback) {
        this.addressLookup.onSelect(function (data) {
          return callback(data);
        });
        return this;
      }
    }, {
      key: "onError",
      value: function onError(callback) {
        this.addressLookup.onError(function (data) {
          return callback(data);
        });
        return this;
      }
    }, {
      key: "renderError",
      value: function renderError(message) {
        var _this2 = this;

        if (!this.$error) {
          this.$error = $('<div class="address-error"></div>').css({
            'padding': '0.5em',
            'color': 'red'
          }).hide();
          this.$error.text(message).appendTo($(this.el).parent()).slideDown('slow');
          setTimeout(function () {
            return _this2.clearError();
          }, 5000);
        }
      }
    }, {
      key: "clearError",
      value: function clearError() {
        if (!this.$error) return;
        this.$error.slideUp('slow', function () {
          $(this).remove();
        });
        this.$error = null;
      }
    }, {
      key: "getValue",
      value: function getValue() {
        return this.addressLookup.getValue();
      }
    }]);

    return LookupWidget;
  }();

  return LookupWidget;
});