

hji.define(['require', 'jquery', 'hji-common/isMobile', 'bxslider', 'hji-common/unveil'], function (require, $, isMobile) {
  var cssUrl = require.toUrl('hji-membership/third-party/bxslider/jquery.bxslider.css');

  var touchEnabled = !!isMobile.any();

  var bxSlider = function bxSlider() {
    var $this;
    var slider;
    var settings;
    var __obj = {
      start: function start(obj) {
        $this = $(obj);
        slider = $this.bxSlider(this.getOptions());
      },
      onLoad: function onLoad() {
        $this.trigger('bxSliderLoaded');
        $this.hide().css({
          'visibility': 'visible'
        }).fadeIn(400);
        $this.find('img[data-src]').unveil();
      },
      getOptions: function getOptions() {
        var that = this;
        settings = $.extend({
          speed: $this.data('speed'),
          maxSlides: $this.data('maxslides'),
          slideMargin: 10,
          moveSlides: $this.data('moveslides'),
          infiniteLoop: true
        }, $this.data());

        if (!settings.maxSlides) {
          settings.maxSlides = this.calculateMaxSlides(settings);
        }

        if (!settings.moveSlides) {
          settings.moveSlides = parseInt(settings.maxSlides) - 1;
        }

        var options = $.extend({
          speed: 1500,
          slideWidth: this.getSlideWidth(settings.maxSlides),
          minSlides: 1,
          moveSlides: 0,
          startSlide: 0,
          auto: false,
          pause: 4000,
          autoHover: true,
          adaptiveHeight: true,
          pager: false,
          easing: 'swing',
          useCSS: true,
          touchEnabled: touchEnabled,
          onSliderLoad: function onSliderLoad(currentIndex) {
            var $sliderImgs = $this.find('img[data-src]');

            for (var i in $sliderImgs) {
              var $selector = $sliderImgs.eq(i);
              if (!$selector.length) break;
              var src = $selector[0].src;
              var data_src = $selector.attr('data-src');

              if (src == data_src) {
                continue;
              }
            }

            that.onLoad();
          }
        }, settings);
        return options;
      },
      getSlideWidth: function getSlideWidth(quantity) {
        var viewPortWidth = $(window).width();
        var sliderWidth = $this.outerWidth(); // Adjust slider width based on viewPort
        // and current wrapper's width.

        if (sliderWidth < 820 && sliderWidth > 780 && quantity == 4) {
          return this.calculateSlideWidth(3, sliderWidth);
        } else if (viewPortWidth > 560 && viewPortWidth < 800 && quantity > 2) {
          return this.calculateSlideWidth(2, sliderWidth);
        } else if ($(window).width() <= 480) {
          return this.calculateSlideWidth(1, sliderWidth);
        } else {
          return this.calculateSlideWidth(quantity, sliderWidth);
        }
      },
      calculateSlideWidth: function calculateSlideWidth(numSlides, sliderWidth) {
        var itemsPadding = 0; // cumulative padding of items within one slide

        if (settings.slideMargin > 0) {
          itemsPadding = numSlides * settings.slideMargin - settings.slideMargin;
        }

        return (sliderWidth - itemsPadding) / numSlides;
      },
      calculateMaxSlides: function calculateMaxSlides(settings) {
        var maxSlides;
        var $imgs = $this.find('img');
        var totalWidth = 0,
            imgWidth = 0,
            sliderWidth = $this.innerWidth(); // Calculate total width of all images

        $imgs.each(function () {
          totalWidth += parseInt($(this).outerWidth());
        }); // Get average width of an image

        imgWidth = Math.ceil(totalWidth / $imgs.length); // Add margin if set in settings

        if (settings.slideMargin) {
          imgWidth = imgWidth + parseInt(settings.slideMargin);
        }

        maxSlides = Math.ceil(sliderWidth / imgWidth);
        return maxSlides;
      }
    };
    return __obj;
  };

  var sliders = $('[data-init="slider"]');

  if (sliders.length) {
    HJI.loadCss(cssUrl);
    sliders.each(function () {
      var slider = bxSlider();
      slider.start(this);
    });
  }

  $.each($('.bx-clone .ratio--content'), function (index) {
    var item = $(this);
    item.attr('data-rel', '');
    item.on('click', function (e) {
      e.preventDefault();
    });
  });
  return bxSlider;
});