

// https://gist.github.com/MattSurabian/7868115#file-google-maps-loader-js
var _gMapsApi = null;
hji.define(['require', 'jquery'], function (require, $) {
  if (!_gMapsApi) {
    _gMapsApi = {
      defer: $.Deferred(),
      load: function load(apiKey) {
        var that = this;

        if (!apiKey) {
          HJI.log('Google Maps API Key is not provided.\nPlease enter your Maps JavaScript API key into the HJI Membership settings. \nhttps://developers.google.com/maps/documentation/embed/get-api-key');
          return this.defer.reject({
            gMapsApiKey: false
          });
        }

        var url = window.location.protocol + '//maps.googleapis.com/maps/api/js?key=' + apiKey + '&libraries=drawing,places&callback=google_maps_loaded';

        require([url], function () {}, function (err) {
          that.defer.reject();
        });

        return this.defer.promise();
      },
      done: function done(callback) {
        if (typeof callback === 'function') {
          this.defer.promise().done(function () {
            return callback();
          });
        }
      },
      fail: function fail(callback) {
        if (typeof callback === 'function') {
          this.defer.promise().fail(function (arg) {
            return callback(arg);
          });
        }
      }
    };

    window.google_maps_loaded = function () {
      _gMapsApi.defer.resolve(google.maps);
    };
  }

  return _gMapsApi;
});