

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define(['jquery'], function ($) {
  var gMapsEmbedApi = /*#__PURE__*/function () {
    function gMapsEmbedApi(options) {
      _classCallCheck(this, gMapsEmbedApi);

      var defaults = {
        $el: null,
        q: null,
        center: {},
        zoom: 18,
        apiKey: null,
        callback: null
      };
      this.settings = Object.assign(defaults, options);
    }

    _createClass(gMapsEmbedApi, [{
      key: "renderMap",
      value: function renderMap() {
        if (validateSettings(this.settings)) {
          var src = "https://www.google.com/maps/embed/v1/place?key=".concat(this.settings.apiKey) + '&q=' + (this.settings.q || '') + "&center=".concat(this.settings.center.lat, ",").concat(this.settings.center.lng) + "&zoom=".concat(this.settings.zoom);
          var iframe = $('<iframe></iframe>');
          iframe.prop('frameborder', 0).css({
            border: 0
          }).prop('width', '100%').prop('height', '100%').prop('src', src);
          var $el = this.settings.$el instanceof $ ? this.settings.$el : $(this.settings.$el);
          $el.html(iframe);
          if (typeof this.settings.callback === 'function') this.settings.callback();
        }
      }
    }]);

    return gMapsEmbedApi;
  }();

  var validateSettings = function validateSettings() {
    var settings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (!settings.$el) {
      HJI.logError('Map could not be rendered. Target element to render map within is not provided.');
      return false;
    } else if (!settings.apiKey) {
      HJI.logError('Map could not be rendered. Google MapsEmbed API Key is not provided.');
      return false;
    } else if (!settings.q) {
      HJI.logError('Map could not be rendered. Property "q" is not defined.');
      return false;
    } else if (!settings.center) {
      HJI.logError('Map could not be rendered. Property "center" is not defined.');
      return false;
    } else if (_typeof(settings.center) !== 'object') {
      HJI.logError('Map could not be rendered. Property "center" expects and object: {lat, lng}.');
      return false;
    }

    return true;
  };

  return gMapsEmbedApi;
});