

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define(['jquery', 'underscore'], function ($, _) {
  var EventManager = /*#__PURE__*/function () {
    function EventManager(options) {
      _classCallCheck(this, EventManager);

      var settings = {
        target: null,
        namespaces: null,
        events: {}
      };
      this.settings = $.extend(settings, options);
      this.target = settings.target;
      this.namespace = settings.namespace;
      this.events = settings.events || {};
    }

    _createClass(EventManager, [{
      key: "registerEvents",
      value: function registerEvents(events) {
        try {
          if (_.isObject(events)) {
            for (var e in events) {
              this.registerEvent(e, events[e]);
            }
          } else {
            throw 'Unsupported argument type in EventManager.registerEvents(arg). Please pass object of event handlers to event names.';
          }
        } catch (e) {
          console.error(e);
        }
      }
    }, {
      key: "registerEvent",
      value: function registerEvent(eventHandler) {
        var eventName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        if (!eventName) eventName = eventHandler;
        this.events[eventName] = {
          'name': "".concat(this.namespace, "/").concat(eventName),
          'handler': eventHandler
        };
        HJI.log('Event registered: ' + eventName);
      }
    }, {
      key: "trigger",
      value: function trigger(eventName, data) {
        HJI.log('Event triggered: ' + eventName);
        HJI.log(data);

        if (this.events.hasOwnProperty(eventName)) {
          $(this.target).trigger(this.events[eventName].name, data);
        } else {
          console.error('Invalid event: ' + eventName + '.');
        }
      }
    }, {
      key: "listen",
      value: function listen(eventName, callback) {
        var event = this.events[eventName];
        $(this.target).on(event.name, function (e, data) {
          callback(data);
        });
      }
    }]);

    return EventManager;
  }();

  return EventManager;
});