

hji.define(function () {
  /**
   * Borrowed from: https://www.mattcromwell.com/detecting-mobile-devices-javascript/
   *
   * @type {{Android: isMobile.Android, BlackBerry: isMobile.BlackBerry, iOS: isMobile.iOS, Opera: isMobile.Opera, Windows: isMobile.Windows, any: isMobile.any}}
   */
  var isMobile = {
    Android: function Android() {
      return navigator.userAgent.match(/Android/i);
    },
    BlackBerry: function BlackBerry() {
      return navigator.userAgent.match(/BlackBerry/i);
    },
    iOS: function iOS() {
      return navigator.userAgent.match(/iPhone|iPad|iPod/i);
    },
    Opera: function Opera() {
      return navigator.userAgent.match(/Opera Mini/i);
    },
    Windows: function Windows() {
      return navigator.userAgent.match(/IEMobile/i);
    },
    any: function any() {
      return isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows();
    }
  };
  return isMobile;
});