

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define(function (require) {
  var Locations = require('./locations'),
      LocationInputUI = require('./locationInputUI'); // Polygon lookup requires a hidden field with ID polynames
  // present on the page. Selectize will save polygon names in it.


  var LocationInput = /*#__PURE__*/function () {
    function LocationInput($el, options) {
      _classCallCheck(this, LocationInput);

      if (!$el) throw new Error('Location input field failed to construct. Target element "$el" is not set.');
      if (!options) throw new Error('Location input field failed to construct. Options are not set.');
      this.settings = Object.assign({
        polygons: null,
        // string polygons value
        polynames: null,
        // string polynames value
        locations: null,
        // array of objects
        polynamesTarget: null // string - element selector

      }, options || {});
      this.$el = $el;
      this.locations = new Locations();
      this.ui = new LocationInputUI(this.$el, {
        polynames: this.settings.polynames,
        polynamesTarget: this.settings.polynamesTarget
      });
    }

    _createClass(LocationInput, [{
      key: "setup",
      value: function setup() {
        var self = this;
        this.ui.setup();

        var _hasLocations = function _hasLocations() {
          var locations = self.settings.locations;
          return Array.isArray(locations) && locations.length ? locations : self.ui.getValues();
        };

        var _setLocations = function _setLocations(collection) {
          var _bool = false;

          if (collection) {
            collection.forEach(function (location) {
              self.addLocation(location);
              _bool = true;
            });
          }

          return _bool;
        };

        return new Promise(function (resolve, reject) {
          _setLocations(_hasLocations());

          resolve(true);
        });
      }
    }, {
      key: "addLocation",
      value: function addLocation(obj) {
        var location = this.locations.add(obj);
        this.ui.updateInput(this.locations.all());
        this.ui.$polygons.trigger('location_added', location);
        return location;
      }
    }, {
      key: "onAddLocation",
      value: function onAddLocation(callback) {
        if (typeof callback === 'function') {
          this.ui.$polygons.on('location_added', function (location) {
            callback(location);
          });
        }
      }
    }, {
      key: "removeLocation",
      value: function removeLocation(id) {
        var location = this.locations.remove(id);

        if (location) {
          this.ui.$polygons.trigger('polygon_removed', {
            id: id,
            polygon: location
          });
        }

        this.ui.updateInput(this.locations.all());
      }
    }, {
      key: "getLocation",
      value: function getLocation(id) {
        return this.locations.get(id);
      }
    }]);

    return LocationInput;
  }();

  return LocationInput;
});