

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define(function (require) {
  var $ = require('jquery');
  /* istanbul ignore next */


  var _isAdmin = function _isAdmin() {
    return HJI ? HJI.commonVar('isAdmin') : false;
  };

  var ERR = {
    ELEMENT_NOT_SET: 'Location element "$el" is not set.',
    ELEMENT_NOT_JQUERY_OBJECT: 'Location element "$el" is not a jQuery object.',
    ELEMENT_NOT_IN_DOM: 'Location element "$el" does not exist in the DOM.'
  };

  var LocationInputUI = /*#__PURE__*/function () {
    function LocationInputUI($polygons, options) {
      _classCallCheck(this, LocationInputUI);

      this.$polygons = $polygons || null;
      this.$locations = null;
      this.$polynames = null;
      this._$container = null;
      this.settings = Object.assign({
        polynames: null,
        polynamesTarget: null
      }, options || {});
    }

    _createClass(LocationInputUI, [{
      key: "setup",
      value: function setup() {
        this._validateElement(this.$polygons);

        this._$container = this.$polygons.parent();
        this.$locations = this._initLocationsField();
        this.$polynames = this._initPolynamesField();
      }
      /**
       * Returns location values pre-set in the UI
       *
       * @return null || array - collection of location formatted objects
       */

    }, {
      key: "getValues",
      value: function getValues() {
        var locations = this.$locations.val().trim(),
            polygons = this.$polygons.val().trim(),
            polynames = this.$polynames.val().trim();
        /* istanbul ignore if */

        if (locations.length) {
          return JSON.parse(locations);
        } else if (polygons.length && polynames.length) {
          var ids = polygons.split('|'),
              names = polynames.split('|');
          return ids.map(function (id, i) {
            return Object.assign({}, {
              id: id,
              name: names[i]
            });
          });
        }

        return null;
      }
    }, {
      key: "updateInput",
      value: function updateInput(locations) {
        var self = this,
            ids = [],
            names = [],
            pipeIt = function pipeIt(arr) {
          return arr.length ? arr.join('|') : '';
        }; // Update $location value


        self.$locations.val(JSON.stringify(locations)); // Update $polygons & $polynames values

        if (locations.length) {
          locations.forEach(function (location) {
            ids.push(location.id);
            names.push(location.name);
          });
        }

        self.$polygons.val(pipeIt(ids));
        self.$polynames.val(pipeIt(names));
        self.$polynames.trigger('change');
        self.$polygons.trigger('polygon_input_updated');
      }
    }, {
      key: "_initLocationsField",
      value: function _initLocationsField() {
        // set location field if it's not defined
        var inputField = this._$container.find('.location');

        if (!inputField.length) {
          inputField = $("<input\n                        type=\"hidden\"\n                        autocomplete=\"off\"\n                        class=\"location\"\n                        name=\"location\"\n                        value=\"\"\n                    >").appendTo(this._$container);
        }

        if (_isAdmin() === true) {
          inputField.addClass('shortcode-value'); // Widgets dashboard requires fields to be prefixed with widget id

          var fieldName = this.$polygons.prop('name');
          if (fieldName.includes('widget')) inputField.prop('name', fieldName.replace('[polygon]', '[location]'));
        }

        return inputField;
      }
    }, {
      key: "_initPolynamesField",
      value: function _initPolynamesField() {
        var _this = this;

        var $el = this._$container.find(this.settings.polynamesTarget),
            createEl = function createEl() {
          // Inject polynames values only if polygon IDs are pre-populated
          // otherwise values won't correspond to each other and search will fail
          var polynames = _this.settings.polynames || '';
          return $("<input type=\"hidden\" \n                            autocomplete=\"off\" \n                            class=\"polynames\" \n                            name=\"polynames\" \n                            value=\"".concat(polynames, "\"\n                    >")).appendTo(_this._$container);
        };

        return $el.length ? $el : createEl();
      }
    }, {
      key: "_validateElement",
      value: function _validateElement($el) {
        var ERR = LocationInputUI._errors();

        if (!$el) throw new Error(ERR.ELEMENT_NOT_SET);
        if ($el instanceof $ !== true) throw new Error(ERR.ELEMENT_NOT_JQUERY_OBJECT);
        if (!document.contains($el[0])) throw new Error(ERR.ELEMENT_NOT_IN_DOM);
      }
    }], [{
      key: "_errors",
      value: function _errors()
      /* istanbul ignore next */
      {
        return ERR;
      }
    }]);

    return LocationInputUI;
  }();

  return LocationInputUI;
});