

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

hji.define(function (require) {
  var $ = require('jquery'),
      SlipstreamMap = require('./slipstream-map'),
      MapInterface = require('hji-common/map/mapInterface'),
      Coordinates = require('../models/coordinates');

  var MapBox = /*#__PURE__*/function (_MapInterface) {
    _inherits(MapBox, _MapInterface);

    function MapBox(options) {
      var _this;

      _classCallCheck(this, MapBox);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(MapBox).call(this, options));
      _this.featureGroup = null;
      _this.markersGroup = null;
      return _this;
    }

    _createClass(MapBox, [{
      key: "_styleMap",
      value: function _styleMap() {
        return [['strokeColor', 'stroke'], ['strokeWeight', 'stroke-width'], ['strokeOpacity', 'stroke-opacity'], ['fillColor', 'fill'], ['fillOpacity', 'fill-opacity']];
      }
    }, {
      key: "addMarkers",
      value: function addMarkers(markers) {
        var self = this,
            map = self.map.map,
            features = [];
        if (!self.markersGroup) self.markersGroup = L.featureGroup().addTo(map);
        markers.forEach(function (marker) {
          features.push({
            type: "Feature",
            properties: {
              description: marker.info || '',
              icon: marker.icon || null
            },
            geometry: {
              type: 'Point',
              coordinates: [marker.lng, marker.lat]
            }
          });
        });
        L.geoJson(features, {
          onEachFeature: function onEachFeature(feature, layer) {
            var icon = feature.properties.icon || self.icon || null;
            if (feature.properties.description) layer.bindPopup(feature.properties.description);
            if (icon) layer.setIcon(L.icon({
              iconUrl: icon
            }));
          }
        }).addTo(self.markersGroup); // map.fitBounds(self.markersGroup.getBounds());
      }
      /**
       * @param Coordinates coords
       * @param numeric radius
       * @param marker object with marker options
       */

    }, {
      key: "_addCircle",
      value: function _addCircle(coords, radius, markerOptions) {
        L.Circle = L.Circle.extend({
          toGeoJSON: function toGeoJSON() {
            return L.GeoJSON.getFeature(this, {
              type: 'Circle',
              coordinates: L.GeoJSON.latLngToCoords(this.getLatLng()),
              radius: this.getRadius()
            });
          }
        });
        var self = this,
            map = self.map.map;
        var coordinates = Object.values(coords);
        var circle = L.circle(coordinates, radius * 1609.344, L.mapbox.simplestyle.style({
          properties: self.style || {}
        })).on({
          click: function click(e) {
            return self.removeShape(e.target);
          }
        });
        circle.addTo(self.featureGroup); // Add feature object to the layer, so it's id accessible

        circle.feature = circle.toGeoJSON();
        circle.feature.properties = Object.assign(circle.feature.properties, markerOptions.object || {});

        this._addMarker(coords, markerOptions); // setTimeout(() => {
        //     map.fitBounds(self.featureGroup.getBounds());
        // },1000)


        return circle;
      }
      /**
       * https://www.mapbox.com/maki-icons/
       * @param coords
       * @param options
       * @returns {*}
       * @private
       */

    }, {
      key: "_addMarker",
      value: function _addMarker(coords, options) {
        var self = this,
            map = self.map.map;
        var coordinates = Object.values(coords);
        var marker = L.marker(coordinates, {
          title: (options || {}).title
        }).addTo(map);
        var symbol = (options || {}).symbol || {};
        var icon = (options || {}).icon || null;
        var info = (options || {}).info || null;

        if (symbol) {
          var _icon = L.mapbox.marker.icon(Object.assign({
            'marker-size': 'small',
            'marker-symbol': 'star',
            'marker-color': '#fa0'
          }, symbol));

          marker.setIcon(_icon);
        } else if (icon) {
          var img = new Image();
          img.src = icon; // reset icon size to 0, to avoid default icon flash

          marker.setIcon(L.icon({
            iconUrl: icon,
            iconSize: [0, 0]
          })); // reset image dimensions after image loads

          img.onload = function () {
            marker.setIcon(L.icon({
              iconUrl: icon,
              iconSize: [img.width, img.height],
              iconAnchor: [img.width / 2, img.height - 1],
              popupAnchor: [0, -img.height + 3]
            }));
          };
        }

        if (info) marker.bindPopup(info);
        return marker;
      }
    }, {
      key: "_addPolygons",
      value: function _addPolygons(polygons) {
        var self = this,
            map = self.map.map;

        if (polygons[0].geometry) {
          self._addGeoJson(polygons);
        } else {
          polygons.forEach(function (polygon) {
            return self._addPolygon(polygon);
          });
        } // map.fitBounds(self.featureGroup.getBounds());

      }
    }, {
      key: "_addPolygon",
      value: function _addPolygon(coords) {
        var self = this,
            map = self.map.map,
            polygon = L.polygon(coords, L.mapbox.simplestyle.style({
          properties: self.style || {}
        })).addTo(self.featureGroup);
        polygon.on({
          click: function click(e) {
            return self.removeShape(e.target);
          }
        }); // map.fitBounds(self.featureGroup.getBounds());
      }
    }, {
      key: "_addGeoJson",
      value: function _addGeoJson(polygons) {
        var self = this,
            map = self.map.map,
            features = [],
            polygons = polygons || [];
        polygons.forEach(function (polygon) {
          if (polygon.type && polygon.properties) {
            if (polygon.geometry.radius) {
              var coords = new Coordinates(polygon.geometry.coordinates[1], polygon.geometry.coordinates[0]);

              self._addCircle(coords, polygon.geometry.radius / 1609.344, {
                object: polygon.properties
              });
            } else {
              features.push(polygon);
            }
          } else {
            features.push({
              type: "Feature",
              properties: Object.assign({
                areaType: polygon.areaType || null,
                geoType: polygon.geoType || null,
                id: polygon.id || null,
                label: polygon.label || null,
                name: polygon.name || null
              }, self.style || {}),
              geometry: polygon.geometry
            });
          }
        });
        if (!features.length) return;
        var geojson = L.geoJson(features, {
          style: L.mapbox.simplestyle.style,
          onEachFeature: function onEachFeature(feature, layer) {
            layer.addTo(self.featureGroup);
            layer.on({
              click: function click(e) {
                var layer = e.target;
                self.removeShape(layer);
              }
            });
          }
        });
        self.shapes.push(geojson); // map.fitBounds(geojson.getBounds());
      }
    }, {
      key: "_removeShape",
      value: function _removeShape(layer) {
        this.featureGroup.removeLayer(layer);
        return layer;
      }
    }, {
      key: "_removeAllShapes",
      value: function _removeAllShapes() {
        this.featureGroup.clearLayers();
      }
    }, {
      key: "_fitBounds",
      value: function _fitBounds() {
        if (this.featureGroup.hasOwnProperty('getBounds')) this.map.map.fitBounds(this.featureGroup.getBounds());
      }
    }, {
      key: "_create",
      value: function _create($map) {
        var self = this;
        self.$map = $map || self.map;
        var setup = {
          map: function map(resolve, reject) {
            if ((self.map || {}).map) {
              resolve({
                map: self.map.map
              });
            } else {
              new SlipstreamMap({
                models: self.models,
                // TODO: we should not be passing a global icon setting
                // they should rather be assigned to each marker in advance
                icon: self.icon || null
              }).render(self.$map).then(function (data) {
                self.map = data.view;
                resolve(data);
              });
            }
          },
          controls: function controls(map) {
            L.control.layers({
              '<span class="hj-map-switch layer-toggle">Map</span>': L.mapbox.tileLayer('mapbox.streets').addTo(map),
              '<span class="hj-satellite-switch layer-toggle">Satellite</span>': L.mapbox.tileLayer('mapbox.satellite')
            }).addTo(map);
            var control = document.querySelector('.layer-toggle').closest('.leaflet-control-layers-list');
            control.style.padding = '4px 8px';
            control.fontSize = '11px';
          }
        };
        return new Promise(function (resolveSetup, rejectSetup) {
          return new Promise(function (resolveMap, rejectMap) {
            setup.map(resolveMap, rejectMap);
          }).then(function (data) {
            self.featureGroup = L.featureGroup().addTo(data.map);
            setup.controls(data.map);
            return data;
          }).then(function (data) {
            return resolveSetup(data);
          });
        });
      }
    }]);

    return MapBox;
  }(MapInterface);

  return MapBox;
});