

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define(function (require) {
  var $ = require('jquery'),
      Backbone = require('backbone'),
      api = require('hji-common/slipstream/api');

  var SlipstreamMap = /*#__PURE__*/function () {
    function SlipstreamMap(options) {
      _classCallCheck(this, SlipstreamMap);

      var self = this,
          _defaults = {
        models: []
      };
      Object.assign(self, _defaults, options || {});
    }

    _createClass(SlipstreamMap, [{
      key: "render",
      value: function render($container) {
        var self = this;

        var _featureHasIcon = function _featureHasIcon(feature) {
          return (feature.properties || {}).icon || self.icon || null;
        };

        var _setLayerIcon = function _setLayerIcon(layer, icon) {
          var img = new Image();
          img.src = icon; // reset icon size to 0, to avoid default icon flash

          layer.setIcon(L.icon({
            iconUrl: icon,
            iconSize: [0, 0]
          })); // reset image dimensions after image loads

          img.onload = function () {
            layer.setIcon(L.icon({
              iconUrl: icon,
              iconSize: [img.width, img.height],
              iconAnchor: [img.width / 2, img.height - 1],
              popupAnchor: [0, -img.height + 3]
            }));
          };
        };

        var _ExtendedRenderer = function _ExtendedRenderer(Types, Renderer) {
          return Types.inherit(Renderer, {
            renderPopup: function renderPopup(item) {
              return $('<span>' + item.get('info') + '</span>');
            },
            __renderPoint: function __renderPoint(item, coordinates, properties) {
              return {
                type: 'Feature',
                geometry: {
                  type: 'Point',
                  coordinates: [coordinates.longitude, coordinates.latitude]
                },
                properties: Object.assign(properties, {
                  id: item.get('id'),
                  icon: item.get('icon')
                })
              };
            }
          });
        };

        var _ExtendedMapView = function _ExtendedMapView(Map, resolve) {
          return Map.extend({
            __onAttached: function __onAttached() {
              Map.prototype.__onAttached.apply(this, arguments);

              if (this.featureLayer) {
                this.featureLayer.eachLayer(function (layer) {
                  var feature = layer.toGeoJSON(),
                      icon = _featureHasIcon(feature);

                  if (icon) _setLayerIcon(layer, icon);
                });
              }

              resolve({
                map: this.map,
                view: this
              });
            }
          });
        };

        return new Promise(function (resolve, reject) {
          api.ready(function (API) {
            hji.require(['slipstream/listings'], function () {
              hji.require(['slipstream/common/util/types', 'slipstream/listings/view/map/renderer', 'slipstream/listings/view/map'], function (Types, Renderer, Map) {
                var ExtendedRenderer = _ExtendedRenderer(Types, Renderer),
                    ExtendedMapView = _ExtendedMapView(Map, resolve),
                    mapView = new ExtendedMapView({
                  renderer: new ExtendedRenderer(),
                  model: new Backbone.Collection(self.models || [])
                });

                mapView.render().$el.appendTo($container).height('100%');
              });
            });
          });
        });
      }
    }]);

    return SlipstreamMap;
  }();

  return SlipstreamMap;
});