

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

hji.define(function (require) {
  var $ = require('jquery'),
      MapBoxWidget = require('hji-common/map/mapbox/widget'),
      GoogleMapWidget = require('hji-common/map/google/widget');

  var MapWidget = HJI.commonVar('gMapsApiKey') ? GoogleMapWidget : MapBoxWidget;
  /**
   * gMap jQuery plugin.
   *
   * Usage Example:
   * $.gMap(); // Will target data-init="gmap" selectors
   * $(#mymap').gMap(); // Custom selector
   * <div data-init="gmap" data-lat="33.586165" data-lng="-111.973083"><p>Max lives here :)</p></div>
   *
   * IMPORTANT Notice: Hide google maps via CSS as follows:
   * [data-init="gmap"] { visibility: hidden; }
   * this will prevent the content from flashing on the page,
   * before Google Map gets loaded.
   *
   * @param settings
   * @param mapOptions
   * @returns {*}
   */

  $.gMap = $.fn.gMap = function (_settings, _mapOptions) {
    var mapOptions = _mapOptions || {},
        // Is function (assuming jQuery) or DOM object is "this"?
    $el = typeof this == 'function' ? $('[data-init="gmap"]') : this;

    var createMaps = function createMaps(element) {
      var callback = function callback() {
        return element.css({
          'visibility': 'visible'
        });
      };

      var _ref = _settings ? [_settings, _mapOptions] : init(element),
          _ref2 = _slicedToArray(_ref, 2),
          widgetSettings = _ref2[0],
          mapOptions = _ref2[1];

      return new MapWidget(widgetSettings, mapOptions, callback);
    };

    var init = function init(element) {
      // Data attribute options
      var widgetOptions = {
        lat: null,
        // latitude
        lng: null,
        // longitude
        info: null,
        // html() of the element will be used if false
        icon: null,
        // marker icon
        width: null,
        // map width
        height: null,
        // map height
        optionsVar: null,
        // name of the declared variable that contains options
        address: null // location address

      };
      var optionsVar = {
        markers: [],
        width: null,
        height: null,
        icon: null,
        styles: null
      }; // Widget config

      var widgetSettings = {
        canvas: false,
        geoData: [],
        icon: false,
        drawingManager: false,
        autozoom: true
      };
      widgetOptions = $.extend(widgetOptions, element.data()); // Determine if options were passes via a custom JS object

      if (widgetOptions.optionsVar && window.hasOwnProperty(widgetOptions.optionsVar)) {
        $.extend(optionsVar, window[widgetOptions.optionsVar]);
      } else if (widgetOptions.lat && widgetOptions.lng) {
        var infoContent = element.html().length ? element.html() : null;
        optionsVar.markers.push({
          lat: widgetOptions.lat,
          lng: widgetOptions.lng,
          info: widgetOptions.info || infoContent,
          icon: widgetOptions.icon || null,
          address: widgetOptions.address || null
        });
      } // Validate markers


      optionsVar.markers = _validateMarkers(optionsVar.markers); // If marker array is empty - there's nothing to do

      if (!optionsVar.markers.length) return;
      if (Array.isArray(optionsVar.styles) && optionsVar.styles.length) mapOptions.styles = optionsVar.styles; // Override widgetOptions width/height/icon with optionsVar if not set

      if (!widgetOptions.width) widgetOptions.width = optionsVar.width;
      if (!widgetOptions.height) widgetOptions.height = optionsVar.height;
      if (!widgetOptions.icon) widgetOptions.icon = optionsVar.icon; // Apply widget dimensions

      if (widgetOptions.width) element.css('width', widgetOptions.width);
      element.css('height', widgetOptions.height || element.width()); // Set widgetSettings to pas to the gMap module

      widgetSettings.canvas = element[0];
      widgetSettings.geoData = optionsVar.markers;
      widgetSettings.icon = widgetOptions.icon; // clear inner html of the container

      element.html('');
      return [widgetSettings, mapOptions];
    };

    var _validateMarkers = function _validateMarkers(data) {
      var markers = [];
      if (!Array.isArray(data) || !data.length) return [];

      for (var i in data) {
        if (_typeof(data[i]) === 'object') {
          if (data[i].lat && !isNaN(data[i].lat) && data[i].lng && !isNaN(data[i].lng)) {
            var marker = new Marker();
            marker.lat = data[i].lat;
            marker.lng = data[i].lng;
            if (data[i].info && typeof data[i].info === 'string') marker.info = data[i].info;
            if (data[i].icon && typeof data[i].icon === 'string') marker.icon = data[i].icon;
            if (data[i].address && typeof data[i].address === 'string') marker.address = data[i].address;
            markers.push(marker);
          }
        }
      }

      return markers;
    };

    var Marker = function Marker() {
      this.lat = null;
      this.lng = null;
      this.info = null;
      this.icon = null;
      this.address = null;
    };

    return $el.each(function (i, el) {
      return createMaps($(el));
    });
  };
});