

hji.define(['require', 'jquery', 'backbone', 'hji-common/modal/gfContentModel', 'hji-common/modal/inlineContentModel'], function (require, $, Backbone) {
  var ContentModelFactory = Backbone.Model.extend({
    defaults: {
      selector: null,
      $el: null
    },
    initialize: function initialize(attributes) {
      if (attributes.selector) {
        this.set(attributes);
        this.set('$el', $(this.get('selector')));
      }
    },
    create: function create() {
      if (!this.get('$el')) {
        return false;
      } // Create type-specific content model


      if (this.isGravityForm()) {
        var Model = require('hji-common/modal/gfContentModel');
      } else {
        var Model = require('hji-common/modal/inlineContentModel');
      }

      return new Model({
        selector: this.get('selector')
      });
    },
    isGravityForm: function isGravityForm() {
      if (this.get('$el').find('[name="gform_submit"]').length) {
        return true;
      }

      return false;
    }
  });
  return ContentModelFactory;
});