

/**
 * Gravity Form Model
 */
hji.define(['jquery', 'backbone', './inlineContentModel'], function ($, Backbone, InlineContentModel) {
  var GFormModel = InlineContentModel.extend({
    defaults: {
      selector: null,
      $el: null,
      content: null,
      original: null,
      form: {}
    },

    /**
     * Determines if the form content is an actual gravity form
     */
    isForm: function isForm() {
      if (this.get('$el').find('.gform_wrapper').length) {
        return true;
      }

      return false;
    },
    _init: function _init() {
      if (this.isForm()) {
        var form = {};
        form.id = this._getId();
        form.title = this._getTitle();
        form.submitTxt = this.get('$el').find('.gform_footer input[type="submit"]').val();
        form.form = this.get('$el').find('form');
        this.set({
          form: form
        });

        if (!this.get('title')) {
          this.set({
            title: this.get('form').title
          });
        }
      }
    },
    _getId: function _getId() {
      return Number(this.get('$el').find('[name="gform_submit"]').val());
    },
    _getTitle: function _getTitle() {
      return this.get('$el').find('.gform_title').text();
    },
    isSubmittable: function isSubmittable() {
      if (this.get('$el').find('[name="gform_submit"]').length) {
        return true;
      }

      return false;
    },

    /**
     * Determines if current form is a submission confirmation
     */
    isConfirmation: function isConfirmation() {
      if (this.get('$el').find('.gform_confirmation_message').length) {
        return true;
      }

      return false;
    },

    /**
     * Determines if current form is a submission validation error
     */
    isValidation: function isValidation() {
      if (this.get('$el').find('.validation_error').length) {
        return true;
      }

      return false;
    }
  });
  return GFormModel;
});