

hji.define(['jquery', 'backbone'], function ($, Backbone) {
  var DetachableContentModel = Backbone.Model.extend({
    defaults: {
      selector: null,
      $el: null,
      content: null,
      original: null
    },
    initialize: function initialize(attributes) {
      if (attributes.selector) {
        this.set(attributes);
        this.set({
          $el: $(this.get('selector'))
        }); // Wrap content within the selector, so we can manipulate it by our own wrapper

        if (!this.get('$el').find('.detachable').length) {
          this.get('$el').wrapInner('<div class="detachable"/>');
        }

        var content = this.get('$el').find('.detachable');
        this.set({
          content: content
        }); // Cloned version of the original content with all events intact

        this.set({
          original: content.clone(true, true)
        });
        var title = this.get('$el').data('title');

        if (!title) {
          title = null;
        }

        this.set({
          title: title
        });
      }

      this._init();
    },
    _init: function _init() {
      return this;
    },
    refresh: function refresh() {
      if (this.get('selector')) {
        this._init();
      }

      return this;
    }
  });
  return DetachableContentModel;
});