

hji.define(['jquery', 'underscore', 'hji-common/slipstream'], function ($, _, Slipstream) {
  var apiUrl = HJI.commonVar('env') == 'production' ? 'https://national-reports.homejunction.com' : 'https://national-reports-test.homejunction.com';

  if (!HJI || !HJI.licenseKey()) {
    return false;
  }

  Slipstream.ready(function () {
    window.require(['national/api'], function (API) {
      var options = {
        license: HJI.licenseKey(),
        url: apiUrl
      };

      if (HJI.commonVar('token') && HJI.commonVar('tokenExpires')) {
        options.auth = {
          token: HJI.commonVar('token'),
          expires: HJI.commonVar('tokenExpires')
        };
      }

      API.init(options);

      window.require(['slipstream/common/view/async', 'national/report/model/report', 'national/report/view/composite', 'national/common/model/selection'], function (Async, Report, Composite, Selection) {
        // Construct the report model
        // data-init="national-reports" data-report-id="123"
        var report = new Report({
          id: $('[data-init="marketReport"]').data('reportId')
        }); // Instantiate CMA modal only once, because it's triggered onClick
        // and modal has its own click handler.

        var doCMA = _.once(function () {
          if ($('#cma-modal').length) {
            $('.nr-avm-estimate .nr-disclaimer-anchor').attr('data-init', 'modal');
            $('.nr-avm-estimate .nr-disclaimer-anchor').attr('data-target', '#cma-modal');
            HJI.modals.setTriggerEvents('.nr-avm-estimate .nr-disclaimer-anchor');
            HJI.modals.createModal('#cma-modal');
          }
        }); // Construct the composite view


        var async = new Async({
          model: report,
          content: function content() {
            return new Composite({
              report: report,
              events: {
                'click .nr-avm-estimate .nr-disclaimer-anchor': doCMA,
                'click .nr-avm-estimate .nr-disclaimer-popup': doCMA
              }
            }).render();
          }
        }).render();
        $('[data-init="marketReport"]').append(async.$el); // Fetch the model

        report.fetch();
      });
    });
  });
});