

var baseUrl = HJI.get('common').apiBaseUrl ? HJI.get('common').apiBaseUrl : 'https://slipstream-cdn.homejunction.com';
var nationalApiUrl = HJI.commonVar('env') == 'production' ? 'https://national-reports-cdn.homejunction.com' : 'https://national-reports-test-cdn.homejunction.com';
hji.define(['slipstream/bootstrap'], function () {
  if (!HJI || !HJI.licenseKey()) {
    return false;
  } // Move HJI require into global namespace for Slipstream to use it


  if (!window.define) {
    window.define = hji.define;
  }

  if (!window.require) {
    window.require = window.requirejs = hji.require;
  } // Pass loaded libraries to the require js


  if (window.jQuery) {
    window.define('jquery', function () {
      return window.jQuery;
    });
  }

  if (window._) {
    window.define('underscore', function () {
      return window._;
    });
  }

  if (window.Backbone) {
    window.define('backbone', function () {
      return window.Backbone;
    });
  } // Init Slipstream


  var options = {
    license: HJI.licenseKey(),
    version: HJI.commonVar('apiVersion'),
    hooks: {
      'pre-config': function preConfig(config) {
        config.paths.national = nationalApiUrl + '/js/1.0.8';
        config.paths.sha = 'https://cdnjs.cloudflare.com/ajax/libs/jsSHA/2.0.2';
        config.paths.snap = 'https://cdnjs.cloudflare.com/ajax/libs/snap.svg/0.4.1/snap.svg'; //config.paths.i18n = 'https://cdnjs.cloudflare.com/ajax/libs/require-i18n/2.0.4/i18n.min';

        config.paths.handlebars = '//cdnjs.cloudflare.com/ajax/libs/handlebars.js/4.0.5/handlebars.min';
        config.paths.marionette = '//cdnjs.cloudflare.com/ajax/libs/backbone.marionette/2.4.4/backbone.marionette.min';
        config.bundles = {
          'slipstream/api': ['slipstream/common/model/address', 'slipstream/common/model/async', 'slipstream/common/model/coordinates', 'slipstream/common/model/response', 'slipstream/common/model/resultset', 'slipstream/common/statistics/model/interval', 'slipstream/common/statistics/util/formatter', 'slipstream/common/statistics/view/chart', 'slipstream/common/util/enumeration', 'slipstream/common/util/formatter', 'slipstream/common/util/geolocator', 'slipstream/common/util/styles', 'slipstream/common/util/types', 'slipstream/common/util/uri', 'slipstream/common/view/async', 'slipstream/common/view/loader'],
          'slipstream/areas': ['slipstream/areas/model/area', 'slipstream/areas/model/areas', 'slipstream/areas/widget/chooser', 'slipstream/areas/widget/details'],
          'slipstream/listings': ['slipstream/listings/model/listings', 'slipstream/listings/view/catalogue', 'slipstream/listings/stylesheet'],
          'slipstream/sales': ['slipstream/sales/model/sales', 'slipstream/sales/view/catalogue', 'slipstream/sales/stylesheet']
        };
      }
    }
  };

  if (HJI.commonVar('token') && HJI.commonVar('tokenExpires')) {
    options.auth = {
      token: HJI.commonVar('token'),
      expires: HJI.commonVar('tokenExpires')
    };
  }

  Slipstream.bootstrap(options);
  return Slipstream;
});