

hji.define(['require', 'jquery'], function (require, $) {
  /**
   * Access to Slipstream API object.
   *
   * Usage:
   *  // make sure the module is required in the definition
   *  // in order to load it like this
   *  var api = require('hji-common/slipstream/api');
   *  api.ready(function(API)
   *      {
   *          API.call('/ws/webservice', params)
   *              .done(data, xhr)
   *              {
   *                  console.log(data);
   *              };
   *       });
   *
   * @type {boolean}
   */
  var def = $.Deferred();
  var __obj = {
    init: function init() {
      require(['hji-common/slipstream'], function (require) {
        Slipstream.ready(function () {
          window.require(['slipstream/api'], function (API) {
            def.resolve(API);
          });
        });
      });
    }
  };
  def.promise(__obj);
  return {
    ready: function ready(callback) {
      __obj.init();

      def.done(function (API) {
        if (typeof callback === 'function') {
          callback(API);
        } else {
          console.error('Callback is not a function.');
        }
      });
    },
    fetch: function fetch(webservice, params) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        _this.ready(function (API) {
          API.call(webservice, params).done(function (response, xhr) {
            if (response.success === true) {
              resolve(response.result);
            } else {
              reject(response.error.message);
            }
          });
        });
      });
    }
  };
});