

(function ($) {
  function getShortcode() {
    var form = $('form'),
        params = getParams(form),
        shortcodeName = form.data('shortcodeName');
    return '[' + shortcodeName + ' ' + params.join(' ') + ']';
  }

  var _toShortcodeProp = function _toShortcodeProp($el) {
    var val = _getVal($el);

    if (val != '' && val != null) {
      var name = $el.attr('name').replace('[]', '');
      val = name == 'location' ? encodeURIComponent(val) : Array.isArray(val) ? val.join('|') : val;
      return name + '=' + JSON.stringify(val);
    }

    return null;
  };

  function getParams(container, element) {
    var params = [];

    if (container) {
      container.find('.shortcode-value').each(function () {
        var val = _toShortcodeProp($(this));

        if (val) params.push(val);
      });
    } else if (element && element.hasClass('shortcode-value')) {
      var val = _toShortcodeProp(element);

      if (val) params.push(val);
    }

    return params;
  }

  function _getVal(elObj) {
    if (elObj.is(':checkbox') || elObj.is(':radio')) {
      if (elObj.is(':checked')) {
        return elObj.val();
      }
    } else {
      return elObj.val();
    }

    return null;
  }

  $(document).ready(function () {
    $('#cancel').click(function () {
      tinyMCEPopup.close();
      return;
    });
    $('#insert').click(function () {
      window.parent.send_to_editor(getShortcode());
      tinyMCEPopup.editor.execCommand('mceRepaint');
      tinyMCEPopup.close();
      return;
    });
  });
})(jQuery);