

hji.define('hji-common/widgets/widget',['jquery'], function ($) {
  /**
   * Abstract Slipstream Widget Class
   *
   * @constructor
   */
  var Widget = function Widget() {
    this.moduleName = 'widget';
    this.$el = null;
    this.options = {};
  };

  Widget.prototype.init = function ($el, options) {
    this.$el = $el;
    this.$el[0][this.moduleName] = this;
    $.extend(this.options, options);
    this.render();
  };
  /**
   * Abstract Render Method
   */


  Widget.prototype.render = function () {
    console.error('widget.render() is not implemented.');
  };

  Widget.prototype.template = function () {
    var template = $('<div class="slipstream">').append($('<div class="slipstream-areas">'));
    if (this.options.chooser) template.find('.slipstream-areas').prepend('<div class="chooser-wrapper">');
    return template;
  };

  return Widget;
});


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

!function (t, e) {
  "object" == (typeof exports === "undefined" ? "undefined" : _typeof(exports)) && "undefined" != typeof module ? module.exports = e(require("jquery")) :'function' === typeof hji.define && hji.define.amd ? hji.define('hji-common/widgets/poi.src',["jquery"], e) : t.PointsOfInterest = e(t.$);
}(void 0, function (t) {
  "use strict";

  t = t && t.hasOwnProperty("default") ? t["default"] : t;

  var e = "function" == typeof Symbol && "symbol" == _typeof(Symbol.iterator) ? function (t) {
    return _typeof(t);
  } : function (t) {
    return t && "function" == typeof Symbol && t.constructor === Symbol && t !== Symbol.prototype ? "symbol" : _typeof(t);
  },
      n = function n(t, e) {
    if (!(t instanceof e)) throw new TypeError("Cannot call a class as a function");
  },
      i = function () {
    function t(t, e) {
      for (var n = 0; n < e.length; n++) {
        var i = e[n];
        i.enumerable = i.enumerable || !1, i.configurable = !0, "value" in i && (i.writable = !0), Object.defineProperty(t, i.key, i);
      }
    }

    return function (e, n, i) {
      return n && t(e.prototype, n), i && t(e, i), e;
    };
  }(),
      r = Object.assign || function (t) {
    for (var e = 1; e < arguments.length; e++) {
      var n = arguments[e];

      for (var i in n) {
        Object.prototype.hasOwnProperty.call(n, i) && (t[i] = n[i]);
      }
    }

    return t;
  },
      s = function () {
    return function (t, e) {
      if (Array.isArray(t)) return t;
      if (Symbol.iterator in Object(t)) return function (t, e) {
        var n = [],
            i = !0,
            r = !1,
            s = void 0;

        try {
          for (var a, o = t[Symbol.iterator](); !(i = (a = o.next()).done) && (n.push(a.value), !e || n.length !== e); i = !0) {
            ;
          }
        } catch (t) {
          r = !0, s = t;
        } finally {
          try {
            !i && o["return"] && o["return"]();
          } finally {
            if (r) throw s;
          }
        }

        return n;
      }(t, e);
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    };
  }(),
      a = {
    cafe: "Restaurants|Cafes",
    restaurant: "Restaurants",
    grocery: "Food|Grocery",
    cinema: "Arts & Entertainment|Cinema",
    park: "Recreation|Parks"
  };

  return function () {
    function o() {
      var t = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null,
          e = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 2;
      n(this, o), this.token = "", this.radius = e, this.coordinates = {}, this.data = {}, this.content = "", this.env = "", t && (this.coordinates = t), this.params = {
        circle: this.coordinates.latitude + "," + this.coordinates.longitude + "," + this.radius,
        sortField: "distance",
        sortOrder: "asc",
        pageSize: 200,
        category: Object.values(a)
      };
    }

    return i(o, [{
      key: "setParams",
      value: function value(t) {
        this.params = r(this.params, t);
      }
    }, {
      key: "setToken",
      value: function value(t) {
        this.token = t;
      }
    }, {
      key: "setContent",
      value: function value(t) {
        this.content = t;
      }
    }, {
      key: "setEnv",
      value: function value(t) {
        this.env = t;
      }
    }, {
      key: "fetch",
      value: function value() {
        var e = this;
        if (!this.token) throw new Error("no token");
        return t.ajax({
          type: "GET",
          url: this._getApiUrl() + "/ws/points-of-interest/search?",
          headers: {
            "HJI-Slipstream-Token": this.token
          },
          data: this.params,
          success: function success(t) {
            var n = !0,
                i = !1,
                r = void 0;

            try {
              for (var o, c = t.result["points-of-interest"][Symbol.iterator](); !(n = (o = c.next()).done); n = !0) {
                var l = o.value,
                    d = l.categories.shift(),
                    u = !0,
                    h = !1,
                    p = void 0;

                try {
                  for (var y, f = Object.entries(a)[Symbol.iterator](); !(u = (y = f.next()).done); u = !0) {
                    var v = s(y.value, 2),
                        m = v[0],
                        b = v[1];
                    Object.values(d).slice(0, b.split("|").length).join("|") !== b || e.data[m] || (l.distance = e._calcDistance(l.coordinates), e.data[m] = {
                      name: l.name,
                      distance: l.distance,
                      address: l.address
                    });
                  }
                } catch (t) {
                  h = !0, p = t;
                } finally {
                  try {
                    !u && f["return"] && f["return"]();
                  } finally {
                    if (h) throw p;
                  }
                }
              }
            } catch (t) {
              i = !0, r = t;
            } finally {
              try {
                !n && c["return"] && c["return"]();
              } finally {
                if (i) throw r;
              }
            }
          }
        });
      }
    }, {
      key: "_calcDistance",
      value: function value(t) {
        var e = t.latitude,
            n = t.longitude,
            i = Math.PI / 180,
            r = .5 - Math.cos((e - this.coordinates.latitude) * i) / 2 + Math.cos(this.coordinates.latitude * i) * Math.cos(e * i) * (1 - Math.cos((n - this.coordinates.longitude) * i)) / 2;
        return (7914 * Math.asin(Math.sqrt(r))).toFixed(1);
      }
    }, {
      key: "_getDisplayAddress",
      value: function value() {
        var e = "";
        if (!this.content) return "";

        if (this.content.property.address && (e += this.content.property.address + ",<br />"), this.content.property.city && (e += this.content.property.city + ", "), this.content.property.state && (e += this.content.property.state + " "), this.content.property.zip && (e += this.content.property.zip), !e.length && !t.isEmptyObject(this.data)) {
          var n = this.data[Object.keys(this.data)[0]];
          if (n.address.deliveryLine) e += "Near " + n.address.deliveryLine.match(/[a-zA-Z\s]+/g)[0] + ",<br />";
          n.address.city && (e += n.address.city + ", "), n.address.state && (e += n.address.state + " "), n.address.zip && (e += n.address.zip);
        }

        return e;
      }
    }, {
      key: "_getApiUrl",
      value: function value() {
        return "test" === this.env ? "https://slipstream-test.homejunction.com" : "https://slipstream.homejunction.com";
      }
    }, {
      key: "appendTo",
      value: function value(n) {
        var i = "poi",
            r = "",
            o = '<div class="content">';
        o += '\n        <p class="title title-content">Within Walking Distance</p>\n        <p class="title title-text">\n          Within <strong>' + this.radius + " Mile Radius</strong>\n        </p>\n    ", o += '<ul class="list">';
        var c = !0,
            l = !1,
            d = void 0;

        try {
          for (var u, h = Object.entries(a)[Symbol.iterator](); !(c = (u = h.next()).done); c = !0) {
            var p = s(u.value, 2),
                y = p[0];
            p[1];
            this.data[y] && (o += '\n              <li>\n                <div class="img-box">\n                  <div id="' + y + '-img" />\n                </div>\n                <p class="li-title">' + this.data[y].name + '</p>\n                <p class="distance">\n                  <span>' + this.data[y].distance + "</span><br/>Miles\n                </p>\n              </li>\n            ");
          }
        } catch (t) {
          l = !0, d = t;
        } finally {
          try {
            !c && h["return"] && h["return"]();
          } finally {
            if (l) throw d;
          }
        }

        o += "</ul>", o += "</div>", "object" === e(this.content) && null != this.content ? (this.content.property && (r += '\n          <div class="details-block">\n            <p class="title title-details">In Your Area</p>\n            <p class="text">\n              ' + this._getDisplayAddress() + "\n            </p>\n          </div>"), this.content.agency && (r += '\n            <div class="details-block">\n              <p class="title title-details">Agent</p>\n              <p class="text">' + this.content.agency.agent + "<br/>" + this.content.agency.name + "<br/>" + this.content.agency.phone + "</p>\n            </div>"), r.length && (o += '\n            <div class="details">\n              ' + r + '    \n              <div class="details-block">\n                <div id="logo"/>\n                </div>\n              </div>\n            </div>')) : "string" == typeof this.content && this.content.length && (o += this.content), r.length || (i += " poi--nodetails"), t(n).append('<div class="' + i + '">' + o + "</div>");
      }
    }]), o;
  }();
});


hji.define('hji-common/widgets/poi',['require', 'jquery', 'hji-common/widgets/widget', './poi.src'], function (require, $, Widget, PointsOfInterest) {
  var _obj = {
    token: window.HJI.commonVar('token'),
    customer: window.HJI.commonVar('customer')
  };
  /**
   * Points of Interest Widget
   *
   * Parameters:
   *      @param data-init string     widgets/poi
   *      @param data-lat string      Latitude
   *      @param data-lng string      Longitude
   *      @param data-radius string   Radius (miles)
   *      @param data-address JSON Object {deliveryLine, city, state, zip} OR false to remove
   *      @param agent JSON Object {name, company, phone} OR false to remove
   *
   *      Example 1:
   *          Renders widget with POI content and street/agent details on the right
   *          <div data-init="widgets/poi"
   *              data-lat="32.800839"
   *              data-lng="-117.199024"
   *              data-address='{"address":"9 West Walton Street 3500","city":"Chicago","state":"IL","zip":"60610"}'
   *              data-agent='{"name":"John Doe","company":"Realty Executives","phone":"(800) 123-4567"}'></div>
   *
   *      Example 2:
   *          Street falls back on to first POI item, and Agent onto Membership Settings
   *          <div data-init="widgets/poi" data-lat="33.630996" data-lng="-111.950739"></div>
   *
   *      Example 3:
   *          Displays only POI items with no street/agent details section
   *          <div data-init="widgets/poi"
   *          data-lat="33.630996"
   *          data-lng="-111.950739"
   *          data-address="false"
   *          data-agent="false"></div>
   */

  var poiWidget = function poiWidget() {
    this.$el = null;
    this.options = {
      lat: null,
      lng: null,
      radius: 2,
      address: {},
      // {deliveryLine, city, state, zip}
      agent: {} // {name, company, phone}

    };
    this.poi = null;
  };

  poiWidget.prototype = new Widget();

  poiWidget.prototype.init = function ($el, options) {
    var _this = this;

    this.$el = $el;
    this.$el[0][this.moduleName] = this;
    $.extend(this.options, options);
    if (!this.options.lat || !this.options.lng || !this.options.radius) return false;
    if (!_obj.token) return false;
    this.poi = this.poi || new PointsOfInterest({
      latitude: this.options.lat,
      longitude: this.options.lng
    }, this.options.radius);
    this.poi.setEnv(HJI.commonVar('env'));
    this.poi.setToken(_obj.token);
    this.poi.setContent({
      property: function () {
        if (!_this.options.address) return false;
        var address = $.extend({}, _this.options.address);

        if (address.hasOwnProperty('deliveryLine')) {
          address.address = address.deliveryLine;
          delete address.deliveryLine;
        }

        return address;
      }(),
      agency: function () {
        return _this.options.agent === false ? false : {
          agent: _getAgentName(_this.options.agent),
          name: _getOfficeName(_this.options.agent),
          phone: _getAgentPhone(_this.options.agent)
        };
      }()
    });
    this.render();
  };

  var _getAgentName = function _getAgentName(agent) {
    if (agent.name) return agent.name;else if (_obj.customer && _obj.customer.name) return _obj.customer.name;
    return null;
  };

  var _getOfficeName = function _getOfficeName(agent) {
    if (agent.company) return agent.company;else if (_obj.customer && _obj.customer.officeName) return _obj.customer.officeName;
    return null;
  };

  var _getAgentPhone = function _getAgentPhone(agent) {
    if (agent.phone) return agent.phone;else if (_obj.customer && _obj.customer.officePhone) return _obj.customer.officePhone;
    return null;
  };

  poiWidget.prototype.render = function () {
    var _this2 = this;

    this.poi.fetch().done(function () {
      return _this2.poi.appendTo(_this2.$el);
    });
  };

  poiWidget.prototype.template = function () {
    return null;
  };

  return poiWidget;
});

hji.define("hji-common/widgets/poi", function(){});
