

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define(function (require) {
  var $ = require('jquery'),
      AssignedSchools = require('./schoolsNearby/assignedSchools'),
      api = require('hji-common/slipstream/api'),
      Utils = require('hji-common/utils');

  var Cache = /*#__PURE__*/function () {
    function Cache() {
      _classCallCheck(this, Cache);

      this.cache = new Map();
    }

    _createClass(Cache, [{
      key: "_toKey",
      value: function _toKey(key) {
        return JSON.stringify(key);
      }
    }, {
      key: "has",
      value: function has(key) {
        return this.cache.has(this._toKey(key));
      }
    }, {
      key: "set",
      value: function set(key, value) {
        this.cache.set(this._toKey(key), value);
      }
    }, {
      key: "get",
      value: function get(key) {
        return this.cache.get(this._toKey(key));
      }
    }]);

    return Cache;
  }();

  var _cache = new Cache();

  var SchoolsNearby = /*#__PURE__*/function () {
    function SchoolsNearby() {
      _classCallCheck(this, SchoolsNearby);

      this.$el = null;
      this.sections = [];
    }

    _createClass(SchoolsNearby, [{
      key: "init",
      value: function init($el, options) {
        var _this = this;

        var params = options.parameters || {};
        this.$el = $el;
        this.ui = new UI(this.$el);
        var assigned = new AssignedSchools('Assigned Schools', params),
            elementary = new SchoolsSection('Elementary', Object.assign(params, {
          grade: 'elementary'
        })),
            middle = new SchoolsSection('Middle', Object.assign(params, {
          grade: 'middle'
        })),
            high = new SchoolsSection('High', Object.assign(params, {
          grade: 'high'
        }));
        this.sections = [assigned, elementary, middle, high];
        this.sections.forEach(function (section) {
          _this.ui.addSection(section);
        });
        this.ui.sections.forEach(function (uiSection, i, sections) {
          uiSection.onActivate(function () {
            _this.$el.find('.slipstream-loader.slipstream-loading').parent().show();

            uiSection.section.fetch().then(function (content) {
              uiSection.render(content);

              _this.$el.find('.slipstream-loader.slipstream-loading').parent().hide();
            })["catch"](function (reason) {
              var n = i + 1;
              sections[n].activate();
              sections[i].$tab.remove();
            }); // Display private filter

            if (uiSection.section instanceof AssignedSchools) {
              _this.ui.$filters.hide();
            } else {
              _this.ui.$filters.show();
            }
          });
        }); // Activate first section

        this.ui.sections[0].activate(); // Set min height of sections to the height of the 1st section

        var once = 0;
        this.ui.sections[0].onRender(function () {
          if (once < 1) {
            _this.ui.$template.css({
              minHeight: _this.ui.$template.height()
            });

            ++once;
          }
        });
        this.ui.$private.on('change', function (e) {
          _this.ui.sections.forEach(function (uiSection) {
            var admission = $(e.target).is(':checked') ? '' : 'Public';
            if (uiSection.section.params) uiSection.section.params.admission = admission;

            if (uiSection.isActive()) {
              uiSection.deactivate();
              uiSection.activate();
            }
          });
        });
      }
    }]);

    return SchoolsNearby;
  }();

  var SchoolsSection = /*#__PURE__*/function () {
    function SchoolsSection(name, options) {
      _classCallCheck(this, SchoolsSection);

      this.name = name;
      this.params = {
        circle: (options.coords || '') + ',5',
        grade: options.grade || '',
        district: options.district || '',
        admission: 'Public',
        details: true,
        sortField: 'distance',
        sortOrder: 'asc',
        pageSize: 4,
        pageNumber: 1
      };
      this._result = null;
      this.pages = {
        total: 1,
        current: 1
      };
    }

    _createClass(SchoolsSection, [{
      key: "fetch",
      value: function fetch() {
        var _this2 = this;

        var self = this;
        return new Promise(function (resolve, reject) {
          if (_cache.has(_this2.params)) {
            var result = _cache.get(_this2.params);

            resolve(result.schools);
          } else {
            api.fetch('/ws/schools/search', _this2.params).then(function (result) {
              if (result.schools.length) {
                self._result = result;
                result.schools.map(function (school) {
                  var coords = self.params.circle.split(',');
                  school.distance = Utils.calculateDistance(coords[0], coords[1], school.coordinates.latitude, school.coordinates.longitude);
                  return school;
                });

                _cache.set(_this2.params, result);

                resolve(result.schools);
              }
            });
          }
        });
      }
    }, {
      key: "getPaging",
      value: function getPaging() {
        if (!_cache.has(this.params)) return false;

        var result = _cache.get(this.params);

        var paging = false;

        if (result.paging) {
          paging = Object.assign({}, result.paging || {});
          paging.total = result.total;
        }

        return paging.count != 1 ? paging : false;
      }
    }, {
      key: "nextPage",
      value: function nextPage() {
        var paging = this.getPaging();
        if (!paging || paging.number === paging.count) return false;

        if (paging.count > paging.number) {
          this.params.pageNumber = paging.number + 1;
          return this.fetch();
        }
      }
    }, {
      key: "prevPage",
      value: function prevPage() {
        var paging = this.getPaging();
        if (!paging || paging.number === 1) return false;

        if (paging.number > 1) {
          this.params.pageNumber = paging.number - 1;
          return this.fetch();
        }
      }
    }]);

    return SchoolsSection;
  }();

  var template = "\n        <div class=\"hjitb schools-nearby\">\n            <div class=\"schools-nearby__controls\">\n                <ul class=\"schools-nearby__tabs nav nav-tabs\"></ul>\n                <div class=\"schools-nearby__filters\">\n                    <input type=\"checkbox\" class=\"schools-nearby__private-filter\" name=\"include-private\">\n                    <label for=\"include-private\">Private</label>\n                </div>\n            </div>\n            <div style=\"min-height: 300px; position:relative\">\n                <div class=\"schools-nearby__school-list\"></div>\n                <div class=\"slipstream\" style=\"display: none;\"><div class=\"slipstream-loader slipstream-loading\"><div class=\"slipstream-spinner\"><div></div></div></div></div>\n            </div>\n        </div>";

  var UI = /*#__PURE__*/function () {
    function UI($container) {
      _classCallCheck(this, UI);

      this.sections = [];
      this.tabs = [];
      this.$template = $(template);
      this.$tabs = this.$template.find('.schools-nearby__tabs');
      this.$private = this.$template.find('.schools-nearby__private-filter');
      this.$schools = this.$template.find('.schools-nearby__school-list');
      this.$filters = this.$template.find('.schools-nearby__filters');
      this.$template.appendTo($container);
    }

    _createClass(UI, [{
      key: "addSection",
      value: function addSection(section) {
        var _this3 = this;

        var uiSection = new UISection(section, this.$schools);
        this.$tabs.append(uiSection.$tab);
        this.tabs.push(uiSection.$tab);
        this.sections.push(uiSection);
        uiSection.$tab.on('click', function () {
          _this3.sections.forEach(function (section) {
            section.deactivate();
          });

          uiSection.activate();
        });
        uiSection.onNext(function (o) {
          var result = o.section.nextPage();
          if (result instanceof Promise) result.then(function (content) {
            return o.render(content);
          });
        });
        uiSection.onPrev(function (o) {
          var result = o.section.prevPage();
          if (result instanceof Promise) result.then(function (content) {
            return o.render(content);
          });
        });
        uiSection.onSchoolClick(function (data) {
          uiSection.showSchoolDetails(data.schoolId);
        });
        return uiSection;
      }
    }]);

    return UI;
  }();

  var UISection = /*#__PURE__*/function () {
    function UISection(section, $section) {
      _classCallCheck(this, UISection);

      this.section = section;
      this["class"] = section.name.replace(' ', '-').toLowerCase();
      this.sectionClass = "school-list--".concat(this["class"]);
      this.$tab = $("<li class=\"nav-item nav-link\">".concat(section.name, "</li>"));
      this.$section = $section;
      this.active = false;
    }

    _createClass(UISection, [{
      key: "onActivate",
      value: function onActivate(callback) {
        this.$tab.on('activate', function () {
          if (typeof callback === 'function') callback();
        });
      }
    }, {
      key: "onRender",
      value: function onRender(callback) {
        this.$section.on('render', function () {
          if (typeof callback === 'function') callback();
        });
      }
    }, {
      key: "onSchoolClick",
      value: function onSchoolClick(callback) {
        this.$section.on('click', ".".concat(this.sectionClass, " .school-list-item"), function (e) {
          e.preventDefault();
          if (typeof callback === 'function') callback($(this).data());
        });
      }
    }, {
      key: "onNext",
      value: function onNext(callback) {
        var _this4 = this;

        this.$section.on('click', ".".concat(this.sectionClass, " .widget-pagination__control-next"), function (e) {
          e.preventDefault();
          callback(_this4);
        });
      }
    }, {
      key: "onPrev",
      value: function onPrev(callback) {
        var _this5 = this;

        this.$section.on('click', ".".concat(this.sectionClass, " .widget-pagination__control-prev"), function (e) {
          e.preventDefault();
          callback(_this5);
        });
      }
    }, {
      key: "activate",
      value: function activate() {
        this.$tab.addClass('active');
        this.$tab.trigger('activate');
        this.active = true;
      }
    }, {
      key: "deactivate",
      value: function deactivate() {
        this.$tab.removeClass('active');
        this.active = false;
      }
    }, {
      key: "isActive",
      value: function isActive() {
        return this.active;
      }
    }, {
      key: "renderSchool",
      value: function renderSchool(school) {
        var grades = school.gradeLow !== school.gradeHigh ? "".concat(school.gradeLow, " - ").concat(school.gradeHigh) : school.gradeLow;
        var admission = school.admission === 'Private' ? "<span class=\"school-info__admission\">Private</span>" : '';

        var ratingClass = function ratingClass() {
          var high = ['S', 'A+', 'A', 'A-', 'B+', 'B'],
              medium = ['B-', 'C+', 'C'];
          if (!school.rating) return 'n-a';
          if (high.includes(school.rating)) return 'high';
          if (medium.includes(school.rating)) return 'medium';
          return 'low';
        };

        var totalStudents = function totalStudents() {
          return school.totalStudents ? school.totalStudents.toLocaleString() : 'N/A';
        };

        var expenditure = function expenditure() {
          return school.expenditure ? "$".concat(school.expenditure.toLocaleString()) : 'N/A';
        };

        var distance = function distance() {
          return school.distance ? "".concat(school.distance, " mi") : '';
        };

        var template = "\n            <tr class=\"school-list-item\" data-school-id=\"".concat(school.id, "\">\n                <td class=\"school-list-item__rating school-rating school-rating--").concat(ratingClass(), " school-list__col\"><span class=\"school-rating__badge\">").concat(school.rating || 'N/A', "</span></td>\n                <td class=\"school-list-item__info school-info school-list__col\">\n                    <div class=\"school-info__name\">").concat(school.name).concat(admission, "</div>\n                    <div class=\"school-info__details school-details\">\n                        <div class=\"school-details__students school-details-col\">\n                            <span class=\"school-details-col__label\">Students</span>\n                            <span class=\"school-details-col__value\">").concat(totalStudents(), "</span>\n                        </div>\n                        <div class=\"school-details__ratio school-details-col\">\n                            <span class=\"school-details-col__label\">Student/Teach</span>\n                            <span class=\"school-details-col__value\">").concat(school.studentTeacherRatio || 'N/A', "</span>\n                        </div>\n                        <div class=\"school-details__charter school-details-col\">\n                            <span class=\"school-details-col__label\">Charter</span>\n                            <span class=\"school-details-col__value\">").concat(school.charter ? 'Yes' : 'No', "</span>\n                        </div>\n                        <div class=\"school-details__title1 school-details-col\">\n                            <span class=\"school-details-col__label\">Title I</span>\n                            <span class=\"school-details-col__value\">").concat(school.titleI ? 'Yes' : 'No', "</span>\n                        </div>\n                        <div class=\"school-details__expenditure school-details-col\">\n                            <span class=\"school-details-col__label\">Expenditure</span>\n                            <span class=\"school-details-col__value\">").concat(expenditure(), "</span>\n                        </div>\n                    </div>\n                </td>\n                <td class=\"school-list-item__grades school-list__col\">").concat(grades, "</td>\n                <td class=\"school-list-item__distance school-list__col\">").concat(distance(), "</td>\n            </tr>");
        return template;
      }
    }, {
      key: "render",
      value: function render(data) {
        var _this6 = this;

        var self = this,
            html,
            paging;

        var display = function display(html) {
          self.$section.slideUp(200, function () {
            return self.$section.html(html);
          }).slideDown(500, function () {
            var obj = {
              html: html
            };
            if (_typeof(data) === 'object') obj.data = data;
            self.$section.find('.school-list').trigger('render', obj);
          });
        };

        if (typeof data === 'string') {
          display(data);
        } else if (Array.isArray(data)) {
          html = "<table class=\"school-list ".concat(this.sectionClass, "\">");
          html += "<thead class=\"school-list__header\">\n                            <tr>\n                                <th class=\"school-list__header--rating school-list__col\">Rating</th>\n                                <th class=\"school-list__header--info school-list__col\">Schools</th>\n                                <th class=\"school-list__header--grade school-list__col\">Grades</th>\n                                <th class=\"school-list__header--distance school-list__col\">Distance</th>\n                            </tr>\n                        </thead>";
          html += "<tbody>";
          data.forEach(function (school) {
            return html += _this6.renderSchool(school);
          });
          paging = this.section.getPaging();

          if (paging) {
            html += this.renderPagination(paging);
          }

          html += "</tbody>";
          html += '</table>';
          display(html);
        } else {
          this.$section.html('Unfortunately, no schools nearby were found.');
        }
      }
    }, {
      key: "renderPagination",
      value: function renderPagination(paging) {
        var from = paging.number === 1 ? 1 : paging.size * paging.number - paging.size + 1;
        var to = from + paging.size - 1 < paging.total ? from + paging.size - 1 : paging.total;
        var prevClass = paging.number === 1 ? 'inactive' : '';
        var nextClass = paging.number === paging.count ? 'inactive' : '';
        var html = "\n            <td class=\"school-list__pagination widget-pagination\" colspan=\"4\">\n                <div class=\"widget-pagination__count\">".concat(from, " - ").concat(to, " of ").concat(paging.total, "</div>\n                <div class=\"widget-pagination__controls\">\n                    <div class=\"widget-pagination__control widget-pagination__control-prev ").concat(prevClass, "\" href=\"#\">\n                        <i class=\"material-icons\">keyboard_arrow_left</i>\n                    </div>\n                    <div class=\"widget-pagination__control widget-pagination__control-next ").concat(nextClass, "\" href=\"#\">\n                        <i class=\"material-icons\">keyboard_arrow_right</i>\n                    </div>\n                </div>\n            </td>");
        return html;
      }
    }, {
      key: "showSchoolDetails",
      value: function showSchoolDetails(schoolId) {
        var self = this; // TODO: fix the Schools common widget so the same is possible via it.

        window.require(['jquery', 'slipstream/schools'], function ($) {
          window.require(['slipstream/schools/view/details'], function (Details) {
            var details = new Details();
            details.model.fetch({
              parameters: {
                id: schoolId,
                details: true
              }
            });
            var $el = $("<div class=\"slipstream slipstream-reset\">\n                                            <div class=\"slipstream-async \n                                                        slipstream-widget \n                                                        slipstream-schools \n                                                        slipstream-schools-widget \n                                                        slipstream-schools-widget-details\">\n                                            </div>\n                                        </div>");
            $el.find('.slipstream-widget').append(details.render().$el); // TODO: figure out why pointer object changes when self.activate() is called
            // const addBackButton = () => {

            var btn = $("<div \n                                                        class=\"slipstream-list-button\" \n                                                        title=\"Schools List\"></div>").one('click', function () {
              return self.activate();
            });
            var targetNode = $el[0];
            var config = {
              attributes: false,
              childList: true,
              subtree: true
            };

            var callback = function callback(mutationsList, observer) {
              var _iteratorNormalCompletion = true;
              var _didIteratorError = false;
              var _iteratorError = undefined;

              try {
                for (var _iterator = mutationsList[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                  var mutation = _step.value;

                  if (mutation.type == 'childList') {
                    observer.disconnect();
                    $el.find('.slipstream-schools-details').after(btn);
                    self.$section.html($el).slideDown(500);
                  }
                }
              } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion && _iterator["return"] != null) {
                    _iterator["return"]();
                  }
                } finally {
                  if (_didIteratorError) {
                    throw _iteratorError;
                  }
                }
              }
            };

            var observer = new MutationObserver(callback);
            observer.observe(targetNode, config); // }

            self.$section.slideUp(300); // addBackButton();
          });
        });
      }
    }]);

    return UISection;
  }();

  return SchoolsNearby;
});