

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define(function (require) {
  var api = require('hji-common/slipstream/api'),
      _ = require('underscore'),
      Utils = require('hji-common/utils'),
      range = function range(start, stop, step) {
    return Array.from({
      length: (stop - start) / step
    }, function (_, i) {
      return start + i * step;
    });
  };

  var _cache = new Map();

  var AssignedSchools = /*#__PURE__*/function () {
    function AssignedSchools(name, options) {
      _classCallCheck(this, AssignedSchools);

      this.name = name;
      this.settings = Object.assign({
        coords: null
      }, options);
    }

    _createClass(AssignedSchools, [{
      key: "render",
      value: function render() {
        var _this = this;

        this.fetch().forEach(function (school) {
          return _this.renderSchool(school);
        });
      }
    }, {
      key: "fetch",
      value: function fetch() {
        var _this2 = this;

        var self = this;

        var getSchoolsList = function getSchoolsList(attendanceAreas) {
          var result = [],
              schoolGroups = self.groupBySchool(attendanceAreas),
              schoolList = self.reduceToSchoolList(schoolGroups),
              _$partition = _.partition(_.sortBy(schoolList, 'gradeLow'), {
            openEnrollment: false
          }),
              _$partition2 = _slicedToArray(_$partition, 2),
              assigned = _$partition2[0],
              openEnrollment = _$partition2[1],
              missingGrades = self.findMissingGrades(assigned),
              missingGradesSchools = [];

          if (missingGrades.length) {
            missingGradesSchools = self.findGradesInOpenEnrollment(openEnrollment, missingGrades);
          }

          result = result.concat(assigned, missingGradesSchools).map(function (school) {
            school.gradeLow = self._gradeAbbr(school.gradeLow);
            school.gradeHigh = self._gradeAbbr(school.gradeHigh);
            return school;
          });
          var IDs = result.map(function (school) {
            return school.id;
          });
          return new Promise(function (resolve, reject) {
            self.fetchSchools({
              id: IDs,
              details: true
            }).then(function (result) {
              if (result.schools) resolve(result.schools);
            });
          });
        };

        return new Promise(function (resolve, reject) {
          var params = {
            coords: _this2.settings.coords,
            details: true,
            pageSize: 200
          };

          if (_cache.has(params.coords)) {
            resolve(_cache.get(params.coords));
          } else {
            self.fetchAttendanceAreas(params).then(function (result) {
              if (result['attendance-areas'].length) {
                getSchoolsList(result['attendance-areas']).then(function (list) {
                  list = list.map(function (school) {
                    var coords = params.coords.split(',');
                    school.distance = Utils.calculateDistance(coords[0], coords[1], school.coordinates.latitude, school.coordinates.longitude);
                    return school;
                  });

                  _cache.set(params.coords, list);

                  resolve(list);
                });
              } else {
                reject(result);
              }
            });
          }
        });
      }
    }, {
      key: "fetchAttendanceAreas",
      value: function fetchAttendanceAreas(parameters) {
        return api.fetch('/ws/schools/attendance-areas/search', parameters);
      }
    }, {
      key: "fetchSchools",
      value: function fetchSchools(parameters) {
        return api.fetch('/ws/schools/get', parameters);
      }
    }, {
      key: "groupBySchool",
      value: function groupBySchool(attendanceAreas) {
        var _this3 = this;

        var schoolGroups = [];
        attendanceAreas.forEach(function (attendanceArea) {
          var schoolId = attendanceArea.school.id;
          attendanceArea.grade = _this3._gradeIndex(attendanceArea.grade);

          if (schoolGroups[schoolId]) {
            schoolGroups[schoolId].push(attendanceArea);
          } else {
            schoolGroups[schoolId] = [];
            schoolGroups[schoolId].push(attendanceArea);
          }
        });
        return schoolGroups;
      }
    }, {
      key: "reduceToSchoolList",
      value: function reduceToSchoolList(schoolGroups) {
        var schools = [];

        for (var i in schoolGroups) {
          var group = schoolGroups[i];
          group = _.sortBy(group, 'grade');
          schools.push({
            id: group[0].school.id,
            name: group[0].school.name,
            gradeLow: group[0].grade,
            gradeHigh: group[group.length - 1].grade,
            openEnrollment: group[0].openEnrollment
          });
        }

        ;
        return schools;
      }
    }, {
      key: "renderSchool",
      value: function renderSchool(school) {
        var html,
            gradeLow = this._gradeAbbr(school.gradeLow),
            gradeHigh = this._gradeAbbr(school.gradeHigh),
            openEnrollment = school.openEnrollment ? " (Open Enrollment)" : '';

        html = "<div>".concat(school.name, " - ").concat(gradeLow);
        if (gradeLow !== gradeHigh) html += " - ".concat(gradeHigh);
        html += "".concat(openEnrollment, "</div>");
        this.$el.append(html);
      }
    }, {
      key: "findMissingGrades",
      value: function findMissingGrades(schools) {
        var grades = range(-1, 13, 1); // find grades that are not covered by non-open enrollment
        // remove grades covered by schools

        schools.forEach(function (school) {
          var schoolGrades = range(school.gradeLow, school.gradeHigh + 1, 1);
          grades = _.difference(grades, schoolGrades);
        });
        return grades;
      }
    }, {
      key: "findGradesInOpenEnrollment",
      value: function findGradesInOpenEnrollment(schools, grades) {
        // Pick 1 school for missing grade from open enrollment list.
        var result = [];
        grades.forEach(function (grade) {
          var _school = _.find(schools, function (school) {
            var gradeRange = range(school.gradeLow, school.gradeHigh),
                i = _.find(gradeRange, grade);

            if (i !== -1) return true;
          });

          if (_school && !_.find(result, {
            id: _school.id
          })) {
            result.push(_school);
          }
        });
        return result;
      }
    }, {
      key: "_gradeIndex",
      value: function _gradeIndex(grade) {
        return grade === 'PK' ? -1 : grade === 'KG' ? 0 : grade;
      }
    }, {
      key: "_gradeAbbr",
      value: function _gradeAbbr(index) {
        return index === -1 ? 'PK' : index === 0 ? 'KG' : index;
      }
    }, {
      key: "getPaging",
      value: function getPaging() {
        return false;
      }
    }, {
      key: "nextPage",
      value: function nextPage() {}
    }, {
      key: "prevPage",
      value: function prevPage() {}
    }]);

    return AssignedSchools;
  }();

  return AssignedSchools;
});