<?php

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

if ( ! class_exists( 'ReduxFramework_address' ) ) {
    class ReduxFramework_address {

        /**
         * Field Constructor.
         * Required - must call the parent constructor, then assign field and value to vars, and obviously call the render field function
         *
         * @since ReduxFramework 1.0.0
         */
        function __construct( $field = array(), $value = '', $parent ) {
            $this->parent = $parent;
            $this->field  = $field;
            $this->value  = $value;
        }

        /**
         * Field Render Function.
         * Takes the vars and outputs the HTML for the field in the settings
         *
         * @since ReduxFramework 1.0.0
         */
        function render() {

            $defaults = array(
                'street' => '',
                'city'   => '',
                'state'  => '',
                'zip'    => ''
            );

            $this->value = wp_parse_args( $this->value, $defaults );
            //if ( ! empty( $this->field['data'] ) && empty( $this->field['options'] ) ) {
            //    if ( empty( $this->field['args'] ) ) {
            //        $this->field['args'] = array();
            //    }
            //
            //    $this->field['options'] = $this->parent->get_wordpress_data( $this->field['data'], $this->field['args'] );
            //    $this->field['class'] .= " hasOptions ";
            //}
            //
            //if ( empty( $this->value ) && ! empty( $this->field['data'] ) && ! empty( $this->field['options'] ) ) {
            //    $this->value = $this->field['options'];
            //}
            //
            ////if (isset($this->field['text_hint']) && is_array($this->field['text_hint'])) {
            //$qtip_title = isset( $this->field['text_hint']['title'] ) ? 'qtip-title="' . $this->field['text_hint']['title'] . '" ' : '';
            //$qtip_text  = isset( $this->field['text_hint']['content'] ) ? 'qtip-content="' . $this->field['text_hint']['content'] . '" ' : '';
            ////}
            //
            //$readonly       = ( isset( $this->field['readonly'] ) && $this->field['readonly']) ? ' readonly="readonly"' : '';
            //$autocomplete   = ( isset($this->field['autocomplete']) && $this->field['autocomplete'] == false) ? ' autocomplete="off"' : '';


            echo '<input type="text" id="' . $this->field['id'] . '-street" name="' . $this->field['name'] . $this->field['name_suffix'] . '[street]" placeholder="Street Address..." value="' . esc_attr( $this->value['street'] ) . '" class="regular-text ' . $this->field['class'] . '" style="width: 43em;" />&nbsp;';

            echo '<input type="text" id="' . $this->field['id'] . '-city" name="' . $this->field['name'] . $this->field['name_suffix'] . '[city]" placeholder="City..." value="' . esc_attr( $this->value['city'] ) . '" class="regular-text ' . $this->field['class'] . '" />&nbsp;';

            echo '<select id="' . $this->field['id'] . '-state" data-placeholder="State" name="' . $this->field['name'] . '[state]" class="redux-select-item ' . $this->field['class'] . '" >';
            echo '<option></option>';

            foreach ( $this->states() as $k => $v ) {
                $this->stateDropdown($k, $v);
            }
            //foreach

            echo '</select>&nbsp;';

            echo '<input type="text" id="' . $this->field['id'] . '-zip" name="' . $this->field['name'] . $this->field['name_suffix'] . '[zip]" placeholder="Zip Code..." value="' . esc_attr( $this->value['zip'] ) . '" class="regular-text ' . $this->field['class'] . '" style="width: 7.3em;" />&nbsp;';

        }

        /**
         * Enqueue Function.
         * If this field requires any scripts, or css define this function and register/enqueue the scripts/css
         *
         * @since ReduxFramework 3.0.0
         */
        //function enqueue() {
        //    if ($this->parent->args['dev_mode']) {
        //        wp_enqueue_style(
        //            'redux-field-text-css',
        //            ReduxFramework::$_url . 'inc/fields/text/field_text.css',
        //            array(),
        //            time(),
        //            'all'
        //        );
        //    }
        //}


        protected function states() {
            $states = array(
                'AL' => 'Alabama',
                'AK' => 'Alaska',
                'AZ' => 'Arizona',
                'AR' => 'Arkansas',
                'CA' => 'California',
                'CO' => 'Colorado',
                'CT' => 'Connecticut',
                'DE' => 'Delaware',
                'FL' => 'Florida',
                'GA' => 'Georgia',
                'HI' => 'Hawaii',
                'ID' => 'Idaho',
                'IL' => 'Illinois',
                'IN' => 'Indiana',
                'IA' => 'Iowa',
                'KS' => 'Kansas',
                'KY' => 'Kentucky',
                'LA' => 'Louisiana',
                'ME' => 'Maine',
                'MD' => 'Maryland',
                'MA' => 'Massachusetts',
                'MI' => 'Michigan',
                'MN' => 'Minnesota',
                'MS' => 'Mississippi',
                'MO' => 'Missouri',
                'MT' => 'Montana',
                'NE' => 'Nebraska',
                'NV' => 'Nevada',
                'NH' => 'New Hampshire',
                'NJ' => 'New Jersey',
                'NM' => 'New Mexico',
                'NY' => 'New York',
                'NC' => 'North Carolina',
                'ND' => 'North Dakota',
                'OH' => 'Ohio',
                'OK' => 'Oklahoma',
                'OR' => 'Oregon',
                'PA' => 'Pennsylvania',
                'RI' => 'Rhode Island',
                'SC' => 'South Carolina',
                'SD' => 'South Dakota',
                'TN' => 'Tennessee',
                'TX' => 'Texas',
                'UT' => 'Utah',
                'VT' => 'Vermont',
                'VA' => 'Virginia',
                'WA' => 'Washington',
                'WV' => 'West Virginia',
                'WI' => 'Wisconsin',
                'WY' => 'Wyoming'
            );

            return $states;
        }


        protected function stateDropdown($id, $value)
        {
            if ( is_array( $this->value ) ) {
                $selected = ( is_array( $this->value ) && in_array( $id, $this->value ) ) ? ' selected="selected"' : '';
            } else {
                $selected = selected( $this->value, $id, false );
            }

            echo '<option value="' . $id . '"' . $selected . '>' . $value . '</option>';
        }

    }
}