var hji;(function () { if (!hji || !hji.requirejs) {
if (!hji) { hji = {}; } else { require = hji; }
/** vim: et:ts=4:sw=4:sts=4
 * @license RequireJS 2.3.5 Copyright jQuery Foundation and other contributors.
 * Released under MIT license, https://github.com/requirejs/requirejs/blob/master/LICENSE
 */
//Not using strict: uneven strict support in browsers, #392, and causes
//problems with requirejs.exec()/transpiler plugins that may not be strict.
/*jslint regexp: true, nomen: true, sloppy: true */
/*global window, navigator, document, importScripts, setTimeout, opera */

var requirejs, require, define;
(function (global, setTimeout) {
    var req, s, head, baseElement, dataMain, src,
        interactiveScript, currentlyAddingScript, mainScript, subPath,
        version = '2.3.5',
        commentRegExp = /\/\*[\s\S]*?\*\/|([^:"'=]|^)\/\/.*$/mg,
        cjsRequireRegExp = /[^.]\s*require\s*\(\s*["']([^'"\s]+)["']\s*\)/g,
        jsSuffixRegExp = /\.js$/,
        currDirRegExp = /^\.\//,
        op = Object.prototype,
        ostring = op.toString,
        hasOwn = op.hasOwnProperty,
        isBrowser = !!(typeof window !== 'undefined' && typeof navigator !== 'undefined' && window.document),
        isWebWorker = !isBrowser && typeof importScripts !== 'undefined',
        //PS3 indicates loaded and complete, but need to wait for complete
        //specifically. Sequence is 'loading', 'loaded', execution,
        // then 'complete'. The UA check is unfortunate, but not sure how
        //to feature test w/o causing perf issues.
        readyRegExp = isBrowser && navigator.platform === 'PLAYSTATION 3' ?
            /^complete$/ : /^(complete|loaded)$/,
        defContextName = '_',
        //Oh the tragedy, detecting opera. See the usage of isOpera for reason.
        isOpera = typeof opera !== 'undefined' && opera.toString() === '[object Opera]',
        contexts = {},
        cfg = {},
        globalDefQueue = [],
        useInteractive = false;

    //Could match something like ')//comment', do not lose the prefix to comment.
    function commentReplace(match, singlePrefix) {
        return singlePrefix || '';
    }

    function isFunction(it) {
        return ostring.call(it) === '[object Function]';
    }

    function isArray(it) {
        return ostring.call(it) === '[object Array]';
    }

    /**
     * Helper function for iterating over an array. If the func returns
     * a true value, it will break out of the loop.
     */
    function each(ary, func) {
        if (ary) {
            var i;
            for (i = 0; i < ary.length; i += 1) {
                if (ary[i] && func(ary[i], i, ary)) {
                    break;
                }
            }
        }
    }

    /**
     * Helper function for iterating over an array backwards. If the func
     * returns a true value, it will break out of the loop.
     */
    function eachReverse(ary, func) {
        if (ary) {
            var i;
            for (i = ary.length - 1; i > -1; i -= 1) {
                if (ary[i] && func(ary[i], i, ary)) {
                    break;
                }
            }
        }
    }

    function hasProp(obj, prop) {
        return hasOwn.call(obj, prop);
    }

    function getOwn(obj, prop) {
        return hasProp(obj, prop) && obj[prop];
    }

    /**
     * Cycles over properties in an object and calls a function for each
     * property value. If the function returns a truthy value, then the
     * iteration is stopped.
     */
    function eachProp(obj, func) {
        var prop;
        for (prop in obj) {
            if (hasProp(obj, prop)) {
                if (func(obj[prop], prop)) {
                    break;
                }
            }
        }
    }

    /**
     * Simple function to mix in properties from source into target,
     * but only if target does not already have a property of the same name.
     */
    function mixin(target, source, force, deepStringMixin) {
        if (source) {
            eachProp(source, function (value, prop) {
                if (force || !hasProp(target, prop)) {
                    if (deepStringMixin && typeof value === 'object' && value &&
                        !isArray(value) && !isFunction(value) &&
                        !(value instanceof RegExp)) {

                        if (!target[prop]) {
                            target[prop] = {};
                        }
                        mixin(target[prop], value, force, deepStringMixin);
                    } else {
                        target[prop] = value;
                    }
                }
            });
        }
        return target;
    }

    //Similar to Function.prototype.bind, but the 'this' object is specified
    //first, since it is easier to read/figure out what 'this' will be.
    function bind(obj, fn) {
        return function () {
            return fn.apply(obj, arguments);
        };
    }

    function scripts() {
        return document.getElementsByTagName('script');
    }

    function defaultOnError(err) {
        throw err;
    }

    //Allow getting a global that is expressed in
    //dot notation, like 'a.b.c'.
    function getGlobal(value) {
        if (!value) {
            return value;
        }
        var g = global;
        each(value.split('.'), function (part) {
            g = g[part];
        });
        return g;
    }

    /**
     * Constructs an error with a pointer to an URL with more information.
     * @param {String} id the error ID that maps to an ID on a web page.
     * @param {String} message human readable error.
     * @param {Error} [err] the original error, if there is one.
     *
     * @returns {Error}
     */
    function makeError(id, msg, err, requireModules) {
        var e = new Error(msg + '\nhttp://requirejs.org/docs/errors.html#' + id);
        e.requireType = id;
        e.requireModules = requireModules;
        if (err) {
            e.originalError = err;
        }
        return e;
    }

    if (typeof define !== 'undefined') {
        //If a define is already in play via another AMD loader,
        //do not overwrite.
        return;
    }

    if (typeof requirejs !== 'undefined') {
        if (isFunction(requirejs)) {
            //Do not overwrite an existing requirejs instance.
            return;
        }
        cfg = requirejs;
        requirejs = undefined;
    }

    //Allow for a require config object
    if (typeof require !== 'undefined' && !isFunction(require)) {
        //assume it is a config object.
        cfg = require;
        require = undefined;
    }

    function newContext(contextName) {
        var inCheckLoaded, Module, context, handlers,
            checkLoadedTimeoutId,
            config = {
                //Defaults. Do not set a default for map
                //config to speed up normalize(), which
                //will run faster if there is no default.
                waitSeconds: 7,
                baseUrl: './',
                paths: {},
                bundles: {},
                pkgs: {},
                shim: {},
                config: {}
            },
            registry = {},
            //registry of just enabled modules, to speed
            //cycle breaking code when lots of modules
            //are registered, but not activated.
            enabledRegistry = {},
            undefEvents = {},
            defQueue = [],
            defined = {},
            urlFetched = {},
            bundlesMap = {},
            requireCounter = 1,
            unnormalizedCounter = 1;

        /**
         * Trims the . and .. from an array of path segments.
         * It will keep a leading path segment if a .. will become
         * the first path segment, to help with module name lookups,
         * which act like paths, but can be remapped. But the end result,
         * all paths that use this function should look normalized.
         * NOTE: this method MODIFIES the input array.
         * @param {Array} ary the array of path segments.
         */
        function trimDots(ary) {
            var i, part;
            for (i = 0; i < ary.length; i++) {
                part = ary[i];
                if (part === '.') {
                    ary.splice(i, 1);
                    i -= 1;
                } else if (part === '..') {
                    // If at the start, or previous value is still ..,
                    // keep them so that when converted to a path it may
                    // still work when converted to a path, even though
                    // as an ID it is less than ideal. In larger point
                    // releases, may be better to just kick out an error.
                    if (i === 0 || (i === 1 && ary[2] === '..') || ary[i - 1] === '..') {
                        continue;
                    } else if (i > 0) {
                        ary.splice(i - 1, 2);
                        i -= 2;
                    }
                }
            }
        }

        /**
         * Given a relative module name, like ./something, normalize it to
         * a real name that can be mapped to a path.
         * @param {String} name the relative name
         * @param {String} baseName a real name that the name arg is relative
         * to.
         * @param {Boolean} applyMap apply the map config to the value. Should
         * only be done if this normalization is for a dependency ID.
         * @returns {String} normalized name
         */
        function normalize(name, baseName, applyMap) {
            var pkgMain, mapValue, nameParts, i, j, nameSegment, lastIndex,
                foundMap, foundI, foundStarMap, starI, normalizedBaseParts,
                baseParts = (baseName && baseName.split('/')),
                map = config.map,
                starMap = map && map['*'];

            //Adjust any relative paths.
            if (name) {
                name = name.split('/');
                lastIndex = name.length - 1;

                // If wanting node ID compatibility, strip .js from end
                // of IDs. Have to do this here, and not in nameToUrl
                // because node allows either .js or non .js to map
                // to same file.
                if (config.nodeIdCompat && jsSuffixRegExp.test(name[lastIndex])) {
                    name[lastIndex] = name[lastIndex].replace(jsSuffixRegExp, '');
                }

                // Starts with a '.' so need the baseName
                if (name[0].charAt(0) === '.' && baseParts) {
                    //Convert baseName to array, and lop off the last part,
                    //so that . matches that 'directory' and not name of the baseName's
                    //module. For instance, baseName of 'one/two/three', maps to
                    //'one/two/three.js', but we want the directory, 'one/two' for
                    //this normalization.
                    normalizedBaseParts = baseParts.slice(0, baseParts.length - 1);
                    name = normalizedBaseParts.concat(name);
                }

                trimDots(name);
                name = name.join('/');
            }

            //Apply map config if available.
            if (applyMap && map && (baseParts || starMap)) {
                nameParts = name.split('/');

                outerLoop: for (i = nameParts.length; i > 0; i -= 1) {
                    nameSegment = nameParts.slice(0, i).join('/');

                    if (baseParts) {
                        //Find the longest baseName segment match in the config.
                        //So, do joins on the biggest to smallest lengths of baseParts.
                        for (j = baseParts.length; j > 0; j -= 1) {
                            mapValue = getOwn(map, baseParts.slice(0, j).join('/'));

                            //baseName segment has config, find if it has one for
                            //this name.
                            if (mapValue) {
                                mapValue = getOwn(mapValue, nameSegment);
                                if (mapValue) {
                                    //Match, update name to the new value.
                                    foundMap = mapValue;
                                    foundI = i;
                                    break outerLoop;
                                }
                            }
                        }
                    }

                    //Check for a star map match, but just hold on to it,
                    //if there is a shorter segment match later in a matching
                    //config, then favor over this star map.
                    if (!foundStarMap && starMap && getOwn(starMap, nameSegment)) {
                        foundStarMap = getOwn(starMap, nameSegment);
                        starI = i;
                    }
                }

                if (!foundMap && foundStarMap) {
                    foundMap = foundStarMap;
                    foundI = starI;
                }

                if (foundMap) {
                    nameParts.splice(0, foundI, foundMap);
                    name = nameParts.join('/');
                }
            }

            // If the name points to a package's name, use
            // the package main instead.
            pkgMain = getOwn(config.pkgs, name);

            return pkgMain ? pkgMain : name;
        }

        function removeScript(name) {
            if (isBrowser) {
                each(scripts(), function (scriptNode) {
                    if (scriptNode.getAttribute('data-requiremodule') === name &&
                        scriptNode.getAttribute('data-requirecontext') === context.contextName) {
                        scriptNode.parentNode.removeChild(scriptNode);
                        return true;
                    }
                });
            }
        }

        function hasPathFallback(id) {
            var pathConfig = getOwn(config.paths, id);
            if (pathConfig && isArray(pathConfig) && pathConfig.length > 1) {
                //Pop off the first array value, since it failed, and
                //retry
                pathConfig.shift();
                context.require.undef(id);

                //Custom require that does not do map translation, since
                //ID is "absolute", already mapped/resolved.
                context.makeRequire(null, {
                    skipMap: true
                })([id]);

                return true;
            }
        }

        //Turns a plugin!resource to [plugin, resource]
        //with the plugin being undefined if the name
        //did not have a plugin prefix.
        function splitPrefix(name) {
            var prefix,
                index = name ? name.indexOf('!') : -1;
            if (index > -1) {
                prefix = name.substring(0, index);
                name = name.substring(index + 1, name.length);
            }
            return [prefix, name];
        }

        /**
         * Creates a module mapping that includes plugin prefix, module
         * name, and path. If parentModuleMap is provided it will
         * also normalize the name via require.normalize()
         *
         * @param {String} name the module name
         * @param {String} [parentModuleMap] parent module map
         * for the module name, used to resolve relative names.
         * @param {Boolean} isNormalized: is the ID already normalized.
         * This is true if this call is done for a define() module ID.
         * @param {Boolean} applyMap: apply the map config to the ID.
         * Should only be true if this map is for a dependency.
         *
         * @returns {Object}
         */
        function makeModuleMap(name, parentModuleMap, isNormalized, applyMap) {
            var url, pluginModule, suffix, nameParts,
                prefix = null,
                parentName = parentModuleMap ? parentModuleMap.name : null,
                originalName = name,
                isDefine = true,
                normalizedName = '';

            //If no name, then it means it is a require call, generate an
            //internal name.
            if (!name) {
                isDefine = false;
                name = '_@r' + (requireCounter += 1);
            }

            nameParts = splitPrefix(name);
            prefix = nameParts[0];
            name = nameParts[1];

            if (prefix) {
                prefix = normalize(prefix, parentName, applyMap);
                pluginModule = getOwn(defined, prefix);
            }

            //Account for relative paths if there is a base name.
            if (name) {
                if (prefix) {
                    if (isNormalized) {
                        normalizedName = name;
                    } else if (pluginModule && pluginModule.normalize) {
                        //Plugin is loaded, use its normalize method.
                        normalizedName = pluginModule.normalize(name, function (name) {
                            return normalize(name, parentName, applyMap);
                        });
                    } else {
                        // If nested plugin references, then do not try to
                        // normalize, as it will not normalize correctly. This
                        // places a restriction on resourceIds, and the longer
                        // term solution is not to normalize until plugins are
                        // loaded and all normalizations to allow for async
                        // loading of a loader plugin. But for now, fixes the
                        // common uses. Details in #1131
                        normalizedName = name.indexOf('!') === -1 ?
                            normalize(name, parentName, applyMap) :
                            name;
                    }
                } else {
                    //A regular module.
                    normalizedName = normalize(name, parentName, applyMap);

                    //Normalized name may be a plugin ID due to map config
                    //application in normalize. The map config values must
                    //already be normalized, so do not need to redo that part.
                    nameParts = splitPrefix(normalizedName);
                    prefix = nameParts[0];
                    normalizedName = nameParts[1];
                    isNormalized = true;

                    url = context.nameToUrl(normalizedName);
                }
            }

            //If the id is a plugin id that cannot be determined if it needs
            //normalization, stamp it with a unique ID so two matching relative
            //ids that may conflict can be separate.
            suffix = prefix && !pluginModule && !isNormalized ?
                '_unnormalized' + (unnormalizedCounter += 1) :
                '';

            return {
                prefix: prefix,
                name: normalizedName,
                parentMap: parentModuleMap,
                unnormalized: !!suffix,
                url: url,
                originalName: originalName,
                isDefine: isDefine,
                id: (prefix ?
                    prefix + '!' + normalizedName :
                    normalizedName) + suffix
            };
        }

        function getModule(depMap) {
            var id = depMap.id,
                mod = getOwn(registry, id);

            if (!mod) {
                mod = registry[id] = new context.Module(depMap);
            }

            return mod;
        }

        function on(depMap, name, fn) {
            var id = depMap.id,
                mod = getOwn(registry, id);

            if (hasProp(defined, id) &&
                (!mod || mod.defineEmitComplete)) {
                if (name === 'defined') {
                    fn(defined[id]);
                }
            } else {
                mod = getModule(depMap);
                if (mod.error && name === 'error') {
                    fn(mod.error);
                } else {
                    mod.on(name, fn);
                }
            }
        }

        function onError(err, errback) {
            var ids = err.requireModules,
                notified = false;

            if (errback) {
                errback(err);
            } else {
                each(ids, function (id) {
                    var mod = getOwn(registry, id);
                    if (mod) {
                        //Set error on module, so it skips timeout checks.
                        mod.error = err;
                        if (mod.events.error) {
                            notified = true;
                            mod.emit('error', err);
                        }
                    }
                });

                if (!notified) {
                    req.onError(err);
                }
            }
        }

        /**
         * Internal method to transfer globalQueue items to this context's
         * defQueue.
         */
        function takeGlobalQueue() {
            //Push all the globalDefQueue items into the context's defQueue
            if (globalDefQueue.length) {
                each(globalDefQueue, function(queueItem) {
                    var id = queueItem[0];
                    if (typeof id === 'string') {
                        context.defQueueMap[id] = true;
                    }
                    defQueue.push(queueItem);
                });
                globalDefQueue = [];
            }
        }

        handlers = {
            'require': function (mod) {
                if (mod.require) {
                    return mod.require;
                } else {
                    return (mod.require = context.makeRequire(mod.map));
                }
            },
            'exports': function (mod) {
                mod.usingExports = true;
                if (mod.map.isDefine) {
                    if (mod.exports) {
                        return (defined[mod.map.id] = mod.exports);
                    } else {
                        return (mod.exports = defined[mod.map.id] = {});
                    }
                }
            },
            'module': function (mod) {
                if (mod.module) {
                    return mod.module;
                } else {
                    return (mod.module = {
                        id: mod.map.id,
                        uri: mod.map.url,
                        config: function () {
                            return getOwn(config.config, mod.map.id) || {};
                        },
                        exports: mod.exports || (mod.exports = {})
                    });
                }
            }
        };

        function cleanRegistry(id) {
            //Clean up machinery used for waiting modules.
            delete registry[id];
            delete enabledRegistry[id];
        }

        function breakCycle(mod, traced, processed) {
            var id = mod.map.id;

            if (mod.error) {
                mod.emit('error', mod.error);
            } else {
                traced[id] = true;
                each(mod.depMaps, function (depMap, i) {
                    var depId = depMap.id,
                        dep = getOwn(registry, depId);

                    //Only force things that have not completed
                    //being defined, so still in the registry,
                    //and only if it has not been matched up
                    //in the module already.
                    if (dep && !mod.depMatched[i] && !processed[depId]) {
                        if (getOwn(traced, depId)) {
                            mod.defineDep(i, defined[depId]);
                            mod.check(); //pass false?
                        } else {
                            breakCycle(dep, traced, processed);
                        }
                    }
                });
                processed[id] = true;
            }
        }

        function checkLoaded() {
            var err, usingPathFallback,
                waitInterval = config.waitSeconds * 1000,
                //It is possible to disable the wait interval by using waitSeconds of 0.
                expired = waitInterval && (context.startTime + waitInterval) < new Date().getTime(),
                noLoads = [],
                reqCalls = [],
                stillLoading = false,
                needCycleCheck = true;

            //Do not bother if this call was a result of a cycle break.
            if (inCheckLoaded) {
                return;
            }

            inCheckLoaded = true;

            //Figure out the state of all the modules.
            eachProp(enabledRegistry, function (mod) {
                var map = mod.map,
                    modId = map.id;

                //Skip things that are not enabled or in error state.
                if (!mod.enabled) {
                    return;
                }

                if (!map.isDefine) {
                    reqCalls.push(mod);
                }

                if (!mod.error) {
                    //If the module should be executed, and it has not
                    //been inited and time is up, remember it.
                    if (!mod.inited && expired) {
                        if (hasPathFallback(modId)) {
                            usingPathFallback = true;
                            stillLoading = true;
                        } else {
                            noLoads.push(modId);
                            removeScript(modId);
                        }
                    } else if (!mod.inited && mod.fetched && map.isDefine) {
                        stillLoading = true;
                        if (!map.prefix) {
                            //No reason to keep looking for unfinished
                            //loading. If the only stillLoading is a
                            //plugin resource though, keep going,
                            //because it may be that a plugin resource
                            //is waiting on a non-plugin cycle.
                            return (needCycleCheck = false);
                        }
                    }
                }
            });

            if (expired && noLoads.length) {
                //If wait time expired, throw error of unloaded modules.
                err = makeError('timeout', 'Load timeout for modules: ' + noLoads, null, noLoads);
                err.contextName = context.contextName;
                return onError(err);
            }

            //Not expired, check for a cycle.
            if (needCycleCheck) {
                each(reqCalls, function (mod) {
                    breakCycle(mod, {}, {});
                });
            }

            //If still waiting on loads, and the waiting load is something
            //other than a plugin resource, or there are still outstanding
            //scripts, then just try back later.
            if ((!expired || usingPathFallback) && stillLoading) {
                //Something is still waiting to load. Wait for it, but only
                //if a timeout is not already in effect.
                if ((isBrowser || isWebWorker) && !checkLoadedTimeoutId) {
                    checkLoadedTimeoutId = setTimeout(function () {
                        checkLoadedTimeoutId = 0;
                        checkLoaded();
                    }, 50);
                }
            }

            inCheckLoaded = false;
        }

        Module = function (map) {
            this.events = getOwn(undefEvents, map.id) || {};
            this.map = map;
            this.shim = getOwn(config.shim, map.id);
            this.depExports = [];
            this.depMaps = [];
            this.depMatched = [];
            this.pluginMaps = {};
            this.depCount = 0;

            /* this.exports this.factory
               this.depMaps = [],
               this.enabled, this.fetched
            */
        };

        Module.prototype = {
            init: function (depMaps, factory, errback, options) {
                options = options || {};

                //Do not do more inits if already done. Can happen if there
                //are multiple define calls for the same module. That is not
                //a normal, common case, but it is also not unexpected.
                if (this.inited) {
                    return;
                }

                this.factory = factory;

                if (errback) {
                    //Register for errors on this module.
                    this.on('error', errback);
                } else if (this.events.error) {
                    //If no errback already, but there are error listeners
                    //on this module, set up an errback to pass to the deps.
                    errback = bind(this, function (err) {
                        this.emit('error', err);
                    });
                }

                //Do a copy of the dependency array, so that
                //source inputs are not modified. For example
                //"shim" deps are passed in here directly, and
                //doing a direct modification of the depMaps array
                //would affect that config.
                this.depMaps = depMaps && depMaps.slice(0);

                this.errback = errback;

                //Indicate this module has be initialized
                this.inited = true;

                this.ignore = options.ignore;

                //Could have option to init this module in enabled mode,
                //or could have been previously marked as enabled. However,
                //the dependencies are not known until init is called. So
                //if enabled previously, now trigger dependencies as enabled.
                if (options.enabled || this.enabled) {
                    //Enable this module and dependencies.
                    //Will call this.check()
                    this.enable();
                } else {
                    this.check();
                }
            },

            defineDep: function (i, depExports) {
                //Because of cycles, defined callback for a given
                //export can be called more than once.
                if (!this.depMatched[i]) {
                    this.depMatched[i] = true;
                    this.depCount -= 1;
                    this.depExports[i] = depExports;
                }
            },

            fetch: function () {
                if (this.fetched) {
                    return;
                }
                this.fetched = true;

                context.startTime = (new Date()).getTime();

                var map = this.map;

                //If the manager is for a plugin managed resource,
                //ask the plugin to load it now.
                if (this.shim) {
                    context.makeRequire(this.map, {
                        enableBuildCallback: true
                    })(this.shim.deps || [], bind(this, function () {
                        return map.prefix ? this.callPlugin() : this.load();
                    }));
                } else {
                    //Regular dependency.
                    return map.prefix ? this.callPlugin() : this.load();
                }
            },

            load: function () {
                var url = this.map.url;

                //Regular dependency.
                if (!urlFetched[url]) {
                    urlFetched[url] = true;
                    context.load(this.map.id, url);
                }
            },

            /**
             * Checks if the module is ready to define itself, and if so,
             * define it.
             */
            check: function () {
                if (!this.enabled || this.enabling) {
                    return;
                }

                var err, cjsModule,
                    id = this.map.id,
                    depExports = this.depExports,
                    exports = this.exports,
                    factory = this.factory;

                if (!this.inited) {
                    // Only fetch if not already in the defQueue.
                    if (!hasProp(context.defQueueMap, id)) {
                        this.fetch();
                    }
                } else if (this.error) {
                    this.emit('error', this.error);
                } else if (!this.defining) {
                    //The factory could trigger another require call
                    //that would result in checking this module to
                    //define itself again. If already in the process
                    //of doing that, skip this work.
                    this.defining = true;

                    if (this.depCount < 1 && !this.defined) {
                        if (isFunction(factory)) {
                            //If there is an error listener, favor passing
                            //to that instead of throwing an error. However,
                            //only do it for define()'d  modules. require
                            //errbacks should not be called for failures in
                            //their callbacks (#699). However if a global
                            //onError is set, use that.
                            if ((this.events.error && this.map.isDefine) ||
                                req.onError !== defaultOnError) {
                                try {
                                    exports = context.execCb(id, factory, depExports, exports);
                                } catch (e) {
                                    err = e;
                                }
                            } else {
                                exports = context.execCb(id, factory, depExports, exports);
                            }

                            // Favor return value over exports. If node/cjs in play,
                            // then will not have a return value anyway. Favor
                            // module.exports assignment over exports object.
                            if (this.map.isDefine && exports === undefined) {
                                cjsModule = this.module;
                                if (cjsModule) {
                                    exports = cjsModule.exports;
                                } else if (this.usingExports) {
                                    //exports already set the defined value.
                                    exports = this.exports;
                                }
                            }

                            if (err) {
                                err.requireMap = this.map;
                                err.requireModules = this.map.isDefine ? [this.map.id] : null;
                                err.requireType = this.map.isDefine ? 'define' : 'require';
                                return onError((this.error = err));
                            }

                        } else {
                            //Just a literal value
                            exports = factory;
                        }

                        this.exports = exports;

                        if (this.map.isDefine && !this.ignore) {
                            defined[id] = exports;

                            if (req.onResourceLoad) {
                                var resLoadMaps = [];
                                each(this.depMaps, function (depMap) {
                                    resLoadMaps.push(depMap.normalizedMap || depMap);
                                });
                                req.onResourceLoad(context, this.map, resLoadMaps);
                            }
                        }

                        //Clean up
                        cleanRegistry(id);

                        this.defined = true;
                    }

                    //Finished the define stage. Allow calling check again
                    //to allow define notifications below in the case of a
                    //cycle.
                    this.defining = false;

                    if (this.defined && !this.defineEmitted) {
                        this.defineEmitted = true;
                        this.emit('defined', this.exports);
                        this.defineEmitComplete = true;
                    }

                }
            },

            callPlugin: function () {
                var map = this.map,
                    id = map.id,
                    //Map already normalized the prefix.
                    pluginMap = makeModuleMap(map.prefix);

                //Mark this as a dependency for this plugin, so it
                //can be traced for cycles.
                this.depMaps.push(pluginMap);

                on(pluginMap, 'defined', bind(this, function (plugin) {
                    var load, normalizedMap, normalizedMod,
                        bundleId = getOwn(bundlesMap, this.map.id),
                        name = this.map.name,
                        parentName = this.map.parentMap ? this.map.parentMap.name : null,
                        localRequire = context.makeRequire(map.parentMap, {
                            enableBuildCallback: true
                        });

                    //If current map is not normalized, wait for that
                    //normalized name to load instead of continuing.
                    if (this.map.unnormalized) {
                        //Normalize the ID if the plugin allows it.
                        if (plugin.normalize) {
                            name = plugin.normalize(name, function (name) {
                                return normalize(name, parentName, true);
                            }) || '';
                        }

                        //prefix and name should already be normalized, no need
                        //for applying map config again either.
                        normalizedMap = makeModuleMap(map.prefix + '!' + name,
                            this.map.parentMap,
                            true);
                        on(normalizedMap,
                            'defined', bind(this, function (value) {
                                this.map.normalizedMap = normalizedMap;
                                this.init([], function () { return value; }, null, {
                                    enabled: true,
                                    ignore: true
                                });
                            }));

                        normalizedMod = getOwn(registry, normalizedMap.id);
                        if (normalizedMod) {
                            //Mark this as a dependency for this plugin, so it
                            //can be traced for cycles.
                            this.depMaps.push(normalizedMap);

                            if (this.events.error) {
                                normalizedMod.on('error', bind(this, function (err) {
                                    this.emit('error', err);
                                }));
                            }
                            normalizedMod.enable();
                        }

                        return;
                    }

                    //If a paths config, then just load that file instead to
                    //resolve the plugin, as it is built into that paths layer.
                    if (bundleId) {
                        this.map.url = context.nameToUrl(bundleId);
                        this.load();
                        return;
                    }

                    load = bind(this, function (value) {
                        this.init([], function () { return value; }, null, {
                            enabled: true
                        });
                    });

                    load.error = bind(this, function (err) {
                        this.inited = true;
                        this.error = err;
                        err.requireModules = [id];

                        //Remove temp unnormalized modules for this module,
                        //since they will never be resolved otherwise now.
                        eachProp(registry, function (mod) {
                            if (mod.map.id.indexOf(id + '_unnormalized') === 0) {
                                cleanRegistry(mod.map.id);
                            }
                        });

                        onError(err);
                    });

                    //Allow plugins to load other code without having to know the
                    //context or how to 'complete' the load.
                    load.fromText = bind(this, function (text, textAlt) {
                        /*jslint evil: true */
                        var moduleName = map.name,
                            moduleMap = makeModuleMap(moduleName),
                            hasInteractive = useInteractive;

                        //As of 2.1.0, support just passing the text, to reinforce
                        //fromText only being called once per resource. Still
                        //support old style of passing moduleName but discard
                        //that moduleName in favor of the internal ref.
                        if (textAlt) {
                            text = textAlt;
                        }

                        //Turn off interactive script matching for IE for any define
                        //calls in the text, then turn it back on at the end.
                        if (hasInteractive) {
                            useInteractive = false;
                        }

                        //Prime the system by creating a module instance for
                        //it.
                        getModule(moduleMap);

                        //Transfer any config to this other module.
                        if (hasProp(config.config, id)) {
                            config.config[moduleName] = config.config[id];
                        }

                        try {
                            req.exec(text);
                        } catch (e) {
                            return onError(makeError('fromtexteval',
                                'fromText eval for ' + id +
                                ' failed: ' + e,
                                e,
                                [id]));
                        }

                        if (hasInteractive) {
                            useInteractive = true;
                        }

                        //Mark this as a dependency for the plugin
                        //resource
                        this.depMaps.push(moduleMap);

                        //Support anonymous modules.
                        context.completeLoad(moduleName);

                        //Bind the value of that module to the value for this
                        //resource ID.
                        localRequire([moduleName], load);
                    });

                    //Use parentName here since the plugin's name is not reliable,
                    //could be some weird string with no path that actually wants to
                    //reference the parentName's path.
                    plugin.load(map.name, localRequire, load, config);
                }));

                context.enable(pluginMap, this);
                this.pluginMaps[pluginMap.id] = pluginMap;
            },

            enable: function () {
                enabledRegistry[this.map.id] = this;
                this.enabled = true;

                //Set flag mentioning that the module is enabling,
                //so that immediate calls to the defined callbacks
                //for dependencies do not trigger inadvertent load
                //with the depCount still being zero.
                this.enabling = true;

                //Enable each dependency
                each(this.depMaps, bind(this, function (depMap, i) {
                    var id, mod, handler;

                    if (typeof depMap === 'string') {
                        //Dependency needs to be converted to a depMap
                        //and wired up to this module.
                        depMap = makeModuleMap(depMap,
                            (this.map.isDefine ? this.map : this.map.parentMap),
                            false,
                            !this.skipMap);
                        this.depMaps[i] = depMap;

                        handler = getOwn(handlers, depMap.id);

                        if (handler) {
                            this.depExports[i] = handler(this);
                            return;
                        }

                        this.depCount += 1;

                        on(depMap, 'defined', bind(this, function (depExports) {
                            if (this.undefed) {
                                return;
                            }
                            this.defineDep(i, depExports);
                            this.check();
                        }));

                        if (this.errback) {
                            on(depMap, 'error', bind(this, this.errback));
                        } else if (this.events.error) {
                            // No direct errback on this module, but something
                            // else is listening for errors, so be sure to
                            // propagate the error correctly.
                            on(depMap, 'error', bind(this, function(err) {
                                this.emit('error', err);
                            }));
                        }
                    }

                    id = depMap.id;
                    mod = registry[id];

                    //Skip special modules like 'require', 'exports', 'module'
                    //Also, don't call enable if it is already enabled,
                    //important in circular dependency cases.
                    if (!hasProp(handlers, id) && mod && !mod.enabled) {
                        context.enable(depMap, this);
                    }
                }));

                //Enable each plugin that is used in
                //a dependency
                eachProp(this.pluginMaps, bind(this, function (pluginMap) {
                    var mod = getOwn(registry, pluginMap.id);
                    if (mod && !mod.enabled) {
                        context.enable(pluginMap, this);
                    }
                }));

                this.enabling = false;

                this.check();
            },

            on: function (name, cb) {
                var cbs = this.events[name];
                if (!cbs) {
                    cbs = this.events[name] = [];
                }
                cbs.push(cb);
            },

            emit: function (name, evt) {
                each(this.events[name], function (cb) {
                    cb(evt);
                });
                if (name === 'error') {
                    //Now that the error handler was triggered, remove
                    //the listeners, since this broken Module instance
                    //can stay around for a while in the registry.
                    delete this.events[name];
                }
            }
        };

        function callGetModule(args) {
            //Skip modules already defined.
            if (!hasProp(defined, args[0])) {
                getModule(makeModuleMap(args[0], null, true)).init(args[1], args[2]);
            }
        }

        function removeListener(node, func, name, ieName) {
            //Favor detachEvent because of IE9
            //issue, see attachEvent/addEventListener comment elsewhere
            //in this file.
            if (node.detachEvent && !isOpera) {
                //Probably IE. If not it will throw an error, which will be
                //useful to know.
                if (ieName) {
                    node.detachEvent(ieName, func);
                }
            } else {
                node.removeEventListener(name, func, false);
            }
        }

        /**
         * Given an event from a script node, get the requirejs info from it,
         * and then removes the event listeners on the node.
         * @param {Event} evt
         * @returns {Object}
         */
        function getScriptData(evt) {
            //Using currentTarget instead of target for Firefox 2.0's sake. Not
            //all old browsers will be supported, but this one was easy enough
            //to support and still makes sense.
            var node = evt.currentTarget || evt.srcElement;

            //Remove the listeners once here.
            removeListener(node, context.onScriptLoad, 'load', 'onreadystatechange');
            removeListener(node, context.onScriptError, 'error');

            return {
                node: node,
                id: node && node.getAttribute('data-requiremodule')
            };
        }

        function intakeDefines() {
            var args;

            //Any defined modules in the global queue, intake them now.
            takeGlobalQueue();

            //Make sure any remaining defQueue items get properly processed.
            while (defQueue.length) {
                args = defQueue.shift();
                if (args[0] === null) {
                    return onError(makeError('mismatch', 'Mismatched anonymous define() module: ' +
                        args[args.length - 1]));
                } else {
                    //args are id, deps, factory. Should be normalized by the
                    //define() function.
                    callGetModule(args);
                }
            }
            context.defQueueMap = {};
        }

        context = {
            config: config,
            contextName: contextName,
            registry: registry,
            defined: defined,
            urlFetched: urlFetched,
            defQueue: defQueue,
            defQueueMap: {},
            Module: Module,
            makeModuleMap: makeModuleMap,
            nextTick: req.nextTick,
            onError: onError,

            /**
             * Set a configuration for the context.
             * @param {Object} cfg config object to integrate.
             */
            configure: function (cfg) {
                //Make sure the baseUrl ends in a slash.
                if (cfg.baseUrl) {
                    if (cfg.baseUrl.charAt(cfg.baseUrl.length - 1) !== '/') {
                        cfg.baseUrl += '/';
                    }
                }

                // Convert old style urlArgs string to a function.
                if (typeof cfg.urlArgs === 'string') {
                    var urlArgs = cfg.urlArgs;
                    cfg.urlArgs = function(id, url) {
                        return (url.indexOf('?') === -1 ? '?' : '&') + urlArgs;
                    };
                }

                //Save off the paths since they require special processing,
                //they are additive.
                var shim = config.shim,
                    objs = {
                        paths: true,
                        bundles: true,
                        config: true,
                        map: true
                    };

                eachProp(cfg, function (value, prop) {
                    if (objs[prop]) {
                        if (!config[prop]) {
                            config[prop] = {};
                        }
                        mixin(config[prop], value, true, true);
                    } else {
                        config[prop] = value;
                    }
                });

                //Reverse map the bundles
                if (cfg.bundles) {
                    eachProp(cfg.bundles, function (value, prop) {
                        each(value, function (v) {
                            if (v !== prop) {
                                bundlesMap[v] = prop;
                            }
                        });
                    });
                }

                //Merge shim
                if (cfg.shim) {
                    eachProp(cfg.shim, function (value, id) {
                        //Normalize the structure
                        if (isArray(value)) {
                            value = {
                                deps: value
                            };
                        }
                        if ((value.exports || value.init) && !value.exportsFn) {
                            value.exportsFn = context.makeShimExports(value);
                        }
                        shim[id] = value;
                    });
                    config.shim = shim;
                }

                //Adjust packages if necessary.
                if (cfg.packages) {
                    each(cfg.packages, function (pkgObj) {
                        var location, name;

                        pkgObj = typeof pkgObj === 'string' ? {name: pkgObj} : pkgObj;

                        name = pkgObj.name;
                        location = pkgObj.location;
                        if (location) {
                            config.paths[name] = pkgObj.location;
                        }

                        //Save pointer to main module ID for pkg name.
                        //Remove leading dot in main, so main paths are normalized,
                        //and remove any trailing .js, since different package
                        //envs have different conventions: some use a module name,
                        //some use a file name.
                        config.pkgs[name] = pkgObj.name + '/' + (pkgObj.main || 'main')
                            .replace(currDirRegExp, '')
                            .replace(jsSuffixRegExp, '');
                    });
                }

                //If there are any "waiting to execute" modules in the registry,
                //update the maps for them, since their info, like URLs to load,
                //may have changed.
                eachProp(registry, function (mod, id) {
                    //If module already has init called, since it is too
                    //late to modify them, and ignore unnormalized ones
                    //since they are transient.
                    if (!mod.inited && !mod.map.unnormalized) {
                        mod.map = makeModuleMap(id, null, true);
                    }
                });

                //If a deps array or a config callback is specified, then call
                //require with those args. This is useful when require is defined as a
                //config object before require.js is loaded.
                if (cfg.deps || cfg.callback) {
                    context.require(cfg.deps || [], cfg.callback);
                }
            },

            makeShimExports: function (value) {
                function fn() {
                    var ret;
                    if (value.init) {
                        ret = value.init.apply(global, arguments);
                    }
                    return ret || (value.exports && getGlobal(value.exports));
                }
                return fn;
            },

            makeRequire: function (relMap, options) {
                options = options || {};

                function localRequire(deps, callback, errback) {
                    var id, map, requireMod;

                    if (options.enableBuildCallback && callback && isFunction(callback)) {
                        callback.__requireJsBuild = true;
                    }

                    if (typeof deps === 'string') {
                        if (isFunction(callback)) {
                            //Invalid call
                            return onError(makeError('requireargs', 'Invalid require call'), errback);
                        }

                        //If require|exports|module are requested, get the
                        //value for them from the special handlers. Caveat:
                        //this only works while module is being defined.
                        if (relMap && hasProp(handlers, deps)) {
                            return handlers[deps](registry[relMap.id]);
                        }

                        //Synchronous access to one module. If require.get is
                        //available (as in the Node adapter), prefer that.
                        if (req.get) {
                            return req.get(context, deps, relMap, localRequire);
                        }

                        //Normalize module name, if it contains . or ..
                        map = makeModuleMap(deps, relMap, false, true);
                        id = map.id;

                        if (!hasProp(defined, id)) {
                            return onError(makeError('notloaded', 'Module name "' +
                                id +
                                '" has not been loaded yet for context: ' +
                                contextName +
                                (relMap ? '' : '. Use require([])')));
                        }
                        return defined[id];
                    }

                    //Grab defines waiting in the global queue.
                    intakeDefines();

                    //Mark all the dependencies as needing to be loaded.
                    context.nextTick(function () {
                        //Some defines could have been added since the
                        //require call, collect them.
                        intakeDefines();

                        requireMod = getModule(makeModuleMap(null, relMap));

                        //Store if map config should be applied to this require
                        //call for dependencies.
                        requireMod.skipMap = options.skipMap;

                        requireMod.init(deps, callback, errback, {
                            enabled: true
                        });

                        checkLoaded();
                    });

                    return localRequire;
                }

                mixin(localRequire, {
                    isBrowser: isBrowser,

                    /**
                     * Converts a module name + .extension into an URL path.
                     * *Requires* the use of a module name. It does not support using
                     * plain URLs like nameToUrl.
                     */
                    toUrl: function (moduleNamePlusExt) {
                        var ext,
                            index = moduleNamePlusExt.lastIndexOf('.'),
                            segment = moduleNamePlusExt.split('/')[0],
                            isRelative = segment === '.' || segment === '..';

                        //Have a file extension alias, and it is not the
                        //dots from a relative path.
                        if (index !== -1 && (!isRelative || index > 1)) {
                            ext = moduleNamePlusExt.substring(index, moduleNamePlusExt.length);
                            moduleNamePlusExt = moduleNamePlusExt.substring(0, index);
                        }

                        return context.nameToUrl(normalize(moduleNamePlusExt,
                            relMap && relMap.id, true), ext,  true);
                    },

                    defined: function (id) {
                        return hasProp(defined, makeModuleMap(id, relMap, false, true).id);
                    },

                    specified: function (id) {
                        id = makeModuleMap(id, relMap, false, true).id;
                        return hasProp(defined, id) || hasProp(registry, id);
                    }
                });

                //Only allow undef on top level require calls
                if (!relMap) {
                    localRequire.undef = function (id) {
                        //Bind any waiting define() calls to this context,
                        //fix for #408
                        takeGlobalQueue();

                        var map = makeModuleMap(id, relMap, true),
                            mod = getOwn(registry, id);

                        mod.undefed = true;
                        removeScript(id);

                        delete defined[id];
                        delete urlFetched[map.url];
                        delete undefEvents[id];

                        //Clean queued defines too. Go backwards
                        //in array so that the splices do not
                        //mess up the iteration.
                        eachReverse(defQueue, function(args, i) {
                            if (args[0] === id) {
                                defQueue.splice(i, 1);
                            }
                        });
                        delete context.defQueueMap[id];

                        if (mod) {
                            //Hold on to listeners in case the
                            //module will be attempted to be reloaded
                            //using a different config.
                            if (mod.events.defined) {
                                undefEvents[id] = mod.events;
                            }

                            cleanRegistry(id);
                        }
                    };
                }

                return localRequire;
            },

            /**
             * Called to enable a module if it is still in the registry
             * awaiting enablement. A second arg, parent, the parent module,
             * is passed in for context, when this method is overridden by
             * the optimizer. Not shown here to keep code compact.
             */
            enable: function (depMap) {
                var mod = getOwn(registry, depMap.id);
                if (mod) {
                    getModule(depMap).enable();
                }
            },

            /**
             * Internal method used by environment adapters to complete a load event.
             * A load event could be a script load or just a load pass from a synchronous
             * load call.
             * @param {String} moduleName the name of the module to potentially complete.
             */
            completeLoad: function (moduleName) {
                var found, args, mod,
                    shim = getOwn(config.shim, moduleName) || {},
                    shExports = shim.exports;

                takeGlobalQueue();

                while (defQueue.length) {
                    args = defQueue.shift();
                    if (args[0] === null) {
                        args[0] = moduleName;
                        //If already found an anonymous module and bound it
                        //to this name, then this is some other anon module
                        //waiting for its completeLoad to fire.
                        if (found) {
                            break;
                        }
                        found = true;
                    } else if (args[0] === moduleName) {
                        //Found matching define call for this script!
                        found = true;
                    }

                    callGetModule(args);
                }
                context.defQueueMap = {};

                //Do this after the cycle of callGetModule in case the result
                //of those calls/init calls changes the registry.
                mod = getOwn(registry, moduleName);

                if (!found && !hasProp(defined, moduleName) && mod && !mod.inited) {
                    if (config.enforceDefine && (!shExports || !getGlobal(shExports))) {
                        if (hasPathFallback(moduleName)) {
                            return;
                        } else {
                            return onError(makeError('nodefine',
                                'No define call for ' + moduleName,
                                null,
                                [moduleName]));
                        }
                    } else {
                        //A script that does not call define(), so just simulate
                        //the call for it.
                        callGetModule([moduleName, (shim.deps || []), shim.exportsFn]);
                    }
                }

                checkLoaded();
            },

            /**
             * Converts a module name to a file path. Supports cases where
             * moduleName may actually be just an URL.
             * Note that it **does not** call normalize on the moduleName,
             * it is assumed to have already been normalized. This is an
             * internal API, not a public one. Use toUrl for the public API.
             */
            nameToUrl: function (moduleName, ext, skipExt) {
                var paths, syms, i, parentModule, url,
                    parentPath, bundleId,
                    pkgMain = getOwn(config.pkgs, moduleName);

                if (pkgMain) {
                    moduleName = pkgMain;
                }

                bundleId = getOwn(bundlesMap, moduleName);

                if (bundleId) {
                    return context.nameToUrl(bundleId, ext, skipExt);
                }

                //If a colon is in the URL, it indicates a protocol is used and it is just
                //an URL to a file, or if it starts with a slash, contains a query arg (i.e. ?)
                //or ends with .js, then assume the user meant to use an url and not a module id.
                //The slash is important for protocol-less URLs as well as full paths.
                if (req.jsExtRegExp.test(moduleName)) {
                    //Just a plain path, not module name lookup, so just return it.
                    //Add extension if it is included. This is a bit wonky, only non-.js things pass
                    //an extension, this method probably needs to be reworked.
                    url = moduleName + (ext || '');
                } else {
                    //A module that needs to be converted to a path.
                    paths = config.paths;

                    syms = moduleName.split('/');
                    //For each module name segment, see if there is a path
                    //registered for it. Start with most specific name
                    //and work up from it.
                    for (i = syms.length; i > 0; i -= 1) {
                        parentModule = syms.slice(0, i).join('/');

                        parentPath = getOwn(paths, parentModule);
                        if (parentPath) {
                            //If an array, it means there are a few choices,
                            //Choose the one that is desired
                            if (isArray(parentPath)) {
                                parentPath = parentPath[0];
                            }
                            syms.splice(0, i, parentPath);
                            break;
                        }
                    }

                    //Join the path parts together, then figure out if baseUrl is needed.
                    url = syms.join('/');
                    url += (ext || (/^data\:|^blob\:|\?/.test(url) || skipExt ? '' : '.js'));
                    url = (url.charAt(0) === '/' || url.match(/^[\w\+\.\-]+:/) ? '' : config.baseUrl) + url;
                }

                return config.urlArgs && !/^blob\:/.test(url) ?
                    url + config.urlArgs(moduleName, url) : url;
            },

            //Delegates to req.load. Broken out as a separate function to
            //allow overriding in the optimizer.
            load: function (id, url) {
                req.load(context, id, url);
            },

            /**
             * Executes a module callback function. Broken out as a separate function
             * solely to allow the build system to sequence the files in the built
             * layer in the right sequence.
             *
             * @private
             */
            execCb: function (name, callback, args, exports) {
                return callback.apply(exports, args);
            },

            /**
             * callback for script loads, used to check status of loading.
             *
             * @param {Event} evt the event from the browser for the script
             * that was loaded.
             */
            onScriptLoad: function (evt) {
                //Using currentTarget instead of target for Firefox 2.0's sake. Not
                //all old browsers will be supported, but this one was easy enough
                //to support and still makes sense.
                if (evt.type === 'load' ||
                    (readyRegExp.test((evt.currentTarget || evt.srcElement).readyState))) {
                    //Reset interactive script so a script node is not held onto for
                    //to long.
                    interactiveScript = null;

                    //Pull out the name of the module and the context.
                    var data = getScriptData(evt);
                    context.completeLoad(data.id);
                }
            },

            /**
             * Callback for script errors.
             */
            onScriptError: function (evt) {
                var data = getScriptData(evt);
                if (!hasPathFallback(data.id)) {
                    var parents = [];
                    eachProp(registry, function(value, key) {
                        if (key.indexOf('_@r') !== 0) {
                            each(value.depMaps, function(depMap) {
                                if (depMap.id === data.id) {
                                    parents.push(key);
                                    return true;
                                }
                            });
                        }
                    });
                    return onError(makeError('scripterror', 'Script error for "' + data.id +
                        (parents.length ?
                            '", needed by: ' + parents.join(', ') :
                            '"'), evt, [data.id]));
                }
            }
        };

        context.require = context.makeRequire();
        return context;
    }

    /**
     * Main entry point.
     *
     * If the only argument to require is a string, then the module that
     * is represented by that string is fetched for the appropriate context.
     *
     * If the first argument is an array, then it will be treated as an array
     * of dependency string names to fetch. An optional function callback can
     * be specified to execute when all of those dependencies are available.
     *
     * Make a local req variable to help Caja compliance (it assumes things
     * on a require that are not standardized), and to give a short
     * name for minification/local scope use.
     */
    req = requirejs = function (deps, callback, errback, optional) {

        //Find the right context, use default
        var context, config,
            contextName = defContextName;

        // Determine if have config object in the call.
        if (!isArray(deps) && typeof deps !== 'string') {
            // deps is a config object
            config = deps;
            if (isArray(callback)) {
                // Adjust args if there are dependencies
                deps = callback;
                callback = errback;
                errback = optional;
            } else {
                deps = [];
            }
        }

        if (config && config.context) {
            contextName = config.context;
        }

        context = getOwn(contexts, contextName);
        if (!context) {
            context = contexts[contextName] = req.s.newContext(contextName);
        }

        if (config) {
            context.configure(config);
        }

        return context.require(deps, callback, errback);
    };

    /**
     * Support hji.require.config() to make it easier to cooperate with other
     * AMD loaders on globally agreed names.
     */
    req.config = function (config) {
        return req(config);
    };

    /**
     * Execute something after the current tick
     * of the event loop. Override for other envs
     * that have a better solution than setTimeout.
     * @param  {Function} fn function to execute later.
     */
    req.nextTick = typeof setTimeout !== 'undefined' ? function (fn) {
        setTimeout(fn, 4);
    } : function (fn) { fn(); };

    /**
     * Export require as a global, but only if it does not already exist.
     */
    if (!require) {
        require = req;
    }

    req.version = version;

    //Used to filter out dependencies that are already paths.
    req.jsExtRegExp = /^\/|:|\?|\.js$/;
    req.isBrowser = isBrowser;
    s = req.s = {
        contexts: contexts,
        newContext: newContext
    };

    //Create default context.
    req({});

    //Exports some context-sensitive methods on global require.
    each([
        'toUrl',
        'undef',
        'defined',
        'specified'
    ], function (prop) {
        //Reference from contexts instead of early binding to default context,
        //so that during builds, the latest instance of the default context
        //with its config gets used.
        req[prop] = function () {
            var ctx = contexts[defContextName];
            return ctx.require[prop].apply(ctx, arguments);
        };
    });

    if (isBrowser) {
        head = s.head = document.getElementsByTagName('head')[0];
        //If BASE tag is in play, using appendChild is a problem for IE6.
        //When that browser dies, this can be removed. Details in this jQuery bug:
        //http://dev.jquery.com/ticket/2709
        baseElement = document.getElementsByTagName('base')[0];
        if (baseElement) {
            head = s.head = baseElement.parentNode;
        }
    }

    /**
     * Any errors that require explicitly generates will be passed to this
     * function. Intercept/override it if you want custom error handling.
     * @param {Error} err the error object.
     */
    req.onError = defaultOnError;

    /**
     * Creates the node for the load command. Only used in browser envs.
     */
    req.createNode = function (config, moduleName, url) {
        var node = config.xhtml ?
            document.createElementNS('http://www.w3.org/1999/xhtml', 'html:script') :
            document.createElement('script');
        node.type = config.scriptType || 'text/javascript';
        node.charset = 'utf-8';
        node.async = true;
        return node;
    };

    /**
     * Does the request to load a module for the browser case.
     * Make this a separate function to allow other environments
     * to override it.
     *
     * @param {Object} context the require context to find state.
     * @param {String} moduleName the name of the module.
     * @param {Object} url the URL to the module.
     */
    req.load = function (context, moduleName, url) {
        var config = (context && context.config) || {},
            node;
        if (isBrowser) {
            //In the browser so use a script tag
            node = req.createNode(config, moduleName, url);

            node.setAttribute('data-requirecontext', context.contextName);
            node.setAttribute('data-requiremodule', moduleName);

            //Set up load listener. Test attachEvent first because IE9 has
            //a subtle issue in its addEventListener and script onload firings
            //that do not match the behavior of all other browsers with
            //addEventListener support, which fire the onload event for a
            //script right after the script execution. See:
            //https://connect.microsoft.com/IE/feedback/details/648057/script-onload-event-is-not-fired-immediately-after-script-execution
            //UNFORTUNATELY Opera implements attachEvent but does not follow the script
            //script execution mode.
            if (node.attachEvent &&
                //Check if node.attachEvent is artificially added by custom script or
                //natively supported by browser
                //read https://github.com/requirejs/requirejs/issues/187
                //if we can NOT find [native code] then it must NOT natively supported.
                //in IE8, node.attachEvent does not have toString()
                //Note the test for "[native code" with no closing brace, see:
                //https://github.com/requirejs/requirejs/issues/273
                !(node.attachEvent.toString && node.attachEvent.toString().indexOf('[native code') < 0) &&
                !isOpera) {
                //Probably IE. IE (at least 6-8) do not fire
                //script onload right after executing the script, so
                //we cannot tie the anonymous define call to a name.
                //However, IE reports the script as being in 'interactive'
                //readyState at the time of the define call.
                useInteractive = true;

                node.attachEvent('onreadystatechange', context.onScriptLoad);
                //It would be great to add an error handler here to catch
                //404s in IE9+. However, onreadystatechange will fire before
                //the error handler, so that does not help. If addEventListener
                //is used, then IE will fire error before load, but we cannot
                //use that pathway given the connect.microsoft.com issue
                //mentioned above about not doing the 'script execute,
                //then fire the script load event listener before execute
                //next script' that other browsers do.
                //Best hope: IE10 fixes the issues,
                //and then destroys all installs of IE 6-9.
                //node.attachEvent('onerror', context.onScriptError);
            } else {
                node.addEventListener('load', context.onScriptLoad, false);
                node.addEventListener('error', context.onScriptError, false);
            }
            node.src = url;

            //Calling onNodeCreated after all properties on the node have been
            //set, but before it is placed in the DOM.
            if (config.onNodeCreated) {
                config.onNodeCreated(node, config, moduleName, url);
            }

            //For some cache cases in IE 6-8, the script executes before the end
            //of the appendChild execution, so to tie an anonymous define
            //call to the module name (which is stored on the node), hold on
            //to a reference to this node, but clear after the DOM insertion.
            currentlyAddingScript = node;
            if (baseElement) {
                head.insertBefore(node, baseElement);
            } else {
                head.appendChild(node);
            }
            currentlyAddingScript = null;

            return node;
        } else if (isWebWorker) {
            try {
                //In a web worker, use importScripts. This is not a very
                //efficient use of importScripts, importScripts will block until
                //its script is downloaded and evaluated. However, if web workers
                //are in play, the expectation is that a build has been done so
                //that only one script needs to be loaded anyway. This may need
                //to be reevaluated if other use cases become common.

                // Post a task to the event loop to work around a bug in WebKit
                // where the worker gets garbage-collected after calling
                // importScripts(): https://webkit.org/b/153317
                setTimeout(function() {}, 0);
                importScripts(url);

                //Account for anonymous modules
                context.completeLoad(moduleName);
            } catch (e) {
                context.onError(makeError('importscripts',
                    'importScripts failed for ' +
                    moduleName + ' at ' + url,
                    e,
                    [moduleName]));
            }
        }
    };

    function getInteractiveScript() {
        if (interactiveScript && interactiveScript.readyState === 'interactive') {
            return interactiveScript;
        }

        eachReverse(scripts(), function (script) {
            if (script.readyState === 'interactive') {
                return (interactiveScript = script);
            }
        });
        return interactiveScript;
    }

    //Look for a data-main script attribute, which could also adjust the baseUrl.
    if (isBrowser && !cfg.skipDataMain) {
        //Figure out baseUrl. Get it from the script tag with require.js in it.
        eachReverse(scripts(), function (script) {
            //Set the 'head' where we can append children by
            //using the script's parent.
            if (!head) {
                head = script.parentNode;
            }

            //Look for a data-main attribute to set main script for the page
            //to load. If it is there, the path to data main becomes the
            //baseUrl, if it is not already set.
            dataMain = script.getAttribute('data-main');
            if (dataMain) {
                //Preserve dataMain in case it is a path (i.e. contains '?')
                mainScript = dataMain;

                //Set final baseUrl if there is not already an explicit one,
                //but only do so if the data-main value is not a loader plugin
                //module ID.
                if (!cfg.baseUrl && mainScript.indexOf('!') === -1) {
                    //Pull off the directory of data-main for use as the
                    //baseUrl.
                    src = mainScript.split('/');
                    mainScript = src.pop();
                    subPath = src.length ? src.join('/')  + '/' : './';

                    cfg.baseUrl = subPath;
                }

                //Strip off any trailing .js since mainScript is now
                //like a module name.
                mainScript = mainScript.replace(jsSuffixRegExp, '');

                //If mainScript is still a path, fall back to dataMain
                if (req.jsExtRegExp.test(mainScript)) {
                    mainScript = dataMain;
                }

                //Put the data-main script in the files to load.
                cfg.deps = cfg.deps ? cfg.deps.concat(mainScript) : [mainScript];

                return true;
            }
        });
    }

    /**
     * The function that handles definitions of modules. Differs from
     * require() in that a string for the module should be the first argument,
     * and the function to execute after dependencies are loaded should
     * return a value to define the module corresponding to the first argument's
     * name.
     */
    define = function (name, deps, callback) {
        var node, context;

        //Allow for anonymous modules
        if (typeof name !== 'string') {
            //Adjust args appropriately
            callback = deps;
            deps = name;
            name = null;
        }

        //This module may not have dependencies
        if (!isArray(deps)) {
            callback = deps;
            deps = null;
        }

        //If no name, and callback is a function, then figure out if it a
        //CommonJS thing with dependencies.
        if (!deps && isFunction(callback)) {
            deps = [];
            //Remove comments from the callback string,
            //look for require calls, and pull them into the dependencies,
            //but only if there are function args.
            if (callback.length) {
                callback
                    .toString()
                    .replace(commentRegExp, commentReplace)
                    .replace(cjsRequireRegExp, function (match, dep) {
                        deps.push(dep);
                    });

                //May be a CommonJS thing even without require calls, but still
                //could use exports, and module. Avoid doing exports and module
                //work though if it just needs require.
                //REQUIRES the function to expect the CommonJS variables in the
                //order listed below.
                deps = (callback.length === 1 ? ['require'] : ['require', 'exports', 'module']).concat(deps);
            }
        }

        //If in IE 6-8 and hit an anonymous define() call, do the interactive
        //work.
        if (useInteractive) {
            node = currentlyAddingScript || getInteractiveScript();
            if (node) {
                if (!name) {
                    name = node.getAttribute('data-requiremodule');
                }
                context = contexts[node.getAttribute('data-requirecontext')];
            }
        }

        //Always save off evaluating the def call until the script onload handler.
        //This allows multiple modules to be in a file without prematurely
        //tracing dependencies, and allows for anonymous module support,
        //where the module name is not known until the script onload event
        //occurs. If no context, use the global queue, and get it processed
        //in the onscript load callback.
        if (context) {
            context.defQueue.push([name, deps, callback]);
            context.defQueueMap[name] = true;
        } else {
            globalDefQueue.push([name, deps, callback]);
        }
    };

    define.amd = {
        jQuery: true
    };

    /**
     * Executes the text. Normally just uses eval, but can be modified
     * to use a better, environment-specific call. Only used for transpiling
     * loader plugins, not for plain JS modules.
     * @param {String} text the text to execute/evaluate.
     */
    req.exec = function (text) {
        /*jslint evil: true */
        return eval(text);
    };

    //Set up with config info.
    req(cfg);
}(this, (typeof setTimeout === 'undefined' ? undefined : setTimeout)));
hji.requirejs = requirejs;hji.require = require;hji.define = define;
}
}());
hji.define("requireLib", function(){});

/**
 * @license RequireJS domReady 2.0.1 Copyright (c) 2010-2012, The Dojo Foundation All Rights Reserved.
 * Available via the MIT or new BSD license.
 * see: http://github.com/requirejs/domReady for details
 */
/*jslint */
/*global require: false, define: false, requirejs: false,
 window: false, clearInterval: false, document: false,
 self: false, setInterval: false */


hji.define('domReady',[],function () {
    'use strict';

    var isTop, testDiv, scrollIntervalId,
        isBrowser = typeof window !== "undefined" && window.document,
        isPageLoaded = !isBrowser,
        doc = isBrowser ? document : null,
        readyCalls = [];

    function runCallbacks(callbacks) {
        var i;
        for (i = 0; i < callbacks.length; i += 1) {
            callbacks[i](doc);
        }
    }

    function callReady() {
        var callbacks = readyCalls;

        if (isPageLoaded) {
            //Call the DOM ready callbacks
            if (callbacks.length) {
                readyCalls = [];
                runCallbacks(callbacks);
            }
        }
    }

    /**
     * Sets the page as loaded.
     */
    function pageLoaded() {
        if (!isPageLoaded) {
            isPageLoaded = true;
            if (scrollIntervalId) {
                clearInterval(scrollIntervalId);
            }

            callReady();
        }
    }

    if (isBrowser) {
        if (document.addEventListener) {
            //Standards. Hooray! Assumption here that if standards based,
            //it knows about DOMContentLoaded.
            document.addEventListener("DOMContentLoaded", pageLoaded, false);
            window.addEventListener("load", pageLoaded, false);
        } else if (window.attachEvent) {
            window.attachEvent("onload", pageLoaded);

            testDiv = document.createElement('div');
            try {
                isTop = window.frameElement === null;
            } catch (e) {}

            //DOMContentLoaded approximation that uses a doScroll, as found by
            //Diego Perini: http://javascript.nwbox.com/IEContentLoaded/,
            //but modified by other contributors, including jdalton
            if (testDiv.doScroll && isTop && window.external) {
                scrollIntervalId = setInterval(function () {
                    try {
                        testDiv.doScroll();
                        pageLoaded();
                    } catch (e) {}
                }, 30);
            }
        }

        //Check if document already complete, and if so, just trigger page load
        //listeners. Latest webkit browsers also use "interactive", and
        //will fire the onDOMContentLoaded before "interactive" but not after
        //entering "interactive" or "complete". More details:
        //http://dev.w3.org/html5/spec/the-end.html#the-end
        //http://stackoverflow.com/questions/3665561/document-readystate-of-interactive-vs-ondomcontentloaded
        //Hmm, this is more complicated on further use, see "firing too early"
        //bug: https://github.com/requirejs/domReady/issues/1
        //so removing the || document.readyState === "interactive" test.
        //There is still a window.onload binding that should get fired if
        //DOMContentLoaded is missed.
        if (document.readyState === "complete") {
            pageLoaded();
        }
    }

    /** START OF PUBLIC API **/

    /**
     * Registers a callback for DOM ready. If DOM is already ready, the
     * callback is called immediately.
     * @param {Function} callback
     */
    function domReady(callback) {
        if (isPageLoaded) {
            callback(doc);
        } else {
            readyCalls.push(callback);
        }
        return domReady;
    }

    domReady.version = '2.0.1';

    /**
     * Loader Plugin API method
     */
    domReady.load = function (name, req, onLoad, config) {
        if (config.isBuild) {
            onLoad(null);
        } else {
            domReady(onLoad);
        }
    };

    /** END OF PUBLIC API **/

    return domReady;
});


/**
 *  Instantiates RequireJS and all registered plugin's main.js (main-built.js)
 *  files asynchronously.
 *  Loaded by WP via wp_enqueue_script().
 *  All main/main-built js files have to be referenced in the
 *  hjiRequireJsConfig in paths as moduleName/main: path/to/main-built.js
 *  This can be done via PHP:
 *  \hji\Membership::getInstance()
 *      ->requireJs->addPath('moduleName/main', 'path/to/main-built.js');
 *  Use main.js for development and main-built.js for production.
 */
window.HJI = function () {
  var hji = {
    debug: false,
    vars: {},
    set: function set(name, value) {
      this.vars[name] = value;
    },
    get: function get(name) {
      return typeof this.vars[name] !== 'undefined' ? this.vars[name] : -1;
    },
    loadCss: function loadCss(url) {
      var link = document.createElement("link");
      link.type = "text/css";
      link.rel = "stylesheet";
      link.href = url;
      document.getElementsByTagName("head")[0].appendChild(link);
    },
    logError: function logError(message, method) {
      if (console && console.error) {
        if (method) {
          console.error(message + ' in ' + method);
        } else {
          console.error(message);
        }
      }
    },
    log: function log(message) {
      if (this.debug) console.log(message);
    },
    ajaxUrl: function ajaxUrl() {
      return this.commonVar('ajaxUrl');
    },
    licenseKey: function licenseKey() {
      return this.commonVar('licenseKey');
    },
    siteUrl: function siteUrl() {
      return this.commonVar('siteUrl');
    },
    setup: function setup() {
      this.vars = typeof hjiSettings != 'undefined' ? hjiSettings : {};
      this.debug = this.commonVar('debug') === true ? true : false;
    },
    commonVar: function commonVar(varName) {
      var common = this.get('common');

      if (common && common[varName]) {
        return common[varName];
      }

      return null;
    },
    utils: {}
  };
  hji.setup();
  document.addEventListener("DOMContentLoaded", function () {
    if (window.HJI.debug === true) {
      console.log('%c HJI DEBUG MODE IS ON', 'font-weight: bold; color: green;');
      var query = decodeURIComponent(location.search.substring(1));

      if (query) {
        console.log('%c URL Query:', 'color: green;');
        var queryObj = JSON.parse('{"' + decodeURI(query).replace(/"/g, '\\"').replace(/&/g, '","').replace(/=/g, '":"') + '"}');
        queryObj.location = queryObj.location ? JSON.parse(queryObj.location) : '';
        console.log(queryObj);
      }
    }
  });
  return hji;
}();

HJI.Membership = function () {
  var __obj = {};
  return __obj;
}();

if (!String.prototype.includes) {
  String.prototype.includes = function (search, start) {
    if (typeof start !== 'number') {
      start = 0;
    }

    if (start + search.length > this.length) {
      return false;
    } else {
      return this.indexOf(search, start) !== -1;
    }
  };
} // Load RequireJS


(function ($) {
  var readyToRoll = function readyToRoll() {
    var config = typeof hjiRequireJsConfig != 'undefined' ? hjiRequireJsConfig : {};

    hji.require.config(config);

    if (window.jQuery) {
      hji.define('jquery', function () {
        return window.jQuery;
      });
    }

    if (window._) {
      hji.define('underscore', function () {
        return window._;
      });
    }

    if (window.Backbone) {
      hji.define('backbone', function () {
        return window.Backbone;
      });
    } // Instantiate all main.js files
    // that were set in config.paths by HJI plugins.


    if (typeof config.paths != 'undefined') {
      for (i in config.paths) {
        if (i.indexOf('/main') > -1) {
          hji.require([i + '']);
        }
      }
    }
  };

  readyToRoll();
})(jQuery);
hji.define("hji-membership/membership", function(){});



var baseUrl = HJI.get('common').apiBaseUrl ? HJI.get('common').apiBaseUrl : 'https://slipstream-cdn.homejunction.com';
var nationalApiUrl = HJI.commonVar('env') == 'production' ? 'https://national-reports-cdn.homejunction.com' : 'https://national-reports-test-cdn.homejunction.com';
hji.define('hji-common/slipstream',['slipstream/bootstrap'], function () {
  if (!HJI || !HJI.licenseKey()) {
    return false;
  } // Move HJI require into global namespace for Slipstream to use it


  if (!window.define) {
    window.define = hji.define;
  }

  if (!window.require) {
    window.require = window.requirejs = hji.require;
  } // Pass loaded libraries to the require js


  if (window.jQuery) {
    window.define('jquery', function () {
      return window.jQuery;
    });
  }

  if (window._) {
    window.define('underscore', function () {
      return window._;
    });
  }

  if (window.Backbone) {
    window.define('backbone', function () {
      return window.Backbone;
    });
  } // Init Slipstream


  var options = {
    license: HJI.licenseKey(),
    version: HJI.commonVar('apiVersion'),
    hooks: {
      'pre-config': function preConfig(config) {
        config.paths.national = nationalApiUrl + '/js/1.0.8';
        config.paths.sha = 'https://cdnjs.cloudflare.com/ajax/libs/jsSHA/2.0.2';
        config.paths.snap = 'https://cdnjs.cloudflare.com/ajax/libs/snap.svg/0.4.1/snap.svg'; //config.paths.i18n = 'https://cdnjs.cloudflare.com/ajax/libs/require-i18n/2.0.4/i18n.min';

        config.paths.handlebars = '//cdnjs.cloudflare.com/ajax/libs/handlebars.js/4.0.5/handlebars.min';
        config.paths.marionette = '//cdnjs.cloudflare.com/ajax/libs/backbone.marionette/2.4.4/backbone.marionette.min';
        config.bundles = {
          'slipstream/api': ['slipstream/common/model/address', 'slipstream/common/model/async', 'slipstream/common/model/coordinates', 'slipstream/common/model/response', 'slipstream/common/model/resultset', 'slipstream/common/statistics/model/interval', 'slipstream/common/statistics/util/formatter', 'slipstream/common/statistics/view/chart', 'slipstream/common/util/enumeration', 'slipstream/common/util/formatter', 'slipstream/common/util/geolocator', 'slipstream/common/util/styles', 'slipstream/common/util/types', 'slipstream/common/util/uri', 'slipstream/common/view/async', 'slipstream/common/view/loader'],
          'slipstream/areas': ['slipstream/areas/model/area', 'slipstream/areas/model/areas', 'slipstream/areas/widget/chooser', 'slipstream/areas/widget/details'],
          'slipstream/listings': ['slipstream/listings/model/listings', 'slipstream/listings/view/catalogue', 'slipstream/listings/stylesheet'],
          'slipstream/sales': ['slipstream/sales/model/sales', 'slipstream/sales/view/catalogue', 'slipstream/sales/stylesheet']
        };
      }
    }
  };

  if (HJI.commonVar('token') && HJI.commonVar('tokenExpires')) {
    options.auth = {
      token: HJI.commonVar('token'),
      expires: HJI.commonVar('tokenExpires')
    };
  }

  Slipstream.bootstrap(options);
  return Slipstream;
});


hji.define('hji-common/national',['jquery', 'underscore', 'hji-common/slipstream'], function ($, _, Slipstream) {
  var apiUrl = HJI.commonVar('env') == 'production' ? 'https://national-reports.homejunction.com' : 'https://national-reports-test.homejunction.com';

  if (!HJI || !HJI.licenseKey()) {
    return false;
  }

  Slipstream.ready(function () {
    window.require(['national/api'], function (API) {
      var options = {
        license: HJI.licenseKey(),
        url: apiUrl
      };

      if (HJI.commonVar('token') && HJI.commonVar('tokenExpires')) {
        options.auth = {
          token: HJI.commonVar('token'),
          expires: HJI.commonVar('tokenExpires')
        };
      }

      API.init(options);

      window.require(['slipstream/common/view/async', 'national/report/model/report', 'national/report/view/composite', 'national/common/model/selection'], function (Async, Report, Composite, Selection) {
        // Construct the report model
        // data-init="national-reports" data-report-id="123"
        var report = new Report({
          id: $('[data-init="marketReport"]').data('reportId')
        }); // Instantiate CMA modal only once, because it's triggered onClick
        // and modal has its own click handler.

        var doCMA = _.once(function () {
          if ($('#cma-modal').length) {
            $('.nr-avm-estimate .nr-disclaimer-anchor').attr('data-init', 'modal');
            $('.nr-avm-estimate .nr-disclaimer-anchor').attr('data-target', '#cma-modal');
            HJI.modals.setTriggerEvents('.nr-avm-estimate .nr-disclaimer-anchor');
            HJI.modals.createModal('#cma-modal');
          }
        }); // Construct the composite view


        var async = new Async({
          model: report,
          content: function content() {
            return new Composite({
              report: report,
              events: {
                'click .nr-avm-estimate .nr-disclaimer-anchor': doCMA,
                'click .nr-avm-estimate .nr-disclaimer-popup': doCMA
              }
            }).render();
          }
        }).render();
        $('[data-init="marketReport"]').append(async.$el); // Fetch the model

        report.fetch();
      });
    });
  });
});


hji.define('hji-common/slipstream/api',['require', 'jquery'], function (require, $) {
  /**
   * Access to Slipstream API object.
   *
   * Usage:
   *  // make sure the module is required in the definition
   *  // in order to load it like this
   *  var api = require('hji-common/slipstream/api');
   *  api.ready(function(API)
   *      {
   *          API.call('/ws/webservice', params)
   *              .done(data, xhr)
   *              {
   *                  console.log(data);
   *              };
   *       });
   *
   * @type {boolean}
   */
  var def = $.Deferred();
  var __obj = {
    init: function init() {
      hji.require(['hji-common/slipstream'], function (require) {
        Slipstream.ready(function () {
          window.require(['slipstream/api'], function (API) {
            def.resolve(API);
          });
        });
      });
    }
  };
  def.promise(__obj);
  return {
    ready: function ready(callback) {
      __obj.init();

      def.done(function (API) {
        if (typeof callback === 'function') {
          callback(API);
        } else {
          console.error('Callback is not a function.');
        }
      });
    },
    fetch: function fetch(webservice, params) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        _this.ready(function (API) {
          API.call(webservice, params).done(function (response, xhr) {
            if (response.success === true) {
              resolve(response.result);
            } else {
              reject(response.error.message);
            }
          });
        });
      });
    }
  };
});


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define('hji-common/lookup/locations',['require','_'],function (require) {
  var _ = require('_');

  var Locations = /*#__PURE__*/function () {
    function Locations() {
      _classCallCheck(this, Locations);

      this.collection = [];
      this.deleted = [];
    }

    _createClass(Locations, [{
      key: "add",
      value: function add(obj) {
        var location = this.get(obj.id);

        if (!location) {
          location = new Location(obj);
          this.collection.push(location);
        }

        return location;
      }
    }, {
      key: "remove",
      value: function remove(id) {
        var index = _.findIndex(this.collection, function (location) {
          return location.id === id;
        });

        if (index > -1) {
          var location = this.collection[index];
          this.collection.splice(index, 1);
          if (!_.findWhere(this.deleted, {
            id: location.id
          })) this.deleted.push(location);
          return location;
        }

        return false;
      }
    }, {
      key: "get",
      value: function get(id) {
        return _.findWhere(this.collection, {
          id: id
        }) || null;
      }
    }, {
      key: "isDeleted",
      value: function isDeleted(id) {
        return _.findWhere(this.deleted, {
          id: id
        }) || false;
      }
    }, {
      key: "all",
      value: function all() {
        return this.collection;
      }
    }]);

    return Locations;
  }();

  var Location = function Location(obj) {
    var _this = this;

    _classCallCheck(this, Location);

    var supportedProps = ['id', 'name', 'type', 'school', 'll', 'r'];
    Object.keys(obj).map(function (key) {
      if (supportedProps.indexOf(key) !== -1 && obj[key] !== null) _this[key] = obj[key];
    });
  };

  return Locations;
});


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define('hji-common/lookup/locationInputUI',['require','jquery'],function (require) {
  var $ = require('jquery');
  /* istanbul ignore next */


  var _isAdmin = function _isAdmin() {
    return HJI ? HJI.commonVar('isAdmin') : false;
  };

  var ERR = {
    ELEMENT_NOT_SET: 'Location element "$el" is not set.',
    ELEMENT_NOT_JQUERY_OBJECT: 'Location element "$el" is not a jQuery object.',
    ELEMENT_NOT_IN_DOM: 'Location element "$el" does not exist in the DOM.'
  };

  var LocationInputUI = /*#__PURE__*/function () {
    function LocationInputUI($polygons, options) {
      _classCallCheck(this, LocationInputUI);

      this.$polygons = $polygons || null;
      this.$locations = null;
      this.$polynames = null;
      this._$container = null;
      this.settings = Object.assign({
        polynames: null,
        polynamesTarget: null
      }, options || {});
    }

    _createClass(LocationInputUI, [{
      key: "setup",
      value: function setup() {
        this._validateElement(this.$polygons);

        this._$container = this.$polygons.parent();
        this.$locations = this._initLocationsField();
        this.$polynames = this._initPolynamesField();
      }
      /**
       * Returns location values pre-set in the UI
       *
       * @return null || array - collection of location formatted objects
       */

    }, {
      key: "getValues",
      value: function getValues() {
        var locations = this.$locations.val().trim(),
            polygons = this.$polygons.val().trim(),
            polynames = this.$polynames.val().trim();
        /* istanbul ignore if */

        if (locations.length) {
          return JSON.parse(locations);
        } else if (polygons.length && polynames.length) {
          var ids = polygons.split('|'),
              names = polynames.split('|');
          return ids.map(function (id, i) {
            return Object.assign({}, {
              id: id,
              name: names[i]
            });
          });
        }

        return null;
      }
    }, {
      key: "updateInput",
      value: function updateInput(locations) {
        var self = this,
            ids = [],
            names = [],
            pipeIt = function pipeIt(arr) {
          return arr.length ? arr.join('|') : '';
        }; // Update $location value


        self.$locations.val(JSON.stringify(locations)); // Update $polygons & $polynames values

        if (locations.length) {
          locations.forEach(function (location) {
            ids.push(location.id);
            names.push(location.name);
          });
        }

        self.$polygons.val(pipeIt(ids));
        self.$polynames.val(pipeIt(names));
        self.$polynames.trigger('change');
        self.$polygons.trigger('polygon_input_updated');
      }
    }, {
      key: "_initLocationsField",
      value: function _initLocationsField() {
        // set location field if it's not defined
        var inputField = this._$container.find('.location');

        if (!inputField.length) {
          inputField = $("<input\n                        type=\"hidden\"\n                        autocomplete=\"off\"\n                        class=\"location\"\n                        name=\"location\"\n                        value=\"\"\n                    >").appendTo(this._$container);
        }

        if (_isAdmin() === true) {
          inputField.addClass('shortcode-value'); // Widgets dashboard requires fields to be prefixed with widget id

          var fieldName = this.$polygons.prop('name');
          if (fieldName.includes('widget')) inputField.prop('name', fieldName.replace('[polygon]', '[location]'));
        }

        return inputField;
      }
    }, {
      key: "_initPolynamesField",
      value: function _initPolynamesField() {
        var _this = this;

        var $el = this._$container.find(this.settings.polynamesTarget),
            createEl = function createEl() {
          // Inject polynames values only if polygon IDs are pre-populated
          // otherwise values won't correspond to each other and search will fail
          var polynames = _this.settings.polynames || '';
          return $("<input type=\"hidden\" \n                            autocomplete=\"off\" \n                            class=\"polynames\" \n                            name=\"polynames\" \n                            value=\"".concat(polynames, "\"\n                    >")).appendTo(_this._$container);
        };

        return $el.length ? $el : createEl();
      }
    }, {
      key: "_validateElement",
      value: function _validateElement($el) {
        var ERR = LocationInputUI._errors();

        if (!$el) throw new Error(ERR.ELEMENT_NOT_SET);
        if ($el instanceof $ !== true) throw new Error(ERR.ELEMENT_NOT_JQUERY_OBJECT);
        if (!document.contains($el[0])) throw new Error(ERR.ELEMENT_NOT_IN_DOM);
      }
    }], [{
      key: "_errors",
      value: function _errors()
      /* istanbul ignore next */
      {
        return ERR;
      }
    }]);

    return LocationInputUI;
  }();

  return LocationInputUI;
});


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define('hji-common/lookup/locationInput',['require','./locations','./locationInputUI'],function (require) {
  var Locations = require('./locations'),
      LocationInputUI = require('./locationInputUI'); // Polygon lookup requires a hidden field with ID polynames
  // present on the page. Selectize will save polygon names in it.


  var LocationInput = /*#__PURE__*/function () {
    function LocationInput($el, options) {
      _classCallCheck(this, LocationInput);

      if (!$el) throw new Error('Location input field failed to construct. Target element "$el" is not set.');
      if (!options) throw new Error('Location input field failed to construct. Options are not set.');
      this.settings = Object.assign({
        polygons: null,
        // string polygons value
        polynames: null,
        // string polynames value
        locations: null,
        // array of objects
        polynamesTarget: null // string - element selector

      }, options || {});
      this.$el = $el;
      this.locations = new Locations();
      this.ui = new LocationInputUI(this.$el, {
        polynames: this.settings.polynames,
        polynamesTarget: this.settings.polynamesTarget
      });
    }

    _createClass(LocationInput, [{
      key: "setup",
      value: function setup() {
        var self = this;
        this.ui.setup();

        var _hasLocations = function _hasLocations() {
          var locations = self.settings.locations;
          return Array.isArray(locations) && locations.length ? locations : self.ui.getValues();
        };

        var _setLocations = function _setLocations(collection) {
          var _bool = false;

          if (collection) {
            collection.forEach(function (location) {
              self.addLocation(location);
              _bool = true;
            });
          }

          return _bool;
        };

        return new Promise(function (resolve, reject) {
          _setLocations(_hasLocations());

          resolve(true);
        });
      }
    }, {
      key: "addLocation",
      value: function addLocation(obj) {
        var location = this.locations.add(obj);
        this.ui.updateInput(this.locations.all());
        this.ui.$polygons.trigger('location_added', location);
        return location;
      }
    }, {
      key: "onAddLocation",
      value: function onAddLocation(callback) {
        if (typeof callback === 'function') {
          this.ui.$polygons.on('location_added', function (location) {
            callback(location);
          });
        }
      }
    }, {
      key: "removeLocation",
      value: function removeLocation(id) {
        var location = this.locations.remove(id);

        if (location) {
          this.ui.$polygons.trigger('polygon_removed', {
            id: id,
            polygon: location
          });
        }

        this.ui.updateInput(this.locations.all());
      }
    }, {
      key: "getLocation",
      value: function getLocation(id) {
        return this.locations.get(id);
      }
    }]);

    return LocationInput;
  }();

  return LocationInput;
});


hji.define('hji-common/getUrlVar',['jquery'], function ($) {
  /**
   * jQuery GET URL Parameter Value
   *
   * @url https://gist.github.com/varemenos/2531765
   *
   * @param key string - query parameter
   * @param url string - optional URL to extract parameter from. In not provided, uses current window.location
   *
   * @return string
   */
  var getUrlVar = function getUrlVar(key, url) {
    var url = url || window.location.search;
    var result = new RegExp(key + "=([^&]*)", "i").exec(url);
    return result && decodeURIComponent(result[1].replace(/\+/g, '%20')) || "";
  };

  $.getUrlVar = getUrlVar;
  return getUrlVar;
});
/**
 * sifter.js
 * Copyright (c) 2013 Brian Reavis & contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this
 * file except in compliance with the License. You may obtain a copy of the License at:
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF
 * ANY KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 *
 * @author Brian Reavis <brian@thirdroute.com>
 */

(function(root, factory) {
	if (typeof hji.define === 'function' && hji.define.amd) {
		hji.define('sifter', factory);
	} else if (typeof exports === 'object') {
		module.exports = factory();
	} else {
		root.Sifter = factory();
	}
}(this, function() {

	/**
	 * Textually searches arrays and hashes of objects
	 * by property (or multiple properties). Designed
	 * specifically for autocomplete.
	 *
	 * @constructor
	 * @param {array|object} items
	 * @param {object} items
	 */
	var Sifter = function(items, settings) {
		this.items = items;
		this.settings = settings || {diacritics: true};
	};

	/**
	 * Splits a search string into an array of individual
	 * regexps to be used to match results.
	 *
	 * @param {string} query
	 * @returns {array}
	 */
	Sifter.prototype.tokenize = function(query) {
		query = trim(String(query || '').toLowerCase());
		if (!query || !query.length) return [];

		var i, n, regex, letter;
		var tokens = [];
		var words = query.split(/ +/);

		for (i = 0, n = words.length; i < n; i++) {
			regex = escape_regex(words[i]);
			if (this.settings.diacritics) {
				for (letter in DIACRITICS) {
					if (DIACRITICS.hasOwnProperty(letter)) {
						regex = regex.replace(new RegExp(letter, 'g'), DIACRITICS[letter]);
					}
				}
			}
			tokens.push({
				string : words[i],
				regex  : new RegExp(regex, 'i')
			});
		}

		return tokens;
	};

	/**
	 * Iterates over arrays and hashes.
	 *
	 * ```
	 * this.iterator(this.items, function(item, id) {
	 *    // invoked for each item
	 * });
	 * ```
	 *
	 * @param {array|object} object
	 */
	Sifter.prototype.iterator = function(object, callback) {
		var iterator;
		if (is_array(object)) {
			iterator = Array.prototype.forEach || function(callback) {
				for (var i = 0, n = this.length; i < n; i++) {
					callback(this[i], i, this);
				}
			};
		} else {
			iterator = function(callback) {
				for (var key in this) {
					if (this.hasOwnProperty(key)) {
						callback(this[key], key, this);
					}
				}
			};
		}

		iterator.apply(object, [callback]);
	};

	/**
	 * Returns a function to be used to score individual results.
	 *
	 * Good matches will have a higher score than poor matches.
	 * If an item is not a match, 0 will be returned by the function.
	 *
	 * @param {object|string} search
	 * @param {object} options (optional)
	 * @returns {function}
	 */
	Sifter.prototype.getScoreFunction = function(search, options) {
		var self, fields, tokens, token_count, nesting;

		self        = this;
		search      = self.prepareSearch(search, options);
		tokens      = search.tokens;
		fields      = search.options.fields;
		token_count = tokens.length;
		nesting     = search.options.nesting;

		/**
		 * Calculates how close of a match the
		 * given value is against a search token.
		 *
		 * @param {mixed} value
		 * @param {object} token
		 * @return {number}
		 */
		var scoreValue = function(value, token) {
			var score, pos;

			if (!value) return 0;
			value = String(value || '');
			pos = value.search(token.regex);
			if (pos === -1) return 0;
			score = token.string.length / value.length;
			if (pos === 0) score += 0.5;
			return score;
		};

		/**
		 * Calculates the score of an object
		 * against the search query.
		 *
		 * @param {object} token
		 * @param {object} data
		 * @return {number}
		 */
		var scoreObject = (function() {
			var field_count = fields.length;
			if (!field_count) {
				return function() { return 0; };
			}
			if (field_count === 1) {
				return function(token, data) {
					return scoreValue(getattr(data, fields[0], nesting), token);
				};
			}
			return function(token, data) {
				for (var i = 0, sum = 0; i < field_count; i++) {
					sum += scoreValue(getattr(data, fields[i], nesting), token);
				}
				return sum / field_count;
			};
		})();

		if (!token_count) {
			return function() { return 0; };
		}
		if (token_count === 1) {
			return function(data) {
				return scoreObject(tokens[0], data);
			};
		}

		if (search.options.conjunction === 'and') {
			return function(data) {
				var score;
				for (var i = 0, sum = 0; i < token_count; i++) {
					score = scoreObject(tokens[i], data);
					if (score <= 0) return 0;
					sum += score;
				}
				return sum / token_count;
			};
		} else {
			return function(data) {
				for (var i = 0, sum = 0; i < token_count; i++) {
					sum += scoreObject(tokens[i], data);
				}
				return sum / token_count;
			};
		}
	};

	/**
	 * Returns a function that can be used to compare two
	 * results, for sorting purposes. If no sorting should
	 * be performed, `null` will be returned.
	 *
	 * @param {string|object} search
	 * @param {object} options
	 * @return function(a,b)
	 */
	Sifter.prototype.getSortFunction = function(search, options) {
		var i, n, self, field, fields, fields_count, multiplier, multipliers, get_field, implicit_score, sort;

		self   = this;
		search = self.prepareSearch(search, options);
		sort   = (!search.query && options.sort_empty) || options.sort;

		/**
		 * Fetches the specified sort field value
		 * from a search result item.
		 *
		 * @param  {string} name
		 * @param  {object} result
		 * @return {mixed}
		 */
		get_field = function(name, result) {
			if (name === '$score') return result.score;
			return getattr(self.items[result.id], name, options.nesting);
		};

		// parse options
		fields = [];
		if (sort) {
			for (i = 0, n = sort.length; i < n; i++) {
				if (search.query || sort[i].field !== '$score') {
					fields.push(sort[i]);
				}
			}
		}

		// the "$score" field is implied to be the primary
		// sort field, unless it's manually specified
		if (search.query) {
			implicit_score = true;
			for (i = 0, n = fields.length; i < n; i++) {
				if (fields[i].field === '$score') {
					implicit_score = false;
					break;
				}
			}
			if (implicit_score) {
				fields.unshift({field: '$score', direction: 'desc'});
			}
		} else {
			for (i = 0, n = fields.length; i < n; i++) {
				if (fields[i].field === '$score') {
					fields.splice(i, 1);
					break;
				}
			}
		}

		multipliers = [];
		for (i = 0, n = fields.length; i < n; i++) {
			multipliers.push(fields[i].direction === 'desc' ? -1 : 1);
		}

		// build function
		fields_count = fields.length;
		if (!fields_count) {
			return null;
		} else if (fields_count === 1) {
			field = fields[0].field;
			multiplier = multipliers[0];
			return function(a, b) {
				return multiplier * cmp(
					get_field(field, a),
					get_field(field, b)
				);
			};
		} else {
			return function(a, b) {
				var i, result, a_value, b_value, field;
				for (i = 0; i < fields_count; i++) {
					field = fields[i].field;
					result = multipliers[i] * cmp(
						get_field(field, a),
						get_field(field, b)
					);
					if (result) return result;
				}
				return 0;
			};
		}
	};

	/**
	 * Parses a search query and returns an object
	 * with tokens and fields ready to be populated
	 * with results.
	 *
	 * @param {string} query
	 * @param {object} options
	 * @returns {object}
	 */
	Sifter.prototype.prepareSearch = function(query, options) {
		if (typeof query === 'object') return query;

		options = extend({}, options);

		var option_fields     = options.fields;
		var option_sort       = options.sort;
		var option_sort_empty = options.sort_empty;

		if (option_fields && !is_array(option_fields)) options.fields = [option_fields];
		if (option_sort && !is_array(option_sort)) options.sort = [option_sort];
		if (option_sort_empty && !is_array(option_sort_empty)) options.sort_empty = [option_sort_empty];

		return {
			options : options,
			query   : String(query || '').toLowerCase(),
			tokens  : this.tokenize(query),
			total   : 0,
			items   : []
		};
	};

	/**
	 * Searches through all items and returns a sorted array of matches.
	 *
	 * The `options` parameter can contain:
	 *
	 *   - fields {string|array}
	 *   - sort {array}
	 *   - score {function}
	 *   - filter {bool}
	 *   - limit {integer}
	 *
	 * Returns an object containing:
	 *
	 *   - options {object}
	 *   - query {string}
	 *   - tokens {array}
	 *   - total {int}
	 *   - items {array}
	 *
	 * @param {string} query
	 * @param {object} options
	 * @returns {object}
	 */
	Sifter.prototype.search = function(query, options) {
		var self = this, value, score, search, calculateScore;
		var fn_sort;
		var fn_score;

		search  = this.prepareSearch(query, options);
		options = search.options;
		query   = search.query;

		// generate result scoring function
		fn_score = options.score || self.getScoreFunction(search);

		// perform search and sort
		if (query.length) {
			self.iterator(self.items, function(item, id) {
				score = fn_score(item);
				if (options.filter === false || score > 0) {
					search.items.push({'score': score, 'id': id});
				}
			});
		} else {
			self.iterator(self.items, function(item, id) {
				search.items.push({'score': 1, 'id': id});
			});
		}

		fn_sort = self.getSortFunction(search, options);
		if (fn_sort) search.items.sort(fn_sort);

		// apply limits
		search.total = search.items.length;
		if (typeof options.limit === 'number') {
			search.items = search.items.slice(0, options.limit);
		}

		return search;
	};

	// utilities
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	var cmp = function(a, b) {
		if (typeof a === 'number' && typeof b === 'number') {
			return a > b ? 1 : (a < b ? -1 : 0);
		}
		a = asciifold(String(a || ''));
		b = asciifold(String(b || ''));
		if (a > b) return 1;
		if (b > a) return -1;
		return 0;
	};

	var extend = function(a, b) {
		var i, n, k, object;
		for (i = 1, n = arguments.length; i < n; i++) {
			object = arguments[i];
			if (!object) continue;
			for (k in object) {
				if (object.hasOwnProperty(k)) {
					a[k] = object[k];
				}
			}
		}
		return a;
	};

	/**
	 * A property getter resolving dot-notation
	 * @param  {Object}  obj     The root object to fetch property on
	 * @param  {String}  name    The optionally dotted property name to fetch
	 * @param  {Boolean} nesting Handle nesting or not
	 * @return {Object}          The resolved property value
	 */
	var getattr = function(obj, name, nesting) {
	    if (!obj || !name) return;
	    if (!nesting) return obj[name];
	    var names = name.split(".");
	    while(names.length && (obj = obj[names.shift()]));
	    return obj;
	};

	var trim = function(str) {
		return (str + '').replace(/^\s+|\s+$|/g, '');
	};

	var escape_regex = function(str) {
		return (str + '').replace(/([.?*+^$[\]\\(){}|-])/g, '\\$1');
	};

	var is_array = Array.isArray || (typeof $ !== 'undefined' && $.isArray) || function(object) {
		return Object.prototype.toString.call(object) === '[object Array]';
	};

	var DIACRITICS = {
		'a': '[aḀḁĂăÂâǍǎȺⱥȦȧẠạÄäÀàÁáĀāÃãÅåąĄÃąĄ]',
		'b': '[b␢βΒB฿𐌁ᛒ]',
		'c': '[cĆćĈĉČčĊċC̄c̄ÇçḈḉȻȼƇƈɕᴄＣｃ]',
		'd': '[dĎďḊḋḐḑḌḍḒḓḎḏĐđD̦d̦ƉɖƊɗƋƌᵭᶁᶑȡᴅＤｄð]',
		'e': '[eÉéÈèÊêḘḙĚěĔĕẼẽḚḛẺẻĖėËëĒēȨȩĘęᶒɆɇȄȅẾếỀềỄễỂểḜḝḖḗḔḕȆȇẸẹỆệⱸᴇＥｅɘǝƏƐε]',
		'f': '[fƑƒḞḟ]',
		'g': '[gɢ₲ǤǥĜĝĞğĢģƓɠĠġ]',
		'h': '[hĤĥĦħḨḩẖẖḤḥḢḣɦʰǶƕ]',
		'i': '[iÍíÌìĬĭÎîǏǐÏïḮḯĨĩĮįĪīỈỉȈȉȊȋỊịḬḭƗɨɨ̆ᵻᶖİiIıɪＩｉ]',
		'j': '[jȷĴĵɈɉʝɟʲ]',
		'k': '[kƘƙꝀꝁḰḱǨǩḲḳḴḵκϰ₭]',
		'l': '[lŁłĽľĻļĹĺḶḷḸḹḼḽḺḻĿŀȽƚⱠⱡⱢɫɬᶅɭȴʟＬｌ]',
		'n': '[nŃńǸǹŇňÑñṄṅŅņṆṇṊṋṈṉN̈n̈ƝɲȠƞᵰᶇɳȵɴＮｎŊŋ]',
		'o': '[oØøÖöÓóÒòÔôǑǒŐőŎŏȮȯỌọƟɵƠơỎỏŌōÕõǪǫȌȍՕօ]',
		'p': '[pṔṕṖṗⱣᵽƤƥᵱ]',
		'q': '[qꝖꝗʠɊɋꝘꝙq̃]',
		'r': '[rŔŕɌɍŘřŖŗṘṙȐȑȒȓṚṛⱤɽ]',
		's': '[sŚśṠṡṢṣꞨꞩŜŝŠšŞşȘșS̈s̈]',
		't': '[tŤťṪṫŢţṬṭƮʈȚțṰṱṮṯƬƭ]',
		'u': '[uŬŭɄʉỤụÜüÚúÙùÛûǓǔŰűŬŭƯưỦủŪūŨũŲųȔȕ∪]',
		'v': '[vṼṽṾṿƲʋꝞꝟⱱʋ]',
		'w': '[wẂẃẀẁŴŵẄẅẆẇẈẉ]',
		'x': '[xẌẍẊẋχ]',
		'y': '[yÝýỲỳŶŷŸÿỸỹẎẏỴỵɎɏƳƴ]',
		'z': '[zŹźẐẑŽžŻżẒẓẔẕƵƶ]'
	};

	var asciifold = (function() {
		var i, n, k, chunk;
		var foreignletters = '';
		var lookup = {};
		for (k in DIACRITICS) {
			if (DIACRITICS.hasOwnProperty(k)) {
				chunk = DIACRITICS[k].substring(2, DIACRITICS[k].length - 1);
				foreignletters += chunk;
				for (i = 0, n = chunk.length; i < n; i++) {
					lookup[chunk.charAt(i)] = k;
				}
			}
		}
		var regexp = new RegExp('[' +  foreignletters + ']', 'g');
		return function(str) {
			return str.replace(regexp, function(foreignletter) {
				return lookup[foreignletter];
			}).toLowerCase();
		};
	})();


	// export
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	return Sifter;
}));



/**
 * microplugin.js
 * Copyright (c) 2013 Brian Reavis & contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this
 * file except in compliance with the License. You may obtain a copy of the License at:
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF
 * ANY KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 *
 * @author Brian Reavis <brian@thirdroute.com>
 */

(function(root, factory) {
	if (typeof hji.define === 'function' && hji.define.amd) {
		hji.define('microplugin', factory);
	} else if (typeof exports === 'object') {
		module.exports = factory();
	} else {
		root.MicroPlugin = factory();
	}
}(this, function() {
	var MicroPlugin = {};

	MicroPlugin.mixin = function(Interface) {
		Interface.plugins = {};

		/**
		 * Initializes the listed plugins (with options).
		 * Acceptable formats:
		 *
		 * List (without options):
		 *   ['a', 'b', 'c']
		 *
		 * List (with options):
		 *   [{'name': 'a', options: {}}, {'name': 'b', options: {}}]
		 *
		 * Hash (with options):
		 *   {'a': { ... }, 'b': { ... }, 'c': { ... }}
		 *
		 * @param {mixed} plugins
		 */
		Interface.prototype.initializePlugins = function(plugins) {
			var i, n, key;
			var self  = this;
			var queue = [];

			self.plugins = {
				names     : [],
				settings  : {},
				requested : {},
				loaded    : {}
			};

			if (utils.isArray(plugins)) {
				for (i = 0, n = plugins.length; i < n; i++) {
					if (typeof plugins[i] === 'string') {
						queue.push(plugins[i]);
					} else {
						self.plugins.settings[plugins[i].name] = plugins[i].options;
						queue.push(plugins[i].name);
					}
				}
			} else if (plugins) {
				for (key in plugins) {
					if (plugins.hasOwnProperty(key)) {
						self.plugins.settings[key] = plugins[key];
						queue.push(key);
					}
				}
			}

			while (queue.length) {
				self.require(queue.shift());
			}
		};

		Interface.prototype.loadPlugin = function(name) {
			var self    = this;
			var plugins = self.plugins;
			var plugin  = Interface.plugins[name];

			if (!Interface.plugins.hasOwnProperty(name)) {
				throw new Error('Unable to find "' +  name + '" plugin');
			}

			plugins.requested[name] = true;
			plugins.loaded[name] = plugin.fn.apply(self, [self.plugins.settings[name] || {}]);
			plugins.names.push(name);
		};

		/**
		 * Initializes a plugin.
		 *
		 * @param {string} name
		 */
		Interface.prototype.require = function(name) {
			var self = this;
			var plugins = self.plugins;

			if (!self.plugins.loaded.hasOwnProperty(name)) {
				if (plugins.requested[name]) {
					throw new Error('Plugin has circular dependency ("' + name + '")');
				}
				self.loadPlugin(name);
			}

			return plugins.loaded[name];
		};

		/**
		 * Registers a plugin.
		 *
		 * @param {string} name
		 * @param {function} fn
		 */
		Interface.define = function(name, fn) {
			Interface.plugins[name] = {
				'name' : name,
				'fn'   : fn
			};
		};
	};

	var utils = {
		isArray: Array.isArray || function(vArg) {
			return Object.prototype.toString.call(vArg) === '[object Array]';
		}
	};

	return MicroPlugin;
}));

/**
 * selectize.js (v0.12.3)
 * Copyright (c) 2013–2015 Brian Reavis & contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this
 * file except in compliance with the License. You may obtain a copy of the License at:
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF
 * ANY KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 *
 * @author Brian Reavis <brian@thirdroute.com>
 */

/*jshint curly:false */
/*jshint browser:true */

(function(root, factory) {
	if (typeof hji.define === 'function' && hji.define.amd) {
		hji.define('selectize', ['jquery','sifter','microplugin'], factory);
	} else if (typeof exports === 'object') {
		module.exports = factory(require('jquery'), require('sifter'), require('microplugin'));
	} else {
		root.Selectize = factory(root.jQuery, root.Sifter, root.MicroPlugin);
	}
}(this, function($, Sifter, MicroPlugin) {
	'use strict';

	var highlight = function($element, pattern) {
		if (typeof pattern === 'string' && !pattern.length) return;
		var regex = (typeof pattern === 'string') ? new RegExp(pattern, 'i') : pattern;
	
		var highlight = function(node) {
			var skip = 0;
			if (node.nodeType === 3) {
				var pos = node.data.search(regex);
				if (pos >= 0 && node.data.length > 0) {
					var match = node.data.match(regex);
					var spannode = document.createElement('span');
					spannode.className = 'highlight';
					var middlebit = node.splitText(pos);
					var endbit = middlebit.splitText(match[0].length);
					var middleclone = middlebit.cloneNode(true);
					spannode.appendChild(middleclone);
					middlebit.parentNode.replaceChild(spannode, middlebit);
					skip = 1;
				}
			} else if (node.nodeType === 1 && node.childNodes && !/(script|style)/i.test(node.tagName)) {
				for (var i = 0; i < node.childNodes.length; ++i) {
					i += highlight(node.childNodes[i]);
				}
			}
			return skip;
		};
	
		return $element.each(function() {
			highlight(this);
		});
	};
	
	/**
	 * removeHighlight fn copied from highlight v5 and
	 * edited to remove with() and pass js strict mode
	 */
	jQuery.fn.removeHighlight = function() {
		return this.find("span.highlight").each(function() {
			this.parentNode.firstChild.nodeName;
			var parent = this.parentNode;
			parent.replaceChild(this.firstChild, this);
			parent.normalize();
		}).end();
	};
	
	
	var MicroEvent = function() {};
	MicroEvent.prototype = {
		on: function(event, fct){
			this._events = this._events || {};
			this._events[event] = this._events[event] || [];
			this._events[event].push(fct);
		},
		off: function(event, fct){
			var n = arguments.length;
			if (n === 0) return delete this._events;
			if (n === 1) return delete this._events[event];
	
			this._events = this._events || {};
			if (event in this._events === false) return;
			this._events[event].splice(this._events[event].indexOf(fct), 1);
		},
		trigger: function(event /* , args... */){
			this._events = this._events || {};
			if (event in this._events === false) return;
			for (var i = 0; i < this._events[event].length; i++){
				this._events[event][i].apply(this, Array.prototype.slice.call(arguments, 1));
			}
		}
	};
	
	/**
	 * Mixin will delegate all MicroEvent.js function in the destination object.
	 *
	 * - MicroEvent.mixin(Foobar) will make Foobar able to use MicroEvent
	 *
	 * @param {object} the object which will support MicroEvent
	 */
	MicroEvent.mixin = function(destObject){
		var props = ['on', 'off', 'trigger'];
		for (var i = 0; i < props.length; i++){
			destObject.prototype[props[i]] = MicroEvent.prototype[props[i]];
		}
	};
	
	var IS_MAC        = /Mac/.test(navigator.userAgent);
	
	var KEY_A         = 65;
	var KEY_COMMA     = 188;
	var KEY_RETURN    = 13;
	var KEY_ESC       = 27;
	var KEY_LEFT      = 37;
	var KEY_UP        = 38;
	var KEY_P         = 80;
	var KEY_RIGHT     = 39;
	var KEY_DOWN      = 40;
	var KEY_N         = 78;
	var KEY_BACKSPACE = 8;
	var KEY_DELETE    = 46;
	var KEY_SHIFT     = 16;
	var KEY_CMD       = IS_MAC ? 91 : 17;
	var KEY_CTRL      = IS_MAC ? 18 : 17;
	var KEY_TAB       = 9;
	
	var TAG_SELECT    = 1;
	var TAG_INPUT     = 2;
	
	// for now, android support in general is too spotty to support validity
	var SUPPORTS_VALIDITY_API = !/android/i.test(window.navigator.userAgent) && !!document.createElement('input').validity;
	
	
	var isset = function(object) {
		return typeof object !== 'undefined';
	};
	
	/**
	 * Converts a scalar to its best string representation
	 * for hash keys and HTML attribute values.
	 *
	 * Transformations:
	 *   'str'     -> 'str'
	 *   null      -> ''
	 *   undefined -> ''
	 *   true      -> '1'
	 *   false     -> '0'
	 *   0         -> '0'
	 *   1         -> '1'
	 *
	 * @param {string} value
	 * @returns {string|null}
	 */
	var hash_key = function(value) {
		if (typeof value === 'undefined' || value === null) return null;
		if (typeof value === 'boolean') return value ? '1' : '0';
		return value + '';
	};
	
	/**
	 * Escapes a string for use within HTML.
	 *
	 * @param {string} str
	 * @returns {string}
	 */
	var escape_html = function(str) {
		return (str + '')
			.replace(/&/g, '&amp;')
			.replace(/</g, '&lt;')
			.replace(/>/g, '&gt;')
			.replace(/"/g, '&quot;');
	};
	
	/**
	 * Escapes "$" characters in replacement strings.
	 *
	 * @param {string} str
	 * @returns {string}
	 */
	var escape_replace = function(str) {
		return (str + '').replace(/\$/g, '$$$$');
	};
	
	var hook = {};
	
	/**
	 * Wraps `method` on `self` so that `fn`
	 * is invoked before the original method.
	 *
	 * @param {object} self
	 * @param {string} method
	 * @param {function} fn
	 */
	hook.before = function(self, method, fn) {
		var original = self[method];
		self[method] = function() {
			fn.apply(self, arguments);
			return original.apply(self, arguments);
		};
	};
	
	/**
	 * Wraps `method` on `self` so that `fn`
	 * is invoked after the original method.
	 *
	 * @param {object} self
	 * @param {string} method
	 * @param {function} fn
	 */
	hook.after = function(self, method, fn) {
		var original = self[method];
		self[method] = function() {
			var result = original.apply(self, arguments);
			fn.apply(self, arguments);
			return result;
		};
	};
	
	/**
	 * Wraps `fn` so that it can only be invoked once.
	 *
	 * @param {function} fn
	 * @returns {function}
	 */
	var once = function(fn) {
		var called = false;
		return function() {
			if (called) return;
			called = true;
			fn.apply(this, arguments);
		};
	};
	
	/**
	 * Wraps `fn` so that it can only be called once
	 * every `delay` milliseconds (invoked on the falling edge).
	 *
	 * @param {function} fn
	 * @param {int} delay
	 * @returns {function}
	 */
	var debounce = function(fn, delay) {
		var timeout;
		return function() {
			var self = this;
			var args = arguments;
			window.clearTimeout(timeout);
			timeout = window.setTimeout(function() {
				fn.apply(self, args);
			}, delay);
		};
	};
	
	/**
	 * Debounce all fired events types listed in `types`
	 * while executing the provided `fn`.
	 *
	 * @param {object} self
	 * @param {array} types
	 * @param {function} fn
	 */
	var debounce_events = function(self, types, fn) {
		var type;
		var trigger = self.trigger;
		var event_args = {};
	
		// override trigger method
		self.trigger = function() {
			var type = arguments[0];
			if (types.indexOf(type) !== -1) {
				event_args[type] = arguments;
			} else {
				return trigger.apply(self, arguments);
			}
		};
	
		// invoke provided function
		fn.apply(self, []);
		self.trigger = trigger;
	
		// trigger queued events
		for (type in event_args) {
			if (event_args.hasOwnProperty(type)) {
				trigger.apply(self, event_args[type]);
			}
		}
	};
	
	/**
	 * A workaround for http://bugs.jquery.com/ticket/6696
	 *
	 * @param {object} $parent - Parent element to listen on.
	 * @param {string} event - Event name.
	 * @param {string} selector - Descendant selector to filter by.
	 * @param {function} fn - Event handler.
	 */
	var watchChildEvent = function($parent, event, selector, fn) {
		$parent.on(event, selector, function(e) {
			var child = e.target;
			while (child && child.parentNode !== $parent[0]) {
				child = child.parentNode;
			}
			e.currentTarget = child;
			return fn.apply(this, [e]);
		});
	};
	
	/**
	 * Determines the current selection within a text input control.
	 * Returns an object containing:
	 *   - start
	 *   - length
	 *
	 * @param {object} input
	 * @returns {object}
	 */
	var getSelection = function(input) {
		var result = {};
		if ('selectionStart' in input) {
			result.start = input.selectionStart;
			result.length = input.selectionEnd - result.start;
		} else if (document.selection) {
			input.focus();
			var sel = document.selection.createRange();
			var selLen = document.selection.createRange().text.length;
			sel.moveStart('character', -input.value.length);
			result.start = sel.text.length - selLen;
			result.length = selLen;
		}
		return result;
	};
	
	/**
	 * Copies CSS properties from one element to another.
	 *
	 * @param {object} $from
	 * @param {object} $to
	 * @param {array} properties
	 */
	var transferStyles = function($from, $to, properties) {
		var i, n, styles = {};
		if (properties) {
			for (i = 0, n = properties.length; i < n; i++) {
				styles[properties[i]] = $from.css(properties[i]);
			}
		} else {
			styles = $from.css();
		}
		$to.css(styles);
	};
	
	/**
	 * Measures the width of a string within a
	 * parent element (in pixels).
	 *
	 * @param {string} str
	 * @param {object} $parent
	 * @returns {int}
	 */
	var measureString = function(str, $parent) {
		if (!str) {
			return 0;
		}
	
		var $test = $('<test>').css({
			position: 'absolute',
			top: -99999,
			left: -99999,
			width: 'auto',
			padding: 0,
			whiteSpace: 'pre'
		}).text(str).appendTo('body');
	
		transferStyles($parent, $test, [
			'letterSpacing',
			'fontSize',
			'fontFamily',
			'fontWeight',
			'textTransform'
		]);
	
		var width = $test.width();
		$test.remove();
	
		return width;
	};
	
	/**
	 * Sets up an input to grow horizontally as the user
	 * types. If the value is changed manually, you can
	 * trigger the "update" handler to resize:
	 *
	 * $input.trigger('update');
	 *
	 * @param {object} $input
	 */
	var autoGrow = function($input) {
		var currentWidth = null;
	
		var update = function(e, options) {
			var value, keyCode, printable, placeholder, width;
			var shift, character, selection;
			e = e || window.event || {};
			options = options || {};
	
			if (e.metaKey || e.altKey) return;
			if (!options.force && $input.data('grow') === false) return;
	
			value = $input.val();
			if (e.type && e.type.toLowerCase() === 'keydown') {
				keyCode = e.keyCode;
				printable = (
					(keyCode >= 97 && keyCode <= 122) || // a-z
					(keyCode >= 65 && keyCode <= 90)  || // A-Z
					(keyCode >= 48 && keyCode <= 57)  || // 0-9
					keyCode === 32 // space
				);
	
				if (keyCode === KEY_DELETE || keyCode === KEY_BACKSPACE) {
					selection = getSelection($input[0]);
					if (selection.length) {
						value = value.substring(0, selection.start) + value.substring(selection.start + selection.length);
					} else if (keyCode === KEY_BACKSPACE && selection.start) {
						value = value.substring(0, selection.start - 1) + value.substring(selection.start + 1);
					} else if (keyCode === KEY_DELETE && typeof selection.start !== 'undefined') {
						value = value.substring(0, selection.start) + value.substring(selection.start + 1);
					}
				} else if (printable) {
					shift = e.shiftKey;
					character = String.fromCharCode(e.keyCode);
					if (shift) character = character.toUpperCase();
					else character = character.toLowerCase();
					value += character;
				}
			}
	
			placeholder = $input.attr('placeholder');
			if (!value && placeholder) {
				value = placeholder;
			}
	
			width = measureString(value, $input) + 4;
			if (width !== currentWidth) {
				currentWidth = width;
				$input.width(width);
				$input.triggerHandler('resize');
			}
		};
	
		$input.on('keydown keyup update blur', update);
		update();
	};
	
	var domToString = function(d) {
		var tmp = document.createElement('div');
	
		tmp.appendChild(d.cloneNode(true));
	
		return tmp.innerHTML;
	};
	
	var logError = function(message, options){
		if(!options) options = {};
		var component = "Selectize";
	
		console.error(component + ": " + message)
	
		if(options.explanation){
			// console.group is undefined in <IE11
			if(console.group) console.group();
			console.error(options.explanation);
			if(console.group) console.groupEnd();
		}
	}
	
	
	var Selectize = function($input, settings) {
		var key, i, n, dir, input, self = this;
		input = $input[0];
		input.selectize = self;
	
		// detect rtl environment
		var computedStyle = window.getComputedStyle && window.getComputedStyle(input, null);
		dir = computedStyle ? computedStyle.getPropertyValue('direction') : input.currentStyle && input.currentStyle.direction;
		dir = dir || $input.parents('[dir]:first').attr('dir') || '';
	
		// setup default state
		$.extend(self, {
			order            : 0,
			settings         : settings,
			$input           : $input,
			tabIndex         : $input.attr('tabindex') || '',
			tagType          : input.tagName.toLowerCase() === 'select' ? TAG_SELECT : TAG_INPUT,
			rtl              : /rtl/i.test(dir),
	
			eventNS          : '.selectize' + (++Selectize.count),
			highlightedValue : null,
			isOpen           : false,
			isDisabled       : false,
			isRequired       : $input.is('[required]'),
			isInvalid        : false,
			isLocked         : false,
			isFocused        : false,
			isInputHidden    : false,
			isSetup          : false,
			isShiftDown      : false,
			isCmdDown        : false,
			isCtrlDown       : false,
			ignoreFocus      : false,
			ignoreBlur       : false,
			ignoreHover      : false,
			hasOptions       : false,
			currentResults   : null,
			lastValue        : '',
			caretPos         : 0,
			loading          : 0,
			loadedSearches   : {},
	
			$activeOption    : null,
			$activeItems     : [],
	
			optgroups        : {},
			options          : {},
			userOptions      : {},
			items            : [],
			renderCache      : {},
			onSearchChange   : settings.loadThrottle === null ? self.onSearchChange : debounce(self.onSearchChange, settings.loadThrottle)
		});
	
		// search system
		self.sifter = new Sifter(this.options, {diacritics: settings.diacritics});
	
		// build options table
		if (self.settings.options) {
			for (i = 0, n = self.settings.options.length; i < n; i++) {
				self.registerOption(self.settings.options[i]);
			}
			delete self.settings.options;
		}
	
		// build optgroup table
		if (self.settings.optgroups) {
			for (i = 0, n = self.settings.optgroups.length; i < n; i++) {
				self.registerOptionGroup(self.settings.optgroups[i]);
			}
			delete self.settings.optgroups;
		}
	
		// option-dependent defaults
		self.settings.mode = self.settings.mode || (self.settings.maxItems === 1 ? 'single' : 'multi');
		if (typeof self.settings.hideSelected !== 'boolean') {
			self.settings.hideSelected = self.settings.mode === 'multi';
		}
	
		self.initializePlugins(self.settings.plugins);
		self.setupCallbacks();
		self.setupTemplates();
		self.setup();
	};
	
	// mixins
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	MicroEvent.mixin(Selectize);
	
	if(typeof MicroPlugin !== "undefined"){
		MicroPlugin.mixin(Selectize);
	}else{
		logError("Dependency MicroPlugin is missing",
			{explanation:
				"Make sure you either: (1) are using the \"standalone\" "+
				"version of Selectize, or (2) require MicroPlugin before you "+
				"load Selectize."}
		);
	}
	
	
	// methods
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	$.extend(Selectize.prototype, {
	
		/**
		 * Creates all elements and sets up event bindings.
		 */
		setup: function() {
			var self      = this;
			var settings  = self.settings;
			var eventNS   = self.eventNS;
			var $window   = $(window);
			var $document = $(document);
			var $input    = self.$input;
	
			var $wrapper;
			var $control;
			var $control_input;
			var $dropdown;
			var $dropdown_content;
			var $dropdown_parent;
			var inputMode;
			var timeout_blur;
			var timeout_focus;
			var classes;
			var classes_plugins;
			var inputId;
	
			inputMode         = self.settings.mode;
			classes           = $input.attr('class') || '';
	
			$wrapper          = $('<div>').addClass(settings.wrapperClass).addClass(classes).addClass(inputMode);
			$control          = $('<div>').addClass(settings.inputClass).addClass('items').appendTo($wrapper);
			$control_input    = $('<input type="text" autocomplete="off" />').appendTo($control).attr('tabindex', $input.is(':disabled') ? '-1' : self.tabIndex);
			$dropdown_parent  = $(settings.dropdownParent || $wrapper);
			$dropdown         = $('<div>').addClass(settings.dropdownClass).addClass(inputMode).hide().appendTo($dropdown_parent);
			$dropdown_content = $('<div>').addClass(settings.dropdownContentClass).appendTo($dropdown);
	
			if(inputId = $input.attr('id')) {
				$control_input.attr('id', inputId + '-selectized');
				$("label[for='"+inputId+"']").attr('for', inputId + '-selectized');
			}
	
			if(self.settings.copyClassesToDropdown) {
				$dropdown.addClass(classes);
			}
	
			$wrapper.css({
				width: $input[0].style.width
			});
	
			if (self.plugins.names.length) {
				classes_plugins = 'plugin-' + self.plugins.names.join(' plugin-');
				$wrapper.addClass(classes_plugins);
				$dropdown.addClass(classes_plugins);
			}
	
			if ((settings.maxItems === null || settings.maxItems > 1) && self.tagType === TAG_SELECT) {
				$input.attr('multiple', 'multiple');
			}
	
			if (self.settings.placeholder) {
				$control_input.attr('placeholder', settings.placeholder);
			}
	
			// if splitOn was not passed in, construct it from the delimiter to allow pasting universally
			if (!self.settings.splitOn && self.settings.delimiter) {
				var delimiterEscaped = self.settings.delimiter.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&');
				self.settings.splitOn = new RegExp('\\s*' + delimiterEscaped + '+\\s*');
			}
	
			if ($input.attr('autocorrect')) {
				$control_input.attr('autocorrect', $input.attr('autocorrect'));
			}
	
			if ($input.attr('autocapitalize')) {
				$control_input.attr('autocapitalize', $input.attr('autocapitalize'));
			}
	
			self.$wrapper          = $wrapper;
			self.$control          = $control;
			self.$control_input    = $control_input;
			self.$dropdown         = $dropdown;
			self.$dropdown_content = $dropdown_content;
	
			$dropdown.on('mouseenter', '[data-selectable]', function() { return self.onOptionHover.apply(self, arguments); });
			$dropdown.on('mousedown click', '[data-selectable]', function() { return self.onOptionSelect.apply(self, arguments); });
			watchChildEvent($control, 'mousedown', '*:not(input)', function() { return self.onItemSelect.apply(self, arguments); });
			autoGrow($control_input);
	
			$control.on({
				mousedown : function() { return self.onMouseDown.apply(self, arguments); },
				click     : function() { return self.onClick.apply(self, arguments); }
			});
	
			$control_input.on({
				mousedown : function(e) { e.stopPropagation(); },
				keydown   : function() { return self.onKeyDown.apply(self, arguments); },
				keyup     : function() { return self.onKeyUp.apply(self, arguments); },
				keypress  : function() { return self.onKeyPress.apply(self, arguments); },
				resize    : function() { self.positionDropdown.apply(self, []); },
				blur      : function() { return self.onBlur.apply(self, arguments); },
				focus     : function() { self.ignoreBlur = false; return self.onFocus.apply(self, arguments); },
				paste     : function() { return self.onPaste.apply(self, arguments); }
			});
	
			$document.on('keydown' + eventNS, function(e) {
				self.isCmdDown = e[IS_MAC ? 'metaKey' : 'ctrlKey'];
				self.isCtrlDown = e[IS_MAC ? 'altKey' : 'ctrlKey'];
				self.isShiftDown = e.shiftKey;
			});
	
			$document.on('keyup' + eventNS, function(e) {
				if (e.keyCode === KEY_CTRL) self.isCtrlDown = false;
				if (e.keyCode === KEY_SHIFT) self.isShiftDown = false;
				if (e.keyCode === KEY_CMD) self.isCmdDown = false;
			});
	
			$document.on('mousedown' + eventNS, function(e) {
				if (self.isFocused) {
					// prevent events on the dropdown scrollbar from causing the control to blur
					if (e.target === self.$dropdown[0] || e.target.parentNode === self.$dropdown[0]) {
						return false;
					}
					// blur on click outside
					if (!self.$control.has(e.target).length && e.target !== self.$control[0]) {
						self.blur(e.target);
					}
				}
			});
	
			$window.on(['scroll' + eventNS, 'resize' + eventNS].join(' '), function() {
				if (self.isOpen) {
					self.positionDropdown.apply(self, arguments);
				}
			});
			$window.on('mousemove' + eventNS, function() {
				self.ignoreHover = false;
			});
	
			// store original children and tab index so that they can be
			// restored when the destroy() method is called.
			this.revertSettings = {
				$children : $input.children().detach(),
				tabindex  : $input.attr('tabindex')
			};
	
			$input.attr('tabindex', -1).hide().after(self.$wrapper);
	
			if ($.isArray(settings.items)) {
				self.setValue(settings.items);
				delete settings.items;
			}
	
			// feature detect for the validation API
			if (SUPPORTS_VALIDITY_API) {
				$input.on('invalid' + eventNS, function(e) {
					e.preventDefault();
					self.isInvalid = true;
					self.refreshState();
				});
			}
	
			self.updateOriginalInput();
			self.refreshItems();
			self.refreshState();
			self.updatePlaceholder();
			self.isSetup = true;
	
			if ($input.is(':disabled')) {
				self.disable();
			}
	
			self.on('change', this.onChange);
	
			$input.data('selectize', self);
			$input.addClass('selectized');
			self.trigger('initialize');
	
			// preload options
			if (settings.preload === true) {
				self.onSearchChange('');
			}
	
		},
	
		/**
		 * Sets up default rendering functions.
		 */
		setupTemplates: function() {
			var self = this;
			var field_label = self.settings.labelField;
			var field_optgroup = self.settings.optgroupLabelField;
	
			var templates = {
				'optgroup': function(data) {
					return '<div class="optgroup">' + data.html + '</div>';
				},
				'optgroup_header': function(data, escape) {
					return '<div class="optgroup-header">' + escape(data[field_optgroup]) + '</div>';
				},
				'option': function(data, escape) {
					return '<div class="option">' + escape(data[field_label]) + '</div>';
				},
				'item': function(data, escape) {
					return '<div class="item">' + escape(data[field_label]) + '</div>';
				},
				'option_create': function(data, escape) {
					return '<div class="create">Add <strong>' + escape(data.input) + '</strong>&hellip;</div>';
				}
			};
	
			self.settings.render = $.extend({}, templates, self.settings.render);
		},
	
		/**
		 * Maps fired events to callbacks provided
		 * in the settings used when creating the control.
		 */
		setupCallbacks: function() {
			var key, fn, callbacks = {
				'initialize'      : 'onInitialize',
				'change'          : 'onChange',
				'item_add'        : 'onItemAdd',
				'item_remove'     : 'onItemRemove',
				'clear'           : 'onClear',
				'option_add'      : 'onOptionAdd',
				'option_remove'   : 'onOptionRemove',
				'option_clear'    : 'onOptionClear',
				'optgroup_add'    : 'onOptionGroupAdd',
				'optgroup_remove' : 'onOptionGroupRemove',
				'optgroup_clear'  : 'onOptionGroupClear',
				'dropdown_open'   : 'onDropdownOpen',
				'dropdown_close'  : 'onDropdownClose',
				'type'            : 'onType',
				'load'            : 'onLoad',
				'focus'           : 'onFocus',
				'blur'            : 'onBlur'
			};
	
			for (key in callbacks) {
				if (callbacks.hasOwnProperty(key)) {
					fn = this.settings[callbacks[key]];
					if (fn) this.on(key, fn);
				}
			}
		},
	
		/**
		 * Triggered when the main control element
		 * has a click event.
		 *
		 * @param {object} e
		 * @return {boolean}
		 */
		onClick: function(e) {
			var self = this;
	
			// necessary for mobile webkit devices (manual focus triggering
			// is ignored unless invoked within a click event)
			if (!self.isFocused) {
				self.focus();
				e.preventDefault();
			}
		},
	
		/**
		 * Triggered when the main control element
		 * has a mouse down event.
		 *
		 * @param {object} e
		 * @return {boolean}
		 */
		onMouseDown: function(e) {
			var self = this;
			var defaultPrevented = e.isDefaultPrevented();
			var $target = $(e.target);
	
			if (self.isFocused) {
				// retain focus by preventing native handling. if the
				// event target is the input it should not be modified.
				// otherwise, text selection within the input won't work.
				if (e.target !== self.$control_input[0]) {
					if (self.settings.mode === 'single') {
						// toggle dropdown
						self.isOpen ? self.close() : self.open();
					} else if (!defaultPrevented) {
						self.setActiveItem(null);
					}
					return false;
				}
			} else {
				// give control focus
				if (!defaultPrevented) {
					window.setTimeout(function() {
						self.focus();
					}, 0);
				}
			}
		},
	
		/**
		 * Triggered when the value of the control has been changed.
		 * This should propagate the event to the original DOM
		 * input / select element.
		 */
		onChange: function() {
			this.$input.trigger('change');
		},
	
		/**
		 * Triggered on <input> paste.
		 *
		 * @param {object} e
		 * @returns {boolean}
		 */
		onPaste: function(e) {
			var self = this;
	
			if (self.isFull() || self.isInputHidden || self.isLocked) {
				e.preventDefault();
				return;
			}
	
			// If a regex or string is included, this will split the pasted
			// input and create Items for each separate value
			if (self.settings.splitOn) {
	
				// Wait for pasted text to be recognized in value
				setTimeout(function() {
					var pastedText = self.$control_input.val();
					if(!pastedText.match(self.settings.splitOn)){ return }
	
					var splitInput = $.trim(pastedText).split(self.settings.splitOn);
					for (var i = 0, n = splitInput.length; i < n; i++) {
						self.createItem(splitInput[i]);
					}
				}, 0);
			}
		},
	
		/**
		 * Triggered on <input> keypress.
		 *
		 * @param {object} e
		 * @returns {boolean}
		 */
		onKeyPress: function(e) {
			if (this.isLocked) return e && e.preventDefault();
			var character = String.fromCharCode(e.keyCode || e.which);
			if (this.settings.create && this.settings.mode === 'multi' && character === this.settings.delimiter) {
				this.createItem();
				e.preventDefault();
				return false;
			}
		},
	
		/**
		 * Triggered on <input> keydown.
		 *
		 * @param {object} e
		 * @returns {boolean}
		 */
		onKeyDown: function(e) {
			var isInput = e.target === this.$control_input[0];
			var self = this;
	
			if (self.isLocked) {
				if (e.keyCode !== KEY_TAB) {
					e.preventDefault();
				}
				return;
			}
	
			switch (e.keyCode) {
				case KEY_A:
					if (self.isCmdDown) {
						self.selectAll();
						return;
					}
					break;
				case KEY_ESC:
					if (self.isOpen) {
						e.preventDefault();
						e.stopPropagation();
						self.close();
					}
					return;
				case KEY_N:
					if (!e.ctrlKey || e.altKey) break;
				case KEY_DOWN:
					if (!self.isOpen && self.hasOptions) {
						self.open();
					} else if (self.$activeOption) {
						self.ignoreHover = true;
						var $next = self.getAdjacentOption(self.$activeOption, 1);
						if ($next.length) self.setActiveOption($next, true, true);
					}
					e.preventDefault();
					return;
				case KEY_P:
					if (!e.ctrlKey || e.altKey) break;
				case KEY_UP:
					if (self.$activeOption) {
						self.ignoreHover = true;
						var $prev = self.getAdjacentOption(self.$activeOption, -1);
						if ($prev.length) self.setActiveOption($prev, true, true);
					}
					e.preventDefault();
					return;
				case KEY_RETURN:
					if (self.isOpen && self.$activeOption) {
						self.onOptionSelect({currentTarget: self.$activeOption});
						e.preventDefault();
					}
					return;
				case KEY_LEFT:
					self.advanceSelection(-1, e);
					return;
				case KEY_RIGHT:
					self.advanceSelection(1, e);
					return;
				case KEY_TAB:
					if (self.settings.selectOnTab && self.isOpen && self.$activeOption) {
						self.onOptionSelect({currentTarget: self.$activeOption});
	
						// Default behaviour is to jump to the next field, we only want this
						// if the current field doesn't accept any more entries
						if (!self.isFull()) {
							e.preventDefault();
						}
					}
					if (self.settings.create && self.createItem()) {
						e.preventDefault();
					}
					return;
				case KEY_BACKSPACE:
				case KEY_DELETE:
					self.deleteSelection(e);
					return;
			}
	
			if ((self.isFull() || self.isInputHidden) && !(IS_MAC ? e.metaKey : e.ctrlKey)) {
				e.preventDefault();
				return;
			}
		},
	
		/**
		 * Triggered on <input> keyup.
		 *
		 * @param {object} e
		 * @returns {boolean}
		 */
		onKeyUp: function(e) {
			var self = this;
	
			if (self.isLocked) return e && e.preventDefault();
			var value = self.$control_input.val() || '';
			if (self.lastValue !== value) {
				self.lastValue = value;
				self.onSearchChange(value);
				self.refreshOptions();
				self.trigger('type', value);
			}
		},
	
		/**
		 * Invokes the user-provide option provider / loader.
		 *
		 * Note: this function is debounced in the Selectize
		 * constructor (by `settings.loadThrottle` milliseconds)
		 *
		 * @param {string} value
		 */
		onSearchChange: function(value) {
			var self = this;
			var fn = self.settings.load;
			if (!fn) return;
			if (self.loadedSearches.hasOwnProperty(value)) return;
			self.loadedSearches[value] = true;
			self.load(function(callback) {
				fn.apply(self, [value, callback]);
			});
		},
	
		/**
		 * Triggered on <input> focus.
		 *
		 * @param {object} e (optional)
		 * @returns {boolean}
		 */
		onFocus: function(e) {
			var self = this;
			var wasFocused = self.isFocused;
	
			if (self.isDisabled) {
				self.blur();
				e && e.preventDefault();
				return false;
			}
	
			if (self.ignoreFocus) return;
			self.isFocused = true;
			if (self.settings.preload === 'focus') self.onSearchChange('');
	
			if (!wasFocused) self.trigger('focus');
	
			if (!self.$activeItems.length) {
				self.showInput();
				self.setActiveItem(null);
				self.refreshOptions(!!self.settings.openOnFocus);
			}
	
			self.refreshState();
		},
	
		/**
		 * Triggered on <input> blur.
		 *
		 * @param {object} e
		 * @param {Element} dest
		 */
		onBlur: function(e, dest) {
			var self = this;
			if (!self.isFocused) return;
			self.isFocused = false;
	
			if (self.ignoreFocus) {
				return;
			} else if (!self.ignoreBlur && document.activeElement === self.$dropdown_content[0]) {
				// necessary to prevent IE closing the dropdown when the scrollbar is clicked
				self.ignoreBlur = true;
				self.onFocus(e);
				return;
			}
	
			var deactivate = function() {
				self.close();
				self.setTextboxValue('');
				self.setActiveItem(null);
				self.setActiveOption(null);
				self.setCaret(self.items.length);
				self.refreshState();
	
				// IE11 bug: element still marked as active
				dest && dest.focus();
	
				self.ignoreFocus = false;
				self.trigger('blur');
			};
	
			self.ignoreFocus = true;
			if (self.settings.create && self.settings.createOnBlur) {
				self.createItem(null, false, deactivate);
			} else {
				deactivate();
			}
		},
	
		/**
		 * Triggered when the user rolls over
		 * an option in the autocomplete dropdown menu.
		 *
		 * @param {object} e
		 * @returns {boolean}
		 */
		onOptionHover: function(e) {
			if (this.ignoreHover) return;
			this.setActiveOption(e.currentTarget, false);
		},
	
		/**
		 * Triggered when the user clicks on an option
		 * in the autocomplete dropdown menu.
		 *
		 * @param {object} e
		 * @returns {boolean}
		 */
		onOptionSelect: function(e) {
			var value, $target, $option, self = this;
	
			if (e.preventDefault) {
				e.preventDefault();
				e.stopPropagation();
			}
	
			$target = $(e.currentTarget);
			if ($target.hasClass('create')) {
				self.createItem(null, function() {
					if (self.settings.closeAfterSelect) {
						self.close();
					}
				});
			} else {
				value = $target.attr('data-value');
				if (typeof value !== 'undefined') {
					self.lastQuery = null;
					self.setTextboxValue('');
					self.addItem(value);
					if (self.settings.closeAfterSelect) {
						self.close();
					} else if (!self.settings.hideSelected && e.type && /mouse/.test(e.type)) {
						self.setActiveOption(self.getOption(value));
					}
				}
			}
		},
	
		/**
		 * Triggered when the user clicks on an item
		 * that has been selected.
		 *
		 * @param {object} e
		 * @returns {boolean}
		 */
		onItemSelect: function(e) {
			var self = this;
	
			if (self.isLocked) return;
			if (self.settings.mode === 'multi') {
				e.preventDefault();
				self.setActiveItem(e.currentTarget, e);
			}
		},
	
		/**
		 * Invokes the provided method that provides
		 * results to a callback---which are then added
		 * as options to the control.
		 *
		 * @param {function} fn
		 */
		load: function(fn) {
			var self = this;
			var $wrapper = self.$wrapper.addClass(self.settings.loadingClass);
	
			self.loading++;
			fn.apply(self, [function(results) {
				self.loading = Math.max(self.loading - 1, 0);
				if (results && results.length) {
					self.addOption(results);
					self.refreshOptions(self.isFocused && !self.isInputHidden);
				}
				if (!self.loading) {
					$wrapper.removeClass(self.settings.loadingClass);
				}
				self.trigger('load', results);
			}]);
		},
	
		/**
		 * Sets the input field of the control to the specified value.
		 *
		 * @param {string} value
		 */
		setTextboxValue: function(value) {
			var $input = this.$control_input;
			var changed = $input.val() !== value;
			if (changed) {
				$input.val(value).triggerHandler('update');
				this.lastValue = value;
			}
		},
	
		/**
		 * Returns the value of the control. If multiple items
		 * can be selected (e.g. <select multiple>), this returns
		 * an array. If only one item can be selected, this
		 * returns a string.
		 *
		 * @returns {mixed}
		 */
		getValue: function() {
			if (this.tagType === TAG_SELECT && this.$input.attr('multiple')) {
				return this.items;
			} else {
				return this.items.join(this.settings.delimiter);
			}
		},
	
		/**
		 * Resets the selected items to the given value.
		 *
		 * @param {mixed} value
		 */
		setValue: function(value, silent) {
			var events = silent ? [] : ['change'];
	
			debounce_events(this, events, function() {
				this.clear(silent);
				this.addItems(value, silent);
			});
		},
	
		/**
		 * Sets the selected item.
		 *
		 * @param {object} $item
		 * @param {object} e (optional)
		 */
		setActiveItem: function($item, e) {
			var self = this;
			var eventName;
			var i, idx, begin, end, item, swap;
			var $last;
	
			if (self.settings.mode === 'single') return;
			$item = $($item);
	
			// clear the active selection
			if (!$item.length) {
				$(self.$activeItems).removeClass('active');
				self.$activeItems = [];
				if (self.isFocused) {
					self.showInput();
				}
				return;
			}
	
			// modify selection
			eventName = e && e.type.toLowerCase();
	
			if (eventName === 'mousedown' && self.isShiftDown && self.$activeItems.length) {
				$last = self.$control.children('.active:last');
				begin = Array.prototype.indexOf.apply(self.$control[0].childNodes, [$last[0]]);
				end   = Array.prototype.indexOf.apply(self.$control[0].childNodes, [$item[0]]);
				if (begin > end) {
					swap  = begin;
					begin = end;
					end   = swap;
				}
				for (i = begin; i <= end; i++) {
					item = self.$control[0].childNodes[i];
					if (self.$activeItems.indexOf(item) === -1) {
						$(item).addClass('active');
						self.$activeItems.push(item);
					}
				}
				e.preventDefault();
			} else if ((eventName === 'mousedown' && self.isCtrlDown) || (eventName === 'keydown' && this.isShiftDown)) {
				if ($item.hasClass('active')) {
					idx = self.$activeItems.indexOf($item[0]);
					self.$activeItems.splice(idx, 1);
					$item.removeClass('active');
				} else {
					self.$activeItems.push($item.addClass('active')[0]);
				}
			} else {
				$(self.$activeItems).removeClass('active');
				self.$activeItems = [$item.addClass('active')[0]];
			}
	
			// ensure control has focus
			self.hideInput();
			if (!this.isFocused) {
				self.focus();
			}
		},
	
		/**
		 * Sets the selected item in the dropdown menu
		 * of available options.
		 *
		 * @param {object} $object
		 * @param {boolean} scroll
		 * @param {boolean} animate
		 */
		setActiveOption: function($option, scroll, animate) {
			var height_menu, height_item, y;
			var scroll_top, scroll_bottom;
			var self = this;
	
			if (self.$activeOption) self.$activeOption.removeClass('active');
			self.$activeOption = null;
	
			$option = $($option);
			if (!$option.length) return;
	
			self.$activeOption = $option.addClass('active');
	
			if (scroll || !isset(scroll)) {
	
				height_menu   = self.$dropdown_content.height();
				height_item   = self.$activeOption.outerHeight(true);
				scroll        = self.$dropdown_content.scrollTop() || 0;
				y             = self.$activeOption.offset().top - self.$dropdown_content.offset().top + scroll;
				scroll_top    = y;
				scroll_bottom = y - height_menu + height_item;
	
				if (y + height_item > height_menu + scroll) {
					self.$dropdown_content.stop().animate({scrollTop: scroll_bottom}, animate ? self.settings.scrollDuration : 0);
				} else if (y < scroll) {
					self.$dropdown_content.stop().animate({scrollTop: scroll_top}, animate ? self.settings.scrollDuration : 0);
				}
	
			}
		},
	
		/**
		 * Selects all items (CTRL + A).
		 */
		selectAll: function() {
			var self = this;
			if (self.settings.mode === 'single') return;
	
			self.$activeItems = Array.prototype.slice.apply(self.$control.children(':not(input)').addClass('active'));
			if (self.$activeItems.length) {
				self.hideInput();
				self.close();
			}
			self.focus();
		},
	
		/**
		 * Hides the input element out of view, while
		 * retaining its focus.
		 */
		hideInput: function() {
			var self = this;
	
			self.setTextboxValue('');
			self.$control_input.css({opacity: 0, position: 'absolute', left: self.rtl ? 10000 : -10000});
			self.isInputHidden = true;
		},
	
		/**
		 * Restores input visibility.
		 */
		showInput: function() {
			this.$control_input.css({opacity: 1, position: 'relative', left: 0});
			this.isInputHidden = false;
		},
	
		/**
		 * Gives the control focus.
		 */
		focus: function() {
			var self = this;
			if (self.isDisabled) return;
	
			self.ignoreFocus = true;
			self.$control_input[0].focus();
			window.setTimeout(function() {
				self.ignoreFocus = false;
				self.onFocus();
			}, 0);
		},
	
		/**
		 * Forces the control out of focus.
		 *
		 * @param {Element} dest
		 */
		blur: function(dest) {
			this.$control_input[0].blur();
			this.onBlur(null, dest);
		},
	
		/**
		 * Returns a function that scores an object
		 * to show how good of a match it is to the
		 * provided query.
		 *
		 * @param {string} query
		 * @param {object} options
		 * @return {function}
		 */
		getScoreFunction: function(query) {
			return this.sifter.getScoreFunction(query, this.getSearchOptions());
		},
	
		/**
		 * Returns search options for sifter (the system
		 * for scoring and sorting results).
		 *
		 * @see https://github.com/brianreavis/sifter.js
		 * @return {object}
		 */
		getSearchOptions: function() {
			var settings = this.settings;
			var sort = settings.sortField;
			if (typeof sort === 'string') {
				sort = [{field: sort}];
			}
	
			return {
				fields      : settings.searchField,
				conjunction : settings.searchConjunction,
				sort        : sort
			};
		},
	
		/**
		 * Searches through available options and returns
		 * a sorted array of matches.
		 *
		 * Returns an object containing:
		 *
		 *   - query {string}
		 *   - tokens {array}
		 *   - total {int}
		 *   - items {array}
		 *
		 * @param {string} query
		 * @returns {object}
		 */
		search: function(query) {
			var i, value, score, result, calculateScore;
			var self     = this;
			var settings = self.settings;
			var options  = this.getSearchOptions();
	
			// validate user-provided result scoring function
			if (settings.score) {
				calculateScore = self.settings.score.apply(this, [query]);
				if (typeof calculateScore !== 'function') {
					throw new Error('Selectize "score" setting must be a function that returns a function');
				}
			}
	
			// perform search
			if (query !== self.lastQuery) {
				self.lastQuery = query;
				result = self.sifter.search(query, $.extend(options, {score: calculateScore}));
				self.currentResults = result;
			} else {
				result = $.extend(true, {}, self.currentResults);
			}
	
			// filter out selected items
			if (settings.hideSelected) {
				for (i = result.items.length - 1; i >= 0; i--) {
					if (self.items.indexOf(hash_key(result.items[i].id)) !== -1) {
						result.items.splice(i, 1);
					}
				}
			}
	
			return result;
		},
	
		/**
		 * Refreshes the list of available options shown
		 * in the autocomplete dropdown menu.
		 *
		 * @param {boolean} triggerDropdown
		 */
		refreshOptions: function(triggerDropdown) {
			var i, j, k, n, groups, groups_order, option, option_html, optgroup, optgroups, html, html_children, has_create_option;
			var $active, $active_before, $create;
	
			if (typeof triggerDropdown === 'undefined') {
				triggerDropdown = true;
			}
	
			var self              = this;
			var query             = $.trim(self.$control_input.val());
			var results           = self.search(query);
			var $dropdown_content = self.$dropdown_content;
			var active_before     = self.$activeOption && hash_key(self.$activeOption.attr('data-value'));
	
			// build markup
			n = results.items.length;
			if (typeof self.settings.maxOptions === 'number') {
				n = Math.min(n, self.settings.maxOptions);
			}
	
			// render and group available options individually
			groups = {};
			groups_order = [];
	
			for (i = 0; i < n; i++) {
				option      = self.options[results.items[i].id];
				option_html = self.render('option', option);
				optgroup    = option[self.settings.optgroupField] || '';
				optgroups   = $.isArray(optgroup) ? optgroup : [optgroup];
	
				for (j = 0, k = optgroups && optgroups.length; j < k; j++) {
					optgroup = optgroups[j];
					if (!self.optgroups.hasOwnProperty(optgroup)) {
						optgroup = '';
					}
					if (!groups.hasOwnProperty(optgroup)) {
						groups[optgroup] = document.createDocumentFragment();
						groups_order.push(optgroup);
					}
					groups[optgroup].appendChild(option_html);
				}
			}
	
			// sort optgroups
			if (this.settings.lockOptgroupOrder) {
				groups_order.sort(function(a, b) {
					var a_order = self.optgroups[a].$order || 0;
					var b_order = self.optgroups[b].$order || 0;
					return a_order - b_order;
				});
			}
	
			// render optgroup headers & join groups
			html = document.createDocumentFragment();
			for (i = 0, n = groups_order.length; i < n; i++) {
				optgroup = groups_order[i];
				if (self.optgroups.hasOwnProperty(optgroup) && groups[optgroup].childNodes.length) {
					// render the optgroup header and options within it,
					// then pass it to the wrapper template
					html_children = document.createDocumentFragment();
					html_children.appendChild(self.render('optgroup_header', self.optgroups[optgroup]));
					html_children.appendChild(groups[optgroup]);
	
					html.appendChild(self.render('optgroup', $.extend({}, self.optgroups[optgroup], {
						html: domToString(html_children),
						dom:  html_children
					})));
				} else {
					html.appendChild(groups[optgroup]);
				}
			}
	
			$dropdown_content.html(html);
	
			// highlight matching terms inline
			if (self.settings.highlight && results.query.length && results.tokens.length) {
				$dropdown_content.removeHighlight();
				for (i = 0, n = results.tokens.length; i < n; i++) {
					highlight($dropdown_content, results.tokens[i].regex);
				}
			}
	
			// add "selected" class to selected options
			if (!self.settings.hideSelected) {
				for (i = 0, n = self.items.length; i < n; i++) {
					self.getOption(self.items[i]).addClass('selected');
				}
			}
	
			// add create option
			has_create_option = self.canCreate(query);
			if (has_create_option) {
				$dropdown_content.prepend(self.render('option_create', {input: query}));
				$create = $($dropdown_content[0].childNodes[0]);
			}
	
			// activate
			self.hasOptions = results.items.length > 0 || has_create_option;
			if (self.hasOptions) {
				if (results.items.length > 0) {
					$active_before = active_before && self.getOption(active_before);
					if ($active_before && $active_before.length) {
						$active = $active_before;
					} else if (self.settings.mode === 'single' && self.items.length) {
						$active = self.getOption(self.items[0]);
					}
					if (!$active || !$active.length) {
						if ($create && !self.settings.addPrecedence) {
							$active = self.getAdjacentOption($create, 1);
						} else {
							$active = $dropdown_content.find('[data-selectable]:first');
						}
					}
				} else {
					$active = $create;
				}
				self.setActiveOption($active);
				if (triggerDropdown && !self.isOpen) { self.open(); }
			} else {
				self.setActiveOption(null);
				if (triggerDropdown && self.isOpen) { self.close(); }
			}
		},
	
		/**
		 * Adds an available option. If it already exists,
		 * nothing will happen. Note: this does not refresh
		 * the options list dropdown (use `refreshOptions`
		 * for that).
		 *
		 * Usage:
		 *
		 *   this.addOption(data)
		 *
		 * @param {object|array} data
		 */
		addOption: function(data) {
			var i, n, value, self = this;
	
			if ($.isArray(data)) {
				for (i = 0, n = data.length; i < n; i++) {
					self.addOption(data[i]);
				}
				return;
			}
	
			if (value = self.registerOption(data)) {
				self.userOptions[value] = true;
				self.lastQuery = null;
				self.trigger('option_add', value, data);
			}
		},
	
		/**
		 * Registers an option to the pool of options.
		 *
		 * @param {object} data
		 * @return {boolean|string}
		 */
		registerOption: function(data) {
			var key = hash_key(data[this.settings.valueField]);
			if (typeof key === 'undefined' || key === null || this.options.hasOwnProperty(key)) return false;
			data.$order = data.$order || ++this.order;
			this.options[key] = data;
			return key;
		},
	
		/**
		 * Registers an option group to the pool of option groups.
		 *
		 * @param {object} data
		 * @return {boolean|string}
		 */
		registerOptionGroup: function(data) {
			var key = hash_key(data[this.settings.optgroupValueField]);
			if (!key) return false;
	
			data.$order = data.$order || ++this.order;
			this.optgroups[key] = data;
			return key;
		},
	
		/**
		 * Registers a new optgroup for options
		 * to be bucketed into.
		 *
		 * @param {string} id
		 * @param {object} data
		 */
		addOptionGroup: function(id, data) {
			data[this.settings.optgroupValueField] = id;
			if (id = this.registerOptionGroup(data)) {
				this.trigger('optgroup_add', id, data);
			}
		},
	
		/**
		 * Removes an existing option group.
		 *
		 * @param {string} id
		 */
		removeOptionGroup: function(id) {
			if (this.optgroups.hasOwnProperty(id)) {
				delete this.optgroups[id];
				this.renderCache = {};
				this.trigger('optgroup_remove', id);
			}
		},
	
		/**
		 * Clears all existing option groups.
		 */
		clearOptionGroups: function() {
			this.optgroups = {};
			this.renderCache = {};
			this.trigger('optgroup_clear');
		},
	
		/**
		 * Updates an option available for selection. If
		 * it is visible in the selected items or options
		 * dropdown, it will be re-rendered automatically.
		 *
		 * @param {string} value
		 * @param {object} data
		 */
		updateOption: function(value, data) {
			var self = this;
			var $item, $item_new;
			var value_new, index_item, cache_items, cache_options, order_old;
	
			value     = hash_key(value);
			value_new = hash_key(data[self.settings.valueField]);
	
			// sanity checks
			if (value === null) return;
			if (!self.options.hasOwnProperty(value)) return;
			if (typeof value_new !== 'string') throw new Error('Value must be set in option data');
	
			order_old = self.options[value].$order;
	
			// update references
			if (value_new !== value) {
				delete self.options[value];
				index_item = self.items.indexOf(value);
				if (index_item !== -1) {
					self.items.splice(index_item, 1, value_new);
				}
			}
			data.$order = data.$order || order_old;
			self.options[value_new] = data;
	
			// invalidate render cache
			cache_items = self.renderCache['item'];
			cache_options = self.renderCache['option'];
	
			if (cache_items) {
				delete cache_items[value];
				delete cache_items[value_new];
			}
			if (cache_options) {
				delete cache_options[value];
				delete cache_options[value_new];
			}
	
			// update the item if it's selected
			if (self.items.indexOf(value_new) !== -1) {
				$item = self.getItem(value);
				$item_new = $(self.render('item', data));
				if ($item.hasClass('active')) $item_new.addClass('active');
				$item.replaceWith($item_new);
			}
	
			// invalidate last query because we might have updated the sortField
			self.lastQuery = null;
	
			// update dropdown contents
			if (self.isOpen) {
				self.refreshOptions(false);
			}
		},
	
		/**
		 * Removes a single option.
		 *
		 * @param {string} value
		 * @param {boolean} silent
		 */
		removeOption: function(value, silent) {
			var self = this;
			value = hash_key(value);
	
			var cache_items = self.renderCache['item'];
			var cache_options = self.renderCache['option'];
			if (cache_items) delete cache_items[value];
			if (cache_options) delete cache_options[value];
	
			delete self.userOptions[value];
			delete self.options[value];
			self.lastQuery = null;
			self.trigger('option_remove', value);
			self.removeItem(value, silent);
		},
	
		/**
		 * Clears all options.
		 */
		clearOptions: function() {
			var self = this;
	
			self.loadedSearches = {};
			self.userOptions = {};
			self.renderCache = {};
			self.options = self.sifter.items = {};
			self.lastQuery = null;
			self.trigger('option_clear');
			self.clear();
		},
	
		/**
		 * Returns the jQuery element of the option
		 * matching the given value.
		 *
		 * @param {string} value
		 * @returns {object}
		 */
		getOption: function(value) {
			return this.getElementWithValue(value, this.$dropdown_content.find('[data-selectable]'));
		},
	
		/**
		 * Returns the jQuery element of the next or
		 * previous selectable option.
		 *
		 * @param {object} $option
		 * @param {int} direction  can be 1 for next or -1 for previous
		 * @return {object}
		 */
		getAdjacentOption: function($option, direction) {
			var $options = this.$dropdown.find('[data-selectable]');
			var index    = $options.index($option) + direction;
	
			return index >= 0 && index < $options.length ? $options.eq(index) : $();
		},
	
		/**
		 * Finds the first element with a "data-value" attribute
		 * that matches the given value.
		 *
		 * @param {mixed} value
		 * @param {object} $els
		 * @return {object}
		 */
		getElementWithValue: function(value, $els) {
			value = hash_key(value);
	
			if (typeof value !== 'undefined' && value !== null) {
				for (var i = 0, n = $els.length; i < n; i++) {
					if ($els[i].getAttribute('data-value') === value) {
						return $($els[i]);
					}
				}
			}
	
			return $();
		},
	
		/**
		 * Returns the jQuery element of the item
		 * matching the given value.
		 *
		 * @param {string} value
		 * @returns {object}
		 */
		getItem: function(value) {
			return this.getElementWithValue(value, this.$control.children());
		},
	
		/**
		 * "Selects" multiple items at once. Adds them to the list
		 * at the current caret position.
		 *
		 * @param {string} value
		 * @param {boolean} silent
		 */
		addItems: function(values, silent) {
			var items = $.isArray(values) ? values : [values];
			for (var i = 0, n = items.length; i < n; i++) {
				this.isPending = (i < n - 1);
				this.addItem(items[i], silent);
			}
		},
	
		/**
		 * "Selects" an item. Adds it to the list
		 * at the current caret position.
		 *
		 * @param {string} value
		 * @param {boolean} silent
		 */
		addItem: function(value, silent) {
			var events = silent ? [] : ['change'];
	
			debounce_events(this, events, function() {
				var $item, $option, $options;
				var self = this;
				var inputMode = self.settings.mode;
				var i, active, value_next, wasFull;
				value = hash_key(value);
	
				if (self.items.indexOf(value) !== -1) {
					if (inputMode === 'single') self.close();
					return;
				}
	
				if (!self.options.hasOwnProperty(value)) return;
				if (inputMode === 'single') self.clear(silent);
				if (inputMode === 'multi' && self.isFull()) return;
	
				$item = $(self.render('item', self.options[value]));
				wasFull = self.isFull();
				self.items.splice(self.caretPos, 0, value);
				self.insertAtCaret($item);
				if (!self.isPending || (!wasFull && self.isFull())) {
					self.refreshState();
				}
	
				if (self.isSetup) {
					$options = self.$dropdown_content.find('[data-selectable]');
	
					// update menu / remove the option (if this is not one item being added as part of series)
					if (!self.isPending) {
						$option = self.getOption(value);
						value_next = self.getAdjacentOption($option, 1).attr('data-value');
						self.refreshOptions(self.isFocused && inputMode !== 'single');
						if (value_next) {
							self.setActiveOption(self.getOption(value_next));
						}
					}
	
					// hide the menu if the maximum number of items have been selected or no options are left
					if (!$options.length || self.isFull()) {
						self.close();
					} else {
						self.positionDropdown();
					}
	
					self.updatePlaceholder();
					self.trigger('item_add', value, $item);
					self.updateOriginalInput({silent: silent});
				}
			});
		},
	
		/**
		 * Removes the selected item matching
		 * the provided value.
		 *
		 * @param {string} value
		 */
		removeItem: function(value, silent) {
			var self = this;
			var $item, i, idx;
	
			$item = (value instanceof $) ? value : self.getItem(value);
			value = hash_key($item.attr('data-value'));
			i = self.items.indexOf(value);
	
			if (i !== -1) {
				$item.remove();
				if ($item.hasClass('active')) {
					idx = self.$activeItems.indexOf($item[0]);
					self.$activeItems.splice(idx, 1);
				}
	
				self.items.splice(i, 1);
				self.lastQuery = null;
				if (!self.settings.persist && self.userOptions.hasOwnProperty(value)) {
					self.removeOption(value, silent);
				}
	
				if (i < self.caretPos) {
					self.setCaret(self.caretPos - 1);
				}
	
				self.refreshState();
				self.updatePlaceholder();
				self.updateOriginalInput({silent: silent});
				self.positionDropdown();
				self.trigger('item_remove', value, $item);
			}
		},
	
		/**
		 * Invokes the `create` method provided in the
		 * selectize options that should provide the data
		 * for the new item, given the user input.
		 *
		 * Once this completes, it will be added
		 * to the item list.
		 *
		 * @param {string} value
		 * @param {boolean} [triggerDropdown]
		 * @param {function} [callback]
		 * @return {boolean}
		 */
		createItem: function(input, triggerDropdown) {
			var self  = this;
			var caret = self.caretPos;
			input = input || $.trim(self.$control_input.val() || '');
	
			var callback = arguments[arguments.length - 1];
			if (typeof callback !== 'function') callback = function() {};
	
			if (typeof triggerDropdown !== 'boolean') {
				triggerDropdown = true;
			}
	
			if (!self.canCreate(input)) {
				callback();
				return false;
			}
	
			self.lock();
	
			var setup = (typeof self.settings.create === 'function') ? this.settings.create : function(input) {
				var data = {};
				data[self.settings.labelField] = input;
				data[self.settings.valueField] = input;
				return data;
			};
	
			var create = once(function(data) {
				self.unlock();
	
				if (!data || typeof data !== 'object') return callback();
				var value = hash_key(data[self.settings.valueField]);
				if (typeof value !== 'string') return callback();
	
				self.setTextboxValue('');
				self.addOption(data);
				self.setCaret(caret);
				self.addItem(value);
				self.refreshOptions(triggerDropdown && self.settings.mode !== 'single');
				callback(data);
			});
	
			var output = setup.apply(this, [input, create]);
			if (typeof output !== 'undefined') {
				create(output);
			}
	
			return true;
		},
	
		/**
		 * Re-renders the selected item lists.
		 */
		refreshItems: function() {
			this.lastQuery = null;
	
			if (this.isSetup) {
				this.addItem(this.items);
			}
	
			this.refreshState();
			this.updateOriginalInput();
		},
	
		/**
		 * Updates all state-dependent attributes
		 * and CSS classes.
		 */
		refreshState: function() {
			this.refreshValidityState();
			this.refreshClasses();
		},
	
		/**
		 * Update the `required` attribute of both input and control input.
		 *
		 * The `required` property needs to be activated on the control input
		 * for the error to be displayed at the right place. `required` also
		 * needs to be temporarily deactivated on the input since the input is
		 * hidden and can't show errors.
		 */
		refreshValidityState: function() {
			if (!this.isRequired) return false;
	
			var invalid = !this.items.length;
	
			this.isInvalid = invalid;
			this.$control_input.prop('required', invalid);
			this.$input.prop('required', !invalid);
		},
	
		/**
		 * Updates all state-dependent CSS classes.
		 */
		refreshClasses: function() {
			var self     = this;
			var isFull   = self.isFull();
			var isLocked = self.isLocked;
	
			self.$wrapper
				.toggleClass('rtl', self.rtl);
	
			self.$control
				.toggleClass('focus', self.isFocused)
				.toggleClass('disabled', self.isDisabled)
				.toggleClass('required', self.isRequired)
				.toggleClass('invalid', self.isInvalid)
				.toggleClass('locked', isLocked)
				.toggleClass('full', isFull).toggleClass('not-full', !isFull)
				.toggleClass('input-active', self.isFocused && !self.isInputHidden)
				.toggleClass('dropdown-active', self.isOpen)
				.toggleClass('has-options', !$.isEmptyObject(self.options))
				.toggleClass('has-items', self.items.length > 0);
	
			self.$control_input.data('grow', !isFull && !isLocked);
		},
	
		/**
		 * Determines whether or not more items can be added
		 * to the control without exceeding the user-defined maximum.
		 *
		 * @returns {boolean}
		 */
		isFull: function() {
			return this.settings.maxItems !== null && this.items.length >= this.settings.maxItems;
		},
	
		/**
		 * Refreshes the original <select> or <input>
		 * element to reflect the current state.
		 */
		updateOriginalInput: function(opts) {
			var i, n, options, label, self = this;
			opts = opts || {};
	
			if (self.tagType === TAG_SELECT) {
				options = [];
				for (i = 0, n = self.items.length; i < n; i++) {
					label = self.options[self.items[i]][self.settings.labelField] || '';
					options.push('<option value="' + escape_html(self.items[i]) + '" selected="selected">' + escape_html(label) + '</option>');
				}
				if (!options.length && !this.$input.attr('multiple')) {
					options.push('<option value="" selected="selected"></option>');
				}
				self.$input.html(options.join(''));
			} else {
				self.$input.val(self.getValue());
				self.$input.attr('value',self.$input.val());
			}
	
			if (self.isSetup) {
				if (!opts.silent) {
					self.trigger('change', self.$input.val());
				}
			}
		},
	
		/**
		 * Shows/hide the input placeholder depending
		 * on if there items in the list already.
		 */
		updatePlaceholder: function() {
			if (!this.settings.placeholder) return;
			var $input = this.$control_input;
	
			if (this.items.length) {
				$input.removeAttr('placeholder');
			} else {
				$input.attr('placeholder', this.settings.placeholder);
			}
			$input.triggerHandler('update', {force: true});
		},
	
		/**
		 * Shows the autocomplete dropdown containing
		 * the available options.
		 */
		open: function() {
			var self = this;
	
			if (self.isLocked || self.isOpen || (self.settings.mode === 'multi' && self.isFull())) return;
			self.focus();
			self.isOpen = true;
			self.refreshState();
			self.$dropdown.css({visibility: 'hidden', display: 'block'});
			self.positionDropdown();
			self.$dropdown.css({visibility: 'visible'});
			self.trigger('dropdown_open', self.$dropdown);
		},
	
		/**
		 * Closes the autocomplete dropdown menu.
		 */
		close: function() {
			var self = this;
			var trigger = self.isOpen;
	
			if (self.settings.mode === 'single' && self.items.length) {
				self.hideInput();
				self.$control_input.blur(); // close keyboard on iOS
			}
	
			self.isOpen = false;
			self.$dropdown.hide();
			self.setActiveOption(null);
			self.refreshState();
	
			if (trigger) self.trigger('dropdown_close', self.$dropdown);
		},
	
		/**
		 * Calculates and applies the appropriate
		 * position of the dropdown.
		 */
		positionDropdown: function() {
			var $control = this.$control;
			var offset = this.settings.dropdownParent === 'body' ? $control.offset() : $control.position();
			offset.top += $control.outerHeight(true);
	
			this.$dropdown.css({
				width : $control.outerWidth(),
				top   : offset.top,
				left  : offset.left
			});
		},
	
		/**
		 * Resets / clears all selected items
		 * from the control.
		 *
		 * @param {boolean} silent
		 */
		clear: function(silent) {
			var self = this;
	
			if (!self.items.length) return;
			self.$control.children(':not(input)').remove();
			self.items = [];
			self.lastQuery = null;
			self.setCaret(0);
			self.setActiveItem(null);
			self.updatePlaceholder();
			self.updateOriginalInput({silent: silent});
			self.refreshState();
			self.showInput();
			self.trigger('clear');
		},
	
		/**
		 * A helper method for inserting an element
		 * at the current caret position.
		 *
		 * @param {object} $el
		 */
		insertAtCaret: function($el) {
			var caret = Math.min(this.caretPos, this.items.length);
			if (caret === 0) {
				this.$control.prepend($el);
			} else {
				$(this.$control[0].childNodes[caret]).before($el);
			}
			this.setCaret(caret + 1);
		},
	
		/**
		 * Removes the current selected item(s).
		 *
		 * @param {object} e (optional)
		 * @returns {boolean}
		 */
		deleteSelection: function(e) {
			var i, n, direction, selection, values, caret, option_select, $option_select, $tail;
			var self = this;
	
			direction = (e && e.keyCode === KEY_BACKSPACE) ? -1 : 1;
			selection = getSelection(self.$control_input[0]);
	
			if (self.$activeOption && !self.settings.hideSelected) {
				option_select = self.getAdjacentOption(self.$activeOption, -1).attr('data-value');
			}
	
			// determine items that will be removed
			values = [];
	
			if (self.$activeItems.length) {
				$tail = self.$control.children('.active:' + (direction > 0 ? 'last' : 'first'));
				caret = self.$control.children(':not(input)').index($tail);
				if (direction > 0) { caret++; }
	
				for (i = 0, n = self.$activeItems.length; i < n; i++) {
					values.push($(self.$activeItems[i]).attr('data-value'));
				}
				if (e) {
					e.preventDefault();
					e.stopPropagation();
				}
			} else if ((self.isFocused || self.settings.mode === 'single') && self.items.length) {
				if (direction < 0 && selection.start === 0 && selection.length === 0) {
					values.push(self.items[self.caretPos - 1]);
				} else if (direction > 0 && selection.start === self.$control_input.val().length) {
					values.push(self.items[self.caretPos]);
				}
			}
	
			// allow the callback to abort
			if (!values.length || (typeof self.settings.onDelete === 'function' && self.settings.onDelete.apply(self, [values]) === false)) {
				return false;
			}
	
			// perform removal
			if (typeof caret !== 'undefined') {
				self.setCaret(caret);
			}
			while (values.length) {
				self.removeItem(values.pop());
			}
	
			self.showInput();
			self.positionDropdown();
			self.refreshOptions(true);
	
			// select previous option
			if (option_select) {
				$option_select = self.getOption(option_select);
				if ($option_select.length) {
					self.setActiveOption($option_select);
				}
			}
	
			return true;
		},
	
		/**
		 * Selects the previous / next item (depending
		 * on the `direction` argument).
		 *
		 * > 0 - right
		 * < 0 - left
		 *
		 * @param {int} direction
		 * @param {object} e (optional)
		 */
		advanceSelection: function(direction, e) {
			var tail, selection, idx, valueLength, cursorAtEdge, $tail;
			var self = this;
	
			if (direction === 0) return;
			if (self.rtl) direction *= -1;
	
			tail = direction > 0 ? 'last' : 'first';
			selection = getSelection(self.$control_input[0]);
	
			if (self.isFocused && !self.isInputHidden) {
				valueLength = self.$control_input.val().length;
				cursorAtEdge = direction < 0
					? selection.start === 0 && selection.length === 0
					: selection.start === valueLength;
	
				if (cursorAtEdge && !valueLength) {
					self.advanceCaret(direction, e);
				}
			} else {
				$tail = self.$control.children('.active:' + tail);
				if ($tail.length) {
					idx = self.$control.children(':not(input)').index($tail);
					self.setActiveItem(null);
					self.setCaret(direction > 0 ? idx + 1 : idx);
				}
			}
		},
	
		/**
		 * Moves the caret left / right.
		 *
		 * @param {int} direction
		 * @param {object} e (optional)
		 */
		advanceCaret: function(direction, e) {
			var self = this, fn, $adj;
	
			if (direction === 0) return;
	
			fn = direction > 0 ? 'next' : 'prev';
			if (self.isShiftDown) {
				$adj = self.$control_input[fn]();
				if ($adj.length) {
					self.hideInput();
					self.setActiveItem($adj);
					e && e.preventDefault();
				}
			} else {
				self.setCaret(self.caretPos + direction);
			}
		},
	
		/**
		 * Moves the caret to the specified index.
		 *
		 * @param {int} i
		 */
		setCaret: function(i) {
			var self = this;
	
			if (self.settings.mode === 'single') {
				i = self.items.length;
			} else {
				i = Math.max(0, Math.min(self.items.length, i));
			}
	
			if(!self.isPending) {
				// the input must be moved by leaving it in place and moving the
				// siblings, due to the fact that focus cannot be restored once lost
				// on mobile webkit devices
				var j, n, fn, $children, $child;
				$children = self.$control.children(':not(input)');
				for (j = 0, n = $children.length; j < n; j++) {
					$child = $($children[j]).detach();
					if (j <  i) {
						self.$control_input.before($child);
					} else {
						self.$control.append($child);
					}
				}
			}
	
			self.caretPos = i;
		},
	
		/**
		 * Disables user input on the control. Used while
		 * items are being asynchronously created.
		 */
		lock: function() {
			this.close();
			this.isLocked = true;
			this.refreshState();
		},
	
		/**
		 * Re-enables user input on the control.
		 */
		unlock: function() {
			this.isLocked = false;
			this.refreshState();
		},
	
		/**
		 * Disables user input on the control completely.
		 * While disabled, it cannot receive focus.
		 */
		disable: function() {
			var self = this;
			self.$input.prop('disabled', true);
			self.$control_input.prop('disabled', true).prop('tabindex', -1);
			self.isDisabled = true;
			self.lock();
		},
	
		/**
		 * Enables the control so that it can respond
		 * to focus and user input.
		 */
		enable: function() {
			var self = this;
			self.$input.prop('disabled', false);
			self.$control_input.prop('disabled', false).prop('tabindex', self.tabIndex);
			self.isDisabled = false;
			self.unlock();
		},
	
		/**
		 * Completely destroys the control and
		 * unbinds all event listeners so that it can
		 * be garbage collected.
		 */
		destroy: function() {
			var self = this;
			var eventNS = self.eventNS;
			var revertSettings = self.revertSettings;
	
			self.trigger('destroy');
			self.off();
			self.$wrapper.remove();
			self.$dropdown.remove();
	
			self.$input
				.html('')
				.append(revertSettings.$children)
				.removeAttr('tabindex')
				.removeClass('selectized')
				.attr({tabindex: revertSettings.tabindex})
				.show();
	
			self.$control_input.removeData('grow');
			self.$input.removeData('selectize');
	
			$(window).off(eventNS);
			$(document).off(eventNS);
			$(document.body).off(eventNS);
	
			delete self.$input[0].selectize;
		},
	
		/**
		 * A helper method for rendering "item" and
		 * "option" templates, given the data.
		 *
		 * @param {string} templateName
		 * @param {object} data
		 * @returns {string}
		 */
		render: function(templateName, data) {
			var value, id, label;
			var html = '';
			var cache = false;
			var self = this;
			var regex_tag = /^[\t \r\n]*<([a-z][a-z0-9\-_]*(?:\:[a-z][a-z0-9\-_]*)?)/i;
	
			if (templateName === 'option' || templateName === 'item') {
				value = hash_key(data[self.settings.valueField]);
				cache = !!value;
			}
	
			// pull markup from cache if it exists
			if (cache) {
				if (!isset(self.renderCache[templateName])) {
					self.renderCache[templateName] = {};
				}
				if (self.renderCache[templateName].hasOwnProperty(value)) {
					return self.renderCache[templateName][value];
				}
			}
	
			// render markup
			html = $(self.settings.render[templateName].apply(this, [data, escape_html]));
	
			// add mandatory attributes
			if (templateName === 'option' || templateName === 'option_create') {
				html.attr('data-selectable', '');
			}
			else if (templateName === 'optgroup') {
				id = data[self.settings.optgroupValueField] || '';
				html.attr('data-group', id);
			}
			if (templateName === 'option' || templateName === 'item') {
				html.attr('data-value', value || '');
			}
	
			// update cache
			if (cache) {
				self.renderCache[templateName][value] = html[0];
			}
	
			return html[0];
		},
	
		/**
		 * Clears the render cache for a template. If
		 * no template is given, clears all render
		 * caches.
		 *
		 * @param {string} templateName
		 */
		clearCache: function(templateName) {
			var self = this;
			if (typeof templateName === 'undefined') {
				self.renderCache = {};
			} else {
				delete self.renderCache[templateName];
			}
		},
	
		/**
		 * Determines whether or not to display the
		 * create item prompt, given a user input.
		 *
		 * @param {string} input
		 * @return {boolean}
		 */
		canCreate: function(input) {
			var self = this;
			if (!self.settings.create) return false;
			var filter = self.settings.createFilter;
			return input.length
				&& (typeof filter !== 'function' || filter.apply(self, [input]))
				&& (typeof filter !== 'string' || new RegExp(filter).test(input))
				&& (!(filter instanceof RegExp) || filter.test(input));
		}
	
	});
	
	
	Selectize.count = 0;
	Selectize.defaults = {
		options: [],
		optgroups: [],
	
		plugins: [],
		delimiter: ',',
		splitOn: null, // regexp or string for splitting up values from a paste command
		persist: true,
		diacritics: true,
		create: false,
		createOnBlur: false,
		createFilter: null,
		highlight: true,
		openOnFocus: true,
		maxOptions: 1000,
		maxItems: null,
		hideSelected: null,
		addPrecedence: false,
		selectOnTab: false,
		preload: false,
		allowEmptyOption: false,
		closeAfterSelect: false,
	
		scrollDuration: 60,
		loadThrottle: 300,
		loadingClass: 'loading',
	
		dataAttr: 'data-data',
		optgroupField: 'optgroup',
		valueField: 'value',
		labelField: 'text',
		optgroupLabelField: 'label',
		optgroupValueField: 'value',
		lockOptgroupOrder: false,
	
		sortField: '$order',
		searchField: ['text'],
		searchConjunction: 'and',
	
		mode: null,
		wrapperClass: 'selectize-control',
		inputClass: 'selectize-input',
		dropdownClass: 'selectize-dropdown',
		dropdownContentClass: 'selectize-dropdown-content',
	
		dropdownParent: null,
	
		copyClassesToDropdown: true,
	
		/*
		load                 : null, // function(query, callback) { ... }
		score                : null, // function(search) { ... }
		onInitialize         : null, // function() { ... }
		onChange             : null, // function(value) { ... }
		onItemAdd            : null, // function(value, $item) { ... }
		onItemRemove         : null, // function(value) { ... }
		onClear              : null, // function() { ... }
		onOptionAdd          : null, // function(value, data) { ... }
		onOptionRemove       : null, // function(value) { ... }
		onOptionClear        : null, // function() { ... }
		onOptionGroupAdd     : null, // function(id, data) { ... }
		onOptionGroupRemove  : null, // function(id) { ... }
		onOptionGroupClear   : null, // function() { ... }
		onDropdownOpen       : null, // function($dropdown) { ... }
		onDropdownClose      : null, // function($dropdown) { ... }
		onType               : null, // function(str) { ... }
		onDelete             : null, // function(values) { ... }
		*/
	
		render: {
			/*
			item: null,
			optgroup: null,
			optgroup_header: null,
			option: null,
			option_create: null
			*/
		}
	};
	
	
	$.fn.selectize = function(settings_user) {
		var defaults             = $.fn.selectize.defaults;
		var settings             = $.extend({}, defaults, settings_user);
		var attr_data            = settings.dataAttr;
		var field_label          = settings.labelField;
		var field_value          = settings.valueField;
		var field_optgroup       = settings.optgroupField;
		var field_optgroup_label = settings.optgroupLabelField;
		var field_optgroup_value = settings.optgroupValueField;
	
		/**
		 * Initializes selectize from a <input type="text"> element.
		 *
		 * @param {object} $input
		 * @param {object} settings_element
		 */
		var init_textbox = function($input, settings_element) {
			var i, n, values, option;
	
			var data_raw = $input.attr(attr_data);
	
			if (!data_raw) {
				var value = $.trim($input.val() || '');
				if (!settings.allowEmptyOption && !value.length) return;
				values = value.split(settings.delimiter);
				for (i = 0, n = values.length; i < n; i++) {
					option = {};
					option[field_label] = values[i];
					option[field_value] = values[i];
					settings_element.options.push(option);
				}
				settings_element.items = values;
			} else {
				settings_element.options = JSON.parse(data_raw);
				for (i = 0, n = settings_element.options.length; i < n; i++) {
					settings_element.items.push(settings_element.options[i][field_value]);
				}
			}
		};
	
		/**
		 * Initializes selectize from a <select> element.
		 *
		 * @param {object} $input
		 * @param {object} settings_element
		 */
		var init_select = function($input, settings_element) {
			var i, n, tagName, $children, order = 0;
			var options = settings_element.options;
			var optionsMap = {};
	
			var readData = function($el) {
				var data = attr_data && $el.attr(attr_data);
				if (typeof data === 'string' && data.length) {
					return JSON.parse(data);
				}
				return null;
			};
	
			var addOption = function($option, group) {
				$option = $($option);
	
				var value = hash_key($option.val());
				if (!value && !settings.allowEmptyOption) return;
	
				// if the option already exists, it's probably been
				// duplicated in another optgroup. in this case, push
				// the current group to the "optgroup" property on the
				// existing option so that it's rendered in both places.
				if (optionsMap.hasOwnProperty(value)) {
					if (group) {
						var arr = optionsMap[value][field_optgroup];
						if (!arr) {
							optionsMap[value][field_optgroup] = group;
						} else if (!$.isArray(arr)) {
							optionsMap[value][field_optgroup] = [arr, group];
						} else {
							arr.push(group);
						}
					}
					return;
				}
	
				var option             = readData($option) || {};
				option[field_label]    = option[field_label] || $option.text();
				option[field_value]    = option[field_value] || value;
				option[field_optgroup] = option[field_optgroup] || group;
	
				optionsMap[value] = option;
				options.push(option);
	
				if ($option.is(':selected')) {
					settings_element.items.push(value);
				}
			};
	
			var addGroup = function($optgroup) {
				var i, n, id, optgroup, $options;
	
				$optgroup = $($optgroup);
				id = $optgroup.attr('label');
	
				if (id) {
					optgroup = readData($optgroup) || {};
					optgroup[field_optgroup_label] = id;
					optgroup[field_optgroup_value] = id;
					settings_element.optgroups.push(optgroup);
				}
	
				$options = $('option', $optgroup);
				for (i = 0, n = $options.length; i < n; i++) {
					addOption($options[i], id);
				}
			};
	
			settings_element.maxItems = $input.attr('multiple') ? null : 1;
	
			$children = $input.children();
			for (i = 0, n = $children.length; i < n; i++) {
				tagName = $children[i].tagName.toLowerCase();
				if (tagName === 'optgroup') {
					addGroup($children[i]);
				} else if (tagName === 'option') {
					addOption($children[i]);
				}
			}
		};
	
		return this.each(function() {
			if (this.selectize) return;
	
			var instance;
			var $input = $(this);
			var tag_name = this.tagName.toLowerCase();
			var placeholder = $input.attr('placeholder') || $input.attr('data-placeholder');
			if (!placeholder && !settings.allowEmptyOption) {
				placeholder = $input.children('option[value=""]').text();
			}
	
			var settings_element = {
				'placeholder' : placeholder,
				'options'     : [],
				'optgroups'   : [],
				'items'       : []
			};
	
			if (tag_name === 'select') {
				init_select($input, settings_element);
			} else {
				init_textbox($input, settings_element);
			}
	
			instance = new Selectize($input, $.extend(true, {}, defaults, settings_element, settings_user));
		});
	};
	
	$.fn.selectize.defaults = Selectize.defaults;
	$.fn.selectize.support = {
		validity: SUPPORTS_VALIDITY_API
	};
	
	
	Selectize.define('drag_drop', function(options) {
		if (!$.fn.sortable) throw new Error('The "drag_drop" plugin requires jQuery UI "sortable".');
		if (this.settings.mode !== 'multi') return;
		var self = this;
	
		self.lock = (function() {
			var original = self.lock;
			return function() {
				var sortable = self.$control.data('sortable');
				if (sortable) sortable.disable();
				return original.apply(self, arguments);
			};
		})();
	
		self.unlock = (function() {
			var original = self.unlock;
			return function() {
				var sortable = self.$control.data('sortable');
				if (sortable) sortable.enable();
				return original.apply(self, arguments);
			};
		})();
	
		self.setup = (function() {
			var original = self.setup;
			return function() {
				original.apply(this, arguments);
	
				var $control = self.$control.sortable({
					items: '[data-value]',
					forcePlaceholderSize: true,
					disabled: self.isLocked,
					start: function(e, ui) {
						ui.placeholder.css('width', ui.helper.css('width'));
						$control.css({overflow: 'visible'});
					},
					stop: function() {
						$control.css({overflow: 'hidden'});
						var active = self.$activeItems ? self.$activeItems.slice() : null;
						var values = [];
						$control.children('[data-value]').each(function() {
							values.push($(this).attr('data-value'));
						});
						self.setValue(values);
						self.setActiveItem(active);
					}
				});
			};
		})();
	
	});
	
	Selectize.define('dropdown_header', function(options) {
		var self = this;
	
		options = $.extend({
			title         : 'Untitled',
			headerClass   : 'selectize-dropdown-header',
			titleRowClass : 'selectize-dropdown-header-title',
			labelClass    : 'selectize-dropdown-header-label',
			closeClass    : 'selectize-dropdown-header-close',
	
			html: function(data) {
				return (
					'<div class="' + data.headerClass + '">' +
						'<div class="' + data.titleRowClass + '">' +
							'<span class="' + data.labelClass + '">' + data.title + '</span>' +
							'<a href="javascript:void(0)" class="' + data.closeClass + '">&times;</a>' +
						'</div>' +
					'</div>'
				);
			}
		}, options);
	
		self.setup = (function() {
			var original = self.setup;
			return function() {
				original.apply(self, arguments);
				self.$dropdown_header = $(options.html(options));
				self.$dropdown.prepend(self.$dropdown_header);
			};
		})();
	
	});
	
	Selectize.define('optgroup_columns', function(options) {
		var self = this;
	
		options = $.extend({
			equalizeWidth  : true,
			equalizeHeight : true
		}, options);
	
		this.getAdjacentOption = function($option, direction) {
			var $options = $option.closest('[data-group]').find('[data-selectable]');
			var index    = $options.index($option) + direction;
	
			return index >= 0 && index < $options.length ? $options.eq(index) : $();
		};
	
		this.onKeyDown = (function() {
			var original = self.onKeyDown;
			return function(e) {
				var index, $option, $options, $optgroup;
	
				if (this.isOpen && (e.keyCode === KEY_LEFT || e.keyCode === KEY_RIGHT)) {
					self.ignoreHover = true;
					$optgroup = this.$activeOption.closest('[data-group]');
					index = $optgroup.find('[data-selectable]').index(this.$activeOption);
	
					if(e.keyCode === KEY_LEFT) {
						$optgroup = $optgroup.prev('[data-group]');
					} else {
						$optgroup = $optgroup.next('[data-group]');
					}
	
					$options = $optgroup.find('[data-selectable]');
					$option  = $options.eq(Math.min($options.length - 1, index));
					if ($option.length) {
						this.setActiveOption($option);
					}
					return;
				}
	
				return original.apply(this, arguments);
			};
		})();
	
		var getScrollbarWidth = function() {
			var div;
			var width = getScrollbarWidth.width;
			var doc = document;
	
			if (typeof width === 'undefined') {
				div = doc.createElement('div');
				div.innerHTML = '<div style="width:50px;height:50px;position:absolute;left:-50px;top:-50px;overflow:auto;"><div style="width:1px;height:100px;"></div></div>';
				div = div.firstChild;
				doc.body.appendChild(div);
				width = getScrollbarWidth.width = div.offsetWidth - div.clientWidth;
				doc.body.removeChild(div);
			}
			return width;
		};
	
		var equalizeSizes = function() {
			var i, n, height_max, width, width_last, width_parent, $optgroups;
	
			$optgroups = $('[data-group]', self.$dropdown_content);
			n = $optgroups.length;
			if (!n || !self.$dropdown_content.width()) return;
	
			if (options.equalizeHeight) {
				height_max = 0;
				for (i = 0; i < n; i++) {
					height_max = Math.max(height_max, $optgroups.eq(i).height());
				}
				$optgroups.css({height: height_max});
			}
	
			if (options.equalizeWidth) {
				width_parent = self.$dropdown_content.innerWidth() - getScrollbarWidth();
				width = Math.round(width_parent / n);
				$optgroups.css({width: width});
				if (n > 1) {
					width_last = width_parent - width * (n - 1);
					$optgroups.eq(n - 1).css({width: width_last});
				}
			}
		};
	
		if (options.equalizeHeight || options.equalizeWidth) {
			hook.after(this, 'positionDropdown', equalizeSizes);
			hook.after(this, 'refreshOptions', equalizeSizes);
		}
	
	
	});
	
	Selectize.define('remove_button', function(options) {
		options = $.extend({
				label     : '&times;',
				title     : 'Remove',
				className : 'remove',
				append    : true
			}, options);
	
			var singleClose = function(thisRef, options) {
	
				options.className = 'remove-single';
	
				var self = thisRef;
				var html = '<a href="javascript:void(0)" class="' + options.className + '" tabindex="-1" title="' + escape_html(options.title) + '">' + options.label + '</a>';
	
				/**
				 * Appends an element as a child (with raw HTML).
				 *
				 * @param {string} html_container
				 * @param {string} html_element
				 * @return {string}
				 */
				var append = function(html_container, html_element) {
					return html_container + html_element;
				};
	
				thisRef.setup = (function() {
					var original = self.setup;
					return function() {
						// override the item rendering method to add the button to each
						if (options.append) {
							var id = $(self.$input.context).attr('id');
							var selectizer = $('#'+id);
	
							var render_item = self.settings.render.item;
							self.settings.render.item = function(data) {
								return append(render_item.apply(thisRef, arguments), html);
							};
						}
	
						original.apply(thisRef, arguments);
	
						// add event listener
						thisRef.$control.on('click', '.' + options.className, function(e) {
							e.preventDefault();
							if (self.isLocked) return;
	
							self.clear();
						});
	
					};
				})();
			};
	
			var multiClose = function(thisRef, options) {
	
				var self = thisRef;
				var html = '<a href="javascript:void(0)" class="' + options.className + '" tabindex="-1" title="' + escape_html(options.title) + '">' + options.label + '</a>';
	
				/**
				 * Appends an element as a child (with raw HTML).
				 *
				 * @param {string} html_container
				 * @param {string} html_element
				 * @return {string}
				 */
				var append = function(html_container, html_element) {
					var pos = html_container.search(/(<\/[^>]+>\s*)$/);
					return html_container.substring(0, pos) + html_element + html_container.substring(pos);
				};
	
				thisRef.setup = (function() {
					var original = self.setup;
					return function() {
						// override the item rendering method to add the button to each
						if (options.append) {
							var render_item = self.settings.render.item;
							self.settings.render.item = function(data) {
								return append(render_item.apply(thisRef, arguments), html);
							};
						}
	
						original.apply(thisRef, arguments);
	
						// add event listener
						thisRef.$control.on('click', '.' + options.className, function(e) {
							e.preventDefault();
							if (self.isLocked) return;
	
							var $item = $(e.currentTarget).parent();
							self.setActiveItem($item);
							if (self.deleteSelection()) {
								self.setCaret(self.items.length);
							}
						});
	
					};
				})();
			};
	
			if (this.settings.mode === 'single') {
				singleClose(this, options);
				return;
			} else {
				multiClose(this, options);
			}
	});
	
	
	Selectize.define('restore_on_backspace', function(options) {
		var self = this;
	
		options.text = options.text || function(option) {
			return option[this.settings.labelField];
		};
	
		this.onKeyDown = (function() {
			var original = self.onKeyDown;
			return function(e) {
				var index, option;
				if (e.keyCode === KEY_BACKSPACE && this.$control_input.val() === '' && !this.$activeItems.length) {
					index = this.caretPos - 1;
					if (index >= 0 && index < this.items.length) {
						option = this.options[this.items[index]];
						if (this.deleteSelection(e)) {
							this.setTextboxValue(options.text.apply(this, [option]));
							this.refreshOptions(true);
						}
						e.preventDefault();
						return;
					}
				}
				return original.apply(this, arguments);
			};
		})();
	});
	

	return Selectize;
}));


hji.define('hji-common/selectize',['require', 'jquery', 'selectize'], function (require, $) {
  var cssUrl = require.toUrl('hji-membership/third-party/selectize/css/selectize.bootstrap3.min.css');

  HJI.loadCss(cssUrl);
});


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

hji.define('hji-common/_lookupArea',['require','jquery','_','hji-common/slipstream/api','hji-common/lookup/locationInput','hji-common/getUrlVar','hji-common/selectize'],function (require) {
  var $ = require('jquery'),
      _ = require('_'),
      api = require('hji-common/slipstream/api'),
      LocationInput = require('hji-common/lookup/locationInput'),
      getUrlParam = require('hji-common/getUrlVar');

  require('hji-common/selectize');

  $.fn.lookupArea = function (options) {
    return this.each(function () {
      var settings = $.extend({
        type: null,
        polygon: null,
        market: null,
        getArea: false,
        areaBias: HJI.commonVar('areaBias') || 'postal-city',
        callback: false,
        polynamesTarget: null
      }, options),
          $this = $(this),
          valueField = 'name',
          notFound = [],
          locationInput;

      if (settings.type == null || settings.type == 'polygon') {
        // API doesn't accept type polygon, so we reset it to null
        settings.type = null; // We need polygon ID when looking up polygon

        valueField = 'id';
      } // Set market pointer to limit results to a given market


      if ($this.data('market') != undefined && $this.data('market') != '') {
        var pointers = $this.data('market').split(',').map(function (market) {
          return '@' + market;
        });
        settings.polygon = pointers.join(',');
      }

      if (settings.polynamesTarget == null) {
        if ($this.data('polynamesTarget') != undefined && $this.data('polynamesTarget') != '') {
          settings.polynamesTarget = $this.data('polynamesTarget');
        } else {
          settings.polynamesTarget = $this.parent().find('input.polynames')[0];
        }
      }

      function prepareSelectizeOptions() {
        return {
          plugins: ['remove_button'],
          delimiter: '|',
          valueField: valueField,
          labelField: 'name',
          searchField: ['name'],
          maxItems: 10,
          maxOptions: 100,
          loadThrottle: 300,
          //                options: [],
          optgroups: [{
            id: 'place',
            name: 'Place'
          }, {
            id: 'township',
            name: 'Township'
          }, {
            id: 'county',
            name: 'County'
          }, {
            id: 'neighborhood',
            name: 'Neighborhood'
          }, {
            id: 'zipcode',
            name: 'Zip Code'
          }, {
            id: 'school',
            name: 'School'
          }],
          optgroupField: 'type',
          optgroupLabelField: 'name',
          optgroupValueField: 'id',
          optgroupOrder: ['place', 'township', 'county', 'neighborhood', 'school', 'zipcode'],
          sortField: 'name',
          create: true,
          createOnBlur: true,
          render: {
            option_create: function option_create(data, escape) {
              return '<div class="create" style="display: none">Add <strong>' + escape(data.input) + '</strong>&hellip;</div>';
            },
            optgroup_header: function optgroup_header(data, escape) {
              return '<div class="optgroup-header">' + escape(data.name) + '</span></div>';
            },
            item: function item(data, escape) {
              if (data.name == data.id) {
                var location = locationInput.getLocation(data.id);
                if (location) data.name = location.name;
              }

              return '<div data-value="' + escape(data.id) + '" class="item">' + escape(data.name) + '</div>';
            },
            option: function option(item, escape) {
              var label = item.type == 'place' || item.type == 'township' ? item.name + ', ' + item.state : item.name;
              var caption = null;

              if (item.type == 'township') {
                caption = item.label;
              }

              if (item.type == 'school' && typeof item.address !== 'undefined') {
                if (typeof item.address.city !== 'undefined' && typeof item.address.state !== 'undefined') caption = item.address.city + ', ' + item.address.state;
              } else if (item.type != 'place' && typeof item.place != 'undefined' && typeof item.state != 'undefined') {
                caption = item.place + ', ' + item.state;
              }

              return '<div>' + '<span class="selectize-label">' + escape(label) + '</span>' + (caption ? '<span class="selectize-caption">' + escape(caption) + '</span>' : '') + '</div>';
            }
          },
          load: function load(query, callback) {
            var self = this;

            var sanitize = function sanitize(string) {
              var map = {
                '&': '&amp;',
                '<': '&lt;',
                '>': '&gt;',
                '"': '&quot;',
                "'": '&#x27;',
                "/": '&#x2F;'
              };
              var reg = /[&<>"'/]/ig;
              return string.replace(reg, function (match) {
                return map[match];
              });
            };

            query = sanitize(query);

            if (self.loading) {
              var searchingMessage = query.length >= 3 ? 'Searching for matches <strong>' + query + '</strong>&hellip;<span class="spinner"></span>' : 'Area name should be at least 3 letters.';
              var searching = '<div class="optgroup-header hji-searching">' + searchingMessage + '</div>';
              self.$dropdown_content.append(searching);
            }

            if (query.length < 3) return callback();
            var params = {
              keyword: query,
              geoType: settings.type || '',
              polygon: settings.polygon,
              pageSize: '10',
              limit: '10'
            };
            params = _.pick(params, function (v, k, o) {
              return !_.isEmpty(v);
            });
            searchAreasWithSchools(params).then(function (areas) {
              // prefix each id with $ character
              for (var i in areas) {
                if (areas[i].type !== 'school') {
                  areas[i].id = '$' + areas[i].id;
                }
              } // Return data to selectize


              callback(areas); // If auto-complete  field is not in focus

              if (!self.isFocused || $.inArray(query, self.items) !== -1) {
                // Remove user typed-in query from the field
                self.removeItem(query); // If matches exists

                if (areas.length) {
                  // Insert first match into the field
                  self.addItem(areas[0].id);
                } // If no matches
                else {
                    // Tell user that such area doesn't exist
                    //alert('Area ' + query + ' is not found. Please try a different search.');
                    notFound.push(query);
                  }
              } // Remove user typed-in query from suggestion list


              self.removeOption(query);
              setTimeout(function () {
                if (!areas.length) {
                  var timer = 3000;
                  self.$dropdown_content.find('.hji-searching').html('Location "' + query + '" was not found.').css('color', 'red').fadeOut(timer);
                  setTimeout(function () {
                    self.setActiveOption(null);
                    self.close();
                    self.removeItem(query);
                  }, timer);
                } else {
                  self.$dropdown_content.find('.hji-searching').slideUp();
                }
              }, 100); // Clearing results on each search.
              // This also clears previous selection,
              // which doesn't work for us.
              // We want to be able to make multiple searches
              // and select items from each search.
              // We need to clear previous selection options in
              // in dropdown list, but not the actual selections.
              //self.clearOptions();
              //self.refreshOptions();

              setTimeout(function () {
                if (!notFound.length) return;

                if (!self.loading) {
                  var _areas = notFound.length > 1 ? 'Areas' : 'Area';

                  alert(_areas + ' "' + notFound.join(', ') + '" not found. Please try different location.');
                  notFound = [];
                }
              }, 300);
            });
          },
          onItemAdd: function onItemAdd(value, $item) {
            var self = this,
                firstChar = value.substring(0, 1),
                name = $item[0].firstChild.nodeValue,
                deleted = locationInput.locations.isDeleted(value); // Do not add items less than 3 char long

            if (value.length < 3) {
              self.removeItem(value);
              self.removeOption(value);
            } // Check if value is a $ prefixed polygon ID


            if (deleted) {
              locationInput.addLocation(deleted);
            } else if (firstChar == '$') {
              locationInput.addLocation({
                id: value,
                name: name
              });
            } else {
              var schoolId = value;
              findBestAttendanceArea(schoolId).then(function (area) {
                var id = '$' + area.id;
                $item.attr('data-value', id);
                locationInput.addLocation({
                  id: id,
                  name: name,
                  school: schoolId
                });
                processAreaData(area, settings.callback);
              })["catch"](function (data) {
                api.ready(function (API) {
                  API.call('/ws/schools/get', {
                    id: schoolId
                  }).done(function (response, xhr) {
                    if (response.success == true && response.result.schools.length) {
                      var lat = response.result.schools[0].coordinates.latitude;
                      var lng = response.result.schools[0].coordinates.longitude;
                      locationInput.addLocation({
                        id: schoolId,
                        name: name,
                        type: 'school',
                        ll: "".concat(lat, ",").concat(lng),
                        r: 2
                      });
                    }
                  });
                });
              });
            }
          },
          onItemRemove: function onItemRemove(id) {
            locationInput.removeLocation(id);
          },
          onBlur: function onBlur() {
            var polygonIDs = this.$input.val().length ? this.$input.val().trim().split('|') : [];
            var lastValue = polygonIDs.length > 0 ? polygonIDs[polygonIDs.length - 1] : null; // If user left the input field before location was selected
            // automatically select first match

            if (!locationInput.getLocation(lastValue)) {
              var s = this;
              var query = polygonIDs[polygonIDs.length - 1]; // Check if looked up items array is not empty

              if (s.currentResults.items.length) {
                // Perform a search to order array of items by match score,
                // otherwise it's not ordered correctly.
                var result = s.search(query); // If match found, add it to selectize field and submit the form

                if (result.items.length && $.inArray(query, s.items) !== -1) {
                  // Remove user typed-in query from the field
                  s.removeItem(query); // Insert first match into the field

                  s.addItem(result.items[0].id); //Remove user typed-in query from suggestion list

                  s.removeOption(query);
                }
              } else {
                // Remove query from the field
                s.removeItem(query);
              }
            }
          }
        };
      }

      ;

      var searchAreasWithSchools = function searchAreasWithSchools(parameters) {
        return new Promise(function (resolve, reject) {
          var request = [],
              params;
          request = request.concat(_toAreaRequest(parameters), _toSchoolsRequest(parameters));
          params = {
            request: JSON.stringify(request)
          };
          api.ready(function (API) {
            API.call('/ws/api/call', params).done(function (response, xhr) {
              if (response.success == true) {
                var i;

                (function () {
                  var collection = [];

                  for (i in response.result.responses) {
                    var r = response.result.responses[i];

                    if (r.success) {
                      if (r.result.areas) {
                        _.each(r.result.areas, function (area) {
                          collection.push(area);
                        });
                      }

                      if (r.result.schools) {
                        _.each(r.result.schools, function (school) {
                          var item = Object.assign({
                            type: 'school'
                          }, school);
                          collection.push(item);
                        });
                      }
                    }
                  }

                  _.sortBy(collection, 'name');

                  resolve(collection);
                })();
              } else {
                reject(response.error.message);
              }
            });
          });
        });
      };

      var findBestAttendanceArea = function findBestAttendanceArea(schoolId) {
        return new Promise(function (resolve, reject) {
          api.ready(function (API) {
            API.call('/ws/schools/attendance-areas/search', {
              school: schoolId,
              bestMatch: 'mostGrades',
              geometry: true
            }).done(function (response, xhr) {
              if (response.success == true) {
                resolve(response.result['attendance-areas'][0]);
              } else {
                reject({
                  schoolId: schoolId
                });
              }
            });
          });
        });
      };

      var _toAreaRequest = function _toAreaRequest(params) {
        var request = [],
            geoTypes = [],
            parameters = Object.assign({
          bias: settings.areaBias
        }, params);

        if (isNaN(parameters.keyword)) {
          // In cases where only one type postal/census place is available,
          // it is important to pass both geoTypes + bias, otherwise we may get no cities back.
          // The bias will make sure there are no duplicate areas returned in case both geoTypes exist.
          geoTypes = geoTypes.concat(['area/postal-city,area/census-place', 'area/township', 'area/county', 'area/neighborhood']);
        } else {
          geoTypes = ['area/zipcode'];
        }

        _.each(geoTypes, function (geoType) {
          request.push({
            uri: '/ws/areas/search',
            parameters: Object.assign({
              geoType: geoType
            }, parameters)
          });
        });

        return request;
      };

      var _toSchoolsRequest = function _toSchoolsRequest(parameters) {
        var request = [];

        if (isNaN(parameters.keyword)) {
          request.push({
            uri: '/ws/schools/search',
            parameters: {
              name: parameters.keyword,
              polygon: parameters.polygon,
              pageSize: 10,
              limit: 10
            }
          });
        }

        return request;
      };

      function selectizeThis($obj, options) {
        if ($obj.length && _typeof($obj) == 'object') {
          if ($obj[0].selectize) $obj[0].selectize.destroy();
          $obj.selectize(options); // Dirty hack to stop Chrome from forcing auto-completions since autocomplete=off no longer works

          $obj[0].selectize.$control_input.prop('autocomplete', 'new-password');
          return $obj;
        }
      }

      var getArea = function getArea(areaId, callback) {
        var id = areaId.replace('$', ''),
            params = {
          id: id,
          details: 1,
          geometry: 1
        };
        api.ready(function (API) {
          API.call('/ws/areas/get', params).done(function (response, xhr) {
            if (response.success === true) {
              processAreaData(response.result.areas[0], callback);
            }
          });
        });
      };

      var processAreaData = function processAreaData(data, callback) {
        var coords = data.geometry.coordinates ? data.geometry.coordinates : false;
        var result = data;
        var polygons = [];

        if (coords) {
          for (var n in coords) {
            var val = coords[n];
            var polygon = [];

            for (var x in val[0]) {
              polygon.push(val[0][x][0] + ' ' + val[0][x][1]);
            }

            polygons.push(polygon);
          }

          result.polygon = polygons;
        }

        if (typeof callback == 'function') {
          callback(result);
        }
      };
      /**
       * Very bad and dirty way to get pre-set parameters for the location field
       * In a perfect world, whatever uses the component would set value on it directly
       *
       * @private
       */


      var _getSearchParam = function _getSearchParam(parameter) {
        var result = null;

        var getParam = function getParam(parameter) {
          if (HJI.rIDX) {
            var _$qsw = $this.closest('[class*="checksum-"]'),
                checksum = null;

            if (_$qsw.length) {
              var checksumClass = _$qsw.attr('class').match(/checksum-([A-Za-z0-9]+)\b/g);

              if (checksumClass) {
                checksum = checksumClass[0].split('-')[1];
                return HJI.rIDX.getSearchParam(parameter, checksum);
              }
            }
          }

          var query = getUrlParam(parameter);
          return query ? query : null;
        }; // Since it may take take for rIDX to get loaded,
        // we set a small delay in case it needs it


        return new Promise(function (resolve, reject) {
          var n = 0,
              interval;
          interval = setInterval(function () {
            ++n;

            if (HJI.hasOwnProperty('rIDX') || n > 4) {
              clearInterval(interval);
              resolve(getParam(parameter));
            }
          }, 25);
        });
      };

      var locations = _getSearchParam('location'),
          polynames = _getSearchParam('polynames');

      return Promise.all([locations, polynames]).then(function (values) {
        locationInput = new LocationInput($this, {
          locations: JSON.parse(values[0]),
          polynames: values[1],
          polynamesTarget: settings.polynamesTarget
        });
        if (settings.getArea === true && typeof settings.callback === 'function') locationInput.onAddLocation(function (location) {
          return getArea(location.id, settings.callback);
        });
        return locationInput.setup().then(function () {
          return new selectizeThis($this, prepareSelectizeOptions());
        });
      });
    });
  };
});


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

hji.define('hji-common/_lookup',['jquery', 'hji-common/selectize'], function ($) {
  $.fn.dataLookup = function () {
    return this.each(function () {
      var $this = $(this);
      var settings = {
        market: $this.data('market'),
        property: $this.data('lookup')
      };

      if (!settings.market || !settings.property) {
        return false;
      }

      var selectizeOptions = {
        plugins: ['remove_button'],
        delimiter: '|',
        load: function load(query, callback) {
          var sanitize = function sanitize(string) {
            var map = {
              '&': '&amp;',
              '<': '&lt;',
              '>': '&gt;',
              '"': '&quot;',
              "'": '&#x27;',
              "/": '&#x2F;'
            };
            var reg = /[&<>"'/]/ig;
            return string.replace(reg, function (match) {
              return map[match];
            });
          };

          query = sanitize(query);
          if (!query.length) return callback();
          $.post(HJI.ajaxUrl(), {
            action: 'hjiAjaxApiRequest',
            method: 'enumerate',
            params: {
              filter: query,
              property: settings.property,
              id: settings.market,
              matching: 'contains',
              limit: 100
            }
          }, function (result) {
            if (result.success == true) {
              var values = result.data[0].values;
              var list = [];

              for (i in values) {
                var item = {
                  text: values[i],
                  value: values[i]
                };
                list.push(item);
              } // Clearing results on each search.
              // This also clears previous selection,
              // which doesn't work for us.
              // We want to be able to make multiple searches
              // and select items from each search.
              // We need to clear previous selection options in
              // in dropdown list, but not the actual selections.
              //                                        $this[0].selectize.clearOptions();
              //                                        $this[0].selectize.refreshOptions();


              callback(list);
            } else {
              throw new Error(result.error.message);
            }
          }, "json");
        }
      };

      var setup = function setup($obj, options) {
        if ($obj.length > 0 && _typeof($obj) == 'object') {
          if ($obj[0].selectize) {
            $obj[0].selectize.destroy();
          }

          setTimeout(function () {
            $obj.selectize(options); // Dirty hack to stop Chrome from forcing auto-completions since autocomplete=off no longer works
            // $obj[0].selectize.$control_input.prop('autocomplete', 'leaveMeAlone');
          }, 100);
        }
      };

      return setup($this, selectizeOptions);
    });
  };
});


hji.define('hji-common/modal/inlineContentModel',['jquery', 'backbone'], function ($, Backbone) {
  var DetachableContentModel = Backbone.Model.extend({
    defaults: {
      selector: null,
      $el: null,
      content: null,
      original: null
    },
    initialize: function initialize(attributes) {
      if (attributes.selector) {
        this.set(attributes);
        this.set({
          $el: $(this.get('selector'))
        }); // Wrap content within the selector, so we can manipulate it by our own wrapper

        if (!this.get('$el').find('.detachable').length) {
          this.get('$el').wrapInner('<div class="detachable"/>');
        }

        var content = this.get('$el').find('.detachable');
        this.set({
          content: content
        }); // Cloned version of the original content with all events intact

        this.set({
          original: content.clone(true, true)
        });
        var title = this.get('$el').data('title');

        if (!title) {
          title = null;
        }

        this.set({
          title: title
        });
      }

      this._init();
    },
    _init: function _init() {
      return this;
    },
    refresh: function refresh() {
      if (this.get('selector')) {
        this._init();
      }

      return this;
    }
  });
  return DetachableContentModel;
});


/**
 * Gravity Form Model
 */
hji.define('hji-common/modal/gfContentModel',['jquery', 'backbone', './inlineContentModel'], function ($, Backbone, InlineContentModel) {
  var GFormModel = InlineContentModel.extend({
    defaults: {
      selector: null,
      $el: null,
      content: null,
      original: null,
      form: {}
    },

    /**
     * Determines if the form content is an actual gravity form
     */
    isForm: function isForm() {
      if (this.get('$el').find('.gform_wrapper').length) {
        return true;
      }

      return false;
    },
    _init: function _init() {
      if (this.isForm()) {
        var form = {};
        form.id = this._getId();
        form.title = this._getTitle();
        form.submitTxt = this.get('$el').find('.gform_footer input[type="submit"]').val();
        form.form = this.get('$el').find('form');
        this.set({
          form: form
        });

        if (!this.get('title')) {
          this.set({
            title: this.get('form').title
          });
        }
      }
    },
    _getId: function _getId() {
      return Number(this.get('$el').find('[name="gform_submit"]').val());
    },
    _getTitle: function _getTitle() {
      return this.get('$el').find('.gform_title').text();
    },
    isSubmittable: function isSubmittable() {
      if (this.get('$el').find('[name="gform_submit"]').length) {
        return true;
      }

      return false;
    },

    /**
     * Determines if current form is a submission confirmation
     */
    isConfirmation: function isConfirmation() {
      if (this.get('$el').find('.gform_confirmation_message').length) {
        return true;
      }

      return false;
    },

    /**
     * Determines if current form is a submission validation error
     */
    isValidation: function isValidation() {
      if (this.get('$el').find('.validation_error').length) {
        return true;
      }

      return false;
    }
  });
  return GFormModel;
});


hji.define('hji-common/modal/contentModelFactory',['require', 'jquery', 'backbone', 'hji-common/modal/gfContentModel', 'hji-common/modal/inlineContentModel'], function (require, $, Backbone) {
  var ContentModelFactory = Backbone.Model.extend({
    defaults: {
      selector: null,
      $el: null
    },
    initialize: function initialize(attributes) {
      if (attributes.selector) {
        this.set(attributes);
        this.set('$el', $(this.get('selector')));
      }
    },
    create: function create() {
      if (!this.get('$el')) {
        return false;
      } // Create type-specific content model


      if (this.isGravityForm()) {
        var Model = require('hji-common/modal/gfContentModel');
      } else {
        var Model = require('hji-common/modal/inlineContentModel');
      }

      return new Model({
        selector: this.get('selector')
      });
    },
    isGravityForm: function isGravityForm() {
      if (this.get('$el').find('[name="gform_submit"]').length) {
        return true;
      }

      return false;
    }
  });
  return ContentModelFactory;
});


hji.define('hji-common/modal/inlineModalView',['jquery', 'backbone'], function ($, Backbone) {
  var InlineModalView = Backbone.View.extend({
    initialize: function initialize() {
      var that = this;
      this.bind("ok", this.okClicked);
      this.bind("onCancel", this.onCancel);
      this.bind("onSubmit", this.onSubmit);
      this.bind("onError", this.onError);
      this.bind("onSuccess", this.onSuccess);
      this.template = this.model.get('content'); // Custom on hidden event - to cover:
      // - Cancel btn click
      // - Close X click
      // - Submit btn click (we remove this on submit though)
      // - Click outside of the modal boundaries

      $(document).off('hide.bs.modal.gfmodal', '.modal');
      $(document).on('hide.bs.modal.gfmodal', '.modal', {
        view: this
      }, function (e) {
        //that.reattach();
        that.trigger('onCancel');
      });
      this.delegateEvents();
    },
    events: {
      "onCancel": "onCancel",
      "onSubmit": "onSubmit",
      "onError": "onError",
      "onSuccess": "onSuccess"
    },
    onCancel: function onCancel() {
      this.reattach();
    },
    onSubmit: function onSubmit() {
      // Don't want to be executing this when OK button is clicked.
      $(document).off('hide.bs.modal.gfmodal', '.modal'); // Modal is closing, so we need to re-attach the content
      // back to the original place in the DOM

      this.reattach();
    },
    onError: function onError(data) {},
    onSuccess: function onSuccess(data) {},
    okClicked: function okClicked(modal) {
      this.trigger('onSubmit');
    },
    render: function render() {
      this.$el.html(this.template);
      return this;
    },

    /**
     * Reattaches modal's content to its original spot in the DOM
     *
     * @returns {ModalView}
     */
    reattach: function reattach() {
      // Re-attache content of the form
      $(this.model.get('selector')).append(this.template);
      return this;
    },

    /**
     * Reattaches original gravity form HTML to its original sport in the DOM
     *
     * Note: because ajax-enabled gravity form modifies its content,
     * we need to be able to re-set the form to the initial state after user done
     * working with it.
     */
    reattachOriginal: function reattachOriginal() {
      var that = this; // Clear out existing content in the DOM

      $(this.model.get('selector')).html(''); // Apply modifications to original content

      modifyOriginalContent(that.model.get('original'));
      setTimeout(function () {
        // Append original content into the DOM
        $(that.model.get('selector')).append(that.model.get('original')); // Refresh gravity form model, since content has changed

        that.model.refresh();
      }, 25);
    }
  });

  function modifyOriginalContent($content) {
    // Fix datepicker within original content that is being re-attached
    // it's a known issue that datepicker doesn't clone well.
    $content.find('.datepicker').each(function () {
      refreshDatepicker($(this));
    });
  }
  /**
   * Refreshes datepicker element with its current settings
   *
   * @param $datepicker jQuery object
   */


  function refreshDatepicker($datepicker) {
    var dpSettings = $datepicker.data('datepicker').settings,
        $img = $datepicker.next('img.ui-datepicker-trigger'); // Destroy datepicker

    $datepicker.datepicker('destroy'); // Remove datepicker icon

    if ($img.length) {
      $img.remove();
    } // Initialize datepicker


    $datepicker.datepicker(dpSettings);
  }

  ;
  return InlineModalView;
});


/**
 * Bootstrap Modal wrapper for use with Backbone.
 *
 * Takes care of instantiation, manages multiple modals,
 * adds several options and removes the element from the DOM when closed
 *
 * @author Charles Davison <charlie@powmedia.co.uk>
 *
 * Events:
 * shown: Fired when the modal has finished animating in
 * hidden: Fired when the modal has finished animating out
 * cancel: The user dismissed the modal
 * ok: The user clicked OK
 */
(function ($, _, Backbone) {
  //Set custom template settings
  var _interpolateBackup = _.templateSettings;
  _.templateSettings = {
    interpolate: /\{\{(.+?)\}\}/g,
    evaluate: /<%([\s\S]+?)%>/g
  };

  var template = _.template('\
            <div class="modal-dialog"><div class="modal-content">\
            <% if (title) { %>\
              <div class="modal-header">\
                <% if (allowCancel) { %>\
                  <a class="close">&times;</a>\
                <% } %>\
                <h4 class="modal-title">{{title}}</h4>\
              </div>\
            <% } %>\
            <div class="modal-body">{{content}}</div>\
            <% if (showFooter) { %>\
              <div class="modal-footer">\
                <% if (allowCancel) { %>\
                  <% if (cancelText) { %>\
                    <a href="#" class="btn cancel">{{cancelText}}</a>\
                  <% } %>\
                <% } %>\
                <a href="#" class="btn ok btn-primary">{{okText}}</a>\
              </div>\
            <% } %>\
            </div></div>\
          '); //Reset to users' template settings


  _.templateSettings = _interpolateBackup;
  var Modal = Backbone.View.extend({
    className: 'hjitb modal',
    events: {
      'click .close': function clickClose(event) {
        event.preventDefault();
        this.trigger('cancel');

        if (this.options.content && this.options.content.trigger) {
          this.options.content.trigger('cancel', this);
        }
      },
      'click .cancel': function clickCancel(event) {
        event.preventDefault();
        this.trigger('cancel');

        if (this.options.content && this.options.content.trigger) {
          this.options.content.trigger('cancel', this);
        }
      },
      'click .ok': function clickOk(event) {
        event.preventDefault();
        this.trigger('ok');

        if (this.options.content && this.options.content.trigger) {
          this.options.content.trigger('ok', this);
        }

        if (this.options.okCloses) {
          this.close();
        }
      },
      'keypress': function keypress(event) {
        if (this.options.enterTriggersOk && event.which == 13) {
          event.preventDefault();
          this.trigger('ok');

          if (this.options.content && this.options.content.trigger) {
            this.options.content.trigger('ok', this);
          }

          if (this.options.okCloses) {
            this.close();
          }
        }
      }
    },

    /**
     * Creates an instance of a Bootstrap Modal
     *
     * @see http://twitter.github.com/bootstrap/javascript.html#modals
     *
     * @param {Object} options
     * @param {String|View} [options.content]     Modal content. Default: none
     * @param {String} [options.title]            Title. Default: none
     * @param {String} [options.okText]           Text for the OK button. Default: 'OK'
     * @param {String} [options.cancelText]       Text for the cancel button. Default: 'Cancel'. If passed a falsey value, the button will be removed
     * @param {Boolean} [options.allowCancel      Whether the modal can be closed, other than by pressing OK. Default: true
     * @param {Boolean} [options.escape]          Whether the 'esc' key can dismiss the modal. Default: true, but false if options.cancellable is true
     * @param {Boolean} [options.animate]         Whether to animate in/out. Default: false
     * @param {Function} [options.template]       Compiled underscore template to override the default one
     * @param {Boolean} [options.enterTriggersOk] Whether the 'enter' key will trigger OK. Default: false
     */
    initialize: function initialize(options) {
      this.options = _.extend({
        title: null,
        okText: 'OK',
        focusOk: true,
        okCloses: true,
        cancelText: 'Cancel',
        showFooter: true,
        allowCancel: true,
        escape: true,
        animate: false,
        template: template,
        enterTriggersOk: false
      }, options);
    },

    /**
     * Creates the DOM element
     *
     * @api private
     */
    render: function render() {
      var $el = this.$el,
          options = this.options,
          content = options.content; //Create the modal container

      $el.html(options.template(options));
      var $content = this.$content = $el.find('.modal-body'); //Insert the main content if it's a view

      if (content && content.$el) {
        content.render();
        $el.find('.modal-body').html(content.$el);
      }

      if (options.animate) $el.addClass('fade');
      this.isRendered = true;
      return this;
    },

    /**
     * Renders and shows the modal
     *
     * @param {Function} [cb]     Optional callback that runs only when OK is pressed.
     */
    open: function open(cb) {
      if (!this.isRendered) this.render();
      var self = this,
          $el = this.$el; //Create it

      $el.modal(_.extend({
        keyboard: this.options.allowCancel,
        backdrop: this.options.allowCancel ? true : 'static'
      }, this.options.modalOptions));
      Modal.count++; //Focus OK button

      $el.one('shown.bs.modal', function () {
        if (self.options.focusOk) {
          $el.find('.btn.ok').focus();
        }

        if (self.options.content && self.options.content.trigger) {
          self.options.content.trigger('shown', self);
        }

        self.trigger('shown');
      }); //Adjust the modal and backdrop z-index; for dealing with multiple modals

      var numModals = Modal.count,
          //$backdrop = $('.modal-backdrop:eq(' + numModals + ')'),
      $backdrop = $('.modal-backdrop:eq(0)'),
          backdropIndex = parseInt($backdrop.css('z-index'), 10),
          elIndex = parseInt($backdrop.css('z-index'), 10);
      $backdrop.css('z-index', backdropIndex + numModals);
      this.$el.css('z-index', elIndex + numModals);

      if (this.options.allowCancel) {
        $backdrop.one('click', function () {
          if (self.options.content && self.options.content.trigger) {
            self.options.content.trigger('cancel', self);
          }

          self.trigger('cancel');
        });
        $(document).one('keyup.dismiss.modal', function (e) {
          e.which == 27 && self.trigger('cancel');

          if (self.options.content && self.options.content.trigger) {
            e.which == 27 && self.options.content.trigger('shown', self);
          }
        });
      }

      this.on('cancel', function () {
        self.close();
      }); //Modal.count++;
      //Run callback on OK if provided

      if (cb) {
        self.on('ok', cb);
      }

      return this;
    },

    /**
     * Closes the modal
     */
    close: function close() {
      var self = this,
          $el = this.$el; //Check if the modal should stay open

      if (this._preventClose) {
        this._preventClose = false;
        return;
      }

      $el.one('hidden.bs.modal', function onHidden(e) {
        // Ignore events propagated from interior objects, like bootstrap tooltips
        if (e.target !== e.currentTarget) {
          return $el.one('hidden', onHidden);
        }

        self.remove();

        if (self.options.content && self.options.content.trigger) {
          self.options.content.trigger('hidden', self);
        }

        self.trigger('hidden');
        $el.reset();
      });
      $el.modal('hide');
      Modal.count--;
    },

    /**
     * Stop the modal from closing.
     * Can be called from within a 'close' or 'ok' event listener.
     */
    preventClose: function preventClose() {
      this._preventClose = true;
    }
  }, {
    //STATICS
    //The number of modals on display
    count: 0
  }); //EXPORTS
  //CommonJS

  if (typeof require == 'function' && typeof module !== 'undefined' && exports) {
    module.exports = Modal;
  } //AMD / RequireJS


  if (typeof hji.define === 'function' && hji.define.amd) {
    return hji.define('hji-common/modal/bootstrapModal',[],function () {
      Backbone.BootstrapModal = Modal;
    });
  } //Regular; add to Backbone.Bootstrap.Modal
  else {
      Backbone.BootstrapModal = Modal;
    }
})(jQuery, _, Backbone);


hji.define('hji-common/modal/alerts',['jquery', 'backbone', './bootstrapModal'], function ($, Backbone) {
  var options = {
    className: 'hjitb modal hji-modal backbone-modal',
    content: '',
    animate: true,
    showFooter: false,
    allowCancel: false
  };

  function create(settings) {
    _.extend(options, settings);

    return new Backbone.BootstrapModal(options);
  }

  var modals = {
    alert: function alert(settings) {
      var alert = create(settings).open();

      if (settings.autoclose) {
        setTimeout(function () {
          alert.close();
        }, 2000);
      }

      return alert;
    },
    progress: function progress(message) {
      var message = '<div class="alert alert-info">' + message + '</div>';
      var alert = create({
        content: message
      }).open();
      return alert;
    }
  };
  return modals;
});


hji.define('hji-common/modal/gfModal',['require', 'jquery', 'underscore', 'backbone', './contentModelFactory', './gfContentModel', './inlineModalView', './alerts', './modals'], function (require, $, _, Backbone, ContentModelFactory, GFContentModel) {
  var gfm = {};
  /**
   * Renders Gravity Form content in a Modal
   *
   * @param gform $jquery object of the gform content
   * @param target original target selector where gform was embedded
   */

  gfm.createGFView = function () {
    var InlineModalView = require('./inlineModalView');

    var ModalView = InlineModalView.extend({
      okClicked: function okClicked(modal) {
        var that = this; // Removes submit event added in GF v.2.4.0 that aborts
        // form submission when Submit button is hidden.

        $(document).off('submit.gravityforms', '.gform_wrapper form');
        this.$el.trigger('onSubmit'); // Ajax-enabled gravity form updates form content after submission
        // Therefore we set event listeners for the "after submission"
        // Delay to process submitted outcomes
        // so the content reattaches to the DOM

        setTimeout(function () {
          var form = $(that.model.get('selector')).find('form');

          if (form.length) {
            // Fire up an "progress modal", so user knows what's happening
            var alerts = require('./alerts');

            var progressModal = alerts.progress('Request is being processed...'); // Submit the re-attached form

            form.submit(); // Set events for an ajax-enabled gravity form, since it updates its content.

            var eventData = {
              gForm: that.model,
              progressModal: progressModal
            };
            that.trigger('onError', eventData);
            that.trigger('onSuccess', eventData);
          }
        }, 25);
      },
      onError: function onError(eventData) {
        gfm.Events().onValidation(eventData);
      },
      onSuccess: function onSuccess(eventData) {
        var that = this;
        gfm.Events().onConfirmation(eventData, function () {
          that.reattachOriginal();
        });
      }
    });
    return ModalView;
  };
  /**
   * Renders gravity form confirmation message in a modal
   *
   * @param target gravity form selector from where confirmation message is being retrieved
   * @returns {*} modal object
   */


  gfm.confirmationModal = function (target) {
    var confirmation = '<div class="alert alert-success">' + $(target).find('.gform_confirmation_message').html() + '</div>';

    var alerts = require('./alerts');

    return alerts.alert({
      content: confirmation,
      autoclose: true
    });
  };
  /**
   * Create modals on document ready
   * if content has to be displayed as soon as page loads.
   *
   * Note: only 1 on load event per TARGET - there are can be
   * multiple triggers for each target though.
   */


  gfm.setOnLoadEvents = function (targets) {
    $(document).ready(function (e) {
      _.each(targets, function (target, i, list) {
        // Check if form needs to be displayed on document ready
        var gForm = new GFContentModel({
          selector: target
        }); // Is validation message being displayed?

        if (gForm.isValidation()) {
          var modals = require('./modals');

          modals.createModal(target);
        } // Is confirmation message being displayed?
        else if (gForm.isConfirmation()) {
            gfm.confirmationModal(gForm.get('selector'));
          }
      });
    });
  };
  /**
   * Gravity Forms events
   *
   * @returns {{onValidation: Function, onConfirmation: Function}}
   * @constructor
   */


  gfm.Events = function () {
    return {
      onValidation: function onValidation(eventData, callback) {
        $(document).off('gform_page_loaded.gfModal');
        $(document).on('gform_page_loaded.gfModal', eventData, function (e, form_id, current_page) {
          // Check if current event is for our modal form
          if (!gfm.isFormEventValid(e, form_id)) {
            return false;
          } // If progress modal is rendered, close it


          if (e.data.progressModal && e.data.progressModal.isRendered) {
            e.data.progressModal.close();
          } // Call callback/display validation modal


          setTimeout(function () {
            gfm.validationEventModal(e.data.gForm);

            if (callback) {
              callback(e, form_id, current_page);
            }
          }, 25);
        });
      },
      onConfirmation: function onConfirmation(eventData, callback) {
        $(document).off('gform_confirmation_loaded.fgModal');
        $(document).on('gform_confirmation_loaded.fgModal', eventData, function (e, form_id) {
          // Check if current event is for our modal form
          if (!gfm.isFormEventValid(e, form_id)) {
            return false;
          } // If progress modal is rendered, close it


          if (e.data.progressModal && e.data.progressModal.isRendered) {
            e.data.progressModal.close();
          }

          gfm.confirmationModal(e.data.gForm.get('selector'));

          if (callback) {
            callback(e, form_id);
          }
        });
      }
    };
  };
  /**
   * Determines if current event is for intended modal
   *
   * @param event     event object expected to contain gForm Model
   * @param form_id   gravity form ID passed by the gravity form event
   * @returns {boolean}
   */


  gfm.isFormEventValid = function (event, form_id) {
    // Does gForm data exist
    if (!event.data.gForm) {
      return false;
    } // Is gForm data == form_id passed by the event


    if (event.data.gForm.get('form').id == form_id) {
      return true;
    }

    return false;
  };
  /**
   * Renders Gravity Form with validation errors in a Modal
   *
   * @param gForm
   */


  gfm.validationEventModal = function (contentModel) {
    var modals = require('./modals');

    modals.createModal(contentModel);
  };

  return gfm;
});


hji.define('hji-common/modal/modals',['require', 'jquery', 'underscore', 'backbone', './contentModelFactory', './gfModal', './inlineModalView'], function (require, $, _, Backbone, ContentModelFactory) {
  var modals = {};
  /**
   * Initializes Modals for all [data-init="modal"] attributes on the page
   */

  modals.initModals = function () {
    this.gforms = require('./gfModal');
    var triggers = $('[data-init="modal"]');
    var targets = [];
    this.options = {
      className: 'hjitb modal hji-modal backbone-modal',
      title: null,
      okText: 'OK',
      focusOk: true,
      okCloses: true,
      cancelText: 'Cancel',
      showFooter: true,
      allowCancel: true,
      escape: true,
      animate: false,
      enterTriggersOk: false
    };

    _.each(triggers, function (el, index, list) {
      targets.push($(el).data('target'));
    });

    targets = _.unique(targets);
    triggers.each(function () {
      modals.setTriggerEvents(this);
    });
    modals.setOnLoadEvents(targets);
  };
  /**
   * Sets modal trigger events for identified content via data-init attributes.
   *
   * @param el string - element selector
   */


  modals.setTriggerEvents = function (el) {
    // On click
    $(el).on('click', function (e) {
      e.preventDefault();
      var target = $(this).data('target');
      var content = $(target);

      if (content.length) {
        modals.createModal(target);
      }
    });
  };
  /**
   * Create modals on document ready
   * if content has to be displayed as soon as page loads.
   *
   * Note: only 1 on load event per TARGET - there are can be
   * multiple triggers for each target though.
   */


  modals.setOnLoadEvents = function (targets) {
    // GravityForms onload events
    this.gforms.setOnLoadEvents();
  };
  /**
   * Creates and opens Modal for an inline content
   *
   * @param content
   * @param target
   */


  modals.createModal = function (target) {
    if (target instanceof Backbone.Model) {
      var contentModel = target;
    } else {
      var contentModel = modals.getContentModel(target);
    }

    var ModalView = modals.createView(contentModel); // Is gravity form?

    if (contentModel.has('form')) {
      var defaultOptions = {
        //className:  'hjitb modal hji-modal backbone-modal',
        content: new ModalView({
          model: contentModel
        }),
        okText: contentModel.get('form').submitTxt,
        animate: true,
        allowCancel: true
      };
      var modal = new Backbone.BootstrapModal(_.extend(defaultOptions, this.getOptions(contentModel.get('$el')))).open();
    } else {
      // TODO: refactor so className gets combined and options don't get wrongfully overwritten
      var defaultOptions = {
        //className: 'hjitb modal hji-modal backbone-modal',
        content: new ModalView({
          model: contentModel
        }),
        animate: true
      };
      var modal = new Backbone.BootstrapModal(_.extend(defaultOptions, this.getOptions(contentModel.get('$el')))).open();
    }
  };
  /**
   * Options parsed from data attributes and merged with default this.options.
   *
   * @param $el
   * @returns {{className: string, title: null, okText: string, focusOk: boolean, okCloses: boolean, cancelText: string, showFooter: boolean, allowCancel: boolean, escape: boolean, animate: boolean, enterTriggersOk: boolean}|*}
   */


  modals.getOptions = function ($el) {
    var _dataOptions = $el.data();

    var _options = this.options;
    if (!_.isObject(_dataOptions) || _.isEmpty(_dataOptions)) return _options;

    for (var key in _dataOptions) {
      var val = _dataOptions[key];

      if (key == 'className') {
        _options.className = _options.className + ' ' + _dataOptions.className;
      } else {
        _options[key] = val;
      }
    }

    return _options;
  };
  /**
   * Returns Gravity Form content itemized into an object
   *
   * @param target string - content selector from where the content is being retrieved
   * @returns {*}
   */


  modals.getContentModel = function (target) {
    var contentModelFactory = new ContentModelFactory({
      selector: target
    });
    var contentModel = contentModelFactory.create();
    return contentModel;
  };
  /**
   * Returns content View object for the BootstrapModal
   *
   * @param contentModel
   * @returns {*}
   */


  modals.createView = function (contentModel) {
    if (contentModel.has('form')) {
      return this.gforms.createGFView();
    } else {
      return require('./inlineModalView');
    }
  };

  return modals;
});


// https://gist.github.com/MattSurabian/7868115#file-google-maps-loader-js
var _gMapsApi = null;
hji.define('hji-common/gMapsApi',['require', 'jquery'], function (require, $) {
  if (!_gMapsApi) {
    _gMapsApi = {
      defer: $.Deferred(),
      load: function load(apiKey) {
        var that = this;

        if (!apiKey) {
          HJI.log('Google Maps API Key is not provided.\nPlease enter your Maps JavaScript API key into the HJI Membership settings. \nhttps://developers.google.com/maps/documentation/embed/get-api-key');
          return this.defer.reject({
            gMapsApiKey: false
          });
        }

        var url = window.location.protocol + '//maps.googleapis.com/maps/api/js?key=' + apiKey + '&libraries=drawing,places&callback=google_maps_loaded';

        require([url], function () {}, function (err) {
          that.defer.reject();
        });

        return this.defer.promise();
      },
      done: function done(callback) {
        if (typeof callback === 'function') {
          this.defer.promise().done(function () {
            return callback();
          });
        }
      },
      fail: function fail(callback) {
        if (typeof callback === 'function') {
          this.defer.promise().fail(function (arg) {
            return callback(arg);
          });
        }
      }
    };

    window.google_maps_loaded = function () {
      _gMapsApi.defer.resolve(google.maps);
    };
  }

  return _gMapsApi;
});


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define('hji-common/visibility',[], function () {
  var _one = false;

  var Visibility = /*#__PURE__*/function () {
    function Visibility(el) {
      _classCallCheck(this, Visibility);

      if (_typeof(el) !== "object") {
        HJI.logError("Providing element is not an object.", 'Visibility.constructor');
        return;
      }

      this.el = el;
      this.visible = this.isVisible();
      this.setListeners();
    }

    _createClass(Visibility, [{
      key: "setListeners",
      value: function setListeners() {
        var that = this; // DOM Ready

        document.addEventListener('DOMContentLoaded', function () {
          that.trigger(that.isVisible());
        }, false); // Deprecated: https://developer.mozilla.org/en-US/docs/Web/API/MutationObserver
        // document.body.addEventListener('DOMSubtreeModified', function () {
        //     that.trigger(that.isVisible());
        // }, false);

        var ticking = false;
        window.addEventListener('scroll', function (e) {
          if (!ticking) {
            window.requestAnimationFrame(function () {
              that.trigger(that.isVisible());
              ticking = false;
            });
            ticking = true;
          }
        });
      }
    }, {
      key: "one",
      value: function one(event, func) {
        var that = this;

        function handler(e) {
          _one = true;
          func.call(this, e);
          that.el.removeEventListener(event, handler);
        }

        if (!_one) {
          if (this.isVisible()) {
            func.call(this, event);
          } else {
            this.el.addEventListener(event, handler);
          }
        }
      }
    }, {
      key: "isVisible",
      value: function isVisible() {
        var _this$el$getBoundingC = this.el.getBoundingClientRect(),
            top = _this$el$getBoundingC.top,
            bottom = _this$el$getBoundingC.bottom;

        var vHeight = window.innerHeight || document.documentElement.clientHeight;
        return (top > 0 || bottom > 0) && top < vHeight;
      }
    }, {
      key: "trigger",
      value: function trigger(visible) {
        if (this.visible !== visible) {
          this.visible = visible;
          var event = visible ? new Event('visible') : new Event('invisible');
          this.el.dispatchEvent(event);
        }
      }
    }]);

    return Visibility;
  }();

  return Visibility;
});


hji.define('hji-common/streetView',['jquery', 'hji-common/gMapsApi', 'hji-common/visibility'], function ($, GoogleMapsLoader, Visibility) {
  /**
   * by Zach Schryver zacharys@hjimail.com
   * https://bitbucket.org/homejunction/street-view
   */
  function streetView(geoInfo, callback) {
    var streetView = function streetView(geoInfo, callback) {
      this.errorFlag = false; //An address is required, so throw our custom error if we don't have one

      if (geoInfo.address.length < 1) {
        this.streetViewError({
          message: 'A valid address is required',
          context: 'streetView.getStreetCoords',
          toString: function toString() {
            return this.message + ' in ' + this.context;
          }
        });
      } else {
        this.address = geoInfo.address;
      } //These aren't absolutely necessary, so let them be empty strings if they weren't included


      this.city = geoInfo.city ? geoInfo.city : '';
      this.state = geoInfo.state ? geoInfo.state : '';

      if (!isNaN(geoInfo.lat) && !isNaN(geoInfo.lng)) {
        this.location = new google.maps.LatLng(geoInfo.lat, geoInfo.lng);
      }

      this.callback = callback ? callback : undefined;
      this.createStreetView();
    };

    streetView.prototype.fullAddress = function () {
      return this.address + ' ' + this.city + ', ' + this.state;
    };

    streetView.prototype.getStreetCoords = function () {
      //Maintain object scope for callback
      var that = this; //Geocoded coordinates point to the center of a property, which can cause issues in tightly packed or very rural neighborhoods
      //To get around this, we use the directions service to get the coordinates of the front of the property

      this.getPanorama(this.location, function () {
        var directions = new google.maps.DirectionsService();
        directions.route({
          origin: that.fullAddress(),
          destination: that.fullAddress(),
          travelMode: 'DRIVING'
        }, function (results, status) {
          if (status === google.maps.DirectionsStatus.OK) {
            that.streetCoords = results.routes[0].legs[0].end_location;
            that.calculateHeading();
          } else {
            that.streetViewError({
              message: 'Unable to locate the front of the property',
              context: 'streetView.getStreetCoords',
              status: status,
              toString: function toString() {
                return this.message + ' in ' + this.context + '. Google status: ' + status;
              }
            });
          }
        });
      });
    };

    streetView.prototype.getPanorama = function (location, callback) {
      var streetViewService = new google.maps.StreetViewService();
      streetViewService.getPanoramaByLocation(location, 50, function (data, status) {
        callback(data, status);
      });
    };

    streetView.prototype.calculateHeading = function () {
      var panoLocation,
          that = this; //Find the nearest panorama to the street address and then calculate the correct heading that points the
      //street view camera at the desired property

      this.getPanorama(this.streetCoords, function (data, status) {
        if (status === google.maps.StreetViewStatus.OK) {
          var diffX = that.location.lat() - data.location.latLng.lat();
          diffY = that.location.lng() - data.location.latLng.lng();
          var heading = Math.atan2(diffY, diffX) * (180 / Math.PI);

          if (heading < 0) {
            heading += 2 * Math.PI;
          }

          that.heading = heading;

          if (that.callback) {
            that.callback.call(that);
          }
        } else {
          that.streetViewError({
            message: 'Unable to locate Street View within 50m of location',
            context: 'streetView.calculateHeading',
            status: 'status',
            toString: function toString() {
              return this.message + ' in ' + this.context + '. Google status: ' + status;
            }
          });
        }
      });
    };

    streetView.prototype.renderStreetView = function (elementId) {
      var targetElement = document.getElementById(elementId);

      if (this.errorFlag || !this.heading) {
        targetElement.innerHTML = "<p class='streetViewError'>Unable to locate Street View for the given location.</p>";
        this.errorFlag = false;
        return;
      } //Take all of our generated options and render a new street view at the target element


      var panoramaOptions = {
        position: this.streetCoords,
        pov: {
          heading: Math.round(this.heading),
          pitch: 0
        },
        zoom: 1
      };
      var myPano = new google.maps.StreetViewPanorama(targetElement, panoramaOptions);
      google.maps.event.addListenerOnce(myPano, 'position_changed', function () {
        $('#' + elementId).trigger('hjiStreetViewLoaded');
      });
      myPano.setVisible(true);
    };

    streetView.prototype.createStreetView = function () {
      var that = this; //Geocode a lat/lng from address if one is not provided

      if (!this.location) {
        var geocoder = new google.maps.Geocoder();
        geocoder.geocode({
          'address': this.fullAddress()
        }, function (results, status) {
          if (status === google.maps.GeocoderStatus.OK) {
            that.location = results[0].geometry.location;
            that.getStreetCoords();
          } else {
            that.streetViewError({
              errorType: 'StreetView',
              message: 'Unable to find a Street View for the given location',
              status: status,
              context: 'streetView.createStreetView',
              toString: function toString() {
                return this.message + ' in ' + this.context + '. Google status: ' + status;
              }
            });
          }
        });
      } else {
        this.getStreetCoords();
      }
    };

    streetView.prototype.getImageUrl = function (width, height) {
      var baseUrl = window.location.protocol + "//maps.googleapis.com/maps/api/streetview?sensor=false&fov=75"; //Establish some defaults

      width = typeof width == 'undefined' ? '50' : width;
      height = typeof height == 'undefined' ? '50' : height;
      var url = [baseUrl, 'size=' + width + 'x' + height, 'location=' + this.location.toUrlValue(), 'heading=' + this.heading];
      return url.join('&');
    };

    streetView.prototype.streetViewError = function (exception) {
      //A small custom error handling function to render a useful error message
      this.errorFlag = true;

      if (this.callback) {
        this.callback();
      } //Probably shouldn't throw this in prod
      // throw new Error(exception.toString());

    };

    return new streetView(geoInfo, callback);
  }
  /*** jQuery Plugin $.streetView(); ***/


  $.fn.streetView = function (options) {
    var $obj = $(this),
        elementId = $obj.attr('id');

    if ($obj.length == 0) {
      return false;
    }

    var address = typeof $obj.data('address') != 'undefined' ? $obj.data('address') : '',
        city = typeof $obj.data('city') != 'undefined' ? $obj.data('city') : '',
        state = typeof $obj.data('state') != 'undefined' ? $obj.data('state') : '',
        lat = typeof $obj.data('lat') != 'undefined' ? $obj.data('lat') : false,
        lng = typeof $obj.data('lng') != 'undefined' ? $obj.data('lng') : false; //noinspection JSValidateTypes

    var settings = $.extend({
      elementId: elementId,
      geoInfo: {
        address: address,
        city: city,
        state: state,
        lat: lat,
        lng: lng
      },
      wrapperSelector: false,
      hideWrapperOnError: true,
      callback: false,
      render: true
    }, options);
    return GoogleMapsLoader.load(HJI.commonVar('gMapsApiKey')).done(function () {
      $objVisibility = new Visibility($obj[0]);
      $objVisibility.one('visible', function () {
        streetView(settings.geoInfo, function () {
          if (settings.render === true) {
            if (this.errorFlag) {
              if (settings.wrapperSelector && settings.hideWrapperOnError) {
                $obj.css({
                  'height': 'auto'
                });
                $obj.closest(settings.wrapperSelector).hide();
                $obj.closest('#property-street-view').hide();
                $obj.closest('#street-view').hide();
              }
            } else {
              this.renderStreetView(settings.elementId);
            }
          }

          if (settings.callback) {
            if (typeof settings.callback === 'string') {
              window[settings.callback]();
            } else if (typeof settings.callback === 'function') {
              settings.callback();
            }
          }
        });
      });
    }).fail(function (arg) {
      $obj.closest('#property-street-view').hide();
      $obj.closest('#street-view').hide();
      $obj.closest('.street-view-wrap').hide();
      $obj.hide();
    });
  };
});


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

hji.define('hji-common/tabsRefresh',['require', 'jquery'], function (require, $) {
  var tabsRefresh = {
    init: function init() {
      this.setEvents();
    },
    setEvents: function setEvents() {
      var that = this; // Targets the tab or accordion event to redraw maps on display

      $('.panel-collapse, a[data-toggle="tab"]').each(function () {
        $(this).on('shown.bs.collapse shown.bs.tab', function (e) {
          var target = $(e.target).attr("href");

          that._refreshGoogleMaps();

          that._refreshStreetView();

          that._refreshIframes(target);
        });
      });
    },
    _refreshGoogleMaps: function _refreshGoogleMaps() {
      var map = $('[data-type="mapCanvas"]'); // reloads standard google map

      if (map.length) {
        for (var i in map) {
          if (_typeof(map[i].gMap) == 'object') {
            map[i].gMap.refresh();
          }
        }
      }
    },
    _refreshStreetView: function _refreshStreetView() {
      // reloads google street view
      if ($('[data-init="streetview"]').length) {
        hji.require(['jquery', 'hji-common/streetView'], function () {
          $('[data-init="streetview"]').streetView({
            wrapperSelector: '#street-view'
          });
        });
      }
    },
    _refreshIframes: function _refreshIframes(target) {
      // reloads iframes of the clicked tab.
      $(target).find('iframe').attr('src', function (i, val) {
        return val;
      });
    }
  };
  tabsRefresh.init();
});
/*! npm.im/object-fit-images 3.2.3 */
var objectFitImages=function(){"use strict";function t(t,e){return"data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='"+t+"' height='"+e+"'%3E%3C/svg%3E"}function e(t){if(t.srcset&&!m&&window.picturefill){var e=window.picturefill._;t[e.ns]&&t[e.ns].evaled||e.fillImg(t,{reselect:!0}),t[e.ns].curSrc||(t[e.ns].supported=!1,e.fillImg(t,{reselect:!0})),t.currentSrc=t[e.ns].curSrc||t.src}}function i(t){for(var e,i=getComputedStyle(t).fontFamily,r={};null!==(e=l.exec(i));)r[e[1]]=e[2];return r}function r(e,i,r){var n=t(i||1,r||0);p.call(e,"src")!==n&&b.call(e,"src",n)}function n(t,e){t.naturalWidth?e(t):setTimeout(n,100,t,e)}function c(t){var c=i(t),o=t[a];if(c["object-fit"]=c["object-fit"]||"fill",!o.img){if("fill"===c["object-fit"])return;if(!o.skipTest&&g&&!c["object-position"])return}if(!o.img){o.img=new Image(t.width,t.height),o.img.srcset=p.call(t,"data-ofi-srcset")||t.srcset,o.img.src=p.call(t,"data-ofi-src")||t.src,b.call(t,"data-ofi-src",t.src),t.srcset&&b.call(t,"data-ofi-srcset",t.srcset),r(t,t.naturalWidth||t.width,t.naturalHeight||t.height),t.srcset&&(t.srcset="");try{s(t)}catch(t){window.console&&console.warn("https://bit.ly/ofi-old-browser")}}e(o.img),t.style.backgroundImage='url("'+(o.img.currentSrc||o.img.src).replace(/"/g,'\\"')+'")',t.style.backgroundPosition=c["object-position"]||"center",t.style.backgroundRepeat="no-repeat",t.style.backgroundOrigin="content-box",/scale-down/.test(c["object-fit"])?n(o.img,function(){o.img.naturalWidth>t.width||o.img.naturalHeight>t.height?t.style.backgroundSize="contain":t.style.backgroundSize="auto"}):t.style.backgroundSize=c["object-fit"].replace("none","auto").replace("fill","100% 100%"),n(o.img,function(e){r(t,e.naturalWidth,e.naturalHeight)})}function s(t){var e={get:function(e){return t[a].img[e||"src"]},set:function(e,i){return t[a].img[i||"src"]=e,b.call(t,"data-ofi-"+i,e),c(t),e}};Object.defineProperty(t,"src",e),Object.defineProperty(t,"currentSrc",{get:function(){return e.get("currentSrc")}}),Object.defineProperty(t,"srcset",{get:function(){return e.get("srcset")},set:function(t){return e.set(t,"srcset")}})}function o(t,e){var i=!h&&!t;if(e=e||{},t=t||"img",f&&!e.skipTest||!d)return!1;"img"===t?t=document.getElementsByTagName("img"):"string"==typeof t?t=document.querySelectorAll(t):"length"in t||(t=[t]);for(var r=0;r<t.length;r++)t[r][a]=t[r][a]||{skipTest:e.skipTest},c(t[r]);i&&(document.body.addEventListener("load",function(t){"IMG"===t.target.tagName&&o(t.target,{skipTest:e.skipTest})},!0),h=!0,t="img"),e.watchMQ&&window.addEventListener("resize",o.bind(null,t,{skipTest:e.skipTest}))}var a="bfred-it:object-fit-images",l=/(object-fit|object-position)\s*:\s*([-\w\s%]+)/g,u="undefined"==typeof Image?{style:{"object-position":1}}:new Image,g="object-fit"in u.style,f="object-position"in u.style,d="background-size"in u.style,m="string"==typeof u.currentSrc,p=u.getAttribute,b=u.setAttribute,h=!1;return o.supportsObjectFit=g,o.supportsObjectPosition=f,function(){function t(t,e){return t[a]&&t[a].img&&("src"===e||"srcset"===e)?t[a].img:t}f||(HTMLImageElement.prototype.getAttribute=function(e){return p.call(t(this,e),e)},HTMLImageElement.prototype.setAttribute=function(e,i){return b.call(t(this,e),e,String(i))})}(),o}();
hji.define("object-fit-images-polyfill", function(){});



hji.define('hji-common/unveil',['jquery'], function ($) {
  /**
   * jQuery Unveil
   * A very lightweight jQuery plugin to lazy load images
   * http://luis-almeida.github.com/unveil
   *
   * Licensed under the MIT license.
   * Copyright 2013 Luís Almeida
   * https://github.com/luis-almeida
   */
  $.fn.unveil = function (threshold, callback) {
    var $w = $(window),
        th = threshold || 0,
        retina = window.devicePixelRatio > 1,
        attrib = retina ? "data-src-retina" : "data-src",
        images = this,
        loaded;
    this.one("unveil", function () {
      var source = this.getAttribute(attrib);
      source = source || this.getAttribute("data-src");

      if (source) {
        this.setAttribute("src", source);
        if (typeof callback === "function") callback.call(this);
      }
    });

    function unveil() {
      var inview = images.filter(function () {
        var $e = $(this);
        if ($e.is(":hidden")) return;
        var wt = $w.scrollTop(),
            wb = wt + $w.height(),
            et = $e.offset().top,
            eb = et + $e.height();
        return eb >= wt - th && et <= wb + th;
      });
      loaded = inview.trigger("unveil");
      images = images.not(loaded);
    }

    $w.on("scroll.unveil resize.unveil lookup.unveil", unveil);
    unveil();
    return this;
  };
});


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define('hji-common/map/mapbox/slipstream-map',['require','jquery','backbone','hji-common/slipstream/api'],function (require) {
  var $ = require('jquery'),
      Backbone = require('backbone'),
      api = require('hji-common/slipstream/api');

  var SlipstreamMap = /*#__PURE__*/function () {
    function SlipstreamMap(options) {
      _classCallCheck(this, SlipstreamMap);

      var self = this,
          _defaults = {
        models: []
      };
      Object.assign(self, _defaults, options || {});
    }

    _createClass(SlipstreamMap, [{
      key: "render",
      value: function render($container) {
        var self = this;

        var _featureHasIcon = function _featureHasIcon(feature) {
          return (feature.properties || {}).icon || self.icon || null;
        };

        var _setLayerIcon = function _setLayerIcon(layer, icon) {
          var img = new Image();
          img.src = icon; // reset icon size to 0, to avoid default icon flash

          layer.setIcon(L.icon({
            iconUrl: icon,
            iconSize: [0, 0]
          })); // reset image dimensions after image loads

          img.onload = function () {
            layer.setIcon(L.icon({
              iconUrl: icon,
              iconSize: [img.width, img.height],
              iconAnchor: [img.width / 2, img.height - 1],
              popupAnchor: [0, -img.height + 3]
            }));
          };
        };

        var _ExtendedRenderer = function _ExtendedRenderer(Types, Renderer) {
          return Types.inherit(Renderer, {
            renderPopup: function renderPopup(item) {
              return $('<span>' + item.get('info') + '</span>');
            },
            __renderPoint: function __renderPoint(item, coordinates, properties) {
              return {
                type: 'Feature',
                geometry: {
                  type: 'Point',
                  coordinates: [coordinates.longitude, coordinates.latitude]
                },
                properties: Object.assign(properties, {
                  id: item.get('id'),
                  icon: item.get('icon')
                })
              };
            }
          });
        };

        var _ExtendedMapView = function _ExtendedMapView(Map, resolve) {
          return Map.extend({
            __onAttached: function __onAttached() {
              Map.prototype.__onAttached.apply(this, arguments);

              if (this.featureLayer) {
                this.featureLayer.eachLayer(function (layer) {
                  var feature = layer.toGeoJSON(),
                      icon = _featureHasIcon(feature);

                  if (icon) _setLayerIcon(layer, icon);
                });
              }

              resolve({
                map: this.map,
                view: this
              });
            }
          });
        };

        return new Promise(function (resolve, reject) {
          api.ready(function (API) {
            hji.require(['slipstream/listings'], function () {
              hji.require(['slipstream/common/util/types', 'slipstream/listings/view/map/renderer', 'slipstream/listings/view/map'], function (Types, Renderer, Map) {
                var ExtendedRenderer = _ExtendedRenderer(Types, Renderer),
                    ExtendedMapView = _ExtendedMapView(Map, resolve),
                    mapView = new ExtendedMapView({
                  renderer: new ExtendedRenderer(),
                  model: new Backbone.Collection(self.models || [])
                });

                mapView.render().$el.appendTo($container).height('100%');
              });
            });
          });
        });
      }
    }]);

    return SlipstreamMap;
  }();

  return SlipstreamMap;
});


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define('hji-common/map/mapInterface',[],function () {
  // TODO: the interface should encapsulate all the events
  // this way, any other implementation can simply use the events,
  // otherwise, we have no clue which events are used
  // in the implementations.
  var MapInterface = /*#__PURE__*/function () {
    function MapInterface(options) {
      _classCallCheck(this, MapInterface);

      var self = this,
          style = {
        fillOpacity: 0.35,
        strokeOpacity: 1,
        strokeWidth: 2,
        fillColor: '#3aa6ff',
        strokeColor: '#3aa6ff'
      };

      var _opt = Object.assign({
        $map: null,
        map: null,
        center: null,
        models: [],
        zoom: null,
        shapes: [],
        style: null
      }, options);

      if (!_opt.style) _opt.style = style;
      _opt.style = self._remapStyle(_opt.style);
      Object.assign(self, _opt);
    }

    _createClass(MapInterface, [{
      key: "_remapStyle",
      value: function _remapStyle(a) {
        if (typeof this._styleMap !== 'function') return a;

        var d = {},
            mapping = this._styleMap();

        if (!mapping) return a;

        for (var i = 0; i < mapping.length; i++) {
          d[mapping[i][1]] = a[mapping[i][0]];
        }

        return d;
      }
    }, {
      key: "render",
      value: function render($map) {
        var $target = _typeof($map) === 'object' && $map.length ? $map : this.$map;
        return this._create($target);
      }
      /**
       * @param Coordinates coords
       * @param numeric radius
       */

    }, {
      key: "addCircle",
      value: function addCircle(coords, radius, markerOptions) {
        this._addCircle(coords, radius, markerOptions);
      }
    }, {
      key: "addMarker",
      value: function addMarker(coords, options) {
        this._addMarker(coords, options);
      }
    }, {
      key: "addPolygons",
      value: function addPolygons(polygons) {
        this._addPolygons(polygons);
      }
    }, {
      key: "resetShapes",
      value: function resetShapes() {
        this._removeAllShapes();
      }
    }, {
      key: "onRemoveShapeIntent",
      value: function onRemoveShapeIntent(callback) {
        if (typeof callback === 'function') this.$map.on('map.removeShapeIntent', function (e, data) {
          return callback(data);
        });
      }
    }, {
      key: "removeShape",
      value: function removeShape(shape) {
        var self = this,
            e = {
          shape: shape,
          remove: true
        },
            removed = {
          id: null,
          geoJSON: null,
          shape: shape
        },
            result;
        self.$map.trigger('map.removeShapeIntent', e);

        if (e.remove === true) {
          result = self._removeShape(shape);

          if (((result.feature || {}).properties || {}).id) {
            removed.id = result.feature.properties.id;
            removed.geoJSON = result.feature;
          }

          self.$map.trigger('polygon_removed', removed);
        }

        return result;
      }
    }, {
      key: "fitBounds",
      value: function fitBounds() {
        this._fitBounds();
      }
    }]);

    return MapInterface;
  }();

  return MapInterface;
});


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define('hji-common/map/models/coordinates',[],function () {
  var Coordinates = /*#__PURE__*/function () {
    function Coordinates(lat, lng) {
      _classCallCheck(this, Coordinates);

      this.latitude = lat;
      this.longitude = lng;
    }

    _createClass(Coordinates, [{
      key: "toShort",
      value: function toShort() {
        return {
          lat: this.latitude,
          lng: this.longitude
        };
      }
    }]);

    return Coordinates;
  }();

  return Coordinates;
});


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

hji.define('hji-common/map/mapbox/mapbox-map',['require','jquery','./slipstream-map','hji-common/map/mapInterface','../models/coordinates'],function (require) {
  var $ = require('jquery'),
      SlipstreamMap = require('./slipstream-map'),
      MapInterface = require('hji-common/map/mapInterface'),
      Coordinates = require('../models/coordinates');

  var MapBox = /*#__PURE__*/function (_MapInterface) {
    _inherits(MapBox, _MapInterface);

    function MapBox(options) {
      var _this;

      _classCallCheck(this, MapBox);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(MapBox).call(this, options));
      _this.featureGroup = null;
      _this.markersGroup = null;
      return _this;
    }

    _createClass(MapBox, [{
      key: "_styleMap",
      value: function _styleMap() {
        return [['strokeColor', 'stroke'], ['strokeWeight', 'stroke-width'], ['strokeOpacity', 'stroke-opacity'], ['fillColor', 'fill'], ['fillOpacity', 'fill-opacity']];
      }
    }, {
      key: "addMarkers",
      value: function addMarkers(markers) {
        var self = this,
            map = self.map.map,
            features = [];
        if (!self.markersGroup) self.markersGroup = L.featureGroup().addTo(map);
        markers.forEach(function (marker) {
          features.push({
            type: "Feature",
            properties: {
              description: marker.info || '',
              icon: marker.icon || null
            },
            geometry: {
              type: 'Point',
              coordinates: [marker.lng, marker.lat]
            }
          });
        });
        L.geoJson(features, {
          onEachFeature: function onEachFeature(feature, layer) {
            var icon = feature.properties.icon || self.icon || null;
            if (feature.properties.description) layer.bindPopup(feature.properties.description);
            if (icon) layer.setIcon(L.icon({
              iconUrl: icon
            }));
          }
        }).addTo(self.markersGroup); // map.fitBounds(self.markersGroup.getBounds());
      }
      /**
       * @param Coordinates coords
       * @param numeric radius
       * @param marker object with marker options
       */

    }, {
      key: "_addCircle",
      value: function _addCircle(coords, radius, markerOptions) {
        L.Circle = L.Circle.extend({
          toGeoJSON: function toGeoJSON() {
            return L.GeoJSON.getFeature(this, {
              type: 'Circle',
              coordinates: L.GeoJSON.latLngToCoords(this.getLatLng()),
              radius: this.getRadius()
            });
          }
        });
        var self = this,
            map = self.map.map;
        var coordinates = Object.values(coords);
        var circle = L.circle(coordinates, radius * 1609.344, L.mapbox.simplestyle.style({
          properties: self.style || {}
        })).on({
          click: function click(e) {
            return self.removeShape(e.target);
          }
        });
        circle.addTo(self.featureGroup); // Add feature object to the layer, so it's id accessible

        circle.feature = circle.toGeoJSON();
        circle.feature.properties = Object.assign(circle.feature.properties, markerOptions.object || {});

        this._addMarker(coords, markerOptions); // setTimeout(() => {
        //     map.fitBounds(self.featureGroup.getBounds());
        // },1000)


        return circle;
      }
      /**
       * https://www.mapbox.com/maki-icons/
       * @param coords
       * @param options
       * @returns {*}
       * @private
       */

    }, {
      key: "_addMarker",
      value: function _addMarker(coords, options) {
        var self = this,
            map = self.map.map;
        var coordinates = Object.values(coords);
        var marker = L.marker(coordinates, {
          title: (options || {}).title
        }).addTo(map);
        var symbol = (options || {}).symbol || {};
        var icon = (options || {}).icon || null;
        var info = (options || {}).info || null;

        if (symbol) {
          var _icon = L.mapbox.marker.icon(Object.assign({
            'marker-size': 'small',
            'marker-symbol': 'star',
            'marker-color': '#fa0'
          }, symbol));

          marker.setIcon(_icon);
        } else if (icon) {
          var img = new Image();
          img.src = icon; // reset icon size to 0, to avoid default icon flash

          marker.setIcon(L.icon({
            iconUrl: icon,
            iconSize: [0, 0]
          })); // reset image dimensions after image loads

          img.onload = function () {
            marker.setIcon(L.icon({
              iconUrl: icon,
              iconSize: [img.width, img.height],
              iconAnchor: [img.width / 2, img.height - 1],
              popupAnchor: [0, -img.height + 3]
            }));
          };
        }

        if (info) marker.bindPopup(info);
        return marker;
      }
    }, {
      key: "_addPolygons",
      value: function _addPolygons(polygons) {
        var self = this,
            map = self.map.map;

        if (polygons[0].geometry) {
          self._addGeoJson(polygons);
        } else {
          polygons.forEach(function (polygon) {
            return self._addPolygon(polygon);
          });
        } // map.fitBounds(self.featureGroup.getBounds());

      }
    }, {
      key: "_addPolygon",
      value: function _addPolygon(coords) {
        var self = this,
            map = self.map.map,
            polygon = L.polygon(coords, L.mapbox.simplestyle.style({
          properties: self.style || {}
        })).addTo(self.featureGroup);
        polygon.on({
          click: function click(e) {
            return self.removeShape(e.target);
          }
        }); // map.fitBounds(self.featureGroup.getBounds());
      }
    }, {
      key: "_addGeoJson",
      value: function _addGeoJson(polygons) {
        var self = this,
            map = self.map.map,
            features = [],
            polygons = polygons || [];
        polygons.forEach(function (polygon) {
          if (polygon.type && polygon.properties) {
            if (polygon.geometry.radius) {
              var coords = new Coordinates(polygon.geometry.coordinates[1], polygon.geometry.coordinates[0]);

              self._addCircle(coords, polygon.geometry.radius / 1609.344, {
                object: polygon.properties
              });
            } else {
              features.push(polygon);
            }
          } else {
            features.push({
              type: "Feature",
              properties: Object.assign({
                areaType: polygon.areaType || null,
                geoType: polygon.geoType || null,
                id: polygon.id || null,
                label: polygon.label || null,
                name: polygon.name || null
              }, self.style || {}),
              geometry: polygon.geometry
            });
          }
        });
        if (!features.length) return;
        var geojson = L.geoJson(features, {
          style: L.mapbox.simplestyle.style,
          onEachFeature: function onEachFeature(feature, layer) {
            layer.addTo(self.featureGroup);
            layer.on({
              click: function click(e) {
                var layer = e.target;
                self.removeShape(layer);
              }
            });
          }
        });
        self.shapes.push(geojson); // map.fitBounds(geojson.getBounds());
      }
    }, {
      key: "_removeShape",
      value: function _removeShape(layer) {
        this.featureGroup.removeLayer(layer);
        return layer;
      }
    }, {
      key: "_removeAllShapes",
      value: function _removeAllShapes() {
        this.featureGroup.clearLayers();
      }
    }, {
      key: "_fitBounds",
      value: function _fitBounds() {
        if (this.featureGroup.hasOwnProperty('getBounds')) this.map.map.fitBounds(this.featureGroup.getBounds());
      }
    }, {
      key: "_create",
      value: function _create($map) {
        var self = this;
        self.$map = $map || self.map;
        var setup = {
          map: function map(resolve, reject) {
            if ((self.map || {}).map) {
              resolve({
                map: self.map.map
              });
            } else {
              new SlipstreamMap({
                models: self.models,
                // TODO: we should not be passing a global icon setting
                // they should rather be assigned to each marker in advance
                icon: self.icon || null
              }).render(self.$map).then(function (data) {
                self.map = data.view;
                resolve(data);
              });
            }
          },
          controls: function controls(map) {
            L.control.layers({
              '<span class="hj-map-switch layer-toggle">Map</span>': L.mapbox.tileLayer('mapbox.streets').addTo(map),
              '<span class="hj-satellite-switch layer-toggle">Satellite</span>': L.mapbox.tileLayer('mapbox.satellite')
            }).addTo(map);
            var control = document.querySelector('.layer-toggle').closest('.leaflet-control-layers-list');
            control.style.padding = '4px 8px';
            control.fontSize = '11px';
          }
        };
        return new Promise(function (resolveSetup, rejectSetup) {
          return new Promise(function (resolveMap, rejectMap) {
            setup.map(resolveMap, rejectMap);
          }).then(function (data) {
            self.featureGroup = L.featureGroup().addTo(data.map);
            setup.controls(data.map);
            return data;
          }).then(function (data) {
            return resolveSetup(data);
          });
        });
      }
    }]);

    return MapBox;
  }(MapInterface);

  return MapBox;
});


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

hji.define('hji-common/map/mapbox/widget',['require','jquery','./mapbox-map','hji-common/map/models/coordinates'],function (require) {
  var $ = require('jquery'),
      Map = require('./mapbox-map'),
      Coordinates = require('hji-common/map/models/coordinates');

  var MapBoxWidget = function MapBoxWidget(widgetOptions, mapOptions, callback) {
    _classCallCheck(this, MapBoxWidget);

    this.widgetOptions = {
      $map: $(widgetOptions.canvas),
      models: widgetOptions.geoData.map(function (m) {
        return {
          coordinates: new Coordinates(m.lat, m.lng),
          info: m.info || null,
          icon: m.icon || null,
          id: m.lat
        };
      }),
      icon: widgetOptions.icon || null
    };
    this.mapOptions = mapOptions || {};
    var map = new Map(this.widgetOptions);
    map.render().then(function (data) {
      if (typeof callback === 'function') callback(data);
      return data;
    }).then(function (data) {// if (widgetOptions.geoData.length)
      //     map.addMarkers(widgetOptions.geoData)
    });
  };

  return MapBoxWidget;
});


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define('hji-common/gMapsEmbedApi',['jquery'], function ($) {
  var gMapsEmbedApi = /*#__PURE__*/function () {
    function gMapsEmbedApi(options) {
      _classCallCheck(this, gMapsEmbedApi);

      var defaults = {
        $el: null,
        q: null,
        center: {},
        zoom: 18,
        apiKey: null,
        callback: null
      };
      this.settings = Object.assign(defaults, options);
    }

    _createClass(gMapsEmbedApi, [{
      key: "renderMap",
      value: function renderMap() {
        if (validateSettings(this.settings)) {
          var src = "https://www.google.com/maps/embed/v1/place?key=".concat(this.settings.apiKey) + '&q=' + (this.settings.q || '') + "&center=".concat(this.settings.center.lat, ",").concat(this.settings.center.lng) + "&zoom=".concat(this.settings.zoom);
          var iframe = $('<iframe></iframe>');
          iframe.prop('frameborder', 0).css({
            border: 0
          }).prop('width', '100%').prop('height', '100%').prop('src', src);
          var $el = this.settings.$el instanceof $ ? this.settings.$el : $(this.settings.$el);
          $el.html(iframe);
          if (typeof this.settings.callback === 'function') this.settings.callback();
        }
      }
    }]);

    return gMapsEmbedApi;
  }();

  var validateSettings = function validateSettings() {
    var settings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (!settings.$el) {
      HJI.logError('Map could not be rendered. Target element to render map within is not provided.');
      return false;
    } else if (!settings.apiKey) {
      HJI.logError('Map could not be rendered. Google MapsEmbed API Key is not provided.');
      return false;
    } else if (!settings.q) {
      HJI.logError('Map could not be rendered. Property "q" is not defined.');
      return false;
    } else if (!settings.center) {
      HJI.logError('Map could not be rendered. Property "center" is not defined.');
      return false;
    } else if (_typeof(settings.center) !== 'object') {
      HJI.logError('Map could not be rendered. Property "center" expects and object: {lat, lng}.');
      return false;
    }

    return true;
  };

  return gMapsEmbedApi;
});


hji.define('hji-common/getUserLocation',[],function () {
  var getUserLocation = function getUserLocation(success, error, options) {
    this.sendLocationRequest(success, error, options);
  };

  getUserLocation.prototype.sendLocationRequest = function (successCallback, errorCallback, options) {
    if (navigator.geolocation) {
      navigator.geolocation.getCurrentPosition(function (position) {
        if (typeof successCallback === 'function') {
          successCallback(position);
        }
      }, function (error) {
        if (typeof errorCallback === 'function') {
          errorCallback(error);
        }
      }, options);
    }

    return false;
  };

  return getUserLocation;
});


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

hji.define('hji-common/gMap',['jquery', 'underscore', 'hji-common/gMapsApi', 'hji-common/visibility', 'hji-common/gMapsEmbedApi'], function ($, _, GoogleMapsLoader, Visibility) {
  /*
   var geoData = [
       {
           lat: '', // Latitude
           lng: '', // Longitude
           info: '' // Information displayed inside infoWindow
       }
   ];
   */
  var gMap = function gMap(settings, mapOptions, callback) {
    var that = this;
    this.map = null; // Preset settings for ready() function

    this.config = $.extend({
      canvas: false,
      geoData: [],
      icon: false,
      drawingManager: false,
      autozoom: true,
      style: null
    }, settings);
    GoogleMapsLoader.load(HJI.commonVar('gMapsApiKey')).done(function () {
      var canvasVisibility = new Visibility(that.config.canvas);
      canvasVisibility.one('visible', function () {
        return that.init(settings, mapOptions, callback);
      });
    }).fail(function (arg) {
      if (arg.hasOwnProperty('gMapsApiKey') && !arg.gMapsApiKey) {
        if (!settings.geoData.length) {
          HJI.logError('Failed to load Google Map. Location is not provided.');
          return;
        } else if (settings.geoData.length > 1) {
          GoogleMapsLoader.load(HJI.commonVar('hjgMapsApiKey')).done(function () {
            return that.init(settings, mapOptions, callback);
          });
          return;
        }

        var gMapsEmbedApiKey = HJI.commonVar('hjgMapsApiKey');

        if (!gMapsEmbedApiKey) {
          HJI.logError('Failed to load Google Map. Google Maps Embed API Key is not provided.');
          return;
        }

        var address = function address() {
          if (HJI.rIDX && HJI.rIDX.getListing()) return HJI.rIDX.getListing().address;
          var propertyName = $(settings.geoData[0].info).text();

          if (propertyName.includes('–')) {
            var parts = propertyName.split('–');
            return parts[1].trim();
          }

          return propertyName || "".concat(settings.geoData[0].lat, ",").concat(settings.geoData[0].lng);
        };

        hji.require(['hji-common/gMapsEmbedApi'], function (gMapsEmbedApi) {
          new gMapsEmbedApi({
            $el: settings.canvas,
            q: settings.geoData[0].address || address(),
            center: {
              lat: settings.geoData[0].lat,
              lng: settings.geoData[0].lng
            },
            zoom: 18,
            apiKey: gMapsEmbedApiKey,
            callback: callback
          }).renderMap();
        });
      }
    });
  };

  gMap.prototype.ready = function (callback) {
    if (typeof callback == 'function') {
      if (this.map) {
        callback();
      } else {
        $(this.config.canvas).on('gMapReady', function () {
          callback();
        });
      }
    }
  };

  gMap.prototype.init = function (settings, mapOptions, callback) {
    // Error flag
    this.errorFlag = false;
    this.config = $.extend({
      canvas: false,
      geoData: [],
      icon: false,
      drawingManager: false,
      autozoom: true
    }, settings || {});
    this.mapOptions = mapOptions || {}; // Currently defined shapes

    this.shapes = [];
    this.shapesIndex = 0; // autoincrement counter for shape IDs.

    this.callback = callback ? callback : undefined; // Terminate if canvas element is not defined

    if (!this.config.canvas || !jQuery(this.config.canvas).length) {
      this.gMapError('Canvas element for rendering Google Map was not defined.');
      return false;
    } else {
      $(this.config.canvas)[0].gMap = this;
      this.createMap();
    } // Utility similar to $.extend();


    function extend(a, b) {
      for (var key in b) {
        if (b.hasOwnProperty(key)) {
          a[key] = b[key];
        }
      }

      return a;
    }

    this.setPublicEvents();
    return this;
  };

  gMap.prototype.createMap = function () {
    var that = this;
    this.mapOptions = $.extend({
      center: new google.maps.LatLng(0, 0),
      zoom: 16,
      mapTypeId: google.maps.MapTypeId.ROADMAP,
      styles: null
    }, this.mapOptions);
    this.map = new google.maps.Map(this.config.canvas, this.mapOptions);
    this.markers = [];
    this.bounds = new google.maps.LatLngBounds();
    this.locationControlUI = false;

    if (this.config.geoData.length) {
      this.plotMarkers(this.config.geoData);
    }

    if (this.config.drawingManager) {
      var options = this.config.drawingManager.options ? this.config.drawingManager.options : null;
      var customControls = this.config.drawingManager.customControls ? this.config.drawingManager.customControls : null;
      var events = this.config.drawingManager.events ? this.config.drawingManager.events : null;
      this.drawingManager(options, customControls, events);
    }

    if (this.callback) {
      this.callback();
    }

    $(this.config.canvas).trigger('gMapReady');
    this.map.data.addListener('click', function (e) {
      if (e.feature) {
        if (confirm('Would you like to delete this polygon?')) {
          that.removeShape(e.feature);
        }
      }
    });
  };

  gMap.prototype.plotMarkers = function (locations) {
    var that = this;
    var infowindow = new google.maps.InfoWindow();
    var marker, i;

    for (i = 0; i < locations.length; i++) {
      var coords = new google.maps.LatLng(locations[i].lat, locations[i].lng);
      marker = new google.maps.Marker({
        position: coords,
        map: that.map,
        icon: this.getIcon(locations[i])
      });
      this.markers.push(marker);
      google.maps.event.addListener(marker, 'click', function (marker, i) {
        return function () {
          infowindow.setOptions({
            maxWidth: 350
          });
          infowindow.setContent('<div class="infoWindowContentWrap">' + locations[i].info);
          +'</div>';
          infowindow.open(that.map, marker);
        };
      }(marker, i));
      this.bounds.extend(coords);
    } // InfoWindow event - triggers when the window gets added to the DOM
    // Lazy-loads images and loads polyfill if necessary.


    google.maps.event.addListener(infowindow, 'domready', function () {
      hji.require(['hji-common/unveil'], function () {
        $("body .infoWindowContentWrap img[data-src]").unveil(1, function () {
          // callback checks to see if we've included our object-fit polyfill
          if (typeof objectFitImages == 'function') {
            objectFitImages();
          }
        });
      });
    });
    this.map.fitBounds(this.bounds); // Keep zoom at 16 if bounds are zoomed-in too much
    // this usually happens when there is only 1 marker

    if (this.config.autozoom) {
      google.maps.event.addListenerOnce(that.map, "idle", function () {
        if (that.map.getZoom() > 16) that.map.setZoom(16);
      });
    }
  };

  gMap.prototype.refresh = function () {
    // Resize doesn't work very well when map is loaded inside tabs
    // - map is not zommed and positioned correctly
    google.maps.event.trigger(this.map, 'resize');
    this.map.fitBounds(this.bounds);
  };

  gMap.prototype.getIcon = function (location) {
    if (typeof location.icon != 'undefined' && location.icon) {
      return location.icon;
    } else if (this.config.icon) {
      // Is default icon set in the settings?
      return this.config.icon;
    }

    return null;
  };

  gMap.prototype.gMapError = function (error) {
    this.errorFlag = true;
    throw new Error(error);
  };

  gMap.prototype.publicEvents = function () {
    var that = this;
    var events = {
      refreshMap: function refreshMap() {
        setTimeout(function () {
          that.refresh();
        }, 25);
      }
    };
    return events;
  };

  gMap.prototype.setPublicEvents = function () {
    var events = this.publicEvents();

    if (events) {
      for (var e in events) {
        $(this.config.canvas).on(e, events[e]);
      }
    }
  };

  gMap.prototype.renderPolygons = function (polygons, options) {
    var that = this;
    polygons.forEach(function (polygon) {
      if (polygon.geometry) {
        that.renderGeoJson([polygon], Object.assign(that.config.style || {}, options || {}));
      } else {
        that.renderPolygon(polygon, Object.assign(that.config.style || {}, options || {}));
      }
    });
  };
  /**
   * Renders polygon on the map
   * @param coords - array of lat/lng pairs
   * Example:
   * [
   *      [32.837481,-117.280169],
   *      [32.837481,-117.280169],
   *      [32.838491,-117.267809]
   * ]
   */


  gMap.prototype.renderPolygon = function (coords, options) {
    var that = this;
    this.ready(function () {
      // Define polygon
      var polygon;
      var polygonCoords = []; // Settings bounds on cities (like Scottsdale)
      // fails if there are no shapes on the map
      // Getting bounds on every shape render
      // resets zoom only to that particular shape.

      if (that.shapes.length == 0) {
        that.bounds = new google.maps.LatLngBounds();
      }

      for (var i in coords) {
        // Supporting both lat/lng object as well as simple array
        if (coords[i].lat && coords[i].lng) {
          var latLng = new google.maps.LatLng(coords[i].lat, coords[i].lng);
        } else {
          var latLng = new google.maps.LatLng(coords[i][0], coords[i][1]);
        }

        polygonCoords.push(latLng);
        that.bounds.extend(latLng);
      } // Construct polygon


      var settings = $.extend({
        paths: polygonCoords,
        editable: true,
        collectable: true,
        hjiPolygonObj: null
      }, options);
      polygon = new google.maps.Polygon(settings);

      if (settings.collectable) {
        if (settings.hjiPolygonObj) {
          polygon.hjiPolygonObj = settings.hjiPolygonObj;
        }

        polygon.shapeId = that.collectShape(polygon);
        polygon.type = 'polygon';
        that.setShapeListeners(polygon);
      } // Render polygon


      polygon.setMap(that.map);
      that.shapesUpdatedTrigger();
    });
  };

  gMap.prototype.renderGeoJson = function (polygons, options) {
    var that = this;
    this.ready(function () {
      // Construct polygon
      polygons.forEach(function (polygon) {
        var features = that.map.data.addGeoJson({
          type: "Feature",
          properties: {
            areaType: polygon.areaType || null,
            geoType: polygon.geoType || null,
            id: polygon.id || null,
            label: polygon.label || null,
            name: polygon.name || null
          },
          geometry: polygon.geometry
        }, {
          collectable: true,
          hjiPolygonObj: null
        });
        if (that.config.style) that.map.data.setStyle(that.config.style);
      });
      that.shapesUpdatedTrigger();
    });
  };

  gMap.prototype.drawingManager = function (options, customControls, customEvents) {
    var that = this,
        settings = $.extend({
      // drawingMode: google.maps.drawing.OverlayType.MARKER,
      drawingControl: true,
      drawingControlOptions: {
        position: google.maps.ControlPosition.TOP_CENTER,
        drawingModes: [//                            google.maps.drawing.OverlayType.CIRCLE,
        google.maps.drawing.OverlayType.POLYGON, google.maps.drawing.OverlayType.RECTANGLE]
      },
      circleOptions: Object.assign({
        clickable: true,
        editable: true,
        zIndex: 1
      }, that.config.style || {}),
      rectangleOptions: Object.assign({
        editable: true
      }, that.config.style || {}),
      // rectangles created are editable by default
      polygonOptions: Object.assign({
        editable: true
      }, that.config.style || {})
    }, options || {});
    var controls = [this.locationButton()]; // Merge customControls with existing controls

    if (customControls) {
      controls = controls.concat(customControls);
    }

    this.ready(function () {
      var drawingManager = new google.maps.drawing.DrawingManager(settings);
      google.maps.event.addListener(drawingManager, 'overlaycomplete', function (e) {
        drawingManager.setDrawingMode(null); // that.removeCircle();

        var newShape = e.overlay;

        if (e.type === google.maps.drawing.OverlayType.RECTANGLE) {
          newShape.type = 'rectangle';
        } else if (e.type === google.maps.drawing.OverlayType.CIRCLE) {
          newShape.type = 'circle';
        } else if (e.type === google.maps.drawing.OverlayType.POLYGON) {
          newShape.type = 'polygon';
        }

        newShape.shapeId = that.collectShape(newShape);
        that.setShapeListeners(newShape);
        that.shapesUpdatedTrigger();
      }); // Create custom events

      var eventSetter = function eventSetter(eventName, eventHandler) {
        google.maps.event.addListener(drawingManager, eventName, function (e) {
          eventHandler();
        });
      };

      if (customEvents) {
        // Loop through events
        for (var i in customEvents) {
          var event = customEvents[i].event,
              handler = customEvents[i].handler;
          eventSetter(event, handler);
        }
      }

      drawingManager.setMap(that.map); // If array - loop through and add controls to the drawing manager

      if (_typeof(controls) == 'object') {
        for (var i in controls) {
          controls[i].index = 1;
          that.map.controls[google.maps.ControlPosition.TOP_CENTER].push(controls[i]);
        }
      }
    });
  };

  gMap.prototype.shapesUpdatedTrigger = function () {
    var that = this;
    $(this.config.canvas).trigger('shapesUpdated', {
      shapes: that.shapes,
      getUrlValues: function getUrlValues() {
        var values = {};
        var result = {};

        for (var i in that.shapes) {
          var type = that.shapes[i].type == 'rectangle' || that.shapes[i].type == 'polygon' ? 'polygon' : that.shapes[i].type;
          if (typeof type === 'undefined') continue;

          if (!values[type]) {
            values[type] = [];
          }

          values[type].push(that.toUrlValue(that.shapes[i]));
        }

        if (!_.isEmpty(values)) {
          for (var i in values) {
            if (values[i].length) {
              result[i] = JSON.stringify(values[i]);
            }
          }
        }

        return result;
      },
      gMap: that
    });
  };

  gMap.prototype.collectShape = function (shape) {
    this.shapesIndex++;
    shape.shapeId = this.shapesIndex;
    this.shapes.push(shape);
    return shape.shapeId;
  };

  gMap.prototype.unCollectShape = function (shape, callback) {
    for (var i in this.shapes) {
      if (this.shapes[i].shapeId == shape.shapeId) {
        $(this.config.canvas).trigger('shapeDelete', shape);
        this.shapes.splice(i, 1);
        this.shapesUpdatedTrigger();
      }
    }

    if (typeof callback != 'undefined') {
      callback();
    }
  };

  gMap.prototype.setShapeListeners = function (shape) {
    var that = this;

    if (shape.type == 'polygon') {
      google.maps.event.addListener(shape.getPath(), 'set_at', function () {
        // that.shapes[shape.shapeId] = shape;
        that.updateShape(shape);
        that.shapesUpdatedTrigger();
        $(that.config.canvas).trigger('shapeBoundsChanged', shape);
      });
      google.maps.event.addListener(shape.getPath(), 'insert_at', function () {
        // that.shapes[shape.shapeId] = shape;
        that.updateShape(shape);
        that.shapesUpdatedTrigger();
        $(that.config.canvas).trigger('shapeBoundsChanged', shape);
      });
    } else if (shape.type == 'rectangle') {
      google.maps.event.addListener(shape, 'bounds_changed', function () {
        // that.shapes[shape.shapeId] = shape;
        that.updateShape(shape);
        that.shapesUpdatedTrigger();
        $(that.config.canvas).trigger('shapeBoundsChanged', shape);
      });
    } else if (shape.type == 'circle') {
      google.maps.event.addListener(shape, 'radius_changed', function () {
        // that.shapes[shape.shapeId] = shape;
        that.updateShape(shape);
        that.shapesUpdatedTrigger();
        $(that.config.canvas).trigger('shapeBoundsChanged', shape);
      });
      google.maps.event.addListener(shape, 'center_changed', function () {
        // that.shapes[shape.shapeId] = shape;
        that.updateShape(shape);
        that.shapesUpdatedTrigger();
        $(that.config.canvas).trigger('shapeBoundsChanged', shape);
      });
    }

    google.maps.event.addListener(shape, 'click', function (e) {
      if (confirm('Would you like to delete this polygon?')) {
        that.removeShape(shape);
      }
    });
  };

  gMap.prototype.updateShape = function (shape) {
    var that = this;

    _.each(this.shapes, function (v, k, list) {
      if (v.shapeId == shape.shapeId) {
        that.shapes[k].shape = shape;
      }
    });
  };
  /**
   * Removes shape from the map
   *
   * @param shape - object - Google Maps shape object
   */


  gMap.prototype.removeShape = function (shape) {
    var that = this;

    if (typeof shape.setMap === 'function') {
      shape.setMap(null);
      this.unCollectShape(shape, function () {
        if (shape.type == 'circle') {
          $(that.config.canvas).trigger('userLocationRemoved');
        }

        if (_.isObject(shape.hjiPolygonObj) && _.has(shape.hjiPolygonObj, 'id')) {
          $(that.config.canvas).trigger('polygon_removed', {
            id: shape.hjiPolygonObj.id,
            shape: shape
          });
        }
      });
    } else if (typeof shape.getGeometry === 'function') {
      var data = {
        id: shape.getProperty('id'),
        geoJSON: null,
        shape: shape
      },
          _triggerEvent = function _triggerEvent(data) {
        $(that.config.canvas).trigger('polygon_removed', data);
      };

      if (data.id) {
        shape.toGeoJson(function (obj) {
          data.geoJSON = obj;

          _triggerEvent(data);

          that.map.data.remove(shape);
        });
      } else {
        this.map.data.remove(shape);
        $(that.config.canvas).trigger('polygon_removed', data);
      }
    }
  };

  gMap.prototype.locationButton = function () {
    var that = this,
        controlDiv = document.createElement('div'); // Set CSS styles for the DIV containing the control
    // Setting padding to 5 px will offset the control
    // from the edge of the map

    controlDiv.style.marginTop = '5px';
    controlDiv.style.marginLeft = '-5px';
    controlDiv.style.padding = '4px';
    controlDiv.style.boxShadow = '0px 1px 4px -1px rgba(0, 0, 0, 0.298039)';
    controlDiv.style.backgroundColor = 'white';
    controlDiv.style.zIndex = '11'; // Set CSS for the control border

    var controlUI = document.createElement('div');
    controlUI.style.backgroundColor = 'white';
    controlUI.style.border = 'none';
    controlUI.style.borderTopRightRadius = '2px';
    controlUI.style.borderBottomRightRadius = '2px';
    controlUI.style.cursor = 'pointer';
    controlUI.style.textAlign = 'center';
    controlUI.title = 'Search near your current location';
    controlDiv.appendChild(controlUI); // Set CSS for the control interior

    var controlText = document.createElement('div'); //        controlText.style.fontFamily = 'Arial,sans-serif';

    controlText.style.fontSize = '14px';
    controlText.style.color = 'rgb(142, 142, 142)';
    controlText.style.width = '16px';
    controlText.style.height = '16px';
    controlText.style.lineHeight = '16px'; //        controlText.innerHTML = 'Current Location';

    controlText.className = 'fa fa-crosshairs';
    this.locationControlUI = controlUI;
    controlUI.appendChild(controlText);
    google.maps.event.addDomListener(controlUI, 'click', function () {
      $(that.config.canvas).trigger('locationControlClick', controlUI);
      controlText.style.color = 'rgb(0,0,0)';
      that.showUserLocation();
    });

    if (navigator.geolocation) {
      return controlDiv;
    }

    return false;
  };

  gMap.prototype.showUserLocation = function (callback, error) {
    var that = this;

    var userPositionCallback = function userPositionCallback(position) {
      var pos = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);

      if (typeof callback != 'undefined') {
        callback(position);
      }

      var circle = {
        map: that.map,
        center: pos,
        radius: that.toMeters(0.5),
        'clickable': true,
        'zIndex': 1
      };
      that.map.setCenter(pos); // Remove existing polygons

      that.removeAllShapes(); // Render circle

      var locationCircle = new google.maps.Circle(circle); // Trigger event that nearbyCircleRender

      $(that.config.canvas).trigger('nearbyCircleRender');
      that.map.fitBounds(locationCircle.getBounds());
      var newShape = locationCircle;
      newShape.type = 'circle';
      newShape.shapeId = that.collectShape(newShape);
      that.setShapeListeners(newShape); // Trigger user location event with location information

      $(that.config.canvas).trigger({
        type: 'userLocationFound',
        coords: position.coords
      });
      that.shapesUpdatedTrigger();
    };

    hji.require(['hji-common/getUserLocation'], function (getUserLocation) {
      new getUserLocation(userPositionCallback, error);
    });

    return false;
  };

  gMap.prototype.renderCircle = function (options) {
    var pos = new google.maps.LatLng(options.coords.lat, options.coords.lng);
    var circle = Object.assign({
      map: this.map,
      center: pos,
      radius: this.toMeters(options.radius),
      editable: true
    }, this.config.style || {});
    this.map.setCenter(pos);
    var locationCircle = new google.maps.Circle(circle);
    var newShape = locationCircle;
    newShape.type = 'circle';
    newShape.shapeId = this.collectShape(newShape);
    this.setShapeListeners(newShape);
    this.shapesUpdatedTrigger();
    return locationCircle;
  };

  gMap.prototype.removeAllShapes = function () {
    // user location passes a circle
    // we don't support circles and polygons together,
    // so circles will need to be removed
    // remove features/geojson
    this.map.data.setMap(null); // hides polygons, but doesn't remove from data collection
    // remove collected shapes

    var l = this.shapes.length;

    for (var i = 0; i < l; i++) {
      if (typeof this.shapes[i].setMap === 'function') {
        this.shapes[i].setMap(null); // delete this.shapes[i];

        delete this.shapes[i];
      } else if (typeof this.shapes[i].getGeometry === 'function') {
        this.map.data.remove(this.shapes[i]);
        delete this.shapes[i];
      }
    } // because we only deleted items, the length of the array is still preserved
    // therefore we're resetting the array


    this.shapes = [];
  };

  gMap.prototype.removeCircle = function () {
    var that = this; // user location passes a circle
    // we don't support circles and polygons together,
    // so circles will need to be removed

    for (var i in this.shapes) {
      if (this.shapes[i].type == 'circle') {
        this.shapes[i].setMap(null); // delete this.shapes[i];

        this.shapes.splice(i, 1);
        $(that.config.canvas).trigger('userLocationRemoved');
        this.shapesUpdatedTrigger();
      }
    }
  };

  gMap.prototype.fitBounds = function () {
    this.map.fitBounds(this.bounds);
  };

  gMap.prototype.toMeters = function (miles) {
    var meters = miles * 1000 / 0.621271;
    return Math.round(meters);
  };
  /**
   * String separators:
   * pipe, space, comma, colon
   *
   * @param string
   */


  gMap.prototype.strToLatLng = function (string, separator) {
    if (separator) {
      var a = string.split(separator);

      if (parseFloat(a[0]) > 0) {
        return this.latLng(a[0], a[1]);
      } else {
        return this.latLng(a[1], a[0]);
      }
    }

    if (string.indexOf('|') != -1) return this.strToLatLng(string, '|');
    if (string.indexOf(' ') != -1) return this.strToLatLng(string, ' ');
    if (string.indexOf(',') != -1) return this.strToLatLng(string, ',');
    if (string.indexOf(':') != -1) return this.strToLatLng(string, ':');
  };

  gMap.prototype.latLng = function (lat, lng) {
    return {
      lat: lat,
      lng: lng
    };
  };

  gMap.prototype.toUrlValue = function (shape) {
    var coords,
        arr = [];
    coords = this.getCoords(shape);

    for (var i in coords) {
      arr.push(coords[i].lat + ',' + coords[i].lng);
    }

    if (shape.type == 'circle') {
      var circle = this.getCircle(shape);
      return circle.center.lat + ':' + circle.center.lng + ':' + (circle.radius * 0.000621371).toFixed(2);
    } else {
      return arr.join(',');
    }
  };

  gMap.prototype.getCoords = function (shape) {
    var item;

    switch (shape.type) {
      case 'polygon':
        item = this.getPolygon(shape);
        return item.coords;

      case 'rectangle':
        item = this.getRectangle(shape);
        return item.coords;

      case 'cirlce':
        item = this.getCircle(shape);
        return item.coords;

      case 'box':
        item = this.getBox(shape);
        return item.coords;
    }
  };

  gMap.prototype.getRectangle = function (shape) {
    var rectangle = {
      coords: []
    };
    rectangle.coords.push(this.latLng(shape.getBounds().getNorthEast().lat(), shape.getBounds().getNorthEast().lng()));
    rectangle.coords.push(this.latLng(shape.getBounds().getSouthWest().lat(), shape.getBounds().getNorthEast().lng()));
    rectangle.coords.push(this.latLng(shape.getBounds().getSouthWest().lat(), shape.getBounds().getSouthWest().lng()));
    rectangle.coords.push(this.latLng(shape.getBounds().getNorthEast().lat(), shape.getBounds().getSouthWest().lng())); // Close polygon

    rectangle.coords = this.closePolygon(rectangle.coords);
    return rectangle;
  };

  gMap.prototype.getPolygon = function (shape) {
    var that = this;
    var polygon = {
      coords: []
    };
    var path = shape.getPath();

    if (shape.hjiPolygonObj) {
      polygon.id = shape.hjiPolygonObj.id;
      polygon.hjiData = shape.hjiPolygonObj;
    }

    path.forEach(function (e, i) {
      polygon.coords.push(that.latLng(e.lat(), e.lng()));
    }); // Close polygon

    polygon.coords = this.closePolygon(polygon.coords);
    return polygon;
  };

  gMap.prototype.getBox = function (shape) {};

  gMap.prototype.getCircle = function (shape) {
    var circle = {
      center: this.latLng(shape.getCenter().lat(), shape.getCenter().lng()),
      radius: shape.getRadius()
    };
    return circle;
  };

  gMap.prototype.closePolygon = function (coords) {
    if (coords.length > 1) {
      var lastPair = coords[coords.length - 1];

      if (JSON.stringify(coords[0]) !== JSON.stringify(lastPair)) {
        coords.push(coords[0]);
      }
    }

    return coords;
  };

  return gMap;
});


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

hji.define('hji-common/map/google/widget',['require','jquery','hji-common/gMap'],function (require) {
  var $ = require('jquery'),
      gMap = require('hji-common/gMap');

  var GoogleMapWidget = function GoogleMapWidget(widgetOptions, mapOptions, callback) {
    _classCallCheck(this, GoogleMapWidget);

    this.widgetOptions = widgetOptions || {};
    this.mapOptions = mapOptions || {};
    this.callback = callback || null;
    new gMap(this.widgetOptions, this.mapOptions, this.callback);
  };

  return GoogleMapWidget;
});


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

hji.define('hji-common/map/widget',['require','jquery','hji-common/map/mapbox/widget','hji-common/map/google/widget'],function (require) {
  var $ = require('jquery'),
      MapBoxWidget = require('hji-common/map/mapbox/widget'),
      GoogleMapWidget = require('hji-common/map/google/widget');

  var MapWidget = HJI.commonVar('gMapsApiKey') ? GoogleMapWidget : MapBoxWidget;
  /**
   * gMap jQuery plugin.
   *
   * Usage Example:
   * $.gMap(); // Will target data-init="gmap" selectors
   * $(#mymap').gMap(); // Custom selector
   * <div data-init="gmap" data-lat="33.586165" data-lng="-111.973083"><p>Max lives here :)</p></div>
   *
   * IMPORTANT Notice: Hide google maps via CSS as follows:
   * [data-init="gmap"] { visibility: hidden; }
   * this will prevent the content from flashing on the page,
   * before Google Map gets loaded.
   *
   * @param settings
   * @param mapOptions
   * @returns {*}
   */

  $.gMap = $.fn.gMap = function (_settings, _mapOptions) {
    var mapOptions = _mapOptions || {},
        // Is function (assuming jQuery) or DOM object is "this"?
    $el = typeof this == 'function' ? $('[data-init="gmap"]') : this;

    var createMaps = function createMaps(element) {
      var callback = function callback() {
        return element.css({
          'visibility': 'visible'
        });
      };

      var _ref = _settings ? [_settings, _mapOptions] : init(element),
          _ref2 = _slicedToArray(_ref, 2),
          widgetSettings = _ref2[0],
          mapOptions = _ref2[1];

      return new MapWidget(widgetSettings, mapOptions, callback);
    };

    var init = function init(element) {
      // Data attribute options
      var widgetOptions = {
        lat: null,
        // latitude
        lng: null,
        // longitude
        info: null,
        // html() of the element will be used if false
        icon: null,
        // marker icon
        width: null,
        // map width
        height: null,
        // map height
        optionsVar: null,
        // name of the declared variable that contains options
        address: null // location address

      };
      var optionsVar = {
        markers: [],
        width: null,
        height: null,
        icon: null,
        styles: null
      }; // Widget config

      var widgetSettings = {
        canvas: false,
        geoData: [],
        icon: false,
        drawingManager: false,
        autozoom: true
      };
      widgetOptions = $.extend(widgetOptions, element.data()); // Determine if options were passes via a custom JS object

      if (widgetOptions.optionsVar && window.hasOwnProperty(widgetOptions.optionsVar)) {
        $.extend(optionsVar, window[widgetOptions.optionsVar]);
      } else if (widgetOptions.lat && widgetOptions.lng) {
        var infoContent = element.html().length ? element.html() : null;
        optionsVar.markers.push({
          lat: widgetOptions.lat,
          lng: widgetOptions.lng,
          info: widgetOptions.info || infoContent,
          icon: widgetOptions.icon || null,
          address: widgetOptions.address || null
        });
      } // Validate markers


      optionsVar.markers = _validateMarkers(optionsVar.markers); // If marker array is empty - there's nothing to do

      if (!optionsVar.markers.length) return;
      if (Array.isArray(optionsVar.styles) && optionsVar.styles.length) mapOptions.styles = optionsVar.styles; // Override widgetOptions width/height/icon with optionsVar if not set

      if (!widgetOptions.width) widgetOptions.width = optionsVar.width;
      if (!widgetOptions.height) widgetOptions.height = optionsVar.height;
      if (!widgetOptions.icon) widgetOptions.icon = optionsVar.icon; // Apply widget dimensions

      if (widgetOptions.width) element.css('width', widgetOptions.width);
      element.css('height', widgetOptions.height || element.width()); // Set widgetSettings to pas to the gMap module

      widgetSettings.canvas = element[0];
      widgetSettings.geoData = optionsVar.markers;
      widgetSettings.icon = widgetOptions.icon; // clear inner html of the container

      element.html('');
      return [widgetSettings, mapOptions];
    };

    var _validateMarkers = function _validateMarkers(data) {
      var markers = [];
      if (!Array.isArray(data) || !data.length) return [];

      for (var i in data) {
        if (_typeof(data[i]) === 'object') {
          if (data[i].lat && !isNaN(data[i].lat) && data[i].lng && !isNaN(data[i].lng)) {
            var marker = new Marker();
            marker.lat = data[i].lat;
            marker.lng = data[i].lng;
            if (data[i].info && typeof data[i].info === 'string') marker.info = data[i].info;
            if (data[i].icon && typeof data[i].icon === 'string') marker.icon = data[i].icon;
            if (data[i].address && typeof data[i].address === 'string') marker.address = data[i].address;
            markers.push(marker);
          }
        }
      }

      return markers;
    };

    var Marker = function Marker() {
      this.lat = null;
      this.lng = null;
      this.info = null;
      this.icon = null;
      this.address = null;
    };

    return $el.each(function (i, el) {
      return createMaps($(el));
    });
  };
});


/** common.js loaded by main.js (DO NOT enqueue into WP) **/
hji.define('hji-membership/common',['require', 'jquery', 'underscore', 'backbone'], function (require, $, _, Backbone) {
  var _selectors = ['[data-init]', '[data-lookup]'];
  var $elements = $(_selectors.join(','));

  if ($('[data-init="marketReport"]').length) {
    hji.require(['hji-common/national']);
  }

  $('#idx-register-login').on('hidden.bs.modal', function () {
    $('#idx-register-login form').each(function () {
      this.reset();
    });
    $('#idx-register-login .ajax-message').html('');
  });

  function initDataLookups() {
    /**
     * Area Lookup Selector
     */
    var polygonFields = $('[data-lookup="polygon"]');
    var lookupFields = $('[data-lookup][data-market]');

    if (polygonFields.length) {
      hji.require(['hji-common/_lookupArea'], function () {
        polygonFields.lookupArea();
      });
    }

    hji.require(['hji-common/_lookup'], function () {
      lookupFields.each(function () {
        if ($(this).data('lookup') != 'polygon') {
          $(this).dataLookup();
        }
      });
    });
  }

  initDataLookups(); // Even listener to re-initialize data lookups
  // especially useful when content refreshed via ajax (like in Widgets Dashboard)

  $(document).on('initDataLookups', function () {
    initDataLookups();
  });

  hji.require(['hji-common/modal/modals'], function (modals) {
    modals.initModals();
    HJI.modals = modals;
  });

  hji.require(['hji-common/tabsRefresh']); // Loads a polyfill for CSS object-fit
  // object-fit is used for image centering


  if (!('object-fit' in document.body.style)) {
    hji.require(['object-fit-images-polyfill'], function () {
      objectFitImages();
    });
  } // image lazy loading


  hji.require(['hji-common/unveil'], function () {
    $("img[data-src]").unveil(800, function () {
      // callback checks to see if we've included our object-fit polyfill
      // if so we need to re-run the polyfill against the newly loaded image
      if (typeof objectFitImages == 'function') {
        objectFitImages();
      }
    });
  });

  var $streetViewEl = $('[data-init="streetview"]');

  if ($streetViewEl.length) {
    hji.require(['hji-common/streetView'], function () {
      $streetViewEl.streetView({
        wrapperSelector: '.street-view-wrap'
      });
    });
  }

  var $gmapEl = $('[data-init="gmap"]');
  if ($gmapEl.length) hji.require(['hji-common/map/widget'], function () {
    return $gmapEl.gMap();
  });

  $.fn.hjiComponentInit = function () {
    var $el = $(this),
        component = $(this).data('init'),
        options = $(this).data() || {};
    var componentName = 'hji-common/' + component;
    HJI.log('Found Component ' + componentName + ' ');

    if (componentName.includes('widgets') || componentName.includes('colorbox')) {
      try {
        require([componentName], function (Component) {
          var component;

          try {
            component = new Component();
          } catch (error) {
            HJI.log('Component ' + componentName + ' is not constructable.');
          }

          if (component) component.init($el, options);
        });
      } catch (error) {
        HJI.log('ERROR: ' + componentName);
      }
    }
  };

  $elements.each(function () {
    if ($(this).data('init')) {
      $(this).hjiComponentInit();
    }
  });
});


HJI.Membership.Admin = function ($) {
  var licenseKeyRegex = /^[A-Z0-9]{4}\-[A-Z0-9]{4}\-[A-Z0-9]{4}(\-[A-Z0-9]{4})?$/;
  var __obj = {
    onload: function onload() {
      if (hjiRequireJsConfig.is_wp_admin === true) {
        this.manageThemes(); // Force HJI CRM link to open in a new window, since it's an external link.

        $('#adminmenu .hji-crm-link').prop('target', '_blank');
      }
    },
    manageSettings: function manageSettings() {
      var lkey = jQuery('#hji-license-key');
      lkey.bind('change keyup', function (event) {
        var value = jQuery.trim(lkey.val());
        var valid = licenseKeyRegex.test(value);
        lkey[valid ? 'removeClass' : 'addClass']('hji-input-invalid');
        lkey.next('span')[valid ? 'hide' : 'show']();
      }).trigger('change');
      this.manageCustomerAssets();
    },

    /**
     * Auto-save for newly created widgets in the
     * Widgets admin dashboard
     *
     * To add a widget to autoSave call addAutoSaveWidget
     * trigger on window.load with the base_id of the widget
     *
     * $(window).load(function(){
     *  $(document).trigger('addAutoSaveWidget', 'widget_base_id');
     * });
     *
     * "widget_saved" hook will be triggered when the widget
     * is saved and widget object will be passed to the handler.
     */
    autoSaveWidgets: function autoSaveWidgets() {
      var autoSave = {
        widgets: [],
        getWidgets: function getWidgets() {
          return autoSave.widgets;
        },
        addWidget: function addWidget(widget) {
          autoSave.widgets.push(widget);
        },
        processWidget: function processWidget(infoObj) {
          // Base IDs of widgets to save
          var widgets = autoSave.getWidgets();
          var id = $(infoObj.widget).find('input[name="id_base"]').val();

          if ($.inArray(id, widgets) >= 0) {
            infoObj.save = true;
          }
        },
        setAjaxCompleteListener: function setAjaxCompleteListener() {
          jQuery(document).ajaxComplete(function (event, XMLHttpRequest, ajaxOptions) {
            if (typeof ajaxOptions.data == 'undefined') return false; // determine which ajax request is this (we're after "save-widget")

            var request = {},
                pairs = ajaxOptions.data.split('&'),
                i,
                split,
                widget;

            for (i in pairs) {
              split = pairs[i].split('=');
              request[decodeURIComponent(split[0])] = decodeURIComponent(split[1]);
            } // only proceed if this was a widget-save request


            if (request.action && request.action === 'save-widget') {
              // locate the widget block
              widget = jQuery('input.widget-id[value="' + request['widget-id'] + '"]').parents('.widget'); // trigger manual save, if this was the save request
              // and if we didn't get the form html response (the wp bug)

              if (!XMLHttpRequest.responseText) {
                // Trigger save only on widgets that indicated they want to be auto-saved
                var infoObj = {
                  widget: widget,
                  save: false
                }; // autoSaveWidget will update infoObj.save if necessary

                jQuery(document).trigger('autoSaveWidget', infoObj);
                wpWidgets.save(widget, 0, 1, 0); // we got an response, this could be either our request above,
                // or a correct widget-save call, so fire an event on which we can hook our js
              } else {
                jQuery(document).trigger('widget_saved', widget);
              }
            }
          });
        },
        setup: function setup() {
          autoSave.setAjaxCompleteListener();
          $(document).on('addAutoSaveWidget', function (e, widget) {
            autoSave.addWidget(widget);
          });
          $(document).on('autoSaveWidget', function (e, infoObj) {
            return autoSave.processWidget(infoObj);
          });
        }
      };
      autoSave.setup();
    },

    /**
     * Adds HJI themes to Appearance/Themes
     * as well as HJI Membership/Product Library/Themes
     *
     * @returns {boolean}
     */
    manageThemes: function manageThemes() {
      if (wp.themes) {
        var themes = wp.themes;

        if (!themes.data.hjiThemes) {
          $('.filter-links .hj-themes').trigger('click');
          var filterLinks = $('ul.filter-links');

          if (!filterLinks.length) {
            return false;
          }

          var li = $('<li><a href="#" data-sort="hj_themes">Home Junction Themes</a></li>').data('sort', 'hj_themes');
          filterLinks.prepend(li);
        } else {
          var RunCustomInstaller = themes.RunInstaller;

          RunCustomInstaller.init = function () {
            // Set up the view
            // Passes the default 'section' as an option
            this.view.browse('hj_themes');
          };

          RunCustomInstaller.init();
        }
      }
    },
    manageCustomerAssets: function manageCustomerAssets() {
      $('.upload-media-button').click(function (e) {
        e.preventDefault();
        var destinationSelector = $(this).data('destination');
        var imageSize = $(this).data('imageSize');
        if (!imageSize) imageSize = 'thumbnail';
        var image = wp.media({
          title: 'Upload Image',
          // multiple: true if you want to upload multiple files at once
          multiple: false
        }).open().on('select', function (e) {
          // This will return the selected image from the Media Uploader, the result is an object
          var uploaded_image = image.state().get('selection').first(); // We convert uploaded_image to a JSON object to make accessing it easier
          // Output to the console uploaded_image

          var sizeDetails = uploaded_image.toJSON().sizes[imageSize];
          if (!sizeDetails) sizeDetails = uploaded_image.toJSON().sizes['thumbnail'];
          if (!sizeDetails) sizeDetails = uploaded_image.toJSON().sizes['full'];
          var image_url = sizeDetails.url; // Let's assign the url value to the input field

          $(destinationSelector).val(image_url);
        });
      });
    }
  };
  $(window).on('load', function () {
    __obj.onload();
  });
  return __obj;
}(jQuery);
hji.define("hji-membership/admin", function(){});



/**
 * Loaded by membership.js asynchronously via RequireJS
 * Do NOT enqueue directly into WordPres!
 */
hji.require(['hji-membership/membership'], function () {
  hji.require(['hji-membership/common']);

  hji.require(['hji-membership/admin']);
});
hji.define("hji-membership/main", function(){});



function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define('hji-common/includes/eventManager',['jquery', 'underscore'], function ($, _) {
  var EventManager = /*#__PURE__*/function () {
    function EventManager(options) {
      _classCallCheck(this, EventManager);

      var settings = {
        target: null,
        namespaces: null,
        events: {}
      };
      this.settings = $.extend(settings, options);
      this.target = settings.target;
      this.namespace = settings.namespace;
      this.events = settings.events || {};
    }

    _createClass(EventManager, [{
      key: "registerEvents",
      value: function registerEvents(events) {
        try {
          if (_.isObject(events)) {
            for (var e in events) {
              this.registerEvent(e, events[e]);
            }
          } else {
            throw 'Unsupported argument type in EventManager.registerEvents(arg). Please pass object of event handlers to event names.';
          }
        } catch (e) {
          console.error(e);
        }
      }
    }, {
      key: "registerEvent",
      value: function registerEvent(eventHandler) {
        var eventName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        if (!eventName) eventName = eventHandler;
        this.events[eventName] = {
          'name': "".concat(this.namespace, "/").concat(eventName),
          'handler': eventHandler
        };
        HJI.log('Event registered: ' + eventName);
      }
    }, {
      key: "trigger",
      value: function trigger(eventName, data) {
        HJI.log('Event triggered: ' + eventName);
        HJI.log(data);

        if (this.events.hasOwnProperty(eventName)) {
          $(this.target).trigger(this.events[eventName].name, data);
        } else {
          console.error('Invalid event: ' + eventName + '.');
        }
      }
    }, {
      key: "listen",
      value: function listen(eventName, callback) {
        var event = this.events[eventName];
        $(this.target).on(event.name, function (e, data) {
          callback(data);
        });
      }
    }]);

    return EventManager;
  }();

  return EventManager;
});


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define('hji-common/address/addressLookupInterface',['jquery', 'hji-common/includes/eventManager'], function ($, EventManager) {
  var AddressLookupInterface = /*#__PURE__*/function () {
    function AddressLookupInterface(el, options) {
      _classCallCheck(this, AddressLookupInterface);

      this.el = el;
      this.options = options || {};
      this.events = {
        onSelect: 'select',
        onError: 'error'
      }; // Event Manager Options

      var emOptions = {
        target: el,
        namespace: 'addressLookup'
      };
      this.eventManager = new EventManager(emOptions);
      this.eventManager.registerEvents(this.events);
    }

    _createClass(AddressLookupInterface, [{
      key: "onSelect",
      value: function onSelect(callback) {
        this.eventManager.listen('select', callback);
      }
    }, {
      key: "onError",
      value: function onError(callback) {
        this.eventManager.listen('error', callback);
      }
    }, {
      key: "trigger",
      value: function trigger(event, data) {
        this.eventManager.trigger(event, data);
      }
    }, {
      key: "getValue",
      value: function getValue() {// abstract method
      }
    }, {
      key: "validateAddress",
      value: function validateAddress() {// abstract method
        // should call this.addressValid() or this.addressInvalid()
      }
    }, {
      key: "addressValid",
      value: function addressValid(address) {
        this.trigger('select', address);
      }
    }, {
      key: "addressInvalid",
      value: function addressInvalid(address) {
        var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        this.trigger('error', 'Address is invalid. Please enter valid address.');
      }
    }]);

    return AddressLookupInterface;
  }();

  return AddressLookupInterface;
});


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

hji.define('hji-common/address/addressLookup',['require', 'jquery', 'underscore', './addressLookupInterface', 'hji-common/slipstream/api', 'hji-common/selectize'], function (require, $, _, AddressLookupInterface) {
  var _helper;

  var SlipstreamAddressLookup = /*#__PURE__*/function (_AddressLookupInterfa) {
    _inherits(SlipstreamAddressLookup, _AddressLookupInterfa);

    function SlipstreamAddressLookup(el, options) {
      var _this;

      _classCallCheck(this, SlipstreamAddressLookup);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(SlipstreamAddressLookup).call(this, el, options));

      _this.init();

      return _this;
    }

    _createClass(SlipstreamAddressLookup, [{
      key: "init",
      value: function init() {
        var _this2 = this;

        var that = this,
            api = require('hji-common/slipstream/api'),
            initAddressLookup = function initAddressLookup(options) {
          return $(_this2.el).selectize(options);
        };

        api.ready(function (API) {
          var cache = {},
              options = {
            valueField: 'label',
            labelField: 'label',
            selectOnTab: true,
            options: [],
            create: false,
            highlight: false,
            // there's a highlighting bug in selectize
            persist: false,
            maxItems: 1,
            maxOptions: 5,
            loadThrottle: 50,
            diacritics: false,
            score: function score(search) {
              return function () {
                return 100;
              };
            },
            load: function load(query, callback) {
              var that = this,
                  trimmed = query.trim(),
                  lcQuery = query.toLowerCase(),
                  matchParams = {
                term: query,
                center: _helper.marketCenter(),
                limit: 5
              };
              this.setActiveOption(null);

              if (_.has(cache, lcQuery)) {
                that.clearOptions();
                return callback(cache[lcQuery]);
              }

              if (trimmed.length < 3 || this.currentResults.query != query && this.currentResults.query == trimmed) {
                return callback();
              }

              API.call('/ws/addresses/match', matchParams).done(function (data, xhr) {
                if (data.success !== true) {
                  return callback();
                } else {
                  // Cache results for repeat searches
                  cache[lcQuery] = data.result.matches;

                  if (!that.isFocused || $.inArray(query, that.items) !== -1) {
                    if (data.result.matches.length) {
                      // Insert first match into the field
                      that.addItem(data.result.matches[0]);
                      that.setActiveOption(that.getOption(data.result.matches[0].label)); // return;
                    }
                  } else {
                    that.clearOptions();
                  }

                  return callback(data.result.matches);
                }
              });
            },
            onItemAdd: function onItemAdd(value, $item) {
              if (_.has(this.options, value)) that.validateAddress(this.options[value]);
            }
          };
          initAddressLookup(options);
        });
      }
    }, {
      key: "validateAddress",
      value: function validateAddress(address) {
        var _this3 = this;

        var api = require('hji-common/slipstream/api');

        api.ready(function (API) {
          var params = {
            deliveryLine: null,
            city: null,
            state: null
          };

          _.extendOwn(params, address);

          var response = API.call('/ws/addresses/standardize', params);
          response.done(function (data, xhr) {
            if (data.success !== true) {
              _this3.addressInvalid(false);
            } else {
              if (data.result.hasOwnProperty('coordinates')) {
                _this3.addressValid(_helper.getAddress(data.result));
              } else {
                // Geocode if coordinates not returned within the address
                API.call('/ws/addresses/geocode', data.result.address).done(function (data, xhr) {
                  _this3.addressValid(_helper.getAddress(data.result));
                });
              }
            }
          });
        });
      }
    }, {
      key: "getValue",
      value: function getValue() {
        return $(el).val();
      }
    }]);

    return SlipstreamAddressLookup;
  }(AddressLookupInterface);
  /**
   * Object with helper methods
   *
   * @type {{getAddress: ((address))}}
   * @private
   */


  _helper = {
    getAddress: function getAddress() {
      var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var address = {
        deliveryLine: null,
        street: null,
        city: null,
        state: null,
        zip: null,
        lat: null,
        lng: null
      };
      var _ref = [obj.address, obj.coordinates],
          _ref$ = _ref[0],
          addr = _ref$ === void 0 ? {} : _ref$,
          _ref$2 = _ref[1],
          coord = _ref$2 === void 0 ? {} : _ref$2;
      address.deliveryLine = addr.deliveryLine || null;
      address.street = addr.deliveryLine || null;
      address.city = addr.city || null;
      address.state = addr.state || null;
      address.zip = addr.zip || null;
      address.lat = coord.latitude || null;
      address.lng = coord.longitude || null;
      return address;
    },
    marketCenter: function marketCenter() {
      var markets = HJI.commonVar('markets'),
          marketsList = _.keys(HJI.commonVar('markets'));

      if (marketsList.length) {
        var centroid = markets[marketsList[0]].centroid;
        return centroid.latitude + ':' + centroid.longitude;
      }

      return null;
    }
  };
  return SlipstreamAddressLookup;
});


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

hji.define('hji-common/address/gAddressLookup',['require', 'jquery', './addressLookupInterface'], function (require, $, AddressLookupInterface) {
  var gAddressLookup = /*#__PURE__*/function (_AddressLookupInterfa) {
    _inherits(gAddressLookup, _AddressLookupInterfa);

    function gAddressLookup(el, options) {
      var _this;

      _classCallCheck(this, gAddressLookup);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(gAddressLookup).call(this, el, options));

      _this.init();

      return _this;
    }

    _createClass(gAddressLookup, [{
      key: "init",
      value: function init() {
        var _this2 = this;

        var callback = function callback(address) {
          return _this2.validateAddress(address);
        },
            el = this.el;

        hji.require(['hji-common/gMapsApi'], function (GoogleMapsLoader) {
          var autocomplete;
          var componentForm = {
            street_number: 'short_name',
            route: 'long_name',
            locality: 'long_name',
            sublocality_level_1: 'long_name',
            administrative_area_level_1: 'short_name',
            country: 'long_name',
            postal_code: 'short_name'
          };
          var hashmap = {
            street: '{street_number} {route}',
            sublocality: '{sublocality_level_1}',
            city: '{locality}',
            state: '{administrative_area_level_1}',
            zip: '{postal_code}'
          };
          var result = {
            street: null,
            city: null,
            sublocality: null,
            state: null,
            zip: null,
            lat: null,
            lng: null
          };

          (function pacSelectFirst(input) {
            // store the original event binding function
            var _addEventListener = input.addEventListener ? input.addEventListener : input.attachEvent;

            function addEventListenerWrapper(type, listener) {
              // Simulate a 'down arrow' keypress on hitting 'return' when no pac suggestion is selected,
              // and then trigger the original listener.
              if (type == "keydown") {
                var orig_listener = listener;

                listener = function listener(event) {
                  var suggestion_selected = $(".pac-item-selected").length > 0;

                  if ((event.which == 13 || event.which == 9) && !suggestion_selected) {
                    var simulated_downarrow = $.Event("keydown", {
                      keyCode: 40,
                      which: 40
                    });
                    orig_listener.apply(input, [simulated_downarrow]);
                  }

                  orig_listener.apply(input, [event]);
                };
              } // add the modified listener


              _addEventListener.apply(input, [type, listener]);
            }

            if (input.addEventListener) {
              input.addEventListener = addEventListenerWrapper;
            } else if (input.attachEvent) {
              input.attachEvent = addEventListenerWrapper;
            }
          })(el);

          function initialize() {
            // Create the autocomplete object, restricting the search
            // to geographical location types.
            autocomplete = new google.maps.places.Autocomplete(
            /** @type {HTMLInputElement} */
            el, {
              types: ['geocode']
            }); // When the user selects an address from the dropdown,
            // populate the address fields in the form.

            google.maps.event.addListener(autocomplete, 'place_changed', function () {
              var address = getAddress();

              if (typeof callback == 'function') {
                return callback(address);
              }
            });
          }

          function getHashmap() {
            return $.extend({}, hashmap);
          }

          function getResult() {
            return $.extend({}, result);
          }

          function getAddress() {
            var address = {
              street: null,
              city: null,
              state: null,
              zip: null,
              lat: null,
              lng: null
            };
            var place = autocomplete.getPlace(); // Get the place details from the autocomplete object.

            var _hashmap = getHashmap();

            var _result = getResult();

            if (!place.hasOwnProperty('address_components')) return false; // Get each component of the address from the place details
            // and replace hashmap tokens

            for (var i = 0; i < place.address_components.length; i++) {
              var addressType = place.address_components[i].types[0];

              if (componentForm[addressType]) {
                var val = place.address_components[i][componentForm[addressType]];

                for (var x in _hashmap) {
                  if (_hashmap[x].indexOf(addressType) > -1) {
                    _hashmap[x] = _hashmap[x].replace('{' + addressType + '}', val);
                  }
                }
              }
            } // Clear out remaining tokens, that didn't find their match


            for (var i in _hashmap) {
              // Only map if value is not a token
              if (_hashmap[i].indexOf('{') == -1) {
                _result[i] = _hashmap[i];
              }
            } // Map latitude and longitude to the result


            if (place.geometry) {
              _result.lat = place.geometry.location.lat();
              _result.lng = place.geometry.location.lng();
            } // Map result values to the properties of the address object


            for (var i in _result) {
              if (typeof address[i] != 'undefined') {
                address[i] = _result[i];
              }
            } // Map result sublocality (if defined) to the city property of the address object


            if (_result.sublocality) {
              address.city = _result.sublocality;
            } // Add Google's original Place object to the address


            address.g = {
              place: place
            };
            return address;
          } // Initialize autoLookup only when Google API is loaded


          GoogleMapsLoader.done(function () {
            initialize();
          });
        });
      }
    }, {
      key: "validateAddress",
      value: function validateAddress(address) {
        if (!address.street || !address.city || !address.state) {
          this.addressInvalid(address);
        } else {
          this.addressValid(address);
        }
      }
    }, {
      key: "getValue",
      value: function getValue() {
        return $(el).val();
      }
    }]);

    return gAddressLookup;
  }(AddressLookupInterface);

  return gAddressLookup;
});


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define('hji-common/address/lookupWidget',['require', 'jquery', 'underscore', './addressLookup', './gAddressLookup'], function (require, $, _, SlipstreamAddressLookup, GoogleAddressLookup) {
  /**
   * Self-contained Address Lookup Widget
   *
   * Auto-complete street address selector.
   *
   * Usage:
   *      new LookupWidget($('input#target')[0])
   *          .onSelect(function(address){ console.log(address); });
   *
   *      // Google API
   *      new LookupWidget($('input#target')[0], {google: true})
   *          .onSelect(function(address){ console.log(address); });
   *
   * Available Events:
   *      onSelect(function(address){ console.log(address); });
   *      onError(function(error){ console.log(error); });
   */
  var LookupWidget = /*#__PURE__*/function () {
    function LookupWidget(el) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      _classCallCheck(this, LookupWidget);

      this.$error = null, this.el = el, this.options = options, this.addressLookup;

      if (this.options.hasOwnProperty('google') && this.options.google == true) {
        this.addressLookup = new GoogleAddressLookup(this.el, this.options);
      } else {
        this.addressLookup = new SlipstreamAddressLookup(this.el, this.options);
      }

      $(this.el)[0]['addressLookupWidget'] = this;

      this._init();
    }

    _createClass(LookupWidget, [{
      key: "_init",
      value: function _init() {
        var _this = this;

        this.addressLookup.onError(function (message) {
          return _this.renderError(message);
        }); // Remove any rendered error messages if user made another selection

        this.onSelect(function () {
          return _this.clearError();
        });
      }
    }, {
      key: "onSelect",
      value: function onSelect(callback) {
        this.addressLookup.onSelect(function (data) {
          return callback(data);
        });
        return this;
      }
    }, {
      key: "onError",
      value: function onError(callback) {
        this.addressLookup.onError(function (data) {
          return callback(data);
        });
        return this;
      }
    }, {
      key: "renderError",
      value: function renderError(message) {
        var _this2 = this;

        if (!this.$error) {
          this.$error = $('<div class="address-error"></div>').css({
            'padding': '0.5em',
            'color': 'red'
          }).hide();
          this.$error.text(message).appendTo($(this.el).parent()).slideDown('slow');
          setTimeout(function () {
            return _this2.clearError();
          }, 5000);
        }
      }
    }, {
      key: "clearError",
      value: function clearError() {
        if (!this.$error) return;
        this.$error.slideUp('slow', function () {
          $(this).remove();
        });
        this.$error = null;
      }
    }, {
      key: "getValue",
      value: function getValue() {
        return this.addressLookup.getValue();
      }
    }]);

    return LookupWidget;
  }();

  return LookupWidget;
});


hji.define('hji-common/isMobile',[],function () {
  /**
   * Borrowed from: https://www.mattcromwell.com/detecting-mobile-devices-javascript/
   *
   * @type {{Android: isMobile.Android, BlackBerry: isMobile.BlackBerry, iOS: isMobile.iOS, Opera: isMobile.Opera, Windows: isMobile.Windows, any: isMobile.any}}
   */
  var isMobile = {
    Android: function Android() {
      return navigator.userAgent.match(/Android/i);
    },
    BlackBerry: function BlackBerry() {
      return navigator.userAgent.match(/BlackBerry/i);
    },
    iOS: function iOS() {
      return navigator.userAgent.match(/iPhone|iPad|iPod/i);
    },
    Opera: function Opera() {
      return navigator.userAgent.match(/Opera Mini/i);
    },
    Windows: function Windows() {
      return navigator.userAgent.match(/IEMobile/i);
    },
    any: function any() {
      return isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows();
    }
  };
  return isMobile;
});
/**
 * bxSlider v4.2.2d
 * Copyright 2013-2017 Steven Wanderski
 * Written while drinking Belgian ales and listening to jazz
 * Licensed under MIT (http://opensource.org/licenses/MIT)
 */
!function(Z){var U={mode:"horizontal",slideSelector:"",infiniteLoop:!0,hideControlOnEnd:!1,speed:500,easing:null,slideMargin:0,startSlide:0,randomStart:!1,captions:!1,ticker:!1,tickerHover:!1,adaptiveHeight:!1,adaptiveHeightSpeed:500,video:!1,useCSS:!0,preloadImages:"visible",responsive:!0,slideZIndex:50,wrapperClass:"bx-wrapper",touchEnabled:!0,swipeThreshold:50,oneToOneTouch:!0,preventDefaultSwipeX:!0,preventDefaultSwipeY:!1,ariaLive:!0,ariaHidden:!0,keyboardEnabled:!1,pager:!0,pagerType:"full",pagerShortSeparator:" / ",pagerSelector:null,buildPager:null,pagerCustom:null,controls:!0,nextText:"Next",prevText:"Prev",nextSelector:null,prevSelector:null,autoControls:!1,startText:"Start",stopText:"Stop",autoControlsCombine:!1,autoControlsSelector:null,auto:!1,pause:4e3,autoStart:!0,autoDirection:"next",stopAutoOnClick:!1,autoHover:!1,autoDelay:0,autoSlideForOnePage:!1,minSlides:1,maxSlides:1,moveSlides:0,slideWidth:0,shrinkItems:!1,onSliderLoad:function(){return!0},onSlideBefore:function(){return!0},onSlideAfter:function(){return!0},onSlideNext:function(){return!0},onSlidePrev:function(){return!0},onSliderResize:function(){return!0},onAutoChange:function(){return!0}};Z.fn.bxSlider=function(e){if(0===this.length)return this;if(1<this.length)return this.each(function(){Z(this).bxSlider(e)}),this;var g={},p=this,n=Z(window).width(),s=Z(window).height();if(!Z(p).data("bxSlider")){function o(){Z(p).data("bxSlider")||(g.settings=Z.extend({},U,e),g.settings.slideWidth=parseInt(g.settings.slideWidth),g.children=p.children(g.settings.slideSelector),g.children.length<g.settings.minSlides&&(g.settings.minSlides=g.children.length),g.children.length<g.settings.maxSlides&&(g.settings.maxSlides=g.children.length),g.settings.randomStart&&(g.settings.startSlide=Math.floor(Math.random()*g.children.length)),g.active={index:g.settings.startSlide},g.carousel=1<g.settings.minSlides||1<g.settings.maxSlides,g.carousel&&(g.settings.preloadImages="all"),g.minThreshold=g.settings.minSlides*g.settings.slideWidth+(g.settings.minSlides-1)*g.settings.slideMargin,g.maxThreshold=g.settings.maxSlides*g.settings.slideWidth+(g.settings.maxSlides-1)*g.settings.slideMargin,g.working=!1,g.controls={},g.interval=null,g.animProp="vertical"===g.settings.mode?"top":"left",g.usingCSS=g.settings.useCSS&&"fade"!==g.settings.mode&&function(){for(var t=document.createElement("div"),e=["WebkitPerspective","MozPerspective","OPerspective","msPerspective"],i=0;i<e.length;i++)if(void 0!==t.style[e[i]])return g.cssPrefix=e[i].replace("Perspective","").toLowerCase(),g.animProp="-"+g.cssPrefix+"-transform",!0;return!1}(),"vertical"===g.settings.mode&&(g.settings.maxSlides=g.settings.minSlides),p.data("origStyle",p.attr("style")),p.children(g.settings.slideSelector).each(function(){Z(this).data("origStyle",Z(this).attr("style"))}),d())}function r(){var t=1,e=null;return"horizontal"===g.settings.mode&&0<g.settings.slideWidth?t=g.viewport.width()<g.minThreshold?g.settings.minSlides:g.viewport.width()>g.maxThreshold?g.settings.maxSlides:(e=g.children.first().width()+g.settings.slideMargin,Math.floor((g.viewport.width()+g.settings.slideMargin)/e)||1):"vertical"===g.settings.mode&&(t=g.settings.minSlides),t}function t(){for(var t="",e="",i=m(),n=0;n<i;n++)e="",g.settings.buildPager&&Z.isFunction(g.settings.buildPager)||g.settings.pagerCustom?(e=g.settings.buildPager(n),g.pagerEl.addClass("bx-custom-pager")):(e=n+1,g.pagerEl.addClass("bx-default-pager")),t+='<div class="bx-pager-item"><a href="" data-slide-index="'+n+'" class="bx-pager-link">'+e+"</a></div>";g.pagerEl.html(t)}function a(){p.startAuto()}function l(){p.stopAuto()}function u(t){var e=r();g.settings.ariaHidden&&!g.settings.ticker&&(g.children.attr("aria-hidden","true"),g.children.slice(t,t+e).attr("aria-hidden","false"))}var d=function(){var t=g.children.eq(g.settings.startSlide);p.wrap('<div class="'+g.settings.wrapperClass+'"><div class="bx-viewport"></div></div>'),g.viewport=p.parent(),g.settings.ariaLive&&!g.settings.ticker&&g.viewport.attr("aria-live","polite"),g.loader=Z('<div class="bx-loading" />'),g.viewport.prepend(g.loader),p.css({width:"horizontal"===g.settings.mode?1e3*g.children.length+215+"%":"auto",position:"relative"}),g.usingCSS&&g.settings.easing?p.css("-"+g.cssPrefix+"-transition-timing-function",g.settings.easing):g.settings.easing||(g.settings.easing="swing"),g.viewport.css({width:"100%",overflow:"hidden",position:"relative"}),g.viewport.parent().css({maxWidth:f()}),g.children.css({float:"horizontal"===g.settings.mode?"left":"none",listStyle:"none",position:"relative"}),g.children.css("width",x()),"horizontal"===g.settings.mode&&0<g.settings.slideMargin&&g.children.css("marginRight",g.settings.slideMargin),"vertical"===g.settings.mode&&0<g.settings.slideMargin&&g.children.css("marginBottom",g.settings.slideMargin),"fade"===g.settings.mode&&(g.children.css({position:"absolute",zIndex:0,display:"none"}),g.children.eq(g.settings.startSlide).css({zIndex:g.settings.slideZIndex,display:"block"})),g.controls.el=Z('<div class="bx-controls" />'),g.settings.captions&&P(),g.active.last=g.settings.startSlide===m()-1,g.settings.video&&p.fitVids(),"none"===g.settings.preloadImages?t=null:"all"!==g.settings.preloadImages&&!g.settings.ticker||(t=g.children),g.settings.ticker?g.settings.pager=!1:(g.settings.controls&&T(),g.settings.auto&&g.settings.autoControls&&k(),g.settings.pager&&C(),(g.settings.controls||g.settings.autoControls||g.settings.pager)&&g.viewport.after(g.controls.el)),null===t?h():c(t,h)},c=function(t,e){var i=t.find('img:not([src=""]), iframe').length,n=0;0!==i?t.find('img:not([src=""]), iframe').each(function(){Z(this).one("load error",function(){++n===i&&e()}).each(function(){!this.complete&&""!=this.src||Z(this).trigger("load")})}):e()},h=function(){if(g.settings.infiniteLoop&&"fade"!==g.settings.mode&&!g.settings.ticker){var t="vertical"===g.settings.mode?g.settings.minSlides:g.settings.maxSlides,e=g.children.slice(0,t).clone(!0).addClass("bx-clone"),i=g.children.slice(-t).clone(!0).addClass("bx-clone");g.settings.ariaHidden&&(e.attr("aria-hidden",!0),i.attr("aria-hidden",!0)),p.append(e).prepend(i)}g.loader.remove(),w(),"vertical"===g.settings.mode&&(g.settings.adaptiveHeight=!0),g.viewport.height(v()),p.redrawSlider(),g.settings.onSliderLoad.call(p,g.active.index),g.initialized=!0,g.settings.responsive&&Z(window).on("resize",R),g.settings.auto&&g.settings.autoStart&&(1<m()||g.settings.autoSlideForOnePage)&&W(),g.settings.ticker&&L(),g.settings.pager&&A(g.settings.startSlide),g.settings.controls&&H(),g.settings.touchEnabled&&!g.settings.ticker&&N(),g.settings.keyboardEnabled&&!g.settings.ticker&&Z(document).keydown(F)},v=function(){var e=0,t=Z();if("vertical"===g.settings.mode||g.settings.adaptiveHeight)if(g.carousel){var n=1===g.settings.moveSlides?g.active.index:g.active.index*S();for(t=g.children.eq(n),i=1;i<=g.settings.maxSlides-1;i++)t=n+i>=g.children.length?t.add(g.children.eq(i-1)):t.add(g.children.eq(n+i))}else t=g.children.eq(g.active.index);else t=g.children;return"vertical"===g.settings.mode?(t.each(function(t){e+=Z(this).outerHeight()}),0<g.settings.slideMargin&&(e+=g.settings.slideMargin*(g.settings.minSlides-1))):e=Math.max.apply(Math,t.map(function(){return Z(this).outerHeight(!1)}).get()),"border-box"===g.viewport.css("box-sizing")?e+=parseFloat(g.viewport.css("padding-top"))+parseFloat(g.viewport.css("padding-bottom"))+parseFloat(g.viewport.css("border-top-width"))+parseFloat(g.viewport.css("border-bottom-width")):"padding-box"===g.viewport.css("box-sizing")&&(e+=parseFloat(g.viewport.css("padding-top"))+parseFloat(g.viewport.css("padding-bottom"))),e},f=function(){var t="100%";return 0<g.settings.slideWidth&&(t="horizontal"===g.settings.mode?g.settings.maxSlides*g.settings.slideWidth+(g.settings.maxSlides-1)*g.settings.slideMargin:g.settings.slideWidth),t},x=function(){var t=g.settings.slideWidth,e=g.viewport.width();if(0===g.settings.slideWidth||g.settings.slideWidth>e&&!g.carousel||"vertical"===g.settings.mode)t=e;else if(1<g.settings.maxSlides&&"horizontal"===g.settings.mode){if(e>g.maxThreshold)return t;e<g.minThreshold?t=(e-g.settings.slideMargin*(g.settings.minSlides-1))/g.settings.minSlides:g.settings.shrinkItems&&(t=Math.floor((e+g.settings.slideMargin)/Math.ceil((e+g.settings.slideMargin)/(t+g.settings.slideMargin))-g.settings.slideMargin))}return t},m=function(){var t=0,e=0,i=0;if(0<g.settings.moveSlides){if(!g.settings.infiniteLoop){for(;e<g.children.length;)++t,e=i+r(),i+=g.settings.moveSlides<=r()?g.settings.moveSlides:r();return i}t=Math.ceil(g.children.length/S())}else t=Math.ceil(g.children.length/r());return t},S=function(){return 0<g.settings.moveSlides&&g.settings.moveSlides<=r()?g.settings.moveSlides:r()},w=function(){var t,e,i;g.children.length>g.settings.maxSlides&&g.active.last&&!g.settings.infiniteLoop?"horizontal"===g.settings.mode?(t=(e=g.children.last()).position(),b(-(t.left-(g.viewport.width()-e.outerWidth())),"reset",0)):"vertical"===g.settings.mode&&(i=g.children.length-g.settings.minSlides,t=g.children.eq(i).position(),b(-t.top,"reset",0)):(t=g.children.eq(g.active.index*S()).position(),g.active.index===m()-1&&(g.active.last=!0),void 0!==t&&("horizontal"===g.settings.mode?b(-t.left,"reset",0):"vertical"===g.settings.mode&&b(-t.top,"reset",0)))},b=function(t,e,i,n){var s,o;g.usingCSS?(o="vertical"===g.settings.mode?"translate3d(0, "+t+"px, 0)":"translate3d("+t+"px, 0, 0)",p.css("-"+g.cssPrefix+"-transition-duration",i/1e3+"s"),"slide"===e?(p.css(g.animProp,o),0!==i?p.on("transitionend webkitTransitionEnd oTransitionEnd MSTransitionEnd",function(t){Z(t.target).is(p)&&(p.off("transitionend webkitTransitionEnd oTransitionEnd MSTransitionEnd"),D())}):D()):"reset"===e?p.css(g.animProp,o):"ticker"===e&&(p.css("-"+g.cssPrefix+"-transition-timing-function","linear"),p.css(g.animProp,o),0!==i?p.on("transitionend webkitTransitionEnd oTransitionEnd MSTransitionEnd",function(t){Z(t.target).is(p)&&(p.off("transitionend webkitTransitionEnd oTransitionEnd MSTransitionEnd"),b(n.resetValue,"reset",0),O())}):(b(n.resetValue,"reset",0),O()))):((s={})[g.animProp]=t,"slide"===e?p.animate(s,i,g.settings.easing,function(){D()}):"reset"===e?p.css(g.animProp,t):"ticker"===e&&p.animate(s,i,"linear",function(){b(n.resetValue,"reset",0),O()}))},C=function(){g.settings.pagerCustom?g.pagerEl=Z(g.settings.pagerCustom):(g.pagerEl=Z('<div class="bx-pager" />'),g.settings.pagerSelector?Z(g.settings.pagerSelector).html(g.pagerEl):g.controls.el.addClass("bx-has-pager").append(g.pagerEl),t()),g.pagerEl.on("click touchend","a",z)},T=function(){g.controls.next=Z('<a class="bx-next" href="">'+g.settings.nextText+"</a>"),g.controls.prev=Z('<a class="bx-prev" href="">'+g.settings.prevText+"</a>"),g.controls.next.on("click touchend",E),g.controls.prev.on("click touchend",M),g.settings.nextSelector&&Z(g.settings.nextSelector).append(g.controls.next),g.settings.prevSelector&&Z(g.settings.prevSelector).append(g.controls.prev),g.settings.nextSelector||g.settings.prevSelector||(g.controls.directionEl=Z('<div class="bx-controls-direction" />'),g.controls.directionEl.append(g.controls.prev).append(g.controls.next),g.controls.el.addClass("bx-has-controls-direction").append(g.controls.directionEl))},k=function(){g.controls.start=Z('<div class="bx-controls-auto-item"><a class="bx-start" href="">'+g.settings.startText+"</a></div>"),g.controls.stop=Z('<div class="bx-controls-auto-item"><a class="bx-stop" href="">'+g.settings.stopText+"</a></div>"),g.controls.autoEl=Z('<div class="bx-controls-auto" />'),g.controls.autoEl.on("click",".bx-start",y),g.controls.autoEl.on("click",".bx-stop",I),g.settings.autoControlsCombine?g.controls.autoEl.append(g.controls.start):g.controls.autoEl.append(g.controls.start).append(g.controls.stop),g.settings.autoControlsSelector?Z(g.settings.autoControlsSelector).html(g.controls.autoEl):g.controls.el.addClass("bx-has-controls-auto").append(g.controls.autoEl),q(g.settings.autoStart?"stop":"start")},P=function(){g.children.each(function(t){var e=Z(this).find("img:first").attr("title");void 0!==e&&(""+e).length&&Z(this).append('<div class="bx-caption"><span>'+e+"</span></div>")})},E=function(t){t.preventDefault(),g.controls.el.hasClass("disabled")||(g.settings.auto&&g.settings.stopAutoOnClick&&p.stopAuto(),p.goToNextSlide())},M=function(t){t.preventDefault(),g.controls.el.hasClass("disabled")||(g.settings.auto&&g.settings.stopAutoOnClick&&p.stopAuto(),p.goToPrevSlide())},y=function(t){p.startAuto(),t.preventDefault()},I=function(t){p.stopAuto(),t.preventDefault()},z=function(t){var e,i;t.preventDefault(),g.controls.el.hasClass("disabled")||(g.settings.auto&&g.settings.stopAutoOnClick&&p.stopAuto(),void 0!==(e=Z(t.currentTarget)).attr("data-slide-index")&&(i=parseInt(e.attr("data-slide-index")))!==g.active.index&&p.goToSlide(i))},A=function(i){var t=g.children.length;if("short"===g.settings.pagerType)return 1<g.settings.maxSlides&&(t=Math.ceil(g.children.length/g.settings.maxSlides)),void g.pagerEl.html(i+1+g.settings.pagerShortSeparator+t);g.pagerEl.find("a").removeClass("active"),g.pagerEl.each(function(t,e){Z(e).find("a").eq(i).addClass("active")})},D=function(){if(g.settings.infiniteLoop){var t="";0===g.active.index?t=g.children.eq(0).position():g.active.index===m()-1&&g.carousel?t=g.children.eq((m()-1)*S()).position():g.active.index===g.children.length-1&&(t=g.children.eq(g.children.length-1).position()),t&&("horizontal"===g.settings.mode?b(-t.left,"reset",0):"vertical"===g.settings.mode&&b(-t.top,"reset",0))}g.working=!1,g.settings.onSlideAfter.call(p,g.children.eq(g.active.index),g.oldIndex,g.active.index)},q=function(t){g.settings.autoControlsCombine?g.controls.autoEl.html(g.controls[t]):(g.controls.autoEl.find("a").removeClass("active"),g.controls.autoEl.find("a:not(.bx-"+t+")").addClass("active"))},H=function(){1===m()?(g.controls.prev.addClass("disabled"),g.controls.next.addClass("disabled")):!g.settings.infiniteLoop&&g.settings.hideControlOnEnd&&(0===g.active.index?(g.controls.prev.addClass("disabled"),g.controls.next.removeClass("disabled")):g.active.index===m()-1?(g.controls.next.addClass("disabled"),g.controls.prev.removeClass("disabled")):(g.controls.prev.removeClass("disabled"),g.controls.next.removeClass("disabled")))},W=function(){0<g.settings.autoDelay?setTimeout(p.startAuto,g.settings.autoDelay):(p.startAuto(),Z(window).focus(a).blur(l)),g.settings.autoHover&&p.hover(function(){g.interval&&(p.stopAuto(!0),g.autoPaused=!0)},function(){g.autoPaused&&(p.startAuto(!0),g.autoPaused=null)})},L=function(){var t,e,i,n,s,o,r,a,l=0;"next"===g.settings.autoDirection?p.append(g.children.clone().addClass("bx-clone")):(p.prepend(g.children.clone().addClass("bx-clone")),t=g.children.first().position(),l="horizontal"===g.settings.mode?-t.left:-t.top),b(l,"reset",0),g.settings.pager=!1,g.settings.controls=!1,g.settings.autoControls=!1,g.settings.tickerHover&&(g.usingCSS?(n="horizontal"===g.settings.mode?4:5,g.viewport.hover(function(){e=p.css("-"+g.cssPrefix+"-transform"),i=parseFloat(e.split(",")[n]),b(i,"reset",0)},function(){a=0,g.children.each(function(t){a+="horizontal"===g.settings.mode?Z(this).outerWidth(!0):Z(this).outerHeight(!0)}),s=g.settings.speed/a,o="horizontal"===g.settings.mode?"left":"top",r=s*(a-Math.abs(parseInt(i))),O(r)})):g.viewport.hover(function(){p.stop()},function(){a=0,g.children.each(function(t){a+="horizontal"===g.settings.mode?Z(this).outerWidth(!0):Z(this).outerHeight(!0)}),s=g.settings.speed/a,o="horizontal"===g.settings.mode?"left":"top",r=s*(a-Math.abs(parseInt(p.css(o)))),O(r)})),O()},O=function(t){var e,i,n=t||g.settings.speed,s={left:0,top:0},o={left:0,top:0};"next"===g.settings.autoDirection?s=p.find(".bx-clone").first().position():o=g.children.first().position(),e="horizontal"===g.settings.mode?-s.left:-s.top,i="horizontal"===g.settings.mode?-o.left:-o.top,b(e,"ticker",n,{resetValue:i})},F=function(t){var e,i,n,s,o=document.activeElement.tagName.toLowerCase();if(null==new RegExp(o,["i"]).exec("input|textarea")&&(e=p,i=Z(window),n={top:i.scrollTop(),left:i.scrollLeft()},s=e.offset(),n.right=n.left+i.width(),n.bottom=n.top+i.height(),s.right=s.left+e.outerWidth(),s.bottom=s.top+e.outerHeight(),!(n.right<s.left||n.left>s.right||n.bottom<s.top||n.top>s.bottom))){if(39===t.keyCode)return E(t),!1;if(37===t.keyCode)return M(t),!1}},N=function(){g.touch={start:{x:0,y:0},end:{x:0,y:0}},g.viewport.on("touchstart MSPointerDown pointerdown",B),g.viewport.on("click",".bxslider a",function(t){g.viewport.hasClass("click-disabled")&&(t.preventDefault(),g.viewport.removeClass("click-disabled"))})},B=function(t){if("touchstart"===t.type||0===t.button)if(g.controls.el.addClass("disabled"),g.working)t.preventDefault(),g.controls.el.removeClass("disabled");else{g.touch.originalPos=p.position();var e=t.originalEvent,i=void 0!==e.changedTouches?e.changedTouches:[e];if("function"==typeof PointerEvent&&void 0===e.pointerId)return;g.touch.start.x=i[0].pageX,g.touch.start.y=i[0].pageY,g.viewport.get(0).setPointerCapture&&(g.pointerId=e.pointerId,g.viewport.get(0).setPointerCapture(g.pointerId)),g.originalClickTarget=e.originalTarget||e.target,g.originalClickButton=e.button,g.originalClickButtons=e.buttons,g.originalEventType=e.type,g.hasMove=!1,g.viewport.on("touchmove MSPointerMove pointermove",Y),g.viewport.on("touchend MSPointerUp pointerup",V),g.viewport.on("MSPointerCancel pointercancel",X)}},X=function(t){t.preventDefault(),b(g.touch.originalPos.left,"reset",0),g.controls.el.removeClass("disabled"),g.viewport.off("MSPointerCancel pointercancel",X),g.viewport.off("touchmove MSPointerMove pointermove",Y),g.viewport.off("touchend MSPointerUp pointerup",V),g.viewport.get(0).releasePointerCapture&&g.viewport.get(0).releasePointerCapture(g.pointerId)},Y=function(t){var e=t.originalEvent,i=void 0!==e.changedTouches?e.changedTouches:[e],n=Math.abs(i[0].pageX-g.touch.start.x),s=Math.abs(i[0].pageY-g.touch.start.y),o=0,r=0;g.hasMove=!0,s<3*n&&g.settings.preventDefaultSwipeX?t.preventDefault():n<3*s&&g.settings.preventDefaultSwipeY&&t.preventDefault(),"touchmove"!==t.type&&t.preventDefault(),"fade"!==g.settings.mode&&g.settings.oneToOneTouch&&(o="horizontal"===g.settings.mode?(r=i[0].pageX-g.touch.start.x,g.touch.originalPos.left+r):(r=i[0].pageY-g.touch.start.y,g.touch.originalPos.top+r),b(o,"reset",0))},V=function(t){t.preventDefault(),g.viewport.off("touchmove MSPointerMove pointermove",Y),g.controls.el.removeClass("disabled");var e=t.originalEvent,i=void 0!==e.changedTouches?e.changedTouches:[e],n=0,s=0;g.touch.end.x=i[0].pageX,g.touch.end.y=i[0].pageY,"fade"===g.settings.mode?(s=Math.abs(g.touch.start.x-g.touch.end.x))>=g.settings.swipeThreshold&&(g.touch.start.x>g.touch.end.x?p.goToNextSlide():p.goToPrevSlide(),p.stopAuto()):(n="horizontal"===g.settings.mode?(s=g.touch.end.x-g.touch.start.x,g.touch.originalPos.left):(s=g.touch.end.y-g.touch.start.y,g.touch.originalPos.top),!g.settings.infiniteLoop&&(0===g.active.index&&0<s||g.active.last&&s<0)?b(n,"reset",200):Math.abs(s)>=g.settings.swipeThreshold?(s<0?p.goToNextSlide():p.goToPrevSlide(),p.stopAuto()):b(n,"reset",200)),g.viewport.off("touchend MSPointerUp pointerup",V),g.viewport.get(0).releasePointerCapture&&g.viewport.get(0).releasePointerCapture(g.pointerId),!1!==g.hasMove||0!==g.originalClickButton&&"touchstart"!==g.originalEventType||Z(g.originalClickTarget).trigger({type:"click",button:g.originalClickButton,buttons:g.originalClickButtons})},R=function(t){if(g.initialized)if(g.working)window.setTimeout(R,10);else{var e=Z(window).width(),i=Z(window).height();n===e&&s===i||(n=e,s=i,p.redrawSlider(),g.settings.onSliderResize.call(p,g.active.index))}};return p.goToSlide=function(t,e){var i,n,s,o,r,a=!0,l=0,d={left:0,top:0},c=null;if(g.oldIndex=g.active.index,g.active.index=(r=t)<0?g.settings.infiniteLoop?m()-1:g.active.index:r>=m()?g.settings.infiniteLoop?0:g.active.index:r,!g.working&&g.active.index!==g.oldIndex){if(g.working=!0,void 0!==(a=g.settings.onSlideBefore.call(p,g.children.eq(g.active.index),g.oldIndex,g.active.index))&&!a)return g.active.index=g.oldIndex,void(g.working=!1);"next"===e?g.settings.onSlideNext.call(p,g.children.eq(g.active.index),g.oldIndex,g.active.index)||(a=!1):"prev"===e&&(g.settings.onSlidePrev.call(p,g.children.eq(g.active.index),g.oldIndex,g.active.index)||(a=!1)),g.active.last=g.active.index>=m()-1,(g.settings.pager||g.settings.pagerCustom)&&A(g.active.index),g.settings.controls&&H(),"fade"===g.settings.mode?(g.settings.adaptiveHeight&&g.viewport.height()!==v()&&g.viewport.animate({height:v()},g.settings.adaptiveHeightSpeed),g.children.filter(":visible").fadeOut(g.settings.speed).css({zIndex:0}),g.children.eq(g.active.index).css("zIndex",g.settings.slideZIndex+1).fadeIn(g.settings.speed,function(){Z(this).css("zIndex",g.settings.slideZIndex),D()})):(g.settings.adaptiveHeight&&g.viewport.height()!==v()&&g.viewport.animate({height:v()},g.settings.adaptiveHeightSpeed),!g.settings.infiniteLoop&&g.carousel&&g.active.last?"horizontal"===g.settings.mode?(d=(c=g.children.eq(g.children.length-1)).position(),l=g.viewport.width()-c.outerWidth()):(i=g.children.length-g.settings.minSlides,d=g.children.eq(i).position()):g.carousel&&g.active.last&&"prev"===e?(n=1===g.settings.moveSlides?g.settings.maxSlides-S():(m()-1)*S()-(g.children.length-g.settings.maxSlides),d=(c=p.children(".bx-clone").eq(n)).position()):"next"===e&&0===g.active.index?(d=p.find("> .bx-clone").eq(g.settings.maxSlides).position(),g.active.last=!1):0<=t&&(o=t*parseInt(S()),d=g.children.eq(o).position()),void 0!==d&&(s="horizontal"===g.settings.mode?-(d.left-l):-d.top,b(s,"slide",g.settings.speed)),g.working=!1),g.settings.ariaHidden&&u(g.active.index*S())}},p.goToNextSlide=function(){if((g.settings.infiniteLoop||!g.active.last)&&!0!==g.working){var t=parseInt(g.active.index)+1;p.goToSlide(t,"next")}},p.goToPrevSlide=function(){if((g.settings.infiniteLoop||0!==g.active.index)&&!0!==g.working){var t=parseInt(g.active.index)-1;p.goToSlide(t,"prev")}},p.startAuto=function(t){g.interval||(g.interval=setInterval(function(){"next"===g.settings.autoDirection?p.goToNextSlide():p.goToPrevSlide()},g.settings.pause),g.settings.onAutoChange.call(p,!0),g.settings.autoControls&&!0!==t&&q("stop"))},p.stopAuto=function(t){g.autoPaused&&(g.autoPaused=!1),g.interval&&(clearInterval(g.interval),g.interval=null,g.settings.onAutoChange.call(p,!1),g.settings.autoControls&&!0!==t&&q("start"))},p.getCurrentSlide=function(){return g.active.index},p.getCurrentSlideElement=function(){return g.children.eq(g.active.index)},p.getSlideElement=function(t){return g.children.eq(t)},p.getSlideCount=function(){return g.children.length},p.isWorking=function(){return g.working},p.redrawSlider=function(){g.children.add(p.find(".bx-clone")).outerWidth(x()),g.viewport.css("height",v()),g.settings.ticker||w(),g.active.last&&(g.active.index=m()-1),g.active.index>=m()&&(g.active.last=!0),g.settings.pager&&!g.settings.pagerCustom&&(t(),A(g.active.index)),g.settings.ariaHidden&&u(g.active.index*S())},p.destroySlider=function(){g.initialized&&(g.initialized=!1,Z(".bx-clone",this).remove(),g.children.each(function(){void 0!==Z(this).data("origStyle")?Z(this).attr("style",Z(this).data("origStyle")):Z(this).removeAttr("style")}),void 0!==Z(this).data("origStyle")?this.attr("style",Z(this).data("origStyle")):Z(this).removeAttr("style"),Z(this).unwrap().unwrap(),g.controls.el&&g.controls.el.remove(),g.controls.next&&g.controls.next.remove(),g.controls.prev&&g.controls.prev.remove(),g.pagerEl&&g.settings.controls&&!g.settings.pagerCustom&&g.pagerEl.remove(),Z(".bx-caption",this).remove(),g.controls.autoEl&&g.controls.autoEl.remove(),clearInterval(g.interval),g.settings.responsive&&Z(window).off("resize",R),g.settings.keyboardEnabled&&Z(document).off("keydown",F),Z(this).removeData("bxSlider"),Z(window).off("blur",l).off("focus",a))},p.reloadSlider=function(t){void 0!==t&&(e=t),p.destroySlider(),o(),Z(p).data("bxSlider",this)},o(),Z(p).data("bxSlider",this),this}}}(jQuery);

hji.define("bxslider", function(){});



hji.define('hji-common/bxslider',['require', 'jquery', 'hji-common/isMobile', 'bxslider', 'hji-common/unveil'], function (require, $, isMobile) {
  var cssUrl = require.toUrl('hji-membership/third-party/bxslider/jquery.bxslider.css');

  var touchEnabled = !!isMobile.any();

  var bxSlider = function bxSlider() {
    var $this;
    var slider;
    var settings;
    var __obj = {
      start: function start(obj) {
        $this = $(obj);
        slider = $this.bxSlider(this.getOptions());
      },
      onLoad: function onLoad() {
        $this.trigger('bxSliderLoaded');
        $this.hide().css({
          'visibility': 'visible'
        }).fadeIn(400);
        $this.find('img[data-src]').unveil();
      },
      getOptions: function getOptions() {
        var that = this;
        settings = $.extend({
          speed: $this.data('speed'),
          maxSlides: $this.data('maxslides'),
          slideMargin: 10,
          moveSlides: $this.data('moveslides'),
          infiniteLoop: true
        }, $this.data());

        if (!settings.maxSlides) {
          settings.maxSlides = this.calculateMaxSlides(settings);
        }

        if (!settings.moveSlides) {
          settings.moveSlides = parseInt(settings.maxSlides) - 1;
        }

        var options = $.extend({
          speed: 1500,
          slideWidth: this.getSlideWidth(settings.maxSlides),
          minSlides: 1,
          moveSlides: 0,
          startSlide: 0,
          auto: false,
          pause: 4000,
          autoHover: true,
          adaptiveHeight: true,
          pager: false,
          easing: 'swing',
          useCSS: true,
          touchEnabled: touchEnabled,
          onSliderLoad: function onSliderLoad(currentIndex) {
            var $sliderImgs = $this.find('img[data-src]');

            for (var i in $sliderImgs) {
              var $selector = $sliderImgs.eq(i);
              if (!$selector.length) break;
              var src = $selector[0].src;
              var data_src = $selector.attr('data-src');

              if (src == data_src) {
                continue;
              }
            }

            that.onLoad();
          }
        }, settings);
        return options;
      },
      getSlideWidth: function getSlideWidth(quantity) {
        var viewPortWidth = $(window).width();
        var sliderWidth = $this.outerWidth(); // Adjust slider width based on viewPort
        // and current wrapper's width.

        if (sliderWidth < 820 && sliderWidth > 780 && quantity == 4) {
          return this.calculateSlideWidth(3, sliderWidth);
        } else if (viewPortWidth > 560 && viewPortWidth < 800 && quantity > 2) {
          return this.calculateSlideWidth(2, sliderWidth);
        } else if ($(window).width() <= 480) {
          return this.calculateSlideWidth(1, sliderWidth);
        } else {
          return this.calculateSlideWidth(quantity, sliderWidth);
        }
      },
      calculateSlideWidth: function calculateSlideWidth(numSlides, sliderWidth) {
        var itemsPadding = 0; // cumulative padding of items within one slide

        if (settings.slideMargin > 0) {
          itemsPadding = numSlides * settings.slideMargin - settings.slideMargin;
        }

        return (sliderWidth - itemsPadding) / numSlides;
      },
      calculateMaxSlides: function calculateMaxSlides(settings) {
        var maxSlides;
        var $imgs = $this.find('img');
        var totalWidth = 0,
            imgWidth = 0,
            sliderWidth = $this.innerWidth(); // Calculate total width of all images

        $imgs.each(function () {
          totalWidth += parseInt($(this).outerWidth());
        }); // Get average width of an image

        imgWidth = Math.ceil(totalWidth / $imgs.length); // Add margin if set in settings

        if (settings.slideMargin) {
          imgWidth = imgWidth + parseInt(settings.slideMargin);
        }

        maxSlides = Math.ceil(sliderWidth / imgWidth);
        return maxSlides;
      }
    };
    return __obj;
  };

  var sliders = $('[data-init="slider"]');

  if (sliders.length) {
    HJI.loadCss(cssUrl);
    sliders.each(function () {
      var slider = bxSlider();
      slider.start(this);
    });
  }

  $.each($('.bx-clone .ratio--content'), function (index) {
    var item = $(this);
    item.attr('data-rel', '');
    item.on('click', function (e) {
      e.preventDefault();
    });
  });
  return bxSlider;
});


hji.define('hji-common/cookies',[],function () {
  var Cookie = {
    createCookie: function createCookie(name, value, days) {
      if (days) {
        var date = new Date();
        date.setTime(date.getTime() + days * 24 * 60 * 60 * 1000);
        var expires = "; expires=" + date.toGMTString();
      } else {
        var expires = "";
      }

      document.cookie = decodeURI(name) + "=" + decodeURI(value) + expires + "; path=/";
    },
    readCookie: function readCookie(name) {
      var nameEQ = decodeURI(name) + "=";
      var ca = document.cookie.split(';');

      for (var i = 0; i < ca.length; i++) {
        var c = ca[i];

        while (c.charAt(0) == ' ') {
          c = c.substring(1, c.length);
        }

        if (c.indexOf(nameEQ) == 0) return decodeURI(c.substring(nameEQ.length, c.length));
      }

      return null;
    },
    deleteCookie: function deleteCookie(name) {
      this.createCookie(name, "", -1);
    }
  };
  return Cookie;
});
/*!
	Colorbox v1.4.27 - 2013-07-16
	jQuery lightbox and modal window plugin
	(c) 2013 Jack Moore - http://www.jacklmoore.com/colorbox
	license: http://www.opensource.org/licenses/mit-license.php
*/
(function(t,e,i){function o(i,o,n){var r=e.createElement(i);return o&&(r.id=te+o),n&&(r.style.cssText=n),t(r)}function n(){return i.innerHeight?i.innerHeight:t(i).height()}function r(t){var e=E.length,i=(j+t)%e;return 0>i?e+i:i}function l(t,e){return Math.round((/%/.test(t)?("x"===e?H.width():n())/100:1)*parseInt(t,10))}function h(t,e){return t.photo||t.photoRegex.test(e)}function s(t,e){return t.retinaUrl&&i.devicePixelRatio>1?e.replace(t.photoRegex,t.retinaSuffix):e}function a(t){"contains"in v[0]&&!v[0].contains(t.target)&&(t.stopPropagation(),v.focus())}function d(){var e,i=t.data(A,Z);null==i?(O=t.extend({},Y),console&&console.log&&console.log("Error: cboxElement missing settings object")):O=t.extend({},i);for(e in O)t.isFunction(O[e])&&"on"!==e.slice(0,2)&&(O[e]=O[e].call(A));O.rel=O.rel||A.rel||t(A).data("rel")||"nofollow",O.href=O.href||t(A).attr("href"),O.title=O.title||A.title,"string"==typeof O.href&&(O.href=t.trim(O.href))}function c(i,o){t(e).trigger(i),se.trigger(i),t.isFunction(o)&&o.call(A)}function u(){var t,e,i,o,n,r=te+"Slideshow_",l="click."+te;O.slideshow&&E[1]?(e=function(){clearTimeout(t)},i=function(){(O.loop||E[j+1])&&(t=setTimeout(J.next,O.slideshowSpeed))},o=function(){R.html(O.slideshowStop).unbind(l).one(l,n),se.bind(ne,i).bind(oe,e).bind(re,n),v.removeClass(r+"off").addClass(r+"on")},n=function(){e(),se.unbind(ne,i).unbind(oe,e).unbind(re,n),R.html(O.slideshowStart).unbind(l).one(l,function(){J.next(),o()}),v.removeClass(r+"on").addClass(r+"off")},O.slideshowAuto?o():n()):v.removeClass(r+"off "+r+"on")}function p(i){G||(A=i,d(),E=t(A),j=0,"nofollow"!==O.rel&&(E=t("."+ee).filter(function(){var e,i=t.data(this,Z);return i&&(e=t(this).data("rel")||i.rel||this.rel),e===O.rel}),j=E.index(A),-1===j&&(E=E.add(A),j=E.length-1)),g.css({opacity:parseFloat(O.opacity),cursor:O.overlayClose?"pointer":"auto",visibility:"visible"}).show(),V&&v.add(g).removeClass(V),O.className&&v.add(g).addClass(O.className),V=O.className,O.closeButton?P.html(O.close).appendTo(x):P.appendTo("<div/>"),$||($=q=!0,v.css({visibility:"hidden",display:"block"}),W=o(ae,"LoadedContent","width:0; height:0; overflow:hidden"),x.css({width:"",height:""}).append(W),_=b.height()+k.height()+x.outerHeight(!0)-x.height(),D=T.width()+C.width()+x.outerWidth(!0)-x.width(),N=W.outerHeight(!0),z=W.outerWidth(!0),O.w=l(O.initialWidth,"x"),O.h=l(O.initialHeight,"y"),J.position(),u(),c(ie,O.onOpen),B.add(S).hide(),v.focus(),O.trapFocus&&e.addEventListener&&(e.addEventListener("focus",a,!0),se.one(le,function(){e.removeEventListener("focus",a,!0)})),O.returnFocus&&se.one(le,function(){t(A).focus()})),w())}function f(){!v&&e.body&&(X=!1,H=t(i),v=o(ae).attr({id:Z,"class":t.support.opacity===!1?te+"IE":"",role:"dialog",tabindex:"-1"}).hide(),g=o(ae,"Overlay").hide(),L=t([o(ae,"LoadingOverlay")[0],o(ae,"LoadingGraphic")[0]]),y=o(ae,"Wrapper"),x=o(ae,"Content").append(S=o(ae,"Title"),M=o(ae,"Current"),K=t('<button type="button"/>').attr({id:te+"Previous"}),I=t('<button type="button"/>').attr({id:te+"Next"}),R=o("button","Slideshow"),L),P=t('<button type="button"/>').attr({id:te+"Close"}),y.append(o(ae).append(o(ae,"TopLeft"),b=o(ae,"TopCenter"),o(ae,"TopRight")),o(ae,!1,"clear:left").append(T=o(ae,"MiddleLeft"),x,C=o(ae,"MiddleRight")),o(ae,!1,"clear:left").append(o(ae,"BottomLeft"),k=o(ae,"BottomCenter"),o(ae,"BottomRight"))).find("div div").css({"float":"left"}),F=o(ae,!1,"position:absolute; width:9999px; visibility:hidden; display:none"),B=I.add(K).add(M).add(R),t(e.body).append(g,v.append(y,F)))}function m(){function i(t){t.which>1||t.shiftKey||t.altKey||t.metaKey||t.ctrlKey||(t.preventDefault(),p(this))}return v?(X||(X=!0,I.click(function(){J.next()}),K.click(function(){J.prev()}),P.click(function(){J.close()}),g.click(function(){O.overlayClose&&J.close()}),t(e).bind("keydown."+te,function(t){var e=t.keyCode;$&&O.escKey&&27===e&&(t.preventDefault(),J.close()),$&&O.arrowKey&&E[1]&&!t.altKey&&(37===e?(t.preventDefault(),K.click()):39===e&&(t.preventDefault(),I.click()))}),t.isFunction(t.fn.on)?t(e).on("click."+te,"."+ee,i):t("."+ee).live("click."+te,i)),!0):!1}function w(){var n,r,a,u=J.prep,p=++de;q=!0,U=!1,A=E[j],d(),c(he),c(oe,O.onLoad),O.h=O.height?l(O.height,"y")-N-_:O.innerHeight&&l(O.innerHeight,"y"),O.w=O.width?l(O.width,"x")-z-D:O.innerWidth&&l(O.innerWidth,"x"),O.mw=O.w,O.mh=O.h,O.maxWidth&&(O.mw=l(O.maxWidth,"x")-z-D,O.mw=O.w&&O.w<O.mw?O.w:O.mw),O.maxHeight&&(O.mh=l(O.maxHeight,"y")-N-_,O.mh=O.h&&O.h<O.mh?O.h:O.mh),n=O.href,Q=setTimeout(function(){L.show()},100),O.inline?(a=o(ae).hide().insertBefore(t(n)[0]),se.one(he,function(){a.replaceWith(W.children())}),u(t(n))):O.iframe?u(" "):O.html?u(O.html):h(O,n)?(n=s(O,n),U=e.createElement("img"),t(U).addClass(te+"Photo").bind("error",function(){O.title=!1,u(o(ae,"Error").html(O.imgError))}).one("load",function(){var e;p===de&&(U.alt=t(A).attr("alt")||t(A).attr("data-alt")||"",O.retinaImage&&i.devicePixelRatio>1&&(U.height=U.height/i.devicePixelRatio,U.width=U.width/i.devicePixelRatio),O.scalePhotos&&(r=function(){U.height-=U.height*e,U.width-=U.width*e},O.mw&&U.width>O.mw&&(e=(U.width-O.mw)/U.width,r()),O.mh&&U.height>O.mh&&(e=(U.height-O.mh)/U.height,r())),O.h&&(U.style.marginTop=Math.max(O.mh-U.height,0)/2+"px"),E[1]&&(O.loop||E[j+1])&&(U.style.cursor="pointer",U.onclick=function(){J.next()}),U.style.width=U.width+"px",U.style.height=U.height+"px",setTimeout(function(){u(U)},1))}),setTimeout(function(){U.src=n},1)):n&&F.load(n,O.data,function(e,i){p===de&&u("error"===i?o(ae,"Error").html(O.xhrError):t(this).contents())})}var g,v,y,x,b,T,C,k,E,H,W,F,L,S,M,R,I,K,P,B,O,_,D,N,z,A,j,U,$,q,G,Q,J,V,X,Y={transition:"elastic",speed:300,fadeOut:300,width:!1,initialWidth:"600",innerWidth:!1,maxWidth:!1,height:!1,initialHeight:"450",innerHeight:!1,maxHeight:!1,scalePhotos:!0,scrolling:!0,inline:!1,html:!1,iframe:!1,fastIframe:!0,photo:!1,href:!1,title:!1,rel:!1,opacity:.9,preloading:!0,className:!1,retinaImage:!1,retinaUrl:!1,retinaSuffix:"@2x.$1",current:"image {current} of {total}",previous:"previous",next:"next",close:"close",xhrError:"This content failed to load.",imgError:"This image failed to load.",open:!1,returnFocus:!0,trapFocus:!0,reposition:!0,loop:!0,slideshow:!1,slideshowAuto:!0,slideshowSpeed:2500,slideshowStart:"start slideshow",slideshowStop:"stop slideshow",photoRegex:/\.(gif|png|jp(e|g|eg)|bmp|ico|webp)((#|\?).*)?$/i,onOpen:!1,onLoad:!1,onComplete:!1,onCleanup:!1,onClosed:!1,overlayClose:!0,escKey:!0,arrowKey:!0,top:!1,bottom:!1,left:!1,right:!1,fixed:!1,data:void 0,closeButton:!0},Z="colorbox",te="cbox",ee=te+"Element",ie=te+"_open",oe=te+"_load",ne=te+"_complete",re=te+"_cleanup",le=te+"_closed",he=te+"_purge",se=t("<a/>"),ae="div",de=0,ce={};t.colorbox||(t(f),J=t.fn[Z]=t[Z]=function(e,i){var o=this;if(e=e||{},f(),m()){if(t.isFunction(o))o=t("<a/>"),e.open=!0;else if(!o[0])return o;i&&(e.onComplete=i),o.each(function(){t.data(this,Z,t.extend({},t.data(this,Z)||Y,e))}).addClass(ee),(t.isFunction(e.open)&&e.open.call(o)||e.open)&&p(o[0])}return o},J.position=function(e,i){function o(){b[0].style.width=k[0].style.width=x[0].style.width=parseInt(v[0].style.width,10)-D+"px",x[0].style.height=T[0].style.height=C[0].style.height=parseInt(v[0].style.height,10)-_+"px"}var r,h,s,a=0,d=0,c=v.offset();if(H.unbind("resize."+te),v.css({top:-9e4,left:-9e4}),h=H.scrollTop(),s=H.scrollLeft(),O.fixed?(c.top-=h,c.left-=s,v.css({position:"fixed"})):(a=h,d=s,v.css({position:"absolute"})),d+=O.right!==!1?Math.max(H.width()-O.w-z-D-l(O.right,"x"),0):O.left!==!1?l(O.left,"x"):Math.round(Math.max(H.width()-O.w-z-D,0)/2),a+=O.bottom!==!1?Math.max(n()-O.h-N-_-l(O.bottom,"y"),0):O.top!==!1?l(O.top,"y"):Math.round(Math.max(n()-O.h-N-_,0)/2),v.css({top:c.top,left:c.left,visibility:"visible"}),y[0].style.width=y[0].style.height="9999px",r={width:O.w+z+D,height:O.h+N+_,top:a,left:d},e){var u=0;t.each(r,function(t){return r[t]!==ce[t]?(u=e,void 0):void 0}),e=u}ce=r,e||v.css(r),v.dequeue().animate(r,{duration:e||0,complete:function(){o(),q=!1,y[0].style.width=O.w+z+D+"px",y[0].style.height=O.h+N+_+"px",O.reposition&&setTimeout(function(){H.bind("resize."+te,J.position)},1),i&&i()},step:o})},J.resize=function(t){var e;$&&(t=t||{},t.width&&(O.w=l(t.width,"x")-z-D),t.innerWidth&&(O.w=l(t.innerWidth,"x")),W.css({width:O.w}),t.height&&(O.h=l(t.height,"y")-N-_),t.innerHeight&&(O.h=l(t.innerHeight,"y")),t.innerHeight||t.height||(e=W.scrollTop(),W.css({height:"auto"}),O.h=W.height()),W.css({height:O.h}),e&&W.scrollTop(e),J.position("none"===O.transition?0:O.speed))},J.prep=function(i){function n(){return O.w=O.w||W.width(),O.w=O.mw&&O.mw<O.w?O.mw:O.w,O.w}function l(){return O.h=O.h||W.height(),O.h=O.mh&&O.mh<O.h?O.mh:O.h,O.h}if($){var a,d="none"===O.transition?0:O.speed;W.empty().remove(),W=o(ae,"LoadedContent").append(i),W.hide().appendTo(F.show()).css({width:n(),overflow:O.scrolling?"auto":"hidden"}).css({height:l()}).prependTo(x),F.hide(),t(U).css({"float":"none"}),a=function(){function i(){t.support.opacity===!1&&v[0].style.removeAttribute("filter")}var n,l,a=E.length,u="frameBorder",p="allowTransparency";$&&(l=function(){clearTimeout(Q),L.hide(),c(ne,O.onComplete)},S.html(O.title).add(W).show(),a>1?("string"==typeof O.current&&M.html(O.current.replace("{current}",j+1).replace("{total}",a)).show(),I[O.loop||a-1>j?"show":"hide"]().html(O.next),K[O.loop||j?"show":"hide"]().html(O.previous),O.slideshow&&R.show(),O.preloading&&t.each([r(-1),r(1)],function(){var i,o,n=E[this],r=t.data(n,Z);r&&r.href?(i=r.href,t.isFunction(i)&&(i=i.call(n))):i=t(n).attr("href"),i&&h(r,i)&&(i=s(r,i),o=e.createElement("img"),o.src=i)})):B.hide(),O.iframe?(n=o("iframe")[0],u in n&&(n[u]=0),p in n&&(n[p]="true"),O.scrolling||(n.scrolling="no"),t(n).attr({src:O.href,name:(new Date).getTime(),"class":te+"Iframe",allowFullScreen:!0,webkitAllowFullScreen:!0,mozallowfullscreen:!0}).one("load",l).appendTo(W),se.one(he,function(){n.src="//about:blank"}),O.fastIframe&&t(n).trigger("load")):l(),"fade"===O.transition?v.fadeTo(d,1,i):i())},"fade"===O.transition?v.fadeTo(d,0,function(){J.position(0,a)}):J.position(d,a)}},J.next=function(){!q&&E[1]&&(O.loop||E[j+1])&&(j=r(1),p(E[j]))},J.prev=function(){!q&&E[1]&&(O.loop||j)&&(j=r(-1),p(E[j]))},J.close=function(){$&&!G&&(G=!0,$=!1,c(re,O.onCleanup),H.unbind("."+te),g.fadeTo(O.fadeOut||0,0),v.stop().fadeTo(O.fadeOut||0,0,function(){v.add(g).css({opacity:1,cursor:"auto"}).hide(),c(he),W.empty().remove(),setTimeout(function(){G=!1,c(le,O.onClosed)},1)}))},J.remove=function(){v&&(v.stop(),t.colorbox.close(),v.stop().remove(),g.remove(),G=!1,v=null,t("."+ee).removeData(Z).removeClass(ee),t(e).unbind("click."+te))},J.element=function(){return t(A)},J.settings=Y)})(jQuery,document,window);
hji.define("colorbox", function(){});



hji.define('hji-common/colorbox',['require', 'jquery', 'colorbox'], function (require, $) {
  var cssUrl = require.toUrl('hji-membership/third-party/colorbox/colorbox.css');

  HJI.loadCss(cssUrl); // do not move it inside the init method - let it execute immediately

  var __colorbox = function __colorbox() {
    return {
      init: function init($el, settings) {
        // Merge options form data() properties
        var options = $.extend({
          fixed: true,
          rel: false,
          onOpen: function onOpen() {
            // add HJI Twitter Bootstrap class to colorbox content
            $('#colorbox').addClass('hjitb');
          }
        }, settings); // Set default dimensions

        if (!options.inline && !options.maxWidth && !options.maxHeight) {
          options.maxWidth = '90%';
          options.maxHeight = '90%';
        }

        var href = $el.attr('href'); // Delete init property since it's not a Colorbox property

        delete options.init; // Execute Colorbox

        if (options.rel) {
          var relSelector = '[rel="' + options.rel + '"]';
          $el.attr('rel', options.rel); // Check if photos are rendered in cloned slides of the bxSlider

          var slider = $('[data-init="slider"]');

          if (slider.find($el).length) {
            var bxSlider = slider.data('bxSlider');

            if (bxSlider && bxSlider.getSlideCount() > 0) {
              // Check if element is not a cloned item by bxSlider
              if (!$el.closest('.bx-clone').length) {
                $el.colorbox(options);
              }
            } else {
              slider.on('bxSliderLoaded', function () {
                // Check if element is not a cloned item by bxSlider
                if (!$el.closest('.bx-clone').length) {
                  $el.colorbox(options);
                }
              });
            }

            return false;
          }
        }

        $el.colorbox(options);
      }
    };
  };

  return __colorbox;
});


hji.define('hji-common/widgets/widget',['jquery'], function ($) {
  /**
   * Abstract Slipstream Widget Class
   *
   * @constructor
   */
  var Widget = function Widget() {
    this.moduleName = 'widget';
    this.$el = null;
    this.options = {};
  };

  Widget.prototype.init = function ($el, options) {
    this.$el = $el;
    this.$el[0][this.moduleName] = this;
    $.extend(this.options, options);
    this.render();
  };
  /**
   * Abstract Render Method
   */


  Widget.prototype.render = function () {
    console.error('widget.render() is not implemented.');
  };

  Widget.prototype.template = function () {
    var template = $('<div class="slipstream">').append($('<div class="slipstream-areas">'));
    if (this.options.chooser) template.find('.slipstream-areas').prepend('<div class="chooser-wrapper">');
    return template;
  };

  return Widget;
});


hji.define('hji-common/widgets/chooser',['jquery'], function ($) {
  /**
   * Area Chooser Widget
   *
   * Auto-complete area selector.
   *
   * Usage:
   *      Chooser.int($target, options);
   *      Chooser.onSelect(function(areaId){ callback(areaId); );
   */
  return {
    events: {
      onSelect: 'hji.widgets.chooser.onSelect'
    },
    chooser: {},
    settings: {},
    $el: null,
    init: function init($renderTo, options) {
      this.$el = $renderTo;
      this.settings.bias = HJI.commonVar('areaBias');
      this.settings = $.extend(this.settings, options);
      this.run();
      return this;
    },
    run: function run() {
      var that = this;

      window.require(['slipstream/areas/widget/chooser'], function (Chooser) {
        /*
         * Create the area chooser widget where the user will select the
         * area whose details they want to view.
         *
         * https://slipstream.homejunction.com/v1/docs/js/areas/widget/chooser
         */
        var chooserOptions = {
          // renderTo: that.$el.find('.chooser-wrapper'),
          renderTo: that.$el,
          parameters: that.settings
        };
        that.chooser = Chooser.init(chooserOptions);
        /*
         * The model associated with the /areas/widget/chooser will always contain the
         * area that the user selected. Let's watch that model for changes.
         *
         * https://slipstream.homejunction.com/v1/docs/js/areas/model/area
         */

        that.chooser.model.on('change', function () {
          /*
           * At this point the user has selected an area.  Get the ID of the selected area.
           */
          var id = that.chooser.model.get('id');

          if (id) {
            that.$el.trigger(that.events.onSelect, id);
          }
        });
      });
    },
    onSelect: function onSelect(callback) {
      if (typeof callback !== 'function') {
        console.error('Callback is not a function.');
        return false;
      }

      this.$el.on(this.events.onSelect, function (event, areaId) {
        callback(areaId);
      });
      return this;
    }
  };
});


hji.define('hji-common/widgets/area',['require', 'jquery', 'hji-common/widgets/widget', 'hji-common/slipstream'], function (require, $, Widget) {
  /**
   * All Area Widgets
   *
   * Parameters:
   *      @param data-init string         widgets/area
   *      @param data-id string           Area ID
   *      @param data-chooser boolean     Render Chooser true|false
   *      @param data-chooser-limit       number of items to be returned within the chooser
   *      @param data-widgets JSON Array  '["age", "cost", "education", "employment",
   *                                        "occupancy", "summary", "weather", "details"]'
   *
   *  Example:
   *      <div
   *          data-init="widgets/area"
   *          data-chooser="true"
   *          data-id="6e87e3e7bf04cda3ce8bdaecf473e2d8" // Paradise Valley AZ
   *          data-widgets='["age", "cost", "education", "employment", "occupancy", "summary", "weather", "details"]'
   *          >
   *      </div>
   *
   *      Widget Object can be accessed in the DOM as follows:
   *          $('[data-init="widgets/area"]')[0].widget;
   *
   *  Manipulating widget instance:
   *      // Re-setting widgets to only summary
   *      $('[data-init="widgets/area"]')[0].widget.options.widgets = ['summary'];
   *      // Setting new area ID
   *      $('[data-init="widgets/area"]')[0].widget.options.id = 'ac28dd4fdde34d4040931bca6459ceea';
   *      // Re-rendering the whole widget
   *      $('[data-init="widgets/area"]')[0].render();
   */
  var areaWidget = function areaWidget() {
    this.options = {
      widgets: ['details']
    };
    this.loaded = [];
  };

  areaWidget.prototype = new Widget();

  areaWidget.prototype.render = function () {
    // Reset object instance, so it can be easily re-rendered with set options.
    this.reset();
    var that = this;
    this.$el.html(this.template());
    Slipstream.ready(function () {
      window.require(['slipstream/areas'], function () {
        if (that.options.chooser) {
          that.loadChooser();
        }

        if (that.options.id) {
          that.loadWidgets(that.options.id);
        }
      });
    });
  };

  areaWidget.prototype.loadWidgets = function (areaId) {
    var that = this;
    that.loadArea(areaId, function () {
      if (that.loaded.length) return;

      for (var i in that.options.widgets) {
        var widget = that.options.widgets[i];
        var widgetWrapper = that.$el.find('.widget-wrapper.' + widget + '-widget');

        if (!widgetWrapper.length) {
          widgetWrapper = $('<div class="widget-wrapper ' + widget + '-widget"></div>');
          that.$el.first('.slipstream-areas').append(widgetWrapper);
        }

        that.loadWidget(widget);
      }
    });
  };

  areaWidget.prototype.loadWidget = function (widget) {
    var that = this;

    window.require(['slipstream/areas/widget/' + widget], function (Widget) {
      /*
       * If we have not already done so, create the /areas/widget/details
       * widget to display the model.
       *
       * https://slipstream.homejunction.com/v1/docs/js/areas/widget/details
       */
      if (!that.loaded[widget]) {
        that.loaded[widget] = Widget.init({
          renderTo: that.$el.find('.widget-wrapper.' + widget + '-widget'),
          model: that.area
        });
      }
    });
  };

  areaWidget.prototype.loadChooser = function () {
    var that = this;

    hji.require(['hji-common/widgets/chooser'], function (Chooser) {
      var options = {
        limit: that.options.chooserLimit
      };
      Chooser.init(that.$el.find('.chooser-wrapper'), options).onSelect(function (id) {
        that.loadWidgets(id);
      });
    });
  };

  areaWidget.prototype.loadArea = function (id, callback) {
    var that = this;

    window.require(['slipstream/areas/model/area'], function (Area) {
      /*
       * An /areas/model/area keeps track of the selected area.
       *
       * https://slipstream.homejunction.com/v1/docs/js/areas/model/area
       */
      if (!that.area) that.area = new Area();
      /*
       * Make sure we are not already displaying this area.    There is no
       * reason to refresh the page unless we absolutely have to.
       */

      var nowShowing = that.area.get('id');

      if (!id || nowShowing === id) {
        return; // Nothing to do!
      }
      /*
       * We now fetch the selected area.
       *
       * https://slipstream.homejunction.com/v1/docs/js/areas/model/area
       */


      that.area.fetch({
        parameters: {
          id: id,
          details: true,
          geometry: true
        }
      });
      that.area.on('change', function () {
        if (typeof callback === 'function') {
          callback();
        }
      });
    });
  };

  areaWidget.prototype.template = function () {
    var template = $('<div class="slipstream">').append($('<div class="slipstream-areas">'));
    if (this.options.chooser) template.find('.slipstream-areas').prepend('<div class="chooser-wrapper">');
    return template;
  };
  /**
   * Resets areaWidget instance so it can be re-rendered.
   */


  areaWidget.prototype.reset = function () {
    this.area = null;
    this.loaded = [];
  };

  return areaWidget;
});


hji.define('hji-common/widgets/school',['require', 'jquery', 'hji-common/widgets/widget', 'hji-common/slipstream'], function (require, $, Widget) {
  /**
   * School Widget
   *
   * Parameters:
   *      @param data-init string         widgets/school
   *      @param data-id string           School ID
   *      @param data-widgets JSON Array  '["details", "enrollment", "ethnicity", "gender", "summary"]'
   *
   * Example:
   *      Renders details view of the North Ranch Elementary School in Scottsdale, AZ
   *      <div data-init="widgets/school" data-id="040593001378"></div>
   *
   *      Widget Object can be accessed in the DOM as follows:
   *       var widget = $('[data-init="widgets/school"]')[0].widget;
   *
   * Manipulating widget instance:
   *      var widget = $('[data-init="widgets/school"]')[0].widget;
   *      // Setting new school ID
   *      widget.options.id = '040593001084';
   *      // Re-rendering the whole widget
   *      widget.render();
   */
  var schoolWidget = function schoolWidget() {
    this.$el = null;
    this.params = {};
    this.details = null;
    this.options = {
      id: null,
      widgets: ['details']
    };
  };

  schoolWidget.prototype = new Widget();

  schoolWidget.prototype.render = function () {
    // Reset object instance, so it can be easily re-rendered with set options.
    this.reset();
    var that = this;
    this.$el.html(this.template());
    return new Promise(function (resolve, reject) {
      Slipstream.ready(function () {
        window.require(['slipstream/schools'], function () {
          if (that.options.id && that.options.widgets.length) that.loadWidgets(that.options.id, resolve, reject);
        });
      });
    });
  };

  schoolWidget.prototype.loadWidgets = function (id, resolve, reject) {
    var that = this;

    for (var i in that.options.widgets) {
      var widget = that.options.widgets[i];
      var widgetWrapper = that.$el.find('.widget-wrapper.' + widget + '-widget');

      if (!widgetWrapper.length) {
        widgetWrapper = $('<div class="widget-wrapper ' + widget + '-widget"></div>');
        that.$el.first('.slipstream-areas').append(widgetWrapper);
      }

      that.loadWidget(widget, resolve, reject);
    }
  };

  schoolWidget.prototype.loadWidget = function (widget, resolve, reject) {
    var that = this;

    window.require(['slipstream/schools/view/' + widget], function (Details) {
      var details = new Details();
      details.model.fetch({
        parameters: {
          id: that.options.id,
          details: true
        }
      });
      details.render().$el.appendTo(that.$el.find('.details-wrapper'));
      resolve();
    });
  };

  schoolWidget.prototype.renderWidget = function (widget) {
    var that = this;

    window.require(['slipstream/schools/view/' + widget], function (Widget) {
      if (!that.loaded[widget]) {
        that.loaded[widget] = Widget.render().$el.appendTo(that.$el.find('.details-wrapper'));
      }
    });
  };

  schoolWidget.prototype.template = function () {
    var template = $('<div class="slipstream slipstream-reset">').append($('<div class="slipstream-school">').append($('<div class="details-wrapper">')));
    if (this.options.chooser) template.find('.slipstream-school').prepend('<div class="chooser-wrapper">');
    return template;
  };
  /**
   * Resets widget instance so it can be re-rendered.
   */


  schoolWidget.prototype.reset = function () {
    this.model = null;
    this.loaded = [];
  };

  return schoolWidget;
});


hji.define('hji-common/widgets/schools',['require', 'jquery', 'underscore', 'hji-common/widgets/widget', 'hji-common/slipstream'], function (require, $, _, Widget) {
  /**
   * Schools Widget
   *
   * Parameters:
   *      @param data-init string         widgets/school
   *      @param data-parameters JSON Object  supports all schools filters
   *
   * Filters (data-parameters):
   *      admission: Public | Private
   *      charter: true | false
   *      district: Name |ID
   *      grade: elementary, middle, high, pk, kg, 1, 2, 3, etc.
   *      magnet: true
   *      name: name of the school
   *      titlei: true to limit the search to only Title I schools.
   *
   * Note: adding area selector (data-chooser) to the front-end,
   *       will reset all pre-set filters/parameters just to the selected area/polygon.
   *
   *
   * Example 1:
   *      Renders table of Magnet schools in Phoenix, AZ
   *      <div data-init="widgets/schools" data-parameters='{"city":"Phoenix", "magnet":"true"}'></div>
   *
   * Example 2:
   *      Renders table of high table in the Paradise Valley Unified District
   *      <div data-init="widgets/schools" data-parameters='{"district":"Paradise Valley Unified", "grade":"high"}' data-chooser="true"></div>
   *
   *      Widget Object can be accessed in the DOM as follows:
   *      var widget = $('[data-init="widgets/schools"]')[0].widget;
   *
   * Manipulating widget instance:
   *      var widget = $('[data-init="widgets/schools"]')[0].widget;
   *      // Resetting search parameters to a polygon
   *      widget.options.parameters = {'polygon' : '$ac28dd4fdde34d4040931bca6459ceea'};
   *      // Re-rendering the whole widget
   *      widget.render();
   */
  var schoolsWidget = function schoolsWidget() {
    this.$el = null;
    this.params = {};
    this.widgets = ['table'];
    this.options = {};
    this.loaded = [];
    this.model = null;
  };

  schoolsWidget.prototype = new Widget();

  schoolsWidget.prototype.init = function ($el, options) {
    this.$el = $el;
    this.$el[0][this.moduleName] = this;
    if (_.has(options, 'widgets')) this.widgets = options.widgets;
    $.extend(this.options, _.omit(options, 'widgets'));
    this.render();
  };

  schoolsWidget.prototype.render = function () {
    // Reset object instance, so it can be easily re-rendered with set options.
    this.reset();
    var that = this;
    this.$el.html(this.template());
    Slipstream.ready(function () {
      window.require(['slipstream/schools'], function () {
        if (that.options.chooser) {
          that.loadChooser();
        }

        that.loadWidgets();
      });
    });
  };

  schoolsWidget.prototype.loadWidgets = function (polygon) {
    for (var i in this.widgets) {
      var widget = this.widgets[i];
      var widgetWrapper = this.$el.find('.widget-wrapper.' + widget + '-widget');

      if (!widgetWrapper.length) {
        widgetWrapper = $('<div class="widget-wrapper ' + widget + '-widget"></div>');
        this.$el.first('.slipstream-areas').append(widgetWrapper);
      }

      if (polygon) {
        this.options.parameters = {
          polygon: '$' + polygon
        };
      }

      this.loadWidget(widget);
    }
  };

  schoolsWidget.prototype.loadWidget = function (widget) {
    var that = this;

    window.require(['slipstream/schools/model/schools', 'slipstream/schools/widget/' + widget], function (Model, Widget) {
      if (!that.model) that.model = new Model();
      var target = that.$el.find('.widget-wrapper.' + widget + '-widget'),
          viewOptions = {
        renderTo: target,
        model: that.model
      };
      that.updateModel(); // If widget is not rendered, render it, otherwise,
      // change of model will change the view automatically

      if (!that.loaded[widget]) {
        that.loaded[widget] = Widget.init(viewOptions);
      }
    });
  };

  schoolsWidget.prototype.updateModel = function () {
    if (!this.model) console.error('Model is not available. Widget has not been initialized.');
    this.model.fetch({
      parameters: this.options.parameters
    });
  };

  schoolsWidget.prototype.loadChooser = function () {
    var that = this;

    hji.require(['hji-common/widgets/chooser'], function (Chooser) {
      var options = {
        limit: that.options.chooserLimit
      };
      Chooser.init(that.$el.find('.chooser-wrapper'), options).onSelect(function (polygon) {
        that.loadWidgets(polygon);
      });
    });
  };

  schoolsWidget.prototype.template = function () {
    var template = $('<div class="slipstream">').append($('<div class="slipstream-school">').append($('<div class="details-wrapper">')));
    var template = $('<div class="slipstream">').append($('<div class="slipstream-school">'));
    if (this.options.chooser) template.find('.slipstream-school').prepend('<div class="chooser-wrapper">');
    return template;
  };
  /**
   * Resets widget instance so it can be re-rendered.
   */


  schoolsWidget.prototype.reset = function () {
    this.model = null;
    this.loaded = [];
  };

  return schoolsWidget;
});


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define('hji-common/utils',['require'],function (require) {
  var Utils = /*#__PURE__*/function () {
    function Utils() {
      _classCallCheck(this, Utils);
    }

    _createClass(Utils, null, [{
      key: "calculateDistance",
      value: function calculateDistance(lat1, lon1, lat2, lon2) {
        var radlat1 = Math.PI * lat1 / 180,
            radlat2 = Math.PI * lat2 / 180,
            theta = lon1 - lon2,
            radtheta = Math.PI * theta / 180,
            dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta);

        if (dist > 1) {
          dist = 1;
        }

        dist = Math.acos(dist);
        dist = dist * 180 / Math.PI;
        dist = dist * 60 * 1.1515;
        return dist.toFixed(2);
      }
    }]);

    return Utils;
  }();

  return Utils;
});


function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define('hji-common/widgets/schoolsNearby/assignedSchools',['require','hji-common/slipstream/api','underscore','hji-common/utils'],function (require) {
  var api = require('hji-common/slipstream/api'),
      _ = require('underscore'),
      Utils = require('hji-common/utils'),
      range = function range(start, stop, step) {
    return Array.from({
      length: (stop - start) / step
    }, function (_, i) {
      return start + i * step;
    });
  };

  var _cache = new Map();

  var AssignedSchools = /*#__PURE__*/function () {
    function AssignedSchools(name, options) {
      _classCallCheck(this, AssignedSchools);

      this.name = name;
      this.settings = Object.assign({
        coords: null
      }, options);
    }

    _createClass(AssignedSchools, [{
      key: "render",
      value: function render() {
        var _this = this;

        this.fetch().forEach(function (school) {
          return _this.renderSchool(school);
        });
      }
    }, {
      key: "fetch",
      value: function fetch() {
        var _this2 = this;

        var self = this;

        var getSchoolsList = function getSchoolsList(attendanceAreas) {
          var result = [],
              schoolGroups = self.groupBySchool(attendanceAreas),
              schoolList = self.reduceToSchoolList(schoolGroups),
              _$partition = _.partition(_.sortBy(schoolList, 'gradeLow'), {
            openEnrollment: false
          }),
              _$partition2 = _slicedToArray(_$partition, 2),
              assigned = _$partition2[0],
              openEnrollment = _$partition2[1],
              missingGrades = self.findMissingGrades(assigned),
              missingGradesSchools = [];

          if (missingGrades.length) {
            missingGradesSchools = self.findGradesInOpenEnrollment(openEnrollment, missingGrades);
          }

          result = result.concat(assigned, missingGradesSchools).map(function (school) {
            school.gradeLow = self._gradeAbbr(school.gradeLow);
            school.gradeHigh = self._gradeAbbr(school.gradeHigh);
            return school;
          });
          var IDs = result.map(function (school) {
            return school.id;
          });
          return new Promise(function (resolve, reject) {
            self.fetchSchools({
              id: IDs,
              details: true
            }).then(function (result) {
              if (result.schools) resolve(result.schools);
            });
          });
        };

        return new Promise(function (resolve, reject) {
          var params = {
            coords: _this2.settings.coords,
            details: true,
            pageSize: 200
          };

          if (_cache.has(params.coords)) {
            resolve(_cache.get(params.coords));
          } else {
            self.fetchAttendanceAreas(params).then(function (result) {
              if (result['attendance-areas'].length) {
                getSchoolsList(result['attendance-areas']).then(function (list) {
                  list = list.map(function (school) {
                    var coords = params.coords.split(',');
                    school.distance = Utils.calculateDistance(coords[0], coords[1], school.coordinates.latitude, school.coordinates.longitude);
                    return school;
                  });

                  _cache.set(params.coords, list);

                  resolve(list);
                });
              } else {
                reject(result);
              }
            });
          }
        });
      }
    }, {
      key: "fetchAttendanceAreas",
      value: function fetchAttendanceAreas(parameters) {
        return api.fetch('/ws/schools/attendance-areas/search', parameters);
      }
    }, {
      key: "fetchSchools",
      value: function fetchSchools(parameters) {
        return api.fetch('/ws/schools/get', parameters);
      }
    }, {
      key: "groupBySchool",
      value: function groupBySchool(attendanceAreas) {
        var _this3 = this;

        var schoolGroups = [];
        attendanceAreas.forEach(function (attendanceArea) {
          var schoolId = attendanceArea.school.id;
          attendanceArea.grade = _this3._gradeIndex(attendanceArea.grade);

          if (schoolGroups[schoolId]) {
            schoolGroups[schoolId].push(attendanceArea);
          } else {
            schoolGroups[schoolId] = [];
            schoolGroups[schoolId].push(attendanceArea);
          }
        });
        return schoolGroups;
      }
    }, {
      key: "reduceToSchoolList",
      value: function reduceToSchoolList(schoolGroups) {
        var schools = [];

        for (var i in schoolGroups) {
          var group = schoolGroups[i];
          group = _.sortBy(group, 'grade');
          schools.push({
            id: group[0].school.id,
            name: group[0].school.name,
            gradeLow: group[0].grade,
            gradeHigh: group[group.length - 1].grade,
            openEnrollment: group[0].openEnrollment
          });
        }

        ;
        return schools;
      }
    }, {
      key: "renderSchool",
      value: function renderSchool(school) {
        var html,
            gradeLow = this._gradeAbbr(school.gradeLow),
            gradeHigh = this._gradeAbbr(school.gradeHigh),
            openEnrollment = school.openEnrollment ? " (Open Enrollment)" : '';

        html = "<div>".concat(school.name, " - ").concat(gradeLow);
        if (gradeLow !== gradeHigh) html += " - ".concat(gradeHigh);
        html += "".concat(openEnrollment, "</div>");
        this.$el.append(html);
      }
    }, {
      key: "findMissingGrades",
      value: function findMissingGrades(schools) {
        var grades = range(-1, 13, 1); // find grades that are not covered by non-open enrollment
        // remove grades covered by schools

        schools.forEach(function (school) {
          var schoolGrades = range(school.gradeLow, school.gradeHigh + 1, 1);
          grades = _.difference(grades, schoolGrades);
        });
        return grades;
      }
    }, {
      key: "findGradesInOpenEnrollment",
      value: function findGradesInOpenEnrollment(schools, grades) {
        // Pick 1 school for missing grade from open enrollment list.
        var result = [];
        grades.forEach(function (grade) {
          var _school = _.find(schools, function (school) {
            var gradeRange = range(school.gradeLow, school.gradeHigh),
                i = _.find(gradeRange, grade);

            if (i !== -1) return true;
          });

          if (_school && !_.find(result, {
            id: _school.id
          })) {
            result.push(_school);
          }
        });
        return result;
      }
    }, {
      key: "_gradeIndex",
      value: function _gradeIndex(grade) {
        return grade === 'PK' ? -1 : grade === 'KG' ? 0 : grade;
      }
    }, {
      key: "_gradeAbbr",
      value: function _gradeAbbr(index) {
        return index === -1 ? 'PK' : index === 0 ? 'KG' : index;
      }
    }, {
      key: "getPaging",
      value: function getPaging() {
        return false;
      }
    }, {
      key: "nextPage",
      value: function nextPage() {}
    }, {
      key: "prevPage",
      value: function prevPage() {}
    }]);

    return AssignedSchools;
  }();

  return AssignedSchools;
});


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

hji.define('hji-common/widgets/schoolsNearby',['require','jquery','./schoolsNearby/assignedSchools','hji-common/slipstream/api','hji-common/utils'],function (require) {
  var $ = require('jquery'),
      AssignedSchools = require('./schoolsNearby/assignedSchools'),
      api = require('hji-common/slipstream/api'),
      Utils = require('hji-common/utils');

  var Cache = /*#__PURE__*/function () {
    function Cache() {
      _classCallCheck(this, Cache);

      this.cache = new Map();
    }

    _createClass(Cache, [{
      key: "_toKey",
      value: function _toKey(key) {
        return JSON.stringify(key);
      }
    }, {
      key: "has",
      value: function has(key) {
        return this.cache.has(this._toKey(key));
      }
    }, {
      key: "set",
      value: function set(key, value) {
        this.cache.set(this._toKey(key), value);
      }
    }, {
      key: "get",
      value: function get(key) {
        return this.cache.get(this._toKey(key));
      }
    }]);

    return Cache;
  }();

  var _cache = new Cache();

  var SchoolsNearby = /*#__PURE__*/function () {
    function SchoolsNearby() {
      _classCallCheck(this, SchoolsNearby);

      this.$el = null;
      this.sections = [];
    }

    _createClass(SchoolsNearby, [{
      key: "init",
      value: function init($el, options) {
        var _this = this;

        var params = options.parameters || {};
        this.$el = $el;
        this.ui = new UI(this.$el);
        var assigned = new AssignedSchools('Assigned Schools', params),
            elementary = new SchoolsSection('Elementary', Object.assign(params, {
          grade: 'elementary'
        })),
            middle = new SchoolsSection('Middle', Object.assign(params, {
          grade: 'middle'
        })),
            high = new SchoolsSection('High', Object.assign(params, {
          grade: 'high'
        }));
        this.sections = [assigned, elementary, middle, high];
        this.sections.forEach(function (section) {
          _this.ui.addSection(section);
        });
        this.ui.sections.forEach(function (uiSection, i, sections) {
          uiSection.onActivate(function () {
            _this.$el.find('.slipstream-loader.slipstream-loading').parent().show();

            uiSection.section.fetch().then(function (content) {
              uiSection.render(content);

              _this.$el.find('.slipstream-loader.slipstream-loading').parent().hide();
            })["catch"](function (reason) {
              var n = i + 1;
              sections[n].activate();
              sections[i].$tab.remove();
            }); // Display private filter

            if (uiSection.section instanceof AssignedSchools) {
              _this.ui.$filters.hide();
            } else {
              _this.ui.$filters.show();
            }
          });
        }); // Activate first section

        this.ui.sections[0].activate(); // Set min height of sections to the height of the 1st section

        var once = 0;
        this.ui.sections[0].onRender(function () {
          if (once < 1) {
            _this.ui.$template.css({
              minHeight: _this.ui.$template.height()
            });

            ++once;
          }
        });
        this.ui.$private.on('change', function (e) {
          _this.ui.sections.forEach(function (uiSection) {
            var admission = $(e.target).is(':checked') ? '' : 'Public';
            if (uiSection.section.params) uiSection.section.params.admission = admission;

            if (uiSection.isActive()) {
              uiSection.deactivate();
              uiSection.activate();
            }
          });
        });
      }
    }]);

    return SchoolsNearby;
  }();

  var SchoolsSection = /*#__PURE__*/function () {
    function SchoolsSection(name, options) {
      _classCallCheck(this, SchoolsSection);

      this.name = name;
      this.params = {
        circle: (options.coords || '') + ',5',
        grade: options.grade || '',
        district: options.district || '',
        admission: 'Public',
        details: true,
        sortField: 'distance',
        sortOrder: 'asc',
        pageSize: 4,
        pageNumber: 1
      };
      this._result = null;
      this.pages = {
        total: 1,
        current: 1
      };
    }

    _createClass(SchoolsSection, [{
      key: "fetch",
      value: function fetch() {
        var _this2 = this;

        var self = this;
        return new Promise(function (resolve, reject) {
          if (_cache.has(_this2.params)) {
            var result = _cache.get(_this2.params);

            resolve(result.schools);
          } else {
            api.fetch('/ws/schools/search', _this2.params).then(function (result) {
              if (result.schools.length) {
                self._result = result;
                result.schools.map(function (school) {
                  var coords = self.params.circle.split(',');
                  school.distance = Utils.calculateDistance(coords[0], coords[1], school.coordinates.latitude, school.coordinates.longitude);
                  return school;
                });

                _cache.set(_this2.params, result);

                resolve(result.schools);
              }
            });
          }
        });
      }
    }, {
      key: "getPaging",
      value: function getPaging() {
        if (!_cache.has(this.params)) return false;

        var result = _cache.get(this.params);

        var paging = false;

        if (result.paging) {
          paging = Object.assign({}, result.paging || {});
          paging.total = result.total;
        }

        return paging.count != 1 ? paging : false;
      }
    }, {
      key: "nextPage",
      value: function nextPage() {
        var paging = this.getPaging();
        if (!paging || paging.number === paging.count) return false;

        if (paging.count > paging.number) {
          this.params.pageNumber = paging.number + 1;
          return this.fetch();
        }
      }
    }, {
      key: "prevPage",
      value: function prevPage() {
        var paging = this.getPaging();
        if (!paging || paging.number === 1) return false;

        if (paging.number > 1) {
          this.params.pageNumber = paging.number - 1;
          return this.fetch();
        }
      }
    }]);

    return SchoolsSection;
  }();

  var template = "\n        <div class=\"hjitb schools-nearby\">\n            <div class=\"schools-nearby__controls\">\n                <ul class=\"schools-nearby__tabs nav nav-tabs\"></ul>\n                <div class=\"schools-nearby__filters\">\n                    <input type=\"checkbox\" class=\"schools-nearby__private-filter\" name=\"include-private\">\n                    <label for=\"include-private\">Private</label>\n                </div>\n            </div>\n            <div style=\"min-height: 300px; position:relative\">\n                <div class=\"schools-nearby__school-list\"></div>\n                <div class=\"slipstream\" style=\"display: none;\"><div class=\"slipstream-loader slipstream-loading\"><div class=\"slipstream-spinner\"><div></div></div></div></div>\n            </div>\n        </div>";

  var UI = /*#__PURE__*/function () {
    function UI($container) {
      _classCallCheck(this, UI);

      this.sections = [];
      this.tabs = [];
      this.$template = $(template);
      this.$tabs = this.$template.find('.schools-nearby__tabs');
      this.$private = this.$template.find('.schools-nearby__private-filter');
      this.$schools = this.$template.find('.schools-nearby__school-list');
      this.$filters = this.$template.find('.schools-nearby__filters');
      this.$template.appendTo($container);
    }

    _createClass(UI, [{
      key: "addSection",
      value: function addSection(section) {
        var _this3 = this;

        var uiSection = new UISection(section, this.$schools);
        this.$tabs.append(uiSection.$tab);
        this.tabs.push(uiSection.$tab);
        this.sections.push(uiSection);
        uiSection.$tab.on('click', function () {
          _this3.sections.forEach(function (section) {
            section.deactivate();
          });

          uiSection.activate();
        });
        uiSection.onNext(function (o) {
          var result = o.section.nextPage();
          if (result instanceof Promise) result.then(function (content) {
            return o.render(content);
          });
        });
        uiSection.onPrev(function (o) {
          var result = o.section.prevPage();
          if (result instanceof Promise) result.then(function (content) {
            return o.render(content);
          });
        });
        uiSection.onSchoolClick(function (data) {
          uiSection.showSchoolDetails(data.schoolId);
        });
        return uiSection;
      }
    }]);

    return UI;
  }();

  var UISection = /*#__PURE__*/function () {
    function UISection(section, $section) {
      _classCallCheck(this, UISection);

      this.section = section;
      this["class"] = section.name.replace(' ', '-').toLowerCase();
      this.sectionClass = "school-list--".concat(this["class"]);
      this.$tab = $("<li class=\"nav-item nav-link\">".concat(section.name, "</li>"));
      this.$section = $section;
      this.active = false;
    }

    _createClass(UISection, [{
      key: "onActivate",
      value: function onActivate(callback) {
        this.$tab.on('activate', function () {
          if (typeof callback === 'function') callback();
        });
      }
    }, {
      key: "onRender",
      value: function onRender(callback) {
        this.$section.on('render', function () {
          if (typeof callback === 'function') callback();
        });
      }
    }, {
      key: "onSchoolClick",
      value: function onSchoolClick(callback) {
        this.$section.on('click', ".".concat(this.sectionClass, " .school-list-item"), function (e) {
          e.preventDefault();
          if (typeof callback === 'function') callback($(this).data());
        });
      }
    }, {
      key: "onNext",
      value: function onNext(callback) {
        var _this4 = this;

        this.$section.on('click', ".".concat(this.sectionClass, " .widget-pagination__control-next"), function (e) {
          e.preventDefault();
          callback(_this4);
        });
      }
    }, {
      key: "onPrev",
      value: function onPrev(callback) {
        var _this5 = this;

        this.$section.on('click', ".".concat(this.sectionClass, " .widget-pagination__control-prev"), function (e) {
          e.preventDefault();
          callback(_this5);
        });
      }
    }, {
      key: "activate",
      value: function activate() {
        this.$tab.addClass('active');
        this.$tab.trigger('activate');
        this.active = true;
      }
    }, {
      key: "deactivate",
      value: function deactivate() {
        this.$tab.removeClass('active');
        this.active = false;
      }
    }, {
      key: "isActive",
      value: function isActive() {
        return this.active;
      }
    }, {
      key: "renderSchool",
      value: function renderSchool(school) {
        var grades = school.gradeLow !== school.gradeHigh ? "".concat(school.gradeLow, " - ").concat(school.gradeHigh) : school.gradeLow;
        var admission = school.admission === 'Private' ? "<span class=\"school-info__admission\">Private</span>" : '';

        var ratingClass = function ratingClass() {
          var high = ['S', 'A+', 'A', 'A-', 'B+', 'B'],
              medium = ['B-', 'C+', 'C'];
          if (!school.rating) return 'n-a';
          if (high.includes(school.rating)) return 'high';
          if (medium.includes(school.rating)) return 'medium';
          return 'low';
        };

        var totalStudents = function totalStudents() {
          return school.totalStudents ? school.totalStudents.toLocaleString() : 'N/A';
        };

        var expenditure = function expenditure() {
          return school.expenditure ? "$".concat(school.expenditure.toLocaleString()) : 'N/A';
        };

        var distance = function distance() {
          return school.distance ? "".concat(school.distance, " mi") : '';
        };

        var template = "\n            <tr class=\"school-list-item\" data-school-id=\"".concat(school.id, "\">\n                <td class=\"school-list-item__rating school-rating school-rating--").concat(ratingClass(), " school-list__col\"><span class=\"school-rating__badge\">").concat(school.rating || 'N/A', "</span></td>\n                <td class=\"school-list-item__info school-info school-list__col\">\n                    <div class=\"school-info__name\">").concat(school.name).concat(admission, "</div>\n                    <div class=\"school-info__details school-details\">\n                        <div class=\"school-details__students school-details-col\">\n                            <span class=\"school-details-col__label\">Students</span>\n                            <span class=\"school-details-col__value\">").concat(totalStudents(), "</span>\n                        </div>\n                        <div class=\"school-details__ratio school-details-col\">\n                            <span class=\"school-details-col__label\">Student/Teach</span>\n                            <span class=\"school-details-col__value\">").concat(school.studentTeacherRatio || 'N/A', "</span>\n                        </div>\n                        <div class=\"school-details__charter school-details-col\">\n                            <span class=\"school-details-col__label\">Charter</span>\n                            <span class=\"school-details-col__value\">").concat(school.charter ? 'Yes' : 'No', "</span>\n                        </div>\n                        <div class=\"school-details__title1 school-details-col\">\n                            <span class=\"school-details-col__label\">Title I</span>\n                            <span class=\"school-details-col__value\">").concat(school.titleI ? 'Yes' : 'No', "</span>\n                        </div>\n                        <div class=\"school-details__expenditure school-details-col\">\n                            <span class=\"school-details-col__label\">Expenditure</span>\n                            <span class=\"school-details-col__value\">").concat(expenditure(), "</span>\n                        </div>\n                    </div>\n                </td>\n                <td class=\"school-list-item__grades school-list__col\">").concat(grades, "</td>\n                <td class=\"school-list-item__distance school-list__col\">").concat(distance(), "</td>\n            </tr>");
        return template;
      }
    }, {
      key: "render",
      value: function render(data) {
        var _this6 = this;

        var self = this,
            html,
            paging;

        var display = function display(html) {
          self.$section.slideUp(200, function () {
            return self.$section.html(html);
          }).slideDown(500, function () {
            var obj = {
              html: html
            };
            if (_typeof(data) === 'object') obj.data = data;
            self.$section.find('.school-list').trigger('render', obj);
          });
        };

        if (typeof data === 'string') {
          display(data);
        } else if (Array.isArray(data)) {
          html = "<table class=\"school-list ".concat(this.sectionClass, "\">");
          html += "<thead class=\"school-list__header\">\n                            <tr>\n                                <th class=\"school-list__header--rating school-list__col\">Rating</th>\n                                <th class=\"school-list__header--info school-list__col\">Schools</th>\n                                <th class=\"school-list__header--grade school-list__col\">Grades</th>\n                                <th class=\"school-list__header--distance school-list__col\">Distance</th>\n                            </tr>\n                        </thead>";
          html += "<tbody>";
          data.forEach(function (school) {
            return html += _this6.renderSchool(school);
          });
          paging = this.section.getPaging();

          if (paging) {
            html += this.renderPagination(paging);
          }

          html += "</tbody>";
          html += '</table>';
          display(html);
        } else {
          this.$section.html('Unfortunately, no schools nearby were found.');
        }
      }
    }, {
      key: "renderPagination",
      value: function renderPagination(paging) {
        var from = paging.number === 1 ? 1 : paging.size * paging.number - paging.size + 1;
        var to = from + paging.size - 1 < paging.total ? from + paging.size - 1 : paging.total;
        var prevClass = paging.number === 1 ? 'inactive' : '';
        var nextClass = paging.number === paging.count ? 'inactive' : '';
        var html = "\n            <td class=\"school-list__pagination widget-pagination\" colspan=\"4\">\n                <div class=\"widget-pagination__count\">".concat(from, " - ").concat(to, " of ").concat(paging.total, "</div>\n                <div class=\"widget-pagination__controls\">\n                    <div class=\"widget-pagination__control widget-pagination__control-prev ").concat(prevClass, "\" href=\"#\">\n                        <i class=\"material-icons\">keyboard_arrow_left</i>\n                    </div>\n                    <div class=\"widget-pagination__control widget-pagination__control-next ").concat(nextClass, "\" href=\"#\">\n                        <i class=\"material-icons\">keyboard_arrow_right</i>\n                    </div>\n                </div>\n            </td>");
        return html;
      }
    }, {
      key: "showSchoolDetails",
      value: function showSchoolDetails(schoolId) {
        var self = this; // TODO: fix the Schools common widget so the same is possible via it.

        window.require(['jquery', 'slipstream/schools'], function ($) {
          window.require(['slipstream/schools/view/details'], function (Details) {
            var details = new Details();
            details.model.fetch({
              parameters: {
                id: schoolId,
                details: true
              }
            });
            var $el = $("<div class=\"slipstream slipstream-reset\">\n                                            <div class=\"slipstream-async \n                                                        slipstream-widget \n                                                        slipstream-schools \n                                                        slipstream-schools-widget \n                                                        slipstream-schools-widget-details\">\n                                            </div>\n                                        </div>");
            $el.find('.slipstream-widget').append(details.render().$el); // TODO: figure out why pointer object changes when self.activate() is called
            // const addBackButton = () => {

            var btn = $("<div \n                                                        class=\"slipstream-list-button\" \n                                                        title=\"Schools List\"></div>").one('click', function () {
              return self.activate();
            });
            var targetNode = $el[0];
            var config = {
              attributes: false,
              childList: true,
              subtree: true
            };

            var callback = function callback(mutationsList, observer) {
              var _iteratorNormalCompletion = true;
              var _didIteratorError = false;
              var _iteratorError = undefined;

              try {
                for (var _iterator = mutationsList[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                  var mutation = _step.value;

                  if (mutation.type == 'childList') {
                    observer.disconnect();
                    $el.find('.slipstream-schools-details').after(btn);
                    self.$section.html($el).slideDown(500);
                  }
                }
              } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion && _iterator["return"] != null) {
                    _iterator["return"]();
                  }
                } finally {
                  if (_didIteratorError) {
                    throw _iteratorError;
                  }
                }
              }
            };

            var observer = new MutationObserver(callback);
            observer.observe(targetNode, config); // }

            self.$section.slideUp(300); // addBackButton();
          });
        });
      }
    }]);

    return UISection;
  }();

  return SchoolsNearby;
});


hji.define('hji-common/widgets/areaDetails',['require', 'jquery', 'hji-common/widgets/widget', 'hji-common/slipstream'], function (require, $, Widget) {
  /**
   * Area Details Widget
   *
   * Parameters:
   *      @param data-init string         widgets/areaDetails
   *      @param data-id string           Area ID
   *      @param data-chooser boolean     Render Chooser true|false
   *      @param data-chooser-limit       number of items to be returned within the chooser
   *
   * Example:
   *      <div data-init="widgets/areaDetails"></div>
   *
   *      Widget Object can be accessed in the DOM as follows:
   *          $('[data-init="widgets/areaDetails"]')[0].widget;
   *
   * Manipulating widget instance:
   *      // Setting new area ID
   *      $('[data-init="widgets/areaDetails"]')[0].widget.options.id = 'ac28dd4fdde34d4040931bca6459ceea';
   *      // Re-rendering the whole widget
   *      $('[data-init="widgets/areaDetails"]')[0].render();
   */
  var areaDetails = function areaDetails() {
    this.$el = null;
    this.params = {};
    this.chooser = null;
    this.area = null;
    this.details = null;
    this.options = {
      id: null,
      chooser: true,
      chooserLimit: 15
    };
  };

  areaDetails.prototype = new Widget();

  areaDetails.prototype.render = function () {
    // Reset object instance, so it can be easily re-rendered with set options.
    this.reset();
    var that = this;
    this.$el.html(this.template());
    Slipstream.ready(function () {
      window.require(['slipstream/areas'], function () {
        if (that.options.chooser) that.loadChooser();
        if (that.options.id) that.loadArea(that.options.id);
      });
    });
  };

  areaDetails.prototype.loadChooser = function () {
    var that = this;

    hji.require(['hji-common/widgets/chooser'], function (Chooser) {
      var options = {
        limit: that.options.chooserLimit
      };
      Chooser.init(that.$el.find('.chooser-wrapper'), options);
      Chooser.onSelect(function (id) {
        that.loadArea(id);
      });
    });
  };

  areaDetails.prototype.loadArea = function (id) {
    var that = this;

    window.require(['slipstream/areas/widget/details', 'slipstream/areas/model/area'], function (Details, Area) {
      /*
       * An /areas/model/area keeps track of the selected area.
       *
       * https://slipstream.homejunction.com/v1/docs/js/areas/model/area
       */
      if (!that.area) that.area = new Area();
      /*
       * Make sure we are not already displaying this area.    There is no
       * reason to refresh the page unless we absolutely have to.
       */

      var nowShowing = that.area.get('id');

      if (!id || nowShowing === id) {
        return; // Nothing to do!
      }
      /*
       * We now fetch the selected area.
       *
       * https://slipstream.homejunction.com/v1/docs/js/areas/model/area
       */


      that.area.fetch({
        parameters: {
          id: id,
          details: true,
          geometry: true
        }
      });
      this.details = Details.init({
        renderTo: that.$el.find('.details-wrapper'),
        model: that.area
      });
    });
  };

  areaDetails.prototype.template = function () {
    var template = $('<div class="slipstream">').append($('<div class="slipstream-areas">').append($('<div class="details-wrapper">')));
    if (this.options.chooser) template.find('.slipstream-areas').prepend('<div class="chooser-wrapper">');
    return template;
  };
  /**
   * Resets areaWidget instance so it can be re-rendered.
   */


  areaDetails.prototype.reset = function () {
    this.area = null;
  };

  return areaDetails;
});

hji.define("hji", function(){});
